# hipfort: Fortran Interface For GPU Kernel Libraries

This repository contains the source and testing for hipfort.  
This is a FORTRAN interface library for accessing GPU Kernels.

## Documentation

> [!NOTE]
> The published hipfort documentation is available at [hipfort](https://rocm.docs.amd.com/projects/hipfort/en/latest/index.html) in an organized, easy-to-read format, with search and a table of contents. The documentation source files reside in the hipfort/docs folder of this repository. As with all ROCm projects, the documentation is open source. For more information, see [Contribute to ROCm documentation](https://rocm.docs.amd.com/en/latest/contribute/contributing.html).

## Known issues

* `hipSOLVER` interfaces will only work for AMD GPUs.
* We recommend `gfortran` version 7.5.0 or newer as we have observed problems with older versions.

## Build and test hipfort from source

Install `gfortran`, `git`, `cmake`, and HIP, if not yet installed.
Then build, install, and test hipfort from source with the commands below:

```shell
git clone https://github.com/ROCm/hipfort.git
cd hipfort
cmake -S. -Bbuild -DCMAKE_INSTALL_PREFIOX=/tmp/hipfort -DBUILD_TESTING=ON
make -C build
make -C build check
```

## Fortran interfaces

`hipfort` provides interfaces to the following HIP and ROCm libraries:

* **HIP:**   HIP runtime, hipBLAS, hipSPARSE, hipFFT, hipRAND, hipSOLVER
* **ROCm:** rocBLAS, rocSPARSE, rocFFT, rocRAND, rocSOLVER

While the HIP interfaces and libraries allow to write portable code, the ROCm ones 
can only be used with AMD devices.

The available interfaces depend on the Fortran compiler that is used to compile the `hipfort` modules and libraries.
As the interfaces make use of the `iso_c_binding` module, the minimum requirement is a Fortran compiler 
that supports the Fortran 2003 standard (`f2003`).
These interfaces typically require to pass `type(c_ptr)` variables and the number of bytes to memory
management (e.g. `hipMalloc`) and math library routines (e.g. `hipblasDGEMM`).

If your compiler understands the Fortran 2008 (`f2008`) code constructs that occur in `hipfort`'s source and test files, 
additional interfaces are compiled into the `hipfort` modules and libraries. 
These directly take Fortran (array) variables and the number of
elements instead of `type(c_ptr)` variables and the number of bytes, respectively. 
Therefore, they reduce the chance to introduce compile-time and runtime errors
into your code and makes it easier to read too.

> **NOTE**: If you plan to use the `f2008` interfaces, we recommend `gfortran` version `7.5.0` or newer
as we have observed problems with older versions.

### Example

While you could write the following using the `f2003` interfaces:

```Fortran
use iso_c_binding
use hipfort
integer     :: ierr        ! error code
real        :: a_h(5,6)    ! host array
type(c_ptr) :: a_d         ! device array pointer
!
ierr = hipMalloc(a_d,size(a_h)*4_c_size_t) ! real has 4 bytes
                                           ! append suffix '_c_size_t' to write '4' 
                                           ! as 'integer(c_size_t)'
ierr = hipMemcpy(a_d,c_loc(a_h),size(a_h)*4_c_size_t,hipMemcpyHostToDevice)
```

you could express the same with the `f2008` interfaces as follows:

```Fortran
use hipfort
integer     :: ierr        ! error code
real        :: a_h(5,6)    ! host array
real,pointer :: a_d(:,:)   ! device array pointer
!
ierr = hipMalloc(a_d,shape(a_h))      ! or hipMalloc(a_d,[5,6]) or hipMalloc(a_d,5,6) or hipMalloc(a_d,mold=a_h)
ierr = hipMemcpy(a_d,a_h,size(a_h),hipMemcpyHostToDevice)
```

The `f2008` interfaces also overload `hipMalloc` similar to the Fortran 2008 `ALLOCATE` intrinsic. 
So you could write the whole code as shown below:

```Fortran
integer     :: ierr        ! error code
real        :: a_h(5,6)    ! host array
real,pointer :: a_d(:,:)   ! device array pointer
!
ierr = hipMalloc(a_d,source=a_h)       ! take shape (incl. bounds) of a_h and perform a blocking copy to device
```

In addition to `source`, there is also `dsource` in case the source is a device array.

### Supported HIP and ROCm API

The current batch of HIPFORT interfaces is derived from ROCm 4.5.0.
The following tables list the supported API:

* [HIP](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_hip.md)
* [hipBLAS](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_hipblas.md)
* [hipFFT](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_hipfft.md)
* [hipRAND](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_hiprand.md)
* [hipSOLVER](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_hipsolver.md)
* [hipSPARSE](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_hipsparse.md)
* [rocBLAS](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_rocblas.md)
* [rocFFT](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_rocfft.md)
* [rocRAND](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_rocrand.md)
* [rocSOLVER](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_rocsolver.md)
* [rocSPARSE](https://github.com/ROCm/hipfort/blob/master/docs/doxygen/input/supported_api_rocsparse.md)

You may further find it convenient to directly use the search function on
[HIPFORT's documentation page](https://rocm.docs.amd.com/projects/hipfort/en/latest/) to get information on the arguments of an interface

## hipfc wrapper compiler and Makefile.hipfort

The hipfc wrapper compiler is deprecated and will be removed in a future release. Users are
encouraged to call their Fortran or HIP compilers directly instead of relying on the hipfc wrapper.
The hipfort project provides exported CMake targets that can be used for linking to the appropriate
ROCm libraries.

hipfort currently ships the `hipfc` wrapper compiler and a `Makefile.hipfort` that can be included
in a project's build system. hipfc is located in the `bin/` subdirectory and Makefile.hipfort in
share/hipfort of the repository. While both can be configured via a number of environment variables,
`hipfc` also understands a greater number of command line options that you can print to the screen via
`hipfc -h`.

Among the environment variables, the most important are:

| Variable | Description | Default |
|---|---|---|
| `HIP_PLATFORM` | The platform to compile for | `amd` |
| `ROCM_PATH` | Path to ROCm installation | `/opt/rocm` |
| `CMAKE_Fortran_COMPILER` | Fortran compiler to be used | `gfortran` | 

## Examples and tests

The examples, which simultaneously serve as tests, are located in the 
`f2003` and `f2008` subdirectories of the repo's `test/` folder.
Both test collections implement the same tests but require
that the used Fortran compiler supports at least the respective Fortran standard.
There are further subcategories per `hip*` or `roc*` library that is tested.

### Building a single test

> **NOTE**: The make targets append the linker flags for AMD devices to the `CFLAGS` variable per default.

To compile for AMD devices you can simply call `make` in the test directories.

Compilation typically boils down to calling `hipfc` as follows:

```shell
hipfc <CFLAGS> <test_name>.f03 -o <test_name>
```

The `vecadd` test is the exception as the additional HIP C++ source must be supplied too:

```shell
hipfc <CFLAGS> hip_implementation.cpp main.f03 -o main
```

### Building and running all tests

You can build and run the whole test collection from the `build/` folder (see [Build and test hipfort from source](#build-and-test-hipfort-from-source)) or
from the `test/` folder. The instructions are given below.

#### AMD devices

> **NOTE**: Running all tests as below requires that all ROCm math libraries can be found at `/opt/rocm`.
Specify a different ROCm location via the `ROCM_PATH` environment variable.
> **NOTE**: When using older ROCm versions, you might need to manually set the environment variable `HIP_PLATFORM` to `hcc`
before running the tests.

```shell
cd build/
make all-tests-run
```

Alternatively:

```shell
cd test/
make run_all
```

## Copyright, License, and Disclaimer

<A NAME="Copyright">

Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
[MITx11 License]

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc.
!
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
!
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module rocsparse
    use iso_c_binding

! ===========================================================================
!   types SPARSE
! ===========================================================================

!   rocsparse_operation
    enum, bind(c)
        enumerator :: rocsparse_operation_none = 111
        enumerator :: rocsparse_operation_transpose = 112
        enumerator :: rocsparse_operation_conjugate_transpose = 113
    end enum

!   rocsparse_index_base
    enum, bind(c)
        enumerator :: rocsparse_index_base_zero = 0
        enumerator :: rocsparse_index_base_one = 1
    end enum

!   rocsparse_matrix_type
    enum, bind(c)
        enumerator :: rocsparse_matrix_type_general = 0
        enumerator :: rocsparse_matrix_type_symmetric = 1
        enumerator :: rocsparse_matrix_type_hermitian = 2
        enumerator :: rocsparse_matrix_type_triangular = 3
    end enum

!   rocsparse_diag_type
    enum, bind(c)
        enumerator :: rocsparse_diag_type_non_unit = 0
        enumerator :: rocsparse_diag_type_unit = 1
    end enum

!   rocsparse_fill_mode
    enum, bind(c)
        enumerator :: rocsparse_fill_mode_lower = 0
        enumerator :: rocsparse_fill_mode_upper = 1
    end enum

!   rocsparse_action
    enum, bind(c)
        enumerator :: rocsparse_action_symbolic = 0
        enumerator :: rocsparse_action_numeric = 1
    end enum

!   rocsparse_direction
    enum, bind(c)
        enumerator :: rocsparse_direction_row = 0
        enumerator :: rocsparse_direction_column = 1
    end enum

!   rocsparse_hyb_partition
    enum, bind(c)
        enumerator :: rocsparse_hyb_partition_auto = 0
        enumerator :: rocsparse_hyb_partition_user = 1
        enumerator :: rocsparse_hyb_partition_max = 2
    end enum

!   rocsparse_analysis_policy
    enum, bind(c)
        enumerator :: rocsparse_analysis_policy_reuse = 0
        enumerator :: rocsparse_analysis_policy_force = 1
    end enum

!   rocsparse_solve_policy
    enum, bind(c)
        enumerator :: rocsparse_solve_policy_auto = 0
    end enum

!   rocsparse_pointer_mode
    enum, bind(c)
        enumerator :: rocsparse_pointer_mode_host = 0
        enumerator :: rocsparse_pointer_mode_device = 1
    end enum

!   rocsparse_layer_mode
    enum, bind(c)
        enumerator :: rocsparse_layer_mode_none = 0
        enumerator :: rocsparse_layer_mode_log_trace = 1
        enumerator :: rocsparse_layer_mode_log_bench = 2
    end enum

!   rocsparse_status
    enum, bind(c)
        enumerator :: rocsparse_status_success = 0
        enumerator :: rocsparse_status_invalid_handle = 1
        enumerator :: rocsparse_status_not_implemented = 2
        enumerator :: rocsparse_status_invalid_pointer = 3
        enumerator :: rocsparse_status_invalid_size = 4
        enumerator :: rocsparse_status_memory_error = 5
        enumerator :: rocsparse_status_internal_error = 6
        enumerator :: rocsparse_status_invalid_value = 7
        enumerator :: rocsparse_status_arch_mismatch = 8
        enumerator :: rocsparse_status_zero_pivot = 9
    end enum

! ===========================================================================
!   auxiliary SPARSE
! ===========================================================================

    interface

!       rocsparse_handle
        function rocsparse_create_handle(handle) &
                result(c_int) &
                bind(c, name = 'rocsparse_create_handle')
            use iso_c_binding
            implicit none
            type(c_ptr) :: handle
        end function rocsparse_create_handle

        function rocsparse_destroy_handle(handle) &
                result(c_int) &
                bind(c, name = 'rocsparse_destroy_handle')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
        end function rocsparse_destroy_handle

!       rocsparse_stream
        function rocsparse_set_stream(handle, stream) &
                result(c_int) &
                bind(c, name = 'rocsparse_set_stream')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: stream
        end function rocsparse_set_stream

        function rocsparse_get_stream(handle, stream) &
                result(c_int) &
                bind(c, name = 'rocsparse_get_stream')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr) :: stream
        end function

!       rocsparse_pointer_mode
        function rocsparse_set_pointer_mode(handle, pointer_mode) &
                result(c_int) &
                bind(c, name = 'rocsparse_set_pointer_mode')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: pointer_mode
        end function rocsparse_set_pointer_mode

        function rocsparse_get_pointer_mode(handle, pointer_mode) &
                result(c_int) &
                bind(c, name = 'rocsparse_get_pointer_mode')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int) :: pointer_mode
        end function

!       rocsparse_version
        function rocsparse_get_version(handle, version) &
                result(c_int) &
                bind(c, name = 'rocsparse_get_version')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int) :: version
        end function rocsparse_get_version

        function rocsparse_get_git_rev(handle, rev) &
                result(c_int) &
                bind(c, name = 'rocsparse_get_git_rev')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            character(c_char) :: rev(*)
        end function rocsparse_get_git_rev

!       rocsparse_mat_descr
        function rocsparse_create_mat_descr(descr) &
                result(c_int) &
                bind(c, name = 'rocsparse_create_mat_descr')
            use iso_c_binding
            implicit none
            type(c_ptr) :: descr
        end function rocsparse_create_mat_descr

        function rocsparse_copy_mat_descr(dest, src) &
                result(c_int) &
                bind(c, name = 'rocsparse_copy_mat_descr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: dest
            type(c_ptr), intent(in), value :: src
        end function rocsparse_copy_mat_descr

        function rocsparse_destroy_mat_descr(descr) &
                result(c_int) &
                bind(c, name = 'rocsparse_destroy_mat_descr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: descr
        end function rocsparse_destroy_mat_descr

!       rocsparse_index_base
        function rocsparse_set_mat_index_base(descr, base) &
                result(c_int) &
                bind(c, name = 'rocsparse_set_mat_index_base')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: descr
            integer(c_int), value :: base
        end function rocsparse_set_mat_index_base

        function rocsparse_get_mat_index_base(descr) &
                result(c_int) &
                bind(c, name = 'rocsparse_get_mat_index_base')
            use iso_c_binding
            implicit none
            type(c_ptr), intent(in), value :: descr
        end function rocsparse_get_mat_index_base

!       rocsparse_matrix_type
        function rocsparse_set_mat_type(descr, mat_type) &
                result(c_int) &
                bind(c, name = 'rocsparse_set_mat_type')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: descr
            integer(c_int), value :: mat_type
        end function rocsparse_set_mat_type

        function rocsparse_get_mat_type(descr) &
                result(c_int) &
                bind(c, name = 'rocsparse_get_mat_type')
            use iso_c_binding
            implicit none
            type(c_ptr), intent(in), value :: descr
        end function rocsparse_get_mat_type

!       rocsparse_fill_mode
        function rocsparse_set_mat_fill_mode(descr, fill_mode) &
                result(c_int) &
                bind(c, name = 'rocsparse_set_mat_fill_mode')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: descr
            integer(c_int), value :: fill_mode
        end function rocsparse_set_mat_fill_mode

        function rocsparse_get_mat_fill_mode(descr) &
                result(c_int) &
                bind(c, name = 'rocsparse_get_mat_fill_mode')
            use iso_c_binding
            implicit none
            type(c_ptr), intent(in), value :: descr
        end function rocsparse_get_mat_fill_mode

!       rocsparse_diag_type
        function rocsparse_set_mat_diag_type(descr, diag_type) &
                result(c_int) &
                bind(c, name = 'rocsparse_set_mat_diag_type')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: descr
            integer(c_int), value :: diag_type
        end function rocsparse_set_mat_diag_type

        function rocsparse_get_mat_diag_type(descr) &
                result(c_int) &
                bind(c, name = 'rocsparse_get_mat_diag_type')
            use iso_c_binding
            implicit none
            type(c_ptr), intent(in), value :: descr
        end function rocsparse_get_mat_diag_type

!       rocsparse_hyb_mat
        function rocsparse_create_hyb_mat(hyb) &
                result(c_int) &
                bind(c, name = 'rocsparse_create_hyb_mat')
            use iso_c_binding
            implicit none
            type(c_ptr) :: hyb
        end function rocsparse_create_hyb_mat

        function rocsparse_destroy_hyb_mat(hyb) &
                result(c_int) &
                bind(c, name = 'rocsparse_destroy_hyb_mat')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: hyb
        end function rocsparse_destroy_hyb_mat

!       rocsparse_mat_info
        function rocsparse_create_mat_info(info) &
                result(c_int) &
                bind(c, name = 'rocsparse_create_mat_info')
            use iso_c_binding
            implicit none
            type(c_ptr) :: info
        end function rocsparse_create_mat_info

        function rocsparse_destroy_mat_info(info) &
                result(c_int) &
                bind(c, name = 'rocsparse_destroy_mat_info')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: info
        end function rocsparse_destroy_mat_info

! ===========================================================================
!   level 1 SPARSE
! ===========================================================================

!       rocsparse_axpyi
        function rocsparse_saxpyi(handle, nnz, alpha, x_val, x_ind, y, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_saxpyi')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), value :: y
            integer(c_int), value :: idx_base
        end function rocsparse_saxpyi

        function rocsparse_daxpyi(handle, nnz, alpha, x_val, x_ind, y, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_daxpyi')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), value :: y
            integer(c_int), value :: idx_base
        end function rocsparse_daxpyi

        function rocsparse_caxpyi(handle, nnz, alpha, x_val, x_ind, y, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_caxpyi')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), value :: y
            integer(c_int), value :: idx_base
        end function rocsparse_caxpyi

        function rocsparse_zaxpyi(handle, nnz, alpha, x_val, x_ind, y, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_zaxpyi')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), value :: y
            integer(c_int), value :: idx_base
        end function rocsparse_zaxpyi

!       rocsparse_doti
        function rocsparse_sdoti(handle, nnz, x_val, x_ind, y, result, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_sdoti')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: result
            integer(c_int), value :: idx_base
        end function rocsparse_sdoti

        function rocsparse_ddoti(handle, nnz, x_val, x_ind, y, result, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_ddoti')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: result
            integer(c_int), value :: idx_base
        end function rocsparse_ddoti

        function rocsparse_cdoti(handle, nnz, x_val, x_ind, y, result, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_cdoti')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: result
            integer(c_int), value :: idx_base
        end function rocsparse_cdoti

        function rocsparse_zdoti(handle, nnz, x_val, x_ind, y, result, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_zdoti')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), intent(in), value :: y
            complex(c_double_complex) :: result
            integer(c_int), value :: idx_base
        end function rocsparse_zdoti

!       rocsparse_dotci
        function rocsparse_cdotci(handle, nnz, x_val, x_ind, y, result, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_cdotci')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: result
            integer(c_int), value :: idx_base
        end function rocsparse_cdotci

        function rocsparse_zdotci(handle, nnz, x_val, x_ind, y, result, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_zdotci')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: result
            integer(c_int), value :: idx_base
        end function rocsparse_zdotci

!       rocsparse_gthr
        function rocsparse_sgthr(handle, nnz, y, x_val, x_ind, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_sgthr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            integer(c_int), value :: idx_base
        end function rocsparse_sgthr

        function rocsparse_dgthr(handle, nnz, y, x_val, x_ind, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_dgthr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            integer(c_int), value :: idx_base
        end function rocsparse_dgthr

        function rocsparse_cgthr(handle, nnz, y, x_val, x_ind, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_cgthr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            integer(c_int), value :: idx_base
        end function rocsparse_cgthr

        function rocsparse_zgthr(handle, nnz, y, x_val, x_ind, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_zgthr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            integer(c_int), value :: idx_base
        end function rocsparse_zgthr

!       rocsparse_gthrz
        function rocsparse_sgthrz(handle, nnz, y, x_val, x_ind, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_sgthrz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            integer(c_int), value :: idx_base
        end function rocsparse_sgthrz

        function rocsparse_dgthrz(handle, nnz, y, x_val, x_ind, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_dgthrz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            integer(c_int), value :: idx_base
        end function rocsparse_dgthrz

        function rocsparse_cgthrz(handle, nnz, y, x_val, x_ind, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_cgthrz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            integer(c_int), value :: idx_base
        end function rocsparse_cgthrz

        function rocsparse_zgthrz(handle, nnz, y, x_val, x_ind, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_zgthrz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: y
            type(c_ptr), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            integer(c_int), value :: idx_base
        end function rocsparse_zgthrz

!       rocsparse_roti
        function rocsparse_sroti(handle, nnz, x_val, x_ind, y, c, s, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_sroti')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), value :: y
            type(c_ptr), intent(in), value :: c
            type(c_ptr), intent(in), value :: s
            integer(c_int), value :: idx_base
        end function rocsparse_sroti

        function rocsparse_droti(handle, nnz, x_val, x_ind, y, c, s, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_droti')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), value :: y
            type(c_ptr), intent(in), value :: c
            type(c_ptr), intent(in), value :: s
            integer(c_int), value :: idx_base
        end function rocsparse_droti

!       rocsparse_sctr
        function rocsparse_ssctr(handle, nnz, x_val, x_ind, y, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_ssctr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), value :: y
            integer(c_int), value :: idx_base
        end function rocsparse_ssctr

        function rocsparse_dsctr(handle, nnz, x_val, x_ind, y, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_dsctr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), value :: y
            integer(c_int), value :: idx_base
        end function rocsparse_dsctr

        function rocsparse_csctr(handle, nnz, x_val, x_ind, y, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_csctr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), value :: y
            integer(c_int), value :: idx_base
        end function rocsparse_csctr

        function rocsparse_zsctr(handle, nnz, x_val, x_ind, y, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_zsctr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: x_val
            type(c_ptr), intent(in), value :: x_ind
            type(c_ptr), value :: y
            integer(c_int), value :: idx_base
        end function rocsparse_zsctr

! ===========================================================================
!   level 2 SPARSE
! ===========================================================================

!       rocsparse_bsrmv
        function rocsparse_sbsrmv(handle, dir, trans, mb, nb, nnzb, alpha, descr, &
                bsr_val, bsr_row_ptr, bsr_col_ind, bsr_dim, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_sbsrmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: trans
            integer(c_int), value :: mb
            integer(c_int), value :: nb
            integer(c_int), value :: nnzb
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: bsr_val
            type(c_ptr), intent(in), value :: bsr_row_ptr
            type(c_ptr), intent(in), value :: bsr_col_ind
            integer(c_int), value :: bsr_dim
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_sbsrmv

        function rocsparse_dbsrmv(handle, dir, trans, mb, nb, nnzb, alpha, descr, &
                bsr_val, bsr_row_ptr, bsr_col_ind, bsr_dim, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_dbsrmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: trans
            integer(c_int), value :: mb
            integer(c_int), value :: nb
            integer(c_int), value :: nnzb
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: bsr_val
            type(c_ptr), intent(in), value :: bsr_row_ptr
            type(c_ptr), intent(in), value :: bsr_col_ind
            integer(c_int), value :: bsr_dim
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_dbsrmv

        function rocsparse_cbsrmv(handle, dir, trans, mb, nb, nnzb, alpha, descr, &
                bsr_val, bsr_row_ptr, bsr_col_ind, bsr_dim, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_cbsrmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: trans
            integer(c_int), value :: mb
            integer(c_int), value :: nb
            integer(c_int), value :: nnzb
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: bsr_val
            type(c_ptr), intent(in), value :: bsr_row_ptr
            type(c_ptr), intent(in), value :: bsr_col_ind
            integer(c_int), value :: bsr_dim
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_cbsrmv

        function rocsparse_zbsrmv(handle, dir, trans, mb, nb, nnzb, alpha, descr, &
                bsr_val, bsr_row_ptr, bsr_col_ind, bsr_dim, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_zbsrmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: trans
            integer(c_int), value :: mb
            integer(c_int), value :: nb
            integer(c_int), value :: nnzb
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: bsr_val
            type(c_ptr), intent(in), value :: bsr_row_ptr
            type(c_ptr), intent(in), value :: bsr_col_ind
            integer(c_int), value :: bsr_dim
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_zbsrmv

!       rocsparse_coomv
        function rocsparse_scoomv(handle, trans, m, n, nnz, alpha, descr, coo_val, &
                coo_row_ind, coo_col_ind, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_scoomv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: coo_val
            type(c_ptr), intent(in), value :: coo_row_ind
            type(c_ptr), intent(in), value :: coo_col_ind
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_scoomv

        function rocsparse_dcoomv(handle, trans, m, n, nnz, alpha, descr, coo_val, &
                coo_row_ind, coo_col_ind, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcoomv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: coo_val
            type(c_ptr), intent(in), value :: coo_row_ind
            type(c_ptr), intent(in), value :: coo_col_ind
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_dcoomv

        function rocsparse_ccoomv(handle, trans, m, n, nnz, alpha, descr, coo_val, &
                coo_row_ind, coo_col_ind, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccoomv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: coo_val
            type(c_ptr), intent(in), value :: coo_row_ind
            type(c_ptr), intent(in), value :: coo_col_ind
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_ccoomv

        function rocsparse_zcoomv(handle, trans, m, n, nnz, alpha, descr, coo_val, &
                coo_row_ind, coo_col_ind, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcoomv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: coo_val
            type(c_ptr), intent(in), value :: coo_row_ind
            type(c_ptr), intent(in), value :: coo_col_ind
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_zcoomv

!       rocsparse_csrmv_analysis
        function rocsparse_scsrmv_analysis(handle, trans, m, n, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrmv_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
        end function rocsparse_scsrmv_analysis

        function rocsparse_dcsrmv_analysis(handle, trans, m, n, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrmv_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
        end function rocsparse_dcsrmv_analysis

        function rocsparse_ccsrmv_analysis(handle, trans, m, n, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrmv_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), intent(in), value :: handle
            integer(c_int), intent(in), value :: trans
            integer(c_int), intent(in), value :: m
            integer(c_int), intent(in), value :: n
            integer(c_int), intent(in), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
        end function rocsparse_ccsrmv_analysis

        function rocsparse_zcsrmv_analysis(handle, trans, m, n, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrmv_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
        end function rocsparse_zcsrmv_analysis

!       rocsparse_csrmv_clear
        function rocsparse_csrmv_clear(handle, info) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrmv_clear')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: info
        end function rocsparse_csrmv_clear

!       rocsparse_csrmv
        function rocsparse_scsrmv(handle, trans, m, n, nnz, alpha, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_scsrmv

        function rocsparse_dcsrmv(handle, trans, m, n, nnz, alpha, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_dcsrmv

        function rocsparse_ccsrmv(handle, trans, m, n, nnz, alpha, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_ccsrmv

        function rocsparse_zcsrmv(handle, trans, m, n, nnz, alpha, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_zcsrmv

!       rocsparse_csrsv_zero_pivot
        function rocsparse_csrsv_zero_pivot(handle, descr, info, position) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrsv_zero_pivot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), value :: info
            type(c_ptr), value :: position
        end function rocsparse_csrsv_zero_pivot

!       rocsparse_csrsv_buffer_size
        function rocsparse_scsrsv_buffer_size(handle, trans, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrsv_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_scsrsv_buffer_size

        function rocsparse_dcsrsv_buffer_size(handle, trans, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrsv_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_dcsrsv_buffer_size

        function rocsparse_ccsrsv_buffer_size(handle, trans, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrsv_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_ccsrsv_buffer_size

        function rocsparse_zcsrsv_buffer_size(handle, trans, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrsv_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_zcsrsv_buffer_size

!       rocsparse_csrsv_analysis
        function rocsparse_scsrsv_analysis(handle, trans, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrsv_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_scsrsv_analysis

        function rocsparse_dcsrsv_analysis(handle, trans, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrsv_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dcsrsv_analysis

        function rocsparse_ccsrsv_analysis(handle, trans, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrsv_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_ccsrsv_analysis

        function rocsparse_zcsrsv_analysis(handle, trans, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrsv_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zcsrsv_analysis

!       rocsparse_csrsv_clear
        function rocsparse_csrsv_clear(handle, descr, info) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrsv_clear')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), value :: info
        end function rocsparse_csrsv_clear

!       rocsparse_csrsv_solve
        function rocsparse_scsrsv_solve(handle, trans, m, nnz, alpha, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, x, y, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrsv_solve')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), intent(in), value :: x
            type(c_ptr), value :: y
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_scsrsv_solve

        function rocsparse_dcsrsv_solve(handle, trans, m, nnz, alpha, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, x, y, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrsv_solve')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), intent(in), value :: x
            type(c_ptr), value :: y
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dcsrsv_solve

        function rocsparse_ccsrsv_solve(handle, trans, m, nnz, alpha, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, x, y, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrsv_solve')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), intent(in), value :: x
            type(c_ptr), value :: y
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_ccsrsv_solve

        function rocsparse_zcsrsv_solve(handle, trans, m, nnz, alpha, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, x, y, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrsv_solve')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            compleX(c_double_complex), intent(in) :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), intent(in), value :: x
            type(c_ptr), value :: y
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zcsrsv_solve

!       rocsparse_ellmv
        function rocsparse_sellmv(handle, trans, m, n, alpha, descr, ell_val, &
                ell_col_ind, ell_width, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_sellmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: ell_val
            type(c_ptr), intent(in), value :: ell_col_ind
            integer(c_int), value :: ell_width
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_sellmv

        function rocsparse_dellmv(handle, trans, m, n, alpha, descr, ell_val, &
                ell_col_ind, ell_width, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_dellmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: ell_val
            type(c_ptr), intent(in), value :: ell_col_ind
            integer(c_int), value :: ell_width
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_dellmv

        function rocsparse_cellmv(handle, trans, m, n, alpha, descr, ell_val, &
                ell_col_ind, ell_width, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_cellmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: ell_val
            type(c_ptr), intent(in), value :: ell_col_ind
            integer(c_int), value :: ell_width
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_cellmv

        function rocsparse_zellmv(handle, trans, m, n, alpha, descr, ell_val, &
                ell_col_ind, ell_width, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_zellmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: ell_val
            type(c_ptr), intent(in), value :: ell_col_ind
            integer(c_int), value :: ell_width
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_zellmv

!       rocsparse_hybmv
        function rocsparse_shybmv(handle, trans, alpha, descr, hyb, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_shybmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: hyb
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_shybmv

        function rocsparse_dhybmv(handle, trans, alpha, descr, hyb, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_dhybmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: hyb
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_dhybmv

        function rocsparse_chybmv(handle, trans, alpha, descr, hyb, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_chybmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: hyb
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_chybmv

        function rocsparse_zhybmv(handle, trans, alpha, descr, hyb, x, beta, y) &
                result(c_int) &
                bind(c, name = 'rocsparse_zhybmv')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: hyb
            type(c_ptr), intent(in), value :: x
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: y
        end function rocsparse_zhybmv

! ===========================================================================
!   level 3 SPARSE
! ===========================================================================

!       rocsparse_csrmm
        function rocsparse_scsrmm(handle, trans_A, trans_B, m, n, k, nnz, alpha, descr, &
                csr_val, csr_row_ptr, csr_col_ind, B, ldb, beta, C, ldc) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrmm')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: C
            integer(c_int), value :: ldc
        end function rocsparse_scsrmm

        function rocsparse_dcsrmm(handle, trans_A, trans_B, m, n, k, nnz, alpha, descr, &
                csr_val, csr_row_ptr, csr_col_ind, B, ldb, beta, C, ldc) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrmm')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: C
            integer(c_int), value :: ldc
        end function rocsparse_dcsrmm

        function rocsparse_ccsrmm(handle, trans_A, trans_B, m, n, k, nnz, alpha, descr, &
                csr_val, csr_row_ptr, csr_col_ind, B, ldb, beta, C, ldc) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrmm')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: C
            integer(c_int), value :: ldc
        end function rocsparse_ccsrmm

        function rocsparse_zcsrmm(handle, trans_A, trans_B, m, n, k, nnz, alpha, descr, &
                csr_val, csr_row_ptr, csr_col_ind, B, ldb, beta, C, ldc) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrmm')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), value :: C
            integer(c_int), value :: ldc
        end function rocsparse_zcsrmm

!       rocsparse_csrsm_zero_pivot
        function rocsparse_csrsm_zero_pivot(handle, info, position) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrsm_zero_pivot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: info
            type(c_ptr), value :: position
        end function rocsparse_csrsm_zero_pivot

!       rocsparse_csrsm_buffer_size
        function rocsparse_scsrsm_buffer_size(handle, trans_A, trans_B, m, nrhs, nnz, &
                alpha, descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, policy, &
                buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrsm_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: buffer_size
        end function rocsparse_scsrsm_buffer_size

        function rocsparse_dcsrsm_buffer_size(handle, trans_A, trans_B, m, nrhs, nnz, &
                alpha, descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, policy, &
                buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrsm_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: buffer_size
        end function rocsparse_dcsrsm_buffer_size

        function rocsparse_ccsrsm_buffer_size(handle, trans_A, trans_B, m, nrhs, nnz, &
                alpha, descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, policy, &
                buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrsm_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: buffer_size
        end function rocsparse_ccsrsm_buffer_size

        function rocsparse_zcsrsm_buffer_size(handle, trans_A, trans_B, m, nrhs, nnz, &
                alpha, descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, policy, &
                buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrsm_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: buffer_size
        end function rocsparse_zcsrsm_buffer_size

!       rocsparse_csrsm_analysis
        function rocsparse_scsrsm_analysis(handle, trans_A, trans_B, m, nrhs, nnz, &
                alpha, descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, &
                analysis, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrsm_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_scsrsm_analysis

        function rocsparse_dcsrsm_analysis(handle, trans_A, trans_B, m, nrhs, nnz, &
                alpha, descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, &
                analysis, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrsm_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dcsrsm_analysis

        function rocsparse_ccsrsm_analysis(handle, trans_A, trans_B, m, nrhs, nnz, &
                alpha, descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, &
                analysis, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrsm_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_ccsrsm_analysis

        function rocsparse_zcsrsm_analysis(handle, trans_A, trans_B, m, nrhs, nnz, &
                alpha, descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, &
                analysis, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrsm_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zcsrsm_analysis

!       rocsparse_csrsm_clear
        function rocsparse_csrsm_clear(handle, info) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrsm_clear')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: info
        end function rocsparse_csrsm_clear

!       rocsparse_csrsm_solve
        function rocsparse_scsrsm_solve(handle, trans_A, trans_B, m, nrhs, nnz, alpha, &
                descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, policy, &
                temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrsm_solve')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_scsrsm_solve

        function rocsparse_dcsrsm_solve(handle, trans_A, trans_B, m, nrhs, nnz, alpha, &
                descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, policy, &
                temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrsm_solve')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dcsrsm_solve

        function rocsparse_ccsrsm_solve(handle, trans_A, trans_B, m, nrhs, nnz, alpha, &
                descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, policy, &
                temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrsm_solve')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_ccsrsm_solve

        function rocsparse_zcsrsm_solve(handle, trans_A, trans_B, m, nrhs, nnz, alpha, &
                descr, csr_val, csr_row_ptr, csr_col_ind, B, ldb, info, policy, &
                temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrsm_solve')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: nrhs
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: B
            integer(c_int), value :: ldb
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zcsrsm_solve

! ===========================================================================
!   extra SPARSE
! ===========================================================================

!       rocsparse_csrgeam_nnz
        function rocsparse_csrgeam_nnz(handle, m, n, descr_A, nnz_A, csr_row_ptr_A, &
                csr_col_ind_A, descr_B, nnz_B, csr_row_ptr_B, csr_col_ind_B, descr_C, &
                csr_row_ptr_C, nnz_C) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrgeam_nnz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: descr_C
            type(c_ptr), value :: csr_row_ptr_C
            type(c_ptr), value :: nnz_C
        end function rocsparse_csrgeam_nnz

!       rocsparse_csrgeam
        function rocsparse_scsrgeam(handle, m, n, alpha, descr_A, nnz_A, csr_val_A, &
                csr_row_ptr_A, csr_col_ind_A, beta, descr_B, nnz_B, csr_val_B, &
                csr_row_ptr_B, csr_col_ind_B, descr_C, csr_val_C, csr_row_ptr_C, &
                csr_col_ind_C) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrgeam')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_val_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: descr_C
            type(c_ptr), value :: csr_val_C
            type(c_ptr), intent(in), value :: csr_row_ptr_C
            type(c_ptr), value :: csr_col_ind_C
        end function rocsparse_scsrgeam

        function rocsparse_dcsrgeam(handle, m, n, alpha, descr_A, nnz_A, csr_val_A, &
                csr_row_ptr_A, csr_col_ind_A, beta, descr_B, nnz_B, csr_val_B, &
                csr_row_ptr_B, csr_col_ind_B, descr_C, csr_val_C, csr_row_ptr_C, &
                csr_col_ind_C) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrgeam')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_val_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: descr_C
            type(c_ptr), value :: csr_val_C
            type(c_ptr), intent(in), value :: csr_row_ptr_C
            type(c_ptr), value :: csr_col_ind_C
        end function rocsparse_dcsrgeam

        function rocsparse_ccsrgeam(handle, m, n, alpha, descr_A, nnz_A, csr_val_A, &
                csr_row_ptr_A, csr_col_ind_A, beta, descr_B, nnz_B, csr_val_B, &
                csr_row_ptr_B, csr_col_ind_B, descr_C, csr_val_C, csr_row_ptr_C, &
                csr_col_ind_C) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrgeam')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_val_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: descr_C
            type(c_ptr), value :: csr_val_C
            type(c_ptr), intent(in), value :: csr_row_ptr_C
            type(c_ptr), value :: csr_col_ind_C
        end function rocsparse_ccsrgeam

        function rocsparse_zcsrgeam(handle, m, n, alpha, descr_A, nnz_A, csr_val_A, &
                csr_row_ptr_A, csr_col_ind_A, beta, descr_B, nnz_B, csr_val_B, &
                csr_row_ptr_B, csr_col_ind_B, descr_C, csr_val_C, csr_row_ptr_C, &
                csr_col_ind_C) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrgeam')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_val_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: descr_C
            type(c_ptr), value :: csr_val_C
            type(c_ptr), intent(in), value :: csr_row_ptr_C
            type(c_ptr), value :: csr_col_ind_C
        end function rocsparse_zcsrgeam

!       rocsparse_csrgemm_buffer_size
        function rocsparse_scsrgemm_buffer_size(handle, trans_A, trans_B, m, n, k, alpha, &
                descr_A, nnz_A, csr_row_ptr_A, csr_col_ind_A, descr_B, nnz_B, csr_row_ptr_B, &
                csr_col_ind_B, beta, descr_D, nnz_D, csr_row_ptr_D, csr_col_ind_D, info_C, &
                buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrgemm_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_D
            integer(c_int), value :: nnz_D
            type(c_ptr), intent(in), value :: csr_row_ptr_D
            type(c_ptr), intent(in), value :: csr_col_ind_D
            type(c_ptr), value :: info_C
            type(c_ptr), value :: buffer_size
        end function rocsparse_scsrgemm_buffer_size

        function rocsparse_dcsrgemm_buffer_size(handle, trans_A, trans_B, m, n, k, alpha, &
                descr_A, nnz_A, csr_row_ptr_A, csr_col_ind_A, descr_B, nnz_B, csr_row_ptr_B, &
                csr_col_ind_B, beta, descr_D, nnz_D, csr_row_ptr_D, csr_col_ind_D, info_C, &
                buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrgemm_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_D
            integer(c_int), value :: nnz_D
            type(c_ptr), intent(in), value :: csr_row_ptr_D
            type(c_ptr), intent(in), value :: csr_col_ind_D
            type(c_ptr), value :: info_C
            type(c_ptr), value :: buffer_size
        end function rocsparse_dcsrgemm_buffer_size

        function rocsparse_ccsrgemm_buffer_size(handle, trans_A, trans_B, m, n, k, alpha, &
                descr_A, nnz_A, csr_row_ptr_A, csr_col_ind_A, descr_B, nnz_B, csr_row_ptr_B, &
                csr_col_ind_B, beta, descr_D, nnz_D, csr_row_ptr_D, csr_col_ind_D, info_C, &
                buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrgemm_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_D
            integer(c_int), value :: nnz_D
            type(c_ptr), intent(in), value :: csr_row_ptr_D
            type(c_ptr), intent(in), value :: csr_col_ind_D
            type(c_ptr), value :: info_C
            type(c_ptr), value :: buffer_size
        end function rocsparse_ccsrgemm_buffer_size

        function rocsparse_zcsrgemm_buffer_size(handle, trans_A, trans_B, m, n, k, alpha, &
                descr_A, nnz_A, csr_row_ptr_A, csr_col_ind_A, descr_B, nnz_B, csr_row_ptr_B, &
                csr_col_ind_B, beta, descr_D, nnz_D, csr_row_ptr_D, csr_col_ind_D, info_C, &
                buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrgemm_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_D
            integer(c_int), value :: nnz_D
            type(c_ptr), intent(in), value :: csr_row_ptr_D
            type(c_ptr), intent(in), value :: csr_col_ind_D
            type(c_ptr), value :: info_C
            type(c_ptr), value :: buffer_size
        end function rocsparse_zcsrgemm_buffer_size

!       rocsparse_csrgemm_nnz
        function rocsparse_csrgemm_nnz(handle, trans_A, trans_B, m, n, k, descr_A, &
                nnz_A, csr_row_ptr_A, csr_col_ind_A, descr_B, nnz_B, csr_row_ptr_B, &
                csr_col_ind_B, descr_D, nnz_D, csr_row_ptr_D, csr_col_ind_D, descr_C, &
                csr_row_ptr_C, nnz_C, info_C, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrgemm_nnz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: descr_D
            integer(c_int), value :: nnz_D
            type(c_ptr), intent(in), value :: csr_row_ptr_D
            type(c_ptr), intent(in), value :: csr_col_ind_D
            type(c_ptr), intent(in), value :: descr_C
            type(c_ptr), value :: csr_row_ptr_C
            type(c_ptr), value :: nnz_C
            type(c_ptr), intent(in), value :: info_C
            type(c_ptr), value :: temp_buffer
        end function rocsparse_csrgemm_nnz

!       rocsparse_csrgemm
        function rocsparse_scsrgemm(handle, trans_A, trans_B, m, n, k, alpha, descr_A, &
                nnz_A, csr_val_A, csr_row_ptr_A, csr_col_ind_A, descr_B, nnz_B, csr_val_B, &
                csr_row_ptr_B, csr_col_ind_B, beta, descr_D, nnz_D, csr_val_D, csr_row_ptr_D, &
                csr_col_ind_D, descr_C, csr_val_C, csr_row_ptr_C, csr_col_ind_C, info_C, &
                temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrgemm')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_val_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_D
            integer(c_int), value :: nnz_D
            type(c_ptr), intent(in), value :: csr_val_D
            type(c_ptr), intent(in), value :: csr_row_ptr_D
            type(c_ptr), intent(in), value :: csr_col_ind_D
            type(c_ptr), intent(in), value :: descr_C
            type(c_ptr), value :: csr_val_C
            type(c_ptr), intent(in), value :: csr_row_ptr_C
            type(c_ptr), value :: csr_col_ind_C
            type(c_ptr), intent(in), value :: info_C
            type(c_ptr), value :: temp_buffer
        end function rocsparse_scsrgemm

        function rocsparse_dcsrgemm(handle, trans_A, trans_B, m, n, k, alpha, descr_A, &
                nnz_A, csr_val_A, csr_row_ptr_A, csr_col_ind_A, descr_B, nnz_B, csr_val_B, &
                csr_row_ptr_B, csr_col_ind_B, beta, descr_D, nnz_D, csr_val_D, csr_row_ptr_D, &
                csr_col_ind_D, descr_C, csr_val_C, csr_row_ptr_C, csr_col_ind_C, info_C, &
                temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrgemm')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_val_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_D
            integer(c_int), value :: nnz_D
            type(c_ptr), intent(in), value :: csr_val_D
            type(c_ptr), intent(in), value :: csr_row_ptr_D
            type(c_ptr), intent(in), value :: csr_col_ind_D
            type(c_ptr), intent(in), value :: descr_C
            type(c_ptr), value :: csr_val_C
            type(c_ptr), intent(in), value :: csr_row_ptr_C
            type(c_ptr), value :: csr_col_ind_C
            type(c_ptr), intent(in), value :: info_C
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dcsrgemm

        function rocsparse_ccsrgemm(handle, trans_A, trans_B, m, n, k, alpha, descr_A, &
                nnz_A, csr_val_A, csr_row_ptr_A, csr_col_ind_A, descr_B, nnz_B, csr_val_B, &
                csr_row_ptr_B, csr_col_ind_B, beta, descr_D, nnz_D, csr_val_D, csr_row_ptr_D, &
                csr_col_ind_D, descr_C, csr_val_C, csr_row_ptr_C, csr_col_ind_C, info_C, &
                temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrgemm')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_val_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_D
            integer(c_int), value :: nnz_D
            type(c_ptr), intent(in), value :: csr_val_D
            type(c_ptr), intent(in), value :: csr_row_ptr_D
            type(c_ptr), intent(in), value :: csr_col_ind_D
            type(c_ptr), intent(in), value :: descr_C
            type(c_ptr), value :: csr_val_C
            type(c_ptr), intent(in), value :: csr_row_ptr_C
            type(c_ptr), value :: csr_col_ind_C
            type(c_ptr), intent(in), value :: info_C
            type(c_ptr), value :: temp_buffer
        end function rocsparse_ccsrgemm

        function rocsparse_zcsrgemm(handle, trans_A, trans_B, m, n, k, alpha, descr_A, &
                nnz_A, csr_val_A, csr_row_ptr_A, csr_col_ind_A, descr_B, nnz_B, csr_val_B, &
                csr_row_ptr_B, csr_col_ind_B, beta, descr_D, nnz_D, csr_val_D, csr_row_ptr_D, &
                csr_col_ind_D, descr_C, csr_val_C, csr_row_ptr_C, csr_col_ind_C, info_C, &
                temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrgemm')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: trans_A
            integer(c_int), value :: trans_B
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: k
            type(c_ptr), intent(in), value :: alpha
            type(c_ptr), intent(in), value :: descr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: descr_B
            integer(c_int), value :: nnz_B
            type(c_ptr), intent(in), value :: csr_val_B
            type(c_ptr), intent(in), value :: csr_row_ptr_B
            type(c_ptr), intent(in), value :: csr_col_ind_B
            type(c_ptr), intent(in), value :: beta
            type(c_ptr), intent(in), value :: descr_D
            integer(c_int), value :: nnz_D
            type(c_ptr), intent(in), value :: csr_val_D
            type(c_ptr), intent(in), value :: csr_row_ptr_D
            type(c_ptr), intent(in), value :: csr_col_ind_D
            type(c_ptr), intent(in), value :: descr_C
            type(c_ptr), value :: csr_val_C
            type(c_ptr), intent(in), value :: csr_row_ptr_C
            type(c_ptr), value :: csr_col_ind_C
            type(c_ptr), intent(in), value :: info_C
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zcsrgemm

! ===========================================================================
!   preconditioner SPARSE
! ===========================================================================

!       rocsparse_csric0_zero_pivot
        function rocsparse_csric0_zero_pivot(handle, info, position) &
                result(c_int) &
                bind(c, name = 'rocsparse_csric0_zero_pivot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: info
            type(c_ptr), value :: position
        end function rocsparse_csric0_zero_pivot

!       rocsparse_csric0_buffer_size
        function rocsparse_scsric0_buffer_size(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsric0_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_scsric0_buffer_size

        function rocsparse_dcsric0_buffer_size(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsric0_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_dcsric0_buffer_size

        function rocsparse_ccsric0_buffer_size(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsric0_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_ccsric0_buffer_size

        function rocsparse_zcsric0_buffer_size(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsric0_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_zcsric0_buffer_size

!       rocsparse_csric0_analysis
        function rocsparse_scsric0_analysis(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsric0_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_scsric0_analysis

        function rocsparse_dcsric0_analysis(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsric0_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dcsric0_analysis

        function rocsparse_ccsric0_analysis(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsric0_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_ccsric0_analysis

        function rocsparse_zcsric0_analysis(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsric0_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zcsric0_analysis

!       rocsparse_csric0_clear
        function rocsparse_csric0_clear(handle, info) &
                result(c_int) &
                bind(c, name = 'rocsparse_csric0_clear')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: info
        end function rocsparse_csric0_clear

!       rocsparse_csric0
        function rocsparse_scsric0(handle, m, nnz, descr, csr_val, csr_row_ptr, &
                csr_col_ind, info, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsric0')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_scsric0

        function rocsparse_dcsric0(handle, m, nnz, descr, csr_val, csr_row_ptr, &
                csr_col_ind, info, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsric0')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dcsric0

        function rocsparse_ccsric0(handle, m, nnz, descr, csr_val, csr_row_ptr, &
                csr_col_ind, info, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsric0')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_ccsric0

        function rocsparse_zcsric0(handle, m, nnz, descr, csr_val, csr_row_ptr, &
                csr_col_ind, info, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsric0')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zcsric0

!       rocsparse_csrilu0_zero_pivot
        function rocsparse_csrilu0_zero_pivot(handle, info, position) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrilu0_zero_pivot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: info
            type(c_ptr), value :: position
        end function rocsparse_csrilu0_zero_pivot

!       rocsparse_csrilu0_buffer_size
        function rocsparse_scsrilu0_buffer_size(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrilu0_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_scsrilu0_buffer_size

        function rocsparse_dcsrilu0_buffer_size(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrilu0_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_dcsrilu0_buffer_size

        function rocsparse_ccsrilu0_buffer_size(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrilu0_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_ccsrilu0_buffer_size

        function rocsparse_zcsrilu0_buffer_size(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrilu0_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            type(c_ptr), value :: buffer_size
        end function rocsparse_zcsrilu0_buffer_size

!       rocsparse_csrilu0_analysis
        function rocsparse_scsrilu0_analysis(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrilu0_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_scsrilu0_analysis

        function rocsparse_dcsrilu0_analysis(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrilu0_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dcsrilu0_analysis

        function rocsparse_ccsrilu0_analysis(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrilu0_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_ccsrilu0_analysis

        function rocsparse_zcsrilu0_analysis(handle, m, nnz, descr, csr_val, &
                csr_row_ptr, csr_col_ind, info, analysis, solve, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrilu0_analysis')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: analysis
            integer(c_int), value :: solve
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zcsrilu0_analysis

!       rocsparse_csrilu0_clear
        function rocsparse_csrilu0_clear(handle, info) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrilu0_clear')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: info
        end function rocsparse_csrilu0_clear

!       rocsparse_csrilu0
        function rocsparse_scsrilu0(handle, m, nnz, descr, csr_val, csr_row_ptr, &
                csr_col_ind, info, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsrilu0')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_scsrilu0

        function rocsparse_dcsrilu0(handle, m, nnz, descr, csr_val, csr_row_ptr, &
                csr_col_ind, info, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsrilu0')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dcsrilu0

        function rocsparse_ccsrilu0(handle, m, nnz, descr, csr_val, csr_row_ptr, &
                csr_col_ind, info, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsrilu0')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_ccsrilu0

        function rocsparse_zcsrilu0(handle, m, nnz, descr, csr_val, csr_row_ptr, &
                csr_col_ind, info, policy, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsrilu0')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: info
            integer(c_int), value :: policy
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zcsrilu0

! ===========================================================================
!   conversion SPARSE
! ===========================================================================

!       rocsparse_nnz
        function rocsparse_snnz(handle, dir, m, n, descr, A, ld, nnz_per_row_columns, &
                nnz_total_dev_host_ptr) &
                result(c_int) &
                bind(c, name = 'rocsparse_snnz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), value :: nnz_per_row_columns
            type(c_ptr), value :: nnz_total_dev_host_ptr
        end function rocsparse_snnz

        function rocsparse_dnnz(handle, dir, m, n, descr, A, ld, nnz_per_row_columns, &
                nnz_total_dev_host_ptr) &
                result(c_int) &
                bind(c, name = 'rocsparse_dnnz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), value :: nnz_per_row_columns
            type(c_ptr), value :: nnz_total_dev_host_ptr
        end function rocsparse_dnnz

        function rocsparse_cnnz(handle, dir, m, n, descr, A, ld, nnz_per_row_columns, &
                nnz_total_dev_host_ptr) &
                result(c_int) &
                bind(c, name = 'rocsparse_cnnz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), value :: nnz_per_row_columns
            type(c_ptr), value :: nnz_total_dev_host_ptr
        end function rocsparse_cnnz

        function rocsparse_znnz(handle, dir, m, n, descr, A, ld, nnz_per_row_columns, &
                nnz_total_dev_host_ptr) &
                result(c_int) &
                bind(c, name = 'rocsparse_znnz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), value :: nnz_per_row_columns
            type(c_ptr), value :: nnz_total_dev_host_ptr
        end function rocsparse_znnz

!       rocsparse_dense2csr
        function rocsparse_sdense2csr(handle, m, n, descr, A, ld, nnz_per_rows, csr_val, &
                csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_sdense2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), intent(in), value :: nnz_per_rows
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_sdense2csr

        function rocsparse_ddense2csr(handle, m, n, descr, A, ld, nnz_per_rows, csr_val, &
                csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_ddense2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), intent(in), value :: nnz_per_rows
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_ddense2csr

        function rocsparse_cdense2csr(handle, m, n, descr, A, ld, nnz_per_rows, csr_val, &
                csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_cdense2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), intent(in), value :: nnz_per_rows
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_cdense2csr

        function rocsparse_zdense2csr(handle, m, n, descr, A, ld, nnz_per_rows, csr_val, &
                csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_zdense2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), intent(in), value :: nnz_per_rows
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_zdense2csr

!       rocsparse_dense2csc
        function rocsparse_sdense2csc(handle, m, n, descr, A, ld, nnz_per_columns, &
                csc_val, csc_col_ptr, csc_row_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_sdense2csc')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), intent(in), value :: nnz_per_columns
            type(c_ptr), value :: csc_val
            type(c_ptr), value :: csc_col_ptr
            type(c_ptr), value :: csc_row_ind
        end function rocsparse_sdense2csc

        function rocsparse_ddense2csc(handle, m, n, descr, A, ld, nnz_per_columns, &
                csc_val, csc_col_ptr, csc_row_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_ddense2csc')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), intent(in), value :: nnz_per_columns
            type(c_ptr), value :: csc_val
            type(c_ptr), value :: csc_col_ptr
            type(c_ptr), value :: csc_row_ind
        end function rocsparse_ddense2csc

        function rocsparse_cdense2csc(handle, m, n, descr, A, ld, nnz_per_columns, &
                csc_val, csc_col_ptr, csc_row_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_cdense2csc')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), intent(in), value :: nnz_per_columns
            type(c_ptr), value :: csc_val
            type(c_ptr), value :: csc_col_ptr
            type(c_ptr), value :: csc_row_ind
        end function rocsparse_cdense2csc

        function rocsparse_zdense2csc(handle, m, n, descr, A, ld, nnz_per_columns, &
                csc_val, csc_col_ptr, csc_row_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_zdense2csc')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: A
            integer(c_int), value :: ld
            type(c_ptr), intent(in), value :: nnz_per_columns
            type(c_ptr), value :: csc_val
            type(c_ptr), value :: csc_col_ptr
            type(c_ptr), value :: csc_row_ind
        end function rocsparse_zdense2csc

!       rocsparse_csr2dense
        function rocsparse_scsr2dense(handle, m, n, descr, csr_val, csr_row_ptr, &
                csr_col_ind, A, ld) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsr2dense')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: A
            integer(c_int), value :: ld
        end function rocsparse_scsr2dense

        function rocsparse_dcsr2dense(handle, m, n, descr, csr_val, csr_row_ptr, &
                csr_col_ind, A, ld) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsr2dense')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: A
            integer(c_int), value :: ld
        end function rocsparse_dcsr2dense

        function rocsparse_ccsr2dense(handle, m, n, descr, csr_val, csr_row_ptr, &
                csr_col_ind, A, ld) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsr2dense')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: A
            integer(c_int), value :: ld
        end function rocsparse_ccsr2dense

        function rocsparse_zcsr2dense(handle, m, n, descr, csr_val, csr_row_ptr, &
                csr_col_ind, A, ld) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsr2dense')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: A
            integer(c_int), value :: ld
        end function rocsparse_zcsr2dense

!       rocsparse_csc2dense
        function rocsparse_scsc2dense(handle, m, n, descr, csc_val, csc_col_ptr, &
                csc_row_ind, A, ld) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsc2dense')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csc_val
            type(c_ptr), intent(in), value :: csc_col_ptr
            type(c_ptr), intent(in), value :: csc_row_ind
            type(c_ptr), value :: A
            integer(c_int), value :: ld
        end function rocsparse_scsc2dense

        function rocsparse_dcsc2dense(handle, m, n, descr, csc_val, csc_col_ptr, &
                csc_row_ind, A, ld) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsc2dense')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csc_val
            type(c_ptr), intent(in), value :: csc_col_ptr
            type(c_ptr), intent(in), value :: csc_row_ind
            type(c_ptr), value :: A
            integer(c_int), value :: ld
        end function rocsparse_dcsc2dense

        function rocsparse_ccsc2dense(handle, m, n, descr, csc_val, csc_col_ptr, &
                csc_row_ind, A, ld) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsc2dense')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csc_val
            type(c_ptr), intent(in), value :: csc_col_ptr
            type(c_ptr), intent(in), value :: csc_row_ind
            type(c_ptr), value :: A
            integer(c_int), value :: ld
        end function rocsparse_ccsc2dense

        function rocsparse_zcsc2dense(handle, m, n, descr, csc_val, csc_col_ptr, &
                csc_row_ind, A, ld) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsc2dense')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csc_val
            type(c_ptr), intent(in), value :: csc_col_ptr
            type(c_ptr), intent(in), value :: csc_row_ind
            type(c_ptr), value :: A
            integer(c_int), value :: ld
        end function rocsparse_zcsc2dense

!       rocsparse_nnz_compress
        function rocsparse_snnz_compress(handle, m, descr_A, csr_val_A, csr_row_ptr_A, &
                nnz_per_row, nnz_C, tol) &
                result(c_int) &
                bind(c, name = 'rocsparse_snnz_compress')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            type(c_ptr), intent(in), value :: descr_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), value :: nnz_per_row
            type(c_ptr), value :: nnz_C
            real(c_float), value :: tol
        end function rocsparse_snnz_compress

        function rocsparse_dnnz_compress(handle, m, descr_A, csr_val_A, csr_row_ptr_A, &
                nnz_per_row, nnz_C, tol) &
                result(c_int) &
                bind(c, name = 'rocsparse_dnnz_compress')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            type(c_ptr), intent(in), value :: descr_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), value :: nnz_per_row
            type(c_ptr), value :: nnz_C
            real(c_double), value :: tol
        end function rocsparse_dnnz_compress

        function rocsparse_cnnz_compress(handle, m, descr_A, csr_val_A, csr_row_ptr_A, &
                nnz_per_row, nnz_C, tol) &
                result(c_int) &
                bind(c, name = 'rocsparse_cnnz_compress')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            type(c_ptr), intent(in), value :: descr_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), value :: nnz_per_row
            type(c_ptr), value :: nnz_C
            complex(c_float_complex), value :: tol
        end function rocsparse_cnnz_compress

        function rocsparse_znnz_compress(handle, m, descr_A, csr_val_A, csr_row_ptr_A, &
                nnz_per_row, nnz_C, tol) &
                result(c_int) &
                bind(c, name = 'rocsparse_znnz_compress')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            type(c_ptr), intent(in), value :: descr_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            type(c_ptr), value :: nnz_per_row
            type(c_ptr), value :: nnz_C
            complex(c_double_complex), value :: tol
        end function rocsparse_znnz_compress

!       rocsparse_csr2coo
        function rocsparse_csr2coo(handle, csr_row_ptr, nnz, m, coo_row_ind, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_csr2coo')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), intent(in), value :: csr_row_ptr
            integer(c_int), value :: nnz
            integer(c_int), value :: m
            type(c_ptr), value :: coo_row_ind
            integer(c_int), value :: idx_base
        end function rocsparse_csr2coo

!       rocsparse_csr2csc_buffer_size
        function rocsparse_csr2csc_buffer_size(handle, m, n, nnz, csr_row_ptr, &
                csr_col_ind, copy_values, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_csr2csc_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            integer(c_int), value :: copy_values
            type(c_ptr), value :: buffer_size
        end function rocsparse_csr2csc_buffer_size

!       rocsparse_csr2csc
        function rocsparse_scsr2csc(handle, m, n, nnz, csr_val, csr_row_ptr, &
                csr_col_ind, csc_val, csc_row_ind, csc_col_ptr, copy_values, &
                idx_base, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsr2csc')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: csc_val
            type(c_ptr), value :: csc_row_ind
            type(c_ptr), value :: csc_col_ptr
            integer(c_int), value :: copy_values
            integer(c_int), value :: idx_base
            type(c_ptr), value :: temp_buffer
        end function rocsparse_scsr2csc

        function rocsparse_dcsr2csc(handle, m, n, nnz, csr_val, csr_row_ptr, &
                csr_col_ind, csc_val, csc_row_ind, csc_col_ptr, copy_values, &
                idx_base, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsr2csc')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: csc_val
            type(c_ptr), value :: csc_row_ind
            type(c_ptr), value :: csc_col_ptr
            integer(c_int), value :: copy_values
            integer(c_int), value :: idx_base
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dcsr2csc

        function rocsparse_ccsr2csc(handle, m, n, nnz, csr_val, csr_row_ptr, &
                csr_col_ind, csc_val, csc_row_ind, csc_col_ptr, copy_values, &
                idx_base, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsr2csc')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: csc_val
            type(c_ptr), value :: csc_row_ind
            type(c_ptr), value :: csc_col_ptr
            integer(c_int), value :: copy_values
            integer(c_int), value :: idx_base
            type(c_ptr), value :: temp_buffer
        end function rocsparse_ccsr2csc

        function rocsparse_zcsr2csc(handle, m, n, nnz, csr_val, csr_row_ptr, &
                csr_col_ind, csc_val, csc_row_ind, csc_col_ptr, copy_values, &
                idx_base, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsr2csc')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: csc_val
            type(c_ptr), value :: csc_row_ind
            type(c_ptr), value :: csc_col_ptr
            integer(c_int), value :: copy_values
            integer(c_int), value :: idx_base
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zcsr2csc

!       rocsparse_csr2ell_width
        function rocsparse_csr2ell_width(handle, m, csr_descr, csr_row_ptr, &
                ell_descr, ell_width) &
                result(c_int) &
                bind(c, name = 'rocsparse_csr2ell_width')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: ell_descr
            type(c_ptr), value :: ell_width
        end function rocsparse_csr2ell_width

!       rocsparse_csr2ell
        function rocsparse_scsr2ell(handle, m, csr_descr, csr_val, csr_row_ptr, &
                csr_col_ind, ell_descr, ell_width, ell_val, ell_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsr2ell')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: ell_descr
            integer(c_int), value :: ell_width
            type(c_ptr), value :: ell_val
            type(c_ptr), value :: ell_col_ind
        end function rocsparse_scsr2ell

        function rocsparse_dcsr2ell(handle, m, csr_descr, csr_val, csr_row_ptr, &
                csr_col_ind, ell_descr, ell_width, ell_val, ell_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsr2ell')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: ell_descr
            integer(c_int), value :: ell_width
            type(c_ptr), value :: ell_val
            type(c_ptr), value :: ell_col_ind
        end function rocsparse_dcsr2ell

        function rocsparse_ccsr2ell(handle, m, csr_descr, csr_val, csr_row_ptr, &
                csr_col_ind, ell_descr, ell_width, ell_val, ell_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsr2ell')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: ell_descr
            integer(c_int), value :: ell_width
            type(c_ptr), value :: ell_val
            type(c_ptr), value :: ell_col_ind
        end function rocsparse_ccsr2ell

        function rocsparse_zcsr2ell(handle, m, csr_descr, csr_val, csr_row_ptr, &
                csr_col_ind, ell_descr, ell_width, ell_val, ell_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsr2ell')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), intent(in), value :: ell_descr
            integer(c_int), value :: ell_width
            type(c_ptr), value :: ell_val
            type(c_ptr), value :: ell_col_ind
        end function rocsparse_zcsr2ell

!       rocsparse_csr2hyb
        function rocsparse_scsr2hyb(handle, m, n, descr, csr_val, csr_row_ptr, &
                csr_col_ind, hyb, user_ell_width, partition_type) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsr2hyb')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: hyb
            integer(c_int), value :: user_ell_width
            integer(c_int), value :: partition_type
        end function rocsparse_scsr2hyb

        function rocsparse_dcsr2hyb(handle, m, n, descr, csr_val, csr_row_ptr, &
                csr_col_ind, hyb, user_ell_width, partition_type) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsr2hyb')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: hyb
            integer(c_int), value :: user_ell_width
            integer(c_int), value :: partition_type
        end function rocsparse_dcsr2hyb

        function rocsparse_ccsr2hyb(handle, m, n, descr, csr_val, csr_row_ptr, &
                csr_col_ind, hyb, user_ell_width, partition_type) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsr2hyb')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: hyb
            integer(c_int), value :: user_ell_width
            integer(c_int), value :: partition_type
        end function rocsparse_ccsr2hyb

        function rocsparse_zcsr2hyb(handle, m, n, descr, csr_val, csr_row_ptr, &
                csr_col_ind, hyb, user_ell_width, partition_type) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsr2hyb')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: hyb
            integer(c_int), value :: user_ell_width
            integer(c_int), value :: partition_type
        end function rocsparse_zcsr2hyb

!       rocsparse_csr2bsr_nnz
        function rocsparse_csr2bsr_nnz(handle, dir, m, n, csr_descr, csr_row_ptr, &
                csr_col_ind, block_dim, bsr_descr, bsr_row_ptr, bsr_nnz) &
                result(c_int) &
                bind(c, name = 'rocsparse_csr2bsr_nnz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            integer(c_int), value :: block_dim
            type(c_ptr), intent(in), value :: bsr_descr
            type(c_ptr), value :: bsr_row_ptr
            type(c_ptr), value :: bsr_nnz
        end function rocsparse_csr2bsr_nnz

!       rocsparse_csr2bsr
        function rocsparse_scsr2bsr(handle, dir, m, n, csr_descr, csr_val, csr_row_ptr, &
                csr_col_ind, block_dim, bsr_descr, bsr_val, bsr_row_ptr, bsr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsr2bsr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            integer(c_int), value :: block_dim
            type(c_ptr), intent(in), value :: bsr_descr
            type(c_ptr), value :: bsr_val
            type(c_ptr), value :: bsr_row_ptr
            type(c_ptr), value :: bsr_col_ind
        end function rocsparse_scsr2bsr

        function rocsparse_dcsr2bsr(handle, dir, m, n, csr_descr, csr_val, csr_row_ptr, &
                csr_col_ind, block_dim, bsr_descr, bsr_val, bsr_row_ptr, bsr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsr2bsr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            integer(c_int), value :: block_dim
            type(c_ptr), intent(in), value :: bsr_descr
            type(c_ptr), value :: bsr_val
            type(c_ptr), value :: bsr_row_ptr
            type(c_ptr), value :: bsr_col_ind
        end function rocsparse_dcsr2bsr

        function rocsparse_ccsr2bsr(handle, dir, m, n, csr_descr, csr_val, csr_row_ptr, &
                csr_col_ind, block_dim, bsr_descr, bsr_val, bsr_row_ptr, bsr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsr2bsr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            integer(c_int), value :: block_dim
            type(c_ptr), intent(in), value :: bsr_descr
            type(c_ptr), value :: bsr_val
            type(c_ptr), value :: bsr_row_ptr
            type(c_ptr), value :: bsr_col_ind
        end function rocsparse_ccsr2bsr

        function rocsparse_zcsr2bsr(handle, dir, m, n, csr_descr, csr_val, csr_row_ptr, &
                csr_col_ind, block_dim, bsr_descr, bsr_val, bsr_row_ptr, bsr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsr2bsr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), intent(in), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            integer(c_int), value :: block_dim
            type(c_ptr), intent(in), value :: bsr_descr
            type(c_ptr), value :: bsr_val
            type(c_ptr), value :: bsr_row_ptr
            type(c_ptr), value :: bsr_col_ind
        end function rocsparse_zcsr2bsr

!       rocsparse_csr2csr_compress
        function rocsparse_scsr2csr_compress(handle, m, n, descr_A, csr_val_A, &
                csr_col_ind_A, csr_row_ptr_A, nnz_A, nnz_per_row, csr_val_C, &
                csr_col_ind_C, csr_row_ptr_C, tol) &
                result(c_int) &
                bind(c, name = 'rocsparse_scsr2csr_compress')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: nnz_per_row
            type(c_ptr), value :: csr_val_C
            type(c_ptr), value :: csr_col_ind_C
            type(c_ptr), value :: csr_row_ptr_C
            real(c_float), value :: tol
        end function rocsparse_scsr2csr_compress

        function rocsparse_dcsr2csr_compress(handle, m, n, descr_A, csr_val_A, &
                csr_col_ind_A, csr_row_ptr_A, nnz_A, nnz_per_row, csr_val_C, &
                csr_col_ind_C, csr_row_ptr_C, tol) &
                result(c_int) &
                bind(c, name = 'rocsparse_dcsr2csr_compress')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: nnz_per_row
            type(c_ptr), value :: csr_val_C
            type(c_ptr), value :: csr_col_ind_C
            type(c_ptr), value :: csr_row_ptr_C
            real(c_float), value :: tol
        end function rocsparse_dcsr2csr_compress

        function rocsparse_ccsr2csr_compress(handle, m, n, descr_A, csr_val_A, &
                csr_col_ind_A, csr_row_ptr_A, nnz_A, nnz_per_row, csr_val_C, &
                csr_col_ind_C, csr_row_ptr_C, tol) &
                result(c_int) &
                bind(c, name = 'rocsparse_ccsr2csr_compress')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: nnz_per_row
            type(c_ptr), value :: csr_val_C
            type(c_ptr), value :: csr_col_ind_C
            type(c_ptr), value :: csr_row_ptr_C
            real(c_float), value :: tol
        end function rocsparse_ccsr2csr_compress

        function rocsparse_zcsr2csr_compress(handle, m, n, descr_A, csr_val_A, &
                csr_col_ind_A, csr_row_ptr_A, nnz_A, nnz_per_row, csr_val_C, &
                csr_col_ind_C, csr_row_ptr_C, tol) &
                result(c_int) &
                bind(c, name = 'rocsparse_zcsr2csr_compress')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: descr_A
            type(c_ptr), intent(in), value :: csr_val_A
            type(c_ptr), intent(in), value :: csr_col_ind_A
            type(c_ptr), intent(in), value :: csr_row_ptr_A
            integer(c_int), value :: nnz_A
            type(c_ptr), intent(in), value :: nnz_per_row
            type(c_ptr), value :: csr_val_C
            type(c_ptr), value :: csr_col_ind_C
            type(c_ptr), value :: csr_row_ptr_C
            real(c_float), value :: tol
        end function rocsparse_zcsr2csr_compress

!       rocsparse_coo2csr
        function rocsparse_coo2csr(handle, coo_row_ind, nnz, m, csr_row_ptr, idx_base) &
                result(c_int) &
                bind(c, name = 'rocsparse_coo2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), intent(in), value :: coo_row_ind
            integer(c_int), value :: nnz
            integer(c_int), value :: m
            type(c_ptr), value :: csr_row_ptr
            integer(c_int), value :: idx_base
        end function rocsparse_coo2csr

!       rocsparse_ell2csr_nnz
        function rocsparse_ell2csr_nnz(handle, m, n, ell_descr, ell_width, ell_col_ind, &
                csr_descr, csr_row_ptr, csr_nnz) &
                result(c_int) &
                bind(c, name = 'rocsparse_ell2csr_nnz')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: ell_descr
            integer(c_int), value :: ell_width
            type(c_ptr), intent(in), value :: ell_col_ind
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_nnz
        end function rocsparse_ell2csr_nnz

!       rocsparse_ell2csr
        function rocsparse_sell2csr(handle, m, n, ell_descr, ell_width, ell_val, &
                ell_col_ind, csr_descr, csr_val, csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_sell2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: ell_descr
            integer(c_int), value :: ell_width
            type(c_ptr), intent(in), value :: ell_val
            type(c_ptr), intent(in), value :: ell_col_ind
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_sell2csr

        function rocsparse_dell2csr(handle, m, n, ell_descr, ell_width, ell_val, &
                ell_col_ind, csr_descr, csr_val, csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_dell2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: ell_descr
            integer(c_int), value :: ell_width
            type(c_ptr), intent(in), value :: ell_val
            type(c_ptr), intent(in), value :: ell_col_ind
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_dell2csr

        function rocsparse_cell2csr(handle, m, n, ell_descr, ell_width, ell_val, &
                ell_col_ind, csr_descr, csr_val, csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_cell2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: ell_descr
            integer(c_int), value :: ell_width
            type(c_ptr), intent(in), value :: ell_val
            type(c_ptr), intent(in), value :: ell_col_ind
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_cell2csr

        function rocsparse_zell2csr(handle, m, n, ell_descr, ell_width, ell_val, &
                ell_col_ind, csr_descr, csr_val, csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_zell2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            type(c_ptr), intent(in), value :: ell_descr
            integer(c_int), value :: ell_width
            type(c_ptr), intent(in), value :: ell_val
            type(c_ptr), intent(in), value :: ell_col_ind
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), value :: csr_val
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_zell2csr

!       rocsparse_hyb2csr_buffer_size
        function rocsparse_hyb2csr_buffer_size(handle, descr, hyb, csr_row_ptr, &
                buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_hyb2csr_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: hyb
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), value :: buffer_size
        end function rocsparse_hyb2csr_buffer_size

!       rocsparse_hyb2csr
        function rocsparse_shyb2csr(handle, descr, hyb, csr_val, csr_row_ptr, &
                csr_col_ind, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_shyb2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: hyb
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
            type(c_ptr), value :: temp_buffer
        end function rocsparse_shyb2csr

        function rocsparse_dhyb2csr(handle, descr, hyb, csr_val, csr_row_ptr, &
                csr_col_ind, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_dhyb2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: hyb
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
            type(c_ptr), value :: temp_buffer
        end function rocsparse_dhyb2csr

        function rocsparse_chyb2csr(handle, descr, hyb, csr_val, csr_row_ptr, &
                csr_col_ind, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_chyb2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: hyb
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
            type(c_ptr), value :: temp_buffer
        end function rocsparse_chyb2csr

        function rocsparse_zhyb2csr(handle, descr, hyb, csr_val, csr_row_ptr, &
                csr_col_ind, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_zhyb2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), intent(in), value :: descr
            type(c_ptr), intent(in), value :: hyb
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
            type(c_ptr), value :: temp_buffer
        end function rocsparse_zhyb2csr

!       rocsparse_create_identity_permutation
        function rocsparse_create_identity_permutation(handle, n, p) &
                result(c_int) &
                bind(c, name = 'rocsparse_create_identity_permutation')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: p
        end function rocsparse_create_identity_permutation

!       rocsparse_csrsort_buffer_size
        function rocsparse_csrsort_buffer_size(handle, m, n, nnz, csr_row_ptr, &
                csr_col_ind, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrsort_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), intent(in), value :: csr_col_ind
            type(c_ptr), value :: buffer_size
        end function rocsparse_csrsort_buffer_size

!       rocsparse_csrsort
        function rocsparse_csrsort(handle, m, n, nnz, csr_row_ptr, &
                csr_col_ind, perm, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_csrsort')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
            type(c_ptr), value :: perm
            type(c_ptr), value :: temp_buffer
        end function rocsparse_csrsort

!       rocsparse_cscsort_buffer_size
        function rocsparse_cscsort_buffer_size(handle, m, n, nnz, csc_col_ptr, &
                csc_row_ind, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_cscsort_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: csc_col_ptr
            type(c_ptr), intent(in), value :: csc_row_ind
            type(c_ptr), value :: buffer_size
        end function rocsparse_cscsort_buffer_size

!       rocsparse_cscsort
        function rocsparse_cscsort(handle, m, n, nnz, csc_col_ptr, &
                csc_row_ind, perm, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_cscsort')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: csc_col_ptr
            type(c_ptr), value :: csc_row_ind
            type(c_ptr), value :: perm
            type(c_ptr), value :: temp_buffer
        end function rocsparse_cscsort

!       rocsparse_coosort_buffer_size
        function rocsparse_coosort_buffer_size(handle, m, n, nnz, coo_row_ind, &
                coo_col_ind, buffer_size) &
                result(c_int) &
                bind(c, name = 'rocsparse_coosort_buffer_size')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), intent(in), value :: coo_row_ind
            type(c_ptr), intent(in), value :: coo_col_ind
            type(c_ptr), value :: buffer_size
        end function rocsparse_coosort_buffer_size

!       rocsparse_coosort_by_row
        function rocsparse_coosort_by_row(handle, m, n, nnz, coo_row_ind, &
                coo_col_ind, perm, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_coosort_by_row')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), value :: coo_row_ind
            type(c_ptr), value :: coo_col_ind
            type(c_ptr), value :: perm
            type(c_ptr), value :: temp_buffer
        end function rocsparse_coosort_by_row

!       rocsparse_coosort_by_column
        function rocsparse_coosort_by_column(handle, m, n, nnz, coo_row_ind, &
                coo_col_ind, perm, temp_buffer) &
                result(c_int) &
                bind(c, name = 'rocsparse_coosort_by_column')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: m
            integer(c_int), value :: n
            integer(c_int), value :: nnz
            type(c_ptr), value :: coo_row_ind
            type(c_ptr), value :: coo_col_ind
            type(c_ptr), value :: perm
            type(c_ptr), value :: temp_buffer
        end function rocsparse_coosort_by_column

!       rocsparse_bsr2csr
        function rocsparse_sbsr2csr(handle, dir, mb, nb, bsr_descr, bsr_val, bsr_row_ptr, &
                bsr_col_ind, block_dim, csr_descr, csr_val, csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_sbsr2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: mb
            integer(c_int), value :: nb
            type(c_ptr), intent(in), value :: bsr_descr
            type(c_ptr), intent(in), value :: bsr_val
            type(c_ptr), intent(in), value :: bsr_row_ptr
            type(c_ptr), intent(in), value :: bsr_col_ind
            integer(c_int), value :: block_dim
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_sbsr2csr

        function rocsparse_dbsr2csr(handle, dir, mb, nb, bsr_descr, bsr_val, bsr_row_ptr, &
                bsr_col_ind, block_dim, csr_descr, csr_val, csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_dbsr2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: mb
            integer(c_int), value :: nb
            type(c_ptr), intent(in), value :: bsr_descr
            type(c_ptr), intent(in), value :: bsr_val
            type(c_ptr), intent(in), value :: bsr_row_ptr
            type(c_ptr), intent(in), value :: bsr_col_ind
            integer(c_int), value :: block_dim
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_dbsr2csr

        function rocsparse_cbsr2csr(handle, dir, mb, nb, bsr_descr, bsr_val, bsr_row_ptr, &
                bsr_col_ind, block_dim, csr_descr, csr_val, csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_cbsr2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: mb
            integer(c_int), value :: nb
            type(c_ptr), intent(in), value :: bsr_descr
            type(c_ptr), intent(in), value :: bsr_val
            type(c_ptr), intent(in), value :: bsr_row_ptr
            type(c_ptr), intent(in), value :: bsr_col_ind
            integer(c_int), value :: block_dim
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_cbsr2csr

        function rocsparse_zbsr2csr(handle, dir, mb, nb, bsr_descr, bsr_val, bsr_row_ptr, &
                bsr_col_ind, block_dim, csr_descr, csr_val, csr_row_ptr, csr_col_ind) &
                result(c_int) &
                bind(c, name = 'rocsparse_zbsr2csr')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: dir
            integer(c_int), value :: mb
            integer(c_int), value :: nb
            type(c_ptr), intent(in), value :: bsr_descr
            type(c_ptr), intent(in), value :: bsr_val
            type(c_ptr), intent(in), value :: bsr_row_ptr
            type(c_ptr), intent(in), value :: bsr_col_ind
            integer(c_int), value :: block_dim
            type(c_ptr), intent(in), value :: csr_descr
            type(c_ptr), value :: csr_val
            type(c_ptr), value :: csr_row_ptr
            type(c_ptr), value :: csr_col_ind
        end function rocsparse_zbsr2csr

    end interface

    contains
        subroutine rocsparseCheck(rocsparseError_t)
            implicit none
            integer(kind(rocsparse_status_success)) :: rocsparseError_t
            if (rocsparseError_t /= rocsparse_status_success) then
                write(*,*) "ROCSPARSE ERROR: Error code = ", rocsparseError_t
                call exit(rocsparseError_t)
            end if
        end subroutine rocsparseCheck

end module rocsparse

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_rocrand_enums
  implicit none

  enum, bind(c)
    enumerator :: ROCRAND_STATUS_SUCCESS = 0
    enumerator :: ROCRAND_STATUS_VERSION_MISMATCH = 100
    enumerator :: ROCRAND_STATUS_NOT_CREATED = 101
    enumerator :: ROCRAND_STATUS_ALLOCATION_FAILED = 102
    enumerator :: ROCRAND_STATUS_TYPE_ERROR = 103
    enumerator :: ROCRAND_STATUS_OUT_OF_RANGE = 104
    enumerator :: ROCRAND_STATUS_LENGTH_NOT_MULTIPLE = 105
    enumerator :: ROCRAND_STATUS_DOUBLE_PRECISION_REQUIRED = 106
    enumerator :: ROCRAND_STATUS_LAUNCH_FAILURE = 107
    enumerator :: ROCRAND_STATUS_INTERNAL_ERROR = 108
  end enum

  enum, bind(c)
    enumerator :: ROCRAND_RNG_PSEUDO_DEFAULT = 400
    enumerator :: ROCRAND_RNG_PSEUDO_XORWOW = 401
    enumerator :: ROCRAND_RNG_PSEUDO_MRG32K3A = 402
    enumerator :: ROCRAND_RNG_PSEUDO_MTGP32 = 403
    enumerator :: ROCRAND_RNG_PSEUDO_PHILOX4_32_10 = 404
    enumerator :: ROCRAND_RNG_QUASI_DEFAULT = 500
    enumerator :: ROCRAND_RNG_QUASI_SOBOL32 = 501
    enumerator :: ROCRAND_RNG_QUASI_SOBOL64 = 504
  end enum

 

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_rocrand_enums

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_hipsolver_enums
  implicit none

  enum, bind(c)
    enumerator :: HIPSOLVER_STATUS_SUCCESS = 0
    enumerator :: HIPSOLVER_STATUS_NOT_INITIALIZED = 1
    enumerator :: HIPSOLVER_STATUS_ALLOC_FAILED = 2
    enumerator :: HIPSOLVER_STATUS_INVALID_VALUE = 3
    enumerator :: HIPSOLVER_STATUS_MAPPING_ERROR = 4
    enumerator :: HIPSOLVER_STATUS_EXECUTION_FAILED = 5
    enumerator :: HIPSOLVER_STATUS_INTERNAL_ERROR = 6
    enumerator :: HIPSOLVER_STATUS_NOT_SUPPORTED = 7
    enumerator :: HIPSOLVER_STATUS_ARCH_MISMATCH = 8
    enumerator :: HIPSOLVER_STATUS_HANDLE_IS_NULLPTR = 9
    enumerator :: HIPSOLVER_STATUS_INVALID_ENUM = 10
    enumerator :: HIPSOLVER_STATUS_UNKNOWN = 11
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVER_OP_N = 111
    enumerator :: HIPSOLVER_OP_T = 112
    enumerator :: HIPSOLVER_OP_C = 113
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVER_FILL_MODE_UPPER = 121
    enumerator :: HIPSOLVER_FILL_MODE_LOWER = 122
    enumerator :: HIPSOLVER_FILL_MODE_FULL = 123
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVER_SIDE_LEFT = 141
    enumerator :: HIPSOLVER_SIDE_RIGHT = 142
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVER_EIG_MODE_NOVECTOR = 201
    enumerator :: HIPSOLVER_EIG_MODE_VECTOR = 202
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVER_EIG_TYPE_1 = 211
    enumerator :: HIPSOLVER_EIG_TYPE_2 = 212
    enumerator :: HIPSOLVER_EIG_TYPE_3 = 213
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVER_EIG_RANGE_ALL = 221
    enumerator :: HIPSOLVER_EIG_RANGE_V = 222
    enumerator :: HIPSOLVER_EIG_RANGE_I = 223
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVER_DETERMINISTIC_RESULTS = 241
    enumerator :: HIPSOLVER_ALLOW_NON_DETERMINISTIC_RESULTS = 242
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVER_ALG_0 = 231
    enumerator :: HIPSOLVER_ALG_1 = 232
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVERDN_GETRF = 0
  end enum
 
  enum, bind(c)
    enumerator :: HIPSOLVERRF_FACTORIZATION_ALG0 = 0
    enumerator :: HIPSOLVERRF_FACTORIZATION_ALG1 = 1
    enumerator :: HIPSOLVERRF_FACTORIZATION_ALG2 = 2
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVERRF_MATRIX_FORMAT_CSR = 0
    enumerator :: HIPSOLVERRF_MATRIX_FORMAT_CSC = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVERRF_NUMERIC_BOOST_NOT_USED = 0
    enumerator :: HIPSOLVERRF_NUMERIC_BOOST_USED = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVERRF_RESET_VALUES_FAST_MODE_OFF = 0
    enumerator :: HIPSOLVERRF_RESET_VALUES_FAST_MODE_ON = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVERRF_TRIANGULAR_SOLVE_ALG1 = 1
    enumerator :: HIPSOLVERRF_TRIANGULAR_SOLVE_ALG2 = 2
    enumerator :: HIPSOLVERRF_TRIANGULAR_SOLVE_ALG3 = 3
  end enum

  enum, bind(c)
    enumerator :: HIPSOLVERRF_UNIT_DIAGONAL_STORED_L = 0
    enumerator :: HIPSOLVERRF_UNIT_DIAGONAL_STORED_U = 1
    enumerator :: HIPSOLVERRF_UNIT_DIAGONAL_ASSUMED_L = 2
    enumerator :: HIPSOLVERRF_UNIT_DIAGONAL_ASSUMED_U = 3
  end enum

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_hipsolver_enums

program hipfft_example
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipfft

  implicit none

  integer(c_size_t), parameter :: N = 16
  integer(c_size_t), parameter :: Nbytes = N * 8 * 2

  type double2
     double precision :: x
     double precision :: y
  end type double2

  type(double2), allocatable, target, dimension(:) :: hx
  integer(c_int) :: direction = HIPFFT_FORWARD
  type(c_ptr) :: dx = c_null_ptr
  type(c_ptr) :: plan = c_null_ptr
  integer(c_size_t), allocatable, target, dimension(:) :: lengths
  integer(c_size_t), parameter :: one = 1
  integer :: i
  integer(kind(HIPFFT_SUCCESS)) :: ierr
  double precision :: error
  double precision, parameter :: error_max = epsilon(error)

  write(*,"(a)",advance="no") "-- Running test 'hipFFT' (Fortran 2003 interfaces) - "

  allocate(lengths(3))
  lengths(1) = N

  allocate(hx(N))
  hx(:)%x = 1
  hx(:)%y = -1

  call hipCheck(hipMalloc(dx, Nbytes))
  call hipCheck(hipMemcpy(dx, c_loc(hx(1)), Nbytes, hipMemcpyHostToDevice))

  call hipfftCheck(hipfftPlan1d(plan, int(N, 4), HIPFFT_Z2Z, 1))

  call hipfftCheck(hipfftExecZ2Z(plan, dx, dx, direction))
  

  call hipCheck(hipDeviceSynchronize())


  call hipCheck(hipMemcpy(c_loc(hx(1)),dx,Nbytes,hipMemcpyDeviceToHost))
  call hipCheck(hipFree(dx))

  ! Using the C++ version of this as the "gold".
  ! first components were \pm 16 and the remaining componenents
  ! were zero, so the sum of each component pair should be zero
  do i = 1,N
     error = abs(hx(i) % x + hx(i) % y)
     if(error > error_max)then
        write(*,*) "FAILED! Error = ", error, "hx(i)%x = ", hx(i)%x, "hx(i)%y = "
     end if
  end do

  deallocate(hx)
  deallocate(lengths)

  
  call hipfftcheck( hipfftDestroy(plan))

  write(*,*) "PASSED!"

end program hipfft_example

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc.
!
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
!
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program rocsparse_ddoti_test

    use iso_c_binding
    use hipfort
    use hipfort_check
    use hipfort_rocsparse

    implicit none

    integer, target :: h_xind(3)
    real(8), target :: h_xval(3), h_y(9)
    real(8), target :: h_dot

    type(c_ptr) :: d_xind
    type(c_ptr) :: d_xval
    type(c_ptr) :: d_y
    type(c_ptr) :: d_dot

    integer :: i
    integer(c_int) :: M, nnz

    type(c_ptr) :: handle
  
    write(*,"(a)",advance="no") "-- Running test 'ddoti' (Fortran 2003 interfaces) - "

!   Input data

!   Number of rows
    M = 9

!   Number of non-zero entries
    nnz = 3

!   Fill structures
    h_xind = (/0, 3, 5/)
    h_xval = (/1, 2, 3/)
    h_y    = (/1, 2, 3, 4, 5, 6, 7, 8, 9/)

!   Allocate device memory
    call hipCheck(hipMalloc(d_xind, (int(nnz, c_size_t) + 1) * 4))
    call hipCheck(hipMalloc(d_xval, int(nnz, c_size_t) * 8))
    call hipCheck(hipMalloc(d_y, int(M, c_size_t) * 8))
    call hipCheck(hipMalloc(d_dot, int(8, c_size_t)))

!   Copy host data to device
    call hipCheck(hipMemcpy(d_xind, c_loc(h_xind(1)), (int(nnz, c_size_t) + 1) * 4, hipMemcpyHostToDevice))
    call hipCheck(hipMemcpy(d_xval, c_loc(h_xval(1)), int(nnz, c_size_t) * 8, hipMemcpyHostToDevice))
    call hipCheck(hipMemcpy(d_y, c_loc(h_y(1)), int(M, c_size_t) * 8, hipMemcpyHostToDevice))

!   Create rocSPARSE handle
    call rocsparseCheck(rocsparse_create_handle(handle))
    call rocsparseCheck(rocsparse_set_pointer_mode(handle, rocsparse_pointer_mode_device))

!   Call ddoti
    call rocsparseCheck(rocsparse_ddoti(handle, &
                                        nnz, &
                                        d_xval, &
                                        d_xind, &
                                        d_y, &
                                        d_dot, &
                                        rocsparse_index_base_zero))

!   Copy result back to host
    call hipCheck(hipMemcpy(c_loc(h_dot), d_dot, int(8, c_size_t), hipMemcpyDeviceToHost))

!   Verification
    if(h_dot /= 27d0) then
        write(*,*) 'FAILED!'
        call exit
    end if

!   Clear rocSPARSE
    call rocsparseCheck(rocsparse_destroy_handle(handle))

!   Clear device memory
    call hipCheck(hipFree(d_xind))
    call hipCheck(hipFree(d_xval))
    call hipCheck(hipFree(d_y))
    call hipCheck(hipFree(d_dot))

!   Print success
    write(*,*) 'PASSED!'

end program rocsparse_ddoti_test

program hip_scopy
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none

  integer :: n = 6
  type(c_ptr) :: handle = c_null_ptr
  integer :: j
  real, allocatable, target, dimension(:) :: x, y
  integer, parameter :: bytes_per_element = 4 !float precision
 
  real, pointer, dimension(:) :: dx,dy

  real :: error
  real, parameter :: error_max = 10*epsilon(error)

  allocate(x(n))
  allocate(y(n))

  do j = 1,n
    x(j) = j
   ! write(*,*) "value of x(j)" , x(j)
  end do

  write(*,"(a)",advance="no") "-- Running test 'Scopy' (Fortran 2008 interfaces) - "

  do j = 1,n
    y(j) = x(j)
   ! write(*,*) "value of y(j)" , y(j)
  end do
  
  call hipblasCheck(hipblasCreate(handle))

  call hipCheck(hipMalloc(dx,source=x))
  call hipCheck(hipMalloc(dy,source=y))

  call hipblasCheck(hipblasScopy(handle,n,dx,1,dy,1))

  call hipCheck(hipDeviceSynchronize())

  call hipCheck(hipMemcpy(y, dy, hipMemcpyDeviceToHost))

  do j = 1,n
    error = abs(y(j) - x(j))
      if( error > error_max )then
        write(*,*) "FAILED! Error bigger than max! Error = ", error
        call exit(1)
      end if
  end do

  call hipCheck(hipFree(dx))
  call hipCheck(hipFree(dy))

  call hipblasCheck(hipblasDestroy(handle))

  deallocate(x,y)

  write(*,*) "PASSED!"
  
end program hip_scopy

program hip_dger

  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none

  integer, parameter ::  m = 100, n = 100
  double precision, parameter ::  alpha = 1.1d0

  double precision, allocatable, target, dimension(:)   :: hx, hy
  double precision, allocatable, target, dimension(:,:) :: hA

  type(c_ptr) :: handle = c_null_ptr
  
  double precision, pointer, dimension(:)   :: dx, dy
  double precision, pointer, dimension(:,:) :: dA

  integer :: i,j
  double precision :: error

  write(*,"(a)",advance="no") "-- Running test 'dger' (Fortran 2008 interfaces) - "

  call hipblasCheck(hipblasCreate(handle))

  allocate(hx(m))
  allocate(hy(n))
  allocate(ha(m,n))

  hx(:)   = 1.d0
  hy(:)   = 1.d0
  hA(:,:) = 1.d0

  ! Allocate device memory
  call hipCheck(hipMalloc(dx,m))
  call hipCheck(hipMalloc(dy,n))
  call hipCheck(hipMalloc(dA,m,n))

  !Transfer from host to device
  call hipCheck(hipMemcpy(dx, hx, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dy, hy, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dA, hA, hipMemcpyHostToDevice))

  call hipblasCheck(hipblasDger(handle,m,n,alpha,dx,1,dy,1,dA,m))

  call hipCheck(hipDeviceSynchronize())

  ! Transfer data back to host memory
  call hipCheck(hipMemcpy(hA, dA, hipMemcpyDeviceToHost))

  do j = 1,n
    do i = 1,m
     error = abs(2.1d0 - hA(i,j))
     if( error > 10*epsilon(error) )then
        write(*,*) "FAILED! Error bigger than max! Error = ", error, "hA(i,j) = ", hA(i,j)
        call exit(1)
     end if
   end do
  end do

  call hipCheck(hipFree(dx))
  call hipCheck(hipFree(dy))
  call hipCheck(hipFree(dA))

  call hipblasCheck(hipblasDestroy(handle))

  deallocate(hx,hy,hA)

  write(*,*) "PASSED!"

end program hip_dger

program rocfft_example
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_rocfft

  implicit none

  integer(c_size_t), parameter :: N=16

  complex(8), allocatable, target, dimension(:) :: hx
  complex(8), pointer, dimension(:) :: dx => null()
  type(c_ptr) :: plan = c_null_ptr
  integer(c_size_t), allocatable, target, dimension(:) :: lengths
  integer(c_size_t), parameter :: one = 1
  integer :: i
  double precision :: error
  double precision, parameter :: error_max = epsilon(error)


  allocate(lengths(3))
  lengths(1) = N
  allocate(hx(N))
  hx(:) = (1., -1.)
  
  call hipCheck(hipMalloc(dx,source=hx))
  
  write(*,"(a)",advance="no") "-- Running test 'rocFFT' (Fortran 2008 interfaces) - "

  call rocfftCheck(rocfft_setup())
  call rocfftCheck(rocfft_plan_create(plan,&
                                      rocfft_placement_inplace,&
                                      rocfft_transform_type_complex_forward,&
                                      rocfft_precision_double,&
                                      one,&
                                      c_loc(lengths),&
                                      one,&
                                      c_null_ptr))

  call rocfftCheck(rocfft_execute(plan,c_loc(dx),c_null_ptr,c_null_ptr))

  call hipCheck(hipDeviceSynchronize())

  call rocfftCheck(rocfft_plan_destroy(plan))

  call hipCheck(hipMemcpy(hx,dx,hipMemcpyDeviceToHost))
  call hipCheck(hipFree(dx))

  ! Using the C++ version of this as the "gold".
  ! first components were \pm 16 and the remaining componenents
  ! were zero, so the sum of each component pair should be zero
  do i = 1,N
     error = DBLE(hx(i)) + AIMAG(hx(i))
     if(error > error_max)then
        write(*,*) "FAILED! Error = ", error, "hx(i)=",hx(i)
        STOP 1
     end if
  end do

  deallocate(hx)
  deallocate(lengths)

  call rocfftCheck(rocfft_cleanup())

  write(*,*) "PASSED!"

end program rocfft_example

program hip_dgemm
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none

  integer(kind(HIPBLAS_OP_N)), parameter :: transa = HIPBLAS_OP_N, transb = HIPBLAS_OP_N;
  complex(kind=4), parameter ::  alpha = 1.1d0, beta = 0.9d0;

  integer, parameter ::  m = 512, n = 512, k = 512;
  integer :: lda, ldb, ldc, size_a, size_b, size_c;

  complex(kind=4), allocatable, target, dimension(:,:) :: ha, hb, hc
  complex(kind=4), allocatable, dimension(:,:) :: hc_exact

  type(c_ptr) :: da = c_null_ptr, db = c_null_ptr, dc = c_null_ptr
  type(c_ptr) :: handle = c_null_ptr

  integer, parameter :: bytes_per_element = 8 ! 2x float
  integer(c_size_t) :: Nabytes, Nbbytes, Ncbytes

  integer :: i,j
  double precision :: error
  double precision, parameter :: error_max = 10*epsilon(error)

  write(*,"(a)",advance="no") "-- Running test 'CGEMM' (Fortran 2003 interfaces) - "

  call hipblasCheck(hipblasCreate(handle))

  lda        = m;
  size_a     = k * lda;
  Nabytes = size_a*bytes_per_element

  ldb        = k;
  size_b     = n * ldb;
  Nbbytes = size_b*bytes_per_element

  ldc    = m;
  size_c = n * ldc;
  Ncbytes = size_c*bytes_per_element

  ! C = A_MxK * B_KxN
  
  allocate(ha(m,k))
  allocate(hb(k,n))
  allocate(hc(m,n))
  allocate(hc_exact(m,n))

  ! Use these constant matrices so the exact answer is also a
  ! constant matrix and therefore easy to check
  ha(:,:) = 1.d0
  hb(:,:) = 2.d0
  hc(:,:) = 3.d0
  hc_exact(:,:) = alpha*k*2.d0 + beta*3.d0

  ! Allocate device memory
  call hipCheck(hipMalloc(da,Nabytes))
  call hipCheck(hipMalloc(db,Nbbytes))
  call hipCheck(hipMalloc(dc,Ncbytes))

  !Transfer from host to device
  call hipCheck(hipMemcpy(da, c_loc(ha(1,1)), Nabytes, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(db, c_loc(hb(1,1)), Nbbytes, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dc, c_loc(hc(1,1)), Ncbytes, hipMemcpyHostToDevice))

  call hipblasCheck(hipblasCgemm(handle,transa,transb,m,n,k,alpha,da,lda,db,ldb,beta,dc,ldc))

  call hipCheck(hipDeviceSynchronize())

  ! Transfer data back to host memory
  call hipCheck(hipMemcpy(c_loc(hc(1,1)), dc, Ncbytes, hipMemcpyDeviceToHost))

  do i = 1,m
  do j = 1,n
     !write(*,*) "hc(i,j)=",hc(i,j),",hc_exact(i,j)=",hc_exact(i,j)
     error = abs((hc_exact(i,j) - hc(i,j))/hc_exact(i,j))
     if( error > error_max )then
        write(*,*) "FAILED! Error bigger than max! Error = ", error
        call exit(1)
     end if
  end do
  end do

  call hipCheck(hipFree(da))
  call hipCheck(hipFree(db))
  call hipCheck(hipFree(dc))

  call hipblasCheck(hipblasDestroy(handle))

  deallocate(ha)
  deallocate(hb)
  deallocate(hc)
  deallocate(hc_exact)

  write(*,*) "PASSED!"

end program hip_dgemm

program hipfft_example
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipfft

  implicit none

  integer(c_int), parameter :: N = 16

  complex(8), allocatable, dimension(:) :: hx
  integer(c_int) :: direction = HIPFFT_FORWARD
  complex(8), pointer, dimension(:) :: dx
  type(c_ptr) :: plan = c_null_ptr
  integer(c_size_t)            :: lengths(3)
  integer(c_size_t), parameter :: one = 1
  integer :: i
  integer(kind(HIPFFT_SUCCESS)) :: ierr
  double precision :: error
  double precision, parameter :: error_max = epsilon(error)

  write(*,"(a)",advance="no") "-- Running test 'hipFFT' (Fortran 2008 interfaces) - "

  lengths(1) = N

  allocate(hx(N))
  hx(:) = (1, -1)

  call hipCheck(hipMalloc(dx, source=hx))

  call hipfftCheck(hipfftPlan1d(plan, N, HIPFFT_Z2Z, 1))

  call hipfftCheck(hipfftExecZ2Z(plan, dx, dx, direction))
  
  call hipCheck(hipDeviceSynchronize())

  call hipCheck(hipMemcpy(hx,dx,hipMemcpyDeviceToHost))
  call hipCheck(hipFree(dx))

  ! Using the C++ version of this as the "gold".
  ! first components were \pm 16 and the remaining componenents
  ! were zero, so the sum of each component pair should be zero
  do i = 1,N
     error = abs(DBLE(hx(i)) + AIMAG(hx(i)))
     if(error > error_max)then
        write(*,*) "FAILED! Error = ", error, "hx(i)%x = ", DBLE(hx(i)), "hx(i)%y = ", AIMAG(hx(i))
     end if
  end do

  deallocate(hx)

  call hipfftcheck( hipfftDestroy(plan))

  write(*,*) "PASSED!"
end program hipfft_example

program hip_dgemm
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none

  integer(kind(HIPBLAS_OP_N)), parameter :: transa = HIPBLAS_OP_N, transb = HIPBLAS_OP_N;
  complex(kind=4), parameter ::  alpha = 1.1d0, beta = 0.9d0;

  integer, parameter :: m = 512, n = 512, k = 512;

  complex(kind=4), allocatable, dimension(:,:) :: ha, hb, hc
  complex(kind=4), allocatable, dimension(:,:) :: hc_exact

  complex(kind=4), pointer, dimension(:,:) :: da, db, dc
  type(c_ptr) :: handle = c_null_ptr

  integer :: i,j
  double precision :: error
  double precision, parameter :: error_max = 10*epsilon(error)

  write(*,"(a)",advance="no") "-- Running test 'CGEMM' (Fortran 2008 interfaces) - "

  call hipblasCheck(hipblasCreate(handle))

  ! C = A_MxK * B_KxN
  
  allocate(ha(m,k))
  allocate(hb(k,n))
  allocate(hc(m,n))
  allocate(hc_exact(m,n))

  ! Use these constant matrices so the exact answer is also a
  ! constant matrix and therefore easy to check
  ha(:,:) = 1.d0
  hb(:,:) = 2.d0
  hc(:,:) = 3.d0
  hc_exact(:,:) = alpha*k*2.d0 + beta*3.d0

  ! Allocate device memory
  call hipCheck(hipMalloc(da,mold=ha))
  call hipCheck(hipMalloc(db,mold=hb))
  call hipCheck(hipMalloc(dc,mold=hc))

  !Transfer from host to device
  call hipCheck(hipMemcpy(da, ha, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(db, hb, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dc, hc, hipMemcpyHostToDevice))

  call hipblasCheck(hipblasCgemm(handle,transa,transb,m,n,k,alpha,da,size(da,1),db,size(db,1),beta,dc,size(dc,1)))

  call hipCheck(hipDeviceSynchronize())

  ! Transfer data back to host memory
  call hipCheck(hipMemcpy(hc, dc, hipMemcpyDeviceToHost))

  do j = 1,n
    do i = 1,m
      !write(*,*) "hc(i,j)=",hc(i,j),",hc_exact(i,j)=",hc_exact(i,j)
      error = abs((hc_exact(i,j) - hc(i,j))/hc_exact(i,j))
      if( error > error_max )then
         write(*,*) "FAILED! Error bigger than max! Error = ", error
         call exit(1)
      end if
    end do
  end do

  call hipCheck(hipFree(da))
  call hipCheck(hipFree(db))
  call hipCheck(hipFree(dc))

  call hipblasCheck(hipblasDestroy(handle))

  deallocate(ha,hb,hc,hc_exact)

  write(*,*) "PASSED!"

end program hip_dgemm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_hipblas_enums
  implicit none

  enum, bind(c)
    enumerator :: HIPBLAS_STATUS_SUCCESS = 0
    enumerator :: HIPBLAS_STATUS_NOT_INITIALIZED = 1
    enumerator :: HIPBLAS_STATUS_ALLOC_FAILED = 2
    enumerator :: HIPBLAS_STATUS_INVALID_VALUE = 3
    enumerator :: HIPBLAS_STATUS_MAPPING_ERROR = 4
    enumerator :: HIPBLAS_STATUS_EXECUTION_FAILED = 5
    enumerator :: HIPBLAS_STATUS_INTERNAL_ERROR = 6
    enumerator :: HIPBLAS_STATUS_NOT_SUPPORTED = 7
    enumerator :: HIPBLAS_STATUS_ARCH_MISMATCH = 8
    enumerator :: HIPBLAS_STATUS_HANDLE_IS_NULLPTR = 9
    enumerator :: HIPBLAS_STATUS_INVALID_ENUM = 10
    enumerator :: HIPBLAS_STATUS_UNKNOWN = 11
  end enum

  enum, bind(c)
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_OP_N = 0
#else
    enumerator :: HIPBLAS_OP_N = 111
#endif
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_OP_T = 1
#else
    enumerator :: HIPBLAS_OP_T = 112
#endif
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_OP_C = 2
#else
    enumerator :: HIPBLAS_OP_C = 113
#endif
  end enum

  enum, bind(c)
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_POINTER_MODE_HOST = 0
#else
    enumerator :: HIPBLAS_POINTER_MODE_HOST
#endif
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_POINTER_MODE_DEVICE = 1
#else
    enumerator :: HIPBLAS_POINTER_MODE_DEVICE
#endif
  end enum

  enum, bind(c)
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_FILL_MODE_UPPER = 1
#else
    enumerator :: HIPBLAS_FILL_MODE_UPPER = 121
#endif
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_FILL_MODE_LOWER = 0
#else
    enumerator :: HIPBLAS_FILL_MODE_LOWER = 122
#endif
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_FILL_MODE_FULL = 2
#else
    enumerator :: HIPBLAS_FILL_MODE_FULL = 123
#endif
  end enum

  enum, bind(c)
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_DIAG_NON_UNIT = 0
#else
    enumerator :: HIPBLAS_DIAG_NON_UNIT = 131
#endif
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_DIAG_UNIT = 1
#else
    enumerator :: HIPBLAS_DIAG_UNIT = 132
#endif
  end enum

  enum, bind(c)
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_SIDE_LEFT = 0
#else
    enumerator :: HIPBLAS_SIDE_LEFT = 141
#endif
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_SIDE_RIGHT = 1
#else
    enumerator :: HIPBLAS_SIDE_RIGHT = 142
#endif
    enumerator :: HIPBLAS_SIDE_BOTH = 143
  end enum

  enum, bind(c)
    enumerator :: HIPBLAS_R_16F = 150
    enumerator :: HIPBLAS_R_32F = 151
    enumerator :: HIPBLAS_R_64F = 152
    enumerator :: HIPBLAS_C_16F = 153
    enumerator :: HIPBLAS_C_32F = 154
    enumerator :: HIPBLAS_C_64F = 155
    enumerator :: HIPBLAS_R_8I = 160
    enumerator :: HIPBLAS_R_8U = 161
    enumerator :: HIPBLAS_R_32I = 162
    enumerator :: HIPBLAS_R_32U = 163
    enumerator :: HIPBLAS_C_8I = 164
    enumerator :: HIPBLAS_C_8U = 165
    enumerator :: HIPBLAS_C_32I = 166
    enumerator :: HIPBLAS_C_32U = 167
    enumerator :: HIPBLAS_R_16B = 168
    enumerator :: HIPBLAS_C_16B = 169
  end enum

  enum, bind(c)
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_GEMM_DEFAULT = -1
#else
    enumerator :: HIPBLAS_GEMM_DEFAULT = 160
#endif
  end enum

  enum, bind(c)
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_ATOMICS_NOT_ALLOWED = 0
#else
    enumerator :: HIPBLAS_ATOMICS_NOT_ALLOWED = 0
#endif
#ifdef USE_CUDA_NAMES
    enumerator :: HIPBLAS_ATOMICS_ALLOWED = 1
#else
    enumerator :: HIPBLAS_ATOMICS_ALLOWED = 1
#endif
  end enum

 

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_hipblas_enums

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_rocsparse_enums
  implicit none

  enum, bind(c)
    enumerator :: rocsparse_operation_none = 111
    enumerator :: rocsparse_operation_transpose = 112
    enumerator :: rocsparse_operation_conjugate_transpose = 113
  end enum

  enum, bind(c)
    enumerator :: rocsparse_index_base_zero = 0
    enumerator :: rocsparse_index_base_one = 1
  end enum

  enum, bind(c)
    enumerator :: rocsparse_matrix_type_general = 0
    enumerator :: rocsparse_matrix_type_symmetric = 1
    enumerator :: rocsparse_matrix_type_hermitian = 2
    enumerator :: rocsparse_matrix_type_triangular = 3
  end enum

  enum, bind(c)
    enumerator :: rocsparse_diag_type_non_unit = 0
    enumerator :: rocsparse_diag_type_unit = 1
  end enum

  enum, bind(c)
    enumerator :: rocsparse_fill_mode_lower = 0
    enumerator :: rocsparse_fill_mode_upper = 1
  end enum

  enum, bind(c)
    enumerator :: rocsparse_action_symbolic = 0
    enumerator :: rocsparse_action_numeric = 1
  end enum

  enum, bind(c)
    enumerator :: rocsparse_direction_row = 0
    enumerator :: rocsparse_direction_column = 1
  end enum

  enum, bind(c)
    enumerator :: rocsparse_hyb_partition_auto = 0
    enumerator :: rocsparse_hyb_partition_user = 1
    enumerator :: rocsparse_hyb_partition_max = 2
  end enum

  enum, bind(c)
    enumerator :: rocsparse_analysis_policy_reuse = 0
    enumerator :: rocsparse_analysis_policy_force = 1
  end enum

  enum, bind(c)
    enumerator :: rocsparse_solve_policy_auto = 0
  end enum

  enum, bind(c)
    enumerator :: rocsparse_pointer_mode_host = 0
    enumerator :: rocsparse_pointer_mode_device = 1
  end enum

  enum, bind(c)
    enumerator :: rocsparse_layer_mode_none = 0
    enumerator :: rocsparse_layer_mode_log_trace = 1
    enumerator :: rocsparse_layer_mode_log_bench = 2
  end enum

  enum, bind(c)
    enumerator :: rocsparse_status_success = 0
    enumerator :: rocsparse_status_invalid_handle = 1
    enumerator :: rocsparse_status_not_implemented = 2
    enumerator :: rocsparse_status_invalid_pointer = 3
    enumerator :: rocsparse_status_invalid_size = 4
    enumerator :: rocsparse_status_memory_error = 5
    enumerator :: rocsparse_status_internal_error = 6
    enumerator :: rocsparse_status_invalid_value = 7
    enumerator :: rocsparse_status_arch_mismatch = 8
    enumerator :: rocsparse_status_zero_pivot = 9
    enumerator :: rocsparse_status_not_initialized = 10
    enumerator :: rocsparse_status_type_mismatch = 11
  end enum

  enum, bind(c)
    enumerator :: rocsparse_indextype_u16 = 1
    enumerator :: rocsparse_indextype_i32 = 2
    enumerator :: rocsparse_indextype_i64 = 3
  end enum

  enum, bind(c)
    enumerator :: rocsparse_datatype_f32_r = 151
    enumerator :: rocsparse_datatype_f64_r = 152
    enumerator :: rocsparse_datatype_f32_c = 154
    enumerator :: rocsparse_datatype_f64_c = 155
  end enum

  enum, bind(c)
    enumerator :: rocsparse_format_coo = 0
    enumerator :: rocsparse_format_coo_aos = 1
    enumerator :: rocsparse_format_csr = 2
    enumerator :: rocsparse_format_csc = 3
    enumerator :: rocsparse_format_ell = 4
    enumerator :: rocsparse_format_bell = 5
  end enum

  enum, bind(c)
    enumerator :: rocsparse_order_row = 0
    enumerator :: rocsparse_order_column = 1
  end enum

  enum, bind(c)
    enumerator :: rocsparse_spmat_fill_mode = 0
    enumerator :: rocsparse_spmat_diag_type = 1
    enumerator :: rocsparse_spmat_matrix_type = 2
  end enum

  enum, bind(c)
    enumerator :: rocsparse_spmv_alg_default = 0
    enumerator :: rocsparse_spmv_alg_coo = 1
    enumerator :: rocsparse_spmv_alg_csr_adaptive = 2
    enumerator :: rocsparse_spmv_alg_csr_stream = 3
    enumerator :: rocsparse_spmv_alg_ell = 4
  end enum

  enum, bind(c)
    enumerator :: rocsparse_spsv_alg_default = 0
  end enum

  enum, bind(c)
    enumerator :: rocsparse_spsv_stage_auto = 0
    enumerator :: rocsparse_spsv_stage_buffer_size = 1
    enumerator :: rocsparse_spsv_stage_preprocess = 2
    enumerator :: rocsparse_spsv_stage_compute = 3
  end enum

  enum, bind(c)
    enumerator :: rocsparse_spsm_alg_default = 0
  end enum

  enum, bind(c)
    enumerator :: rocsparse_spsm_stage_auto = 0
    enumerator :: rocsparse_spsm_stage_buffer_size = 1
    enumerator :: rocsparse_spsm_stage_preprocess = 2
    enumerator :: rocsparse_spsm_stage_compute = 3
  end enum

  enum, bind(c)
    enumerator :: rocsparse_spmm_alg_default = 0
    enumerator :: rocsparse_spmm_alg_csr
    enumerator :: rocsparse_spmm_alg_coo_segmented
    enumerator :: rocsparse_spmm_alg_coo_atomic
    enumerator :: rocsparse_spmm_alg_csr_row_split
    enumerator :: rocsparse_spmm_alg_csr_merge
    enumerator :: rocsparse_spmm_alg_coo_segmented_atomic
    enumerator :: rocsparse_spmm_alg_bell
  end enum

  enum, bind(c)
    enumerator :: rocsparse_sddmm_alg_default = 0
  end enum

  enum, bind(c)
    enumerator :: rocsparse_sparse_to_dense_alg_default = 0
  end enum

  enum, bind(c)
    enumerator :: rocsparse_dense_to_sparse_alg_default = 0
  end enum

  enum, bind(c)
    enumerator :: rocsparse_spmm_stage_auto = 0
    enumerator :: rocsparse_spmm_stage_buffer_size = 1
    enumerator :: rocsparse_spmm_stage_preprocess = 2
    enumerator :: rocsparse_spmm_stage_compute = 3
  end enum

  enum, bind(c)
    enumerator :: rocsparse_spgemm_stage_auto = 0
    enumerator :: rocsparse_spgemm_stage_buffer_size = 1
    enumerator :: rocsparse_spgemm_stage_nnz = 2
    enumerator :: rocsparse_spgemm_stage_compute = 3
  end enum

  enum, bind(c)
    enumerator :: rocsparse_spgemm_alg_default = 0
  end enum

 

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_rocsparse_enums

program hip_dgemm

  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none

  integer(kind(HIPBLAS_OP_N)), parameter :: transa = HIPBLAS_OP_N, transb = HIPBLAS_OP_N;
  double precision, parameter ::  alpha = 1.1d0, beta = 0.9d0;

  integer, parameter ::  m = 1024, n = 1024, k = 1024;
  integer :: lda, ldb, ldc, size_a, size_b, size_c;

  double precision, allocatable, target, dimension(:) :: ha, hb, hc
  double precision, allocatable, dimension(:) :: hc_exact

  type(c_ptr) :: da = c_null_ptr, db = c_null_ptr, dc = c_null_ptr
  type(c_ptr) :: handle = c_null_ptr

  integer, parameter :: bytes_per_element = 8 !double precision
  integer(c_size_t) :: Nabytes, Nbbytes, Ncbytes

  integer :: i
  double precision :: error
  double precision, parameter :: error_max = 10*epsilon(error)

  write(*,"(a)",advance="no") "-- Running test 'DGEMM' (Fortran 2003 interfaces) - "

  call hipblasCheck(hipblasCreate(handle))

  lda        = m;
  size_a     = k * lda;
  Nabytes = size_a*bytes_per_element

  ldb        = k;
  size_b     = n * ldb;
  Nbbytes = size_b*bytes_per_element

  ldc    = m;
  size_c = n * ldc;
  Ncbytes = size_c*bytes_per_element

  allocate(ha(size_a))
  allocate(hb(size_b))
  allocate(hc(size_c))
  allocate(hc_exact(size_c))

  ! Use these constant matrices so the exact answer is also a
  ! constant matrix and therefore easy to check
  ha(:) = 1.d0
  hb(:) = 2.d0
  hc(:) = 3.d0
  hc_exact = alpha*k*2.d0 + beta*3.d0

  ! Allocate device memory
  call hipCheck(hipMalloc(da,Nabytes))
  call hipCheck(hipMalloc(db,Nbbytes))
  call hipCheck(hipMalloc(dc,Ncbytes))

  !Transfer from host to device
  call hipCheck(hipMemcpy(da, c_loc(ha(1)), Nabytes, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(db, c_loc(hb(1)), Nbbytes, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dc, c_loc(hc(1)), Ncbytes, hipMemcpyHostToDevice))


  call hipblasCheck(hipblasDgemm(handle,transa,transb,m,n,k,alpha,da,lda,db,ldb,beta,dc,ldc))

  call hipCheck(hipDeviceSynchronize())

  ! Transfer data back to host memory
  call hipCheck(hipMemcpy(c_loc(hc(1)), dc, Ncbytes, hipMemcpyDeviceToHost))


  do i = 1,size_c
     error = abs((hc_exact(i) - hc(i))/hc_exact(i))
     if( error > error_max )then
        write(*,*) "FAILED! Error bigger than max! Error = ", error
        call exit(1)
     end if
  end do

  call hipCheck(hipFree(da))
  call hipCheck(hipFree(db))
  call hipCheck(hipFree(dc))

  call hipblasCheck(hipblasDestroy(handle))

  deallocate(ha)
  deallocate(hb)
  deallocate(hc)
  deallocate(hc_exact)

  write(*,*) "PASSED!"

end program hip_dgemm

module hipfort_types
  use iso_c_binding
  implicit none

  !> Derived type that can be mapped directly to a CUDA/HIP C++ dim3.  
  type,bind(c) :: dim3
     integer(c_int) :: x=1,y=1,z=1
  end type dim3


#ifdef USE_CUDA_NAMES
  type,bind(c) :: hipDeviceProp_t  ! as of cuda 11.4
    character(kind=c_char) :: name(256)
    character(kind=c_char) :: uuid(16)
    integer(c_size_t) :: totalGlobalMem
    integer(c_size_t) :: sharedMemPerBlock
    integer(c_int) :: regsPerBlock
    integer(c_int) :: warpSize
    integer(c_size_t) :: memPitch
    integer(c_int) :: maxThreadsPerBlock
    integer(c_int) :: maxThreadsDim(3)
    integer(c_int) :: maxGridSize(3)
    integer(c_int) :: clockRate
    integer(c_size_t) :: totalConstMem
    integer(c_int) :: major
    integer(c_int) :: minor
    integer(c_size_t) :: textureAlignment
    integer(c_size_t) :: texturePitchAlignment
    integer(c_int) :: deviceOverlap
    integer(c_int) :: multiProcessorCount
    integer(c_int) :: kernelExecTimeoutEnabled
    integer(c_int) :: integrated
    integer(c_int) :: canMapHostMemory
    integer(c_int) :: computeMode
    integer(c_int) :: maxTexture1D
    integer(c_int) :: maxTexture1DMipmap
    integer(c_int) :: maxTexture1DLinear
    integer(c_int) :: maxTexture2D(2)
    integer(c_int) :: maxTexture2DMipmap(2)
    integer(c_int) :: maxTexture2DLinear(3)
    integer(c_int) :: maxTexture2DGather(2)
    integer(c_int) :: maxTexture3D(3)
    integer(c_int) :: maxTexture3DAlt(3)
    integer(c_int) :: maxTextureCubemap
    integer(c_int) :: maxTexture1DLayered(2)
    integer(c_int) :: maxTexture2DLayered(3)
    integer(c_int) :: maxTextureCubemapLayered(2)
    integer(c_int) :: maxSurface1D
    integer(c_int) :: maxSurface2D(2)
    integer(c_int) :: maxSurface3D(3)
    integer(c_int) :: maxSurface1DLayered(2)
    integer(c_int) :: maxSurface2DLayered(3)
    integer(c_int) :: maxSurfaceCubemap
    integer(c_int) :: maxSurfaceCubemapLayered(2)
    integer(c_size_t) :: surfaceAlignment
    integer(c_int) :: concurrentKernels
    integer(c_int) :: ECCEnabled
    integer(c_int) :: pciBusID
    integer(c_int) :: pciDeviceID
    integer(c_int) :: pciDomainID
    integer(c_int) :: tccDriver
    integer(c_int) :: asyncEngineCount
    integer(c_int) :: unifiedAddressing
    integer(c_int) :: memoryClockRate
    integer(c_int) :: memoryBusWidth
    integer(c_int) :: l2CacheSize
    integer(c_int) :: persistingL2CacheMaxSize
    integer(c_int) :: maxThreadsPerMultiProcessor
    integer(c_int) :: streamPrioritiesSupported
    integer(c_int) :: globalL1CacheSupported
    integer(c_int) :: localL1CacheSupported
    integer(c_size_t) :: sharedMemPerMultiprocessor
    integer(c_int) :: regsPerMultiprocessor
    integer(c_int) :: managedMemory
    integer(c_int) :: isMultiGpuBoard
    integer(c_int) :: multiGpuBoardGroupID
    integer(c_int) :: singleToDoublePrecisionPerfRatio
    integer(c_int) :: pageableMemoryAccess
    integer(c_int) :: concurrentManagedAccess
    integer(c_int) :: computePreemptionSupported
    integer(c_int) :: canUseHostPointerForRegisteredMem
    integer(c_int) :: cooperativeLaunch
    integer(c_int) :: cooperativeMultiDeviceLaunch
    integer(c_int) :: pageableMemoryAccessUsesHostPageTables
    integer(c_int) :: directManagedMemAccessFromHost
    integer(c_int) :: accessPolicyMaxWindowSize
    character(kind=c_char) :: GPUFORT_PADDING(256) !< GPUFORT :Some extra bytes to prevent seg faults in newer versions
  end type hipDeviceProp_t
#else
  type,bind(c) :: hipDeviceProp_t ! as of ROCm 4.4
    character(kind=c_char) :: name(256)            !< Device name.
    integer(c_size_t) :: totalGlobalMem     !< Size of global memory region (in bytes).
    integer(c_size_t) :: sharedMemPerBlock  !< Size of shared memory region (in bytes).
    integer(c_int) :: regsPerBlock          !< Registers per block.
    integer(c_int) :: warpSize              !< Warp size.
    integer(c_int) :: maxThreadsPerBlock    !< Max work items per work group or workgroup max size.
    integer(c_int) :: maxThreadsDim(3)      !< Max number of threads in each dimension (XYZ) of a block.
    integer(c_int) :: maxGridSize(3)        !< Max grid dimensions (XYZ).
    integer(c_int) :: clockRate             !< Max clock frequency of the multiProcessors in khz.
    integer(c_int) :: memoryClockRate       !< Max global memory clock frequency in khz.
    integer(c_int) :: memoryBusWidth        !< Global memory bus width in bits.
    integer(c_size_t) :: totalConstMem      !< Size of shared memory region (in bytes).
    integer(c_int) :: major  !< Major compute capability.  On HCC, this is an approximation and features may
                !< differ from CUDA CC.  See the arch feature flags for portable ways to query
                !< feature caps.
    integer(c_int) :: minor  !< Minor compute capability.  On HCC, this is an approximation and features may
                !< differ from CUDA CC.  See the arch feature flags for portable ways to query
                !< feature caps.
    integer(c_int) :: multiProcessorCount          !< Number of multi-processors (compute units).
    integer(c_int) :: l2CacheSize                  !< L2 cache size.
    integer(c_int) :: maxThreadsPerMultiProcessor  !< Maximum resident threads per multi-processor.
    integer(c_int) :: computeMode                  !< Compute mode.
    integer(c_int) :: clockInstructionRate  !< Frequency in khz of the timer used by the device-side "clock*"
                               !< instructions.  New for HIP.
    integer(c_int) arch       !< Architectural feature flags.  New for HIP. 
    integer(c_int) :: concurrentKernels     !< Device can possibly execute multiple kernels concurrently.
    integer(c_int) :: pciDomainID           !< PCI Domain ID
    integer(c_int) :: pciBusID              !< PCI Bus ID.
    integer(c_int) :: pciDeviceID           !< PCI Device ID.
    integer(c_size_t) :: maxSharedMemoryPerMultiProcessor  !< Maximum Shared Memory Per Multiprocessor.
    integer(c_int) :: isMultiGpuBoard                      !< 1 if device is on a multi-GPU board, 0 if not.
    integer(c_int) :: canMapHostMemory                     !< Check whether HIP can map host memory
    integer(c_int) :: gcnArch                              !< DEPRECATED: use gcnArchName instead
    character(kind=c_char) :: gcnArchName(256)                    !< AMD GCN Arch Name.
    integer(c_int) :: integrated            !< APU vs dGPU
    integer(c_int) :: cooperativeLaunch            !< HIP device supports cooperative launch
    integer(c_int) :: cooperativeMultiDeviceLaunch !< HIP device supports cooperative launch on multiple devices
    integer(c_int) :: maxTexture1DLinear    !< Maximum size for 1D textures bound to linear memory
    integer(c_int) :: maxTexture1D          !< Maximum number of elements in 1D images
    integer(c_int) :: maxTexture2D(2)       !< Maximum dimensions (width, height) of 2D images, in image elements
    integer(c_int) :: maxTexture3D(3)       !< Maximum dimensions (width, height, depth) of 3D images, in image elements
    type(c_ptr) :: hdpMemFlushCntl      !< Addres of HDP_MEM_COHERENCY_FLUSH_CNTL register
    type(c_ptr) :: hdpRegFlushCntl      !< Addres of HDP_REG_COHERENCY_FLUSH_CNTL register
    integer(c_size_t) :: memPitch                 !<Maximum pitch in bytes allowed by memory copies
    integer(c_size_t) :: textureAlignment         !<Alignment requirement for textures
    integer(c_size_t) :: texturePitchAlignment    !<Pitch alignment requirement for texture references bound to pitched memory
    integer(c_int) :: kernelExecTimeoutEnabled    !<Run time limit for kernels executed on the device
    integer(c_int) :: ECCEnabled                  !<Device has ECC support enabled
    integer(c_int) :: tccDriver                   !< 1:If device is Tesla device using TCC driver, else 0
    integer(c_int) :: cooperativeMultiDeviceUnmatchedFunc        !< HIP device supports cooperative launch on multiple
                                                    !devices with unmatched functions
    integer(c_int) :: cooperativeMultiDeviceUnmatchedGridDim     !< HIP device supports cooperative launch on multiple
                                                    !devices with unmatched grid dimensions
    integer(c_int) :: cooperativeMultiDeviceUnmatchedBlockDim    !< HIP device supports cooperative launch on multiple
                                                    !devices with unmatched block dimensions
    integer(c_int) :: cooperativeMultiDeviceUnmatchedSharedMem   !< HIP device supports cooperative launch on multiple
                                                    !devices with unmatched shared memories
    integer(c_int) :: isLargeBar                  !< 1: if it is a large PCI bar device, else 0
    integer(c_int) :: asicRevision                !< Revision of the GPU in this device
    integer(c_int) :: managedMemory               !< Device supports allocating managed memory on this system
    integer(c_int) :: directManagedMemAccessFromHost !< Host can directly access managed memory on the device without migration
    integer(c_int) :: concurrentManagedAccess     !< Device can coherently access managed memory concurrently with the CPU
    integer(c_int) :: pageableMemoryAccess        !< Device supports coherently accessing pageable memory
                                     !< without calling hipHostRegister on it
    integer(c_int) :: pageableMemoryAccessUsesHostPageTables !< Device accesses pageable memory via the host's page tables
    character(kind=c_char) :: GPUFORT_PADDING(256) !< GPUFORT :Some extra bytes to prevent seg faults in newer versions
  end type hipDeviceProp_t
#endif

  ! runtime api parameters

  integer, parameter :: hipIpcMemLazyEnablePeerAccess =  0

  integer, parameter :: hipStreamDefault = &
      0  !< Default stream creation flags. These are used with hipStreamCreate = ().
  integer, parameter :: hipStreamNonBlocking =  1  !< Stream does not implicitly synchronize with null stream
  
  integer, parameter :: hipEventDefault =  0  !< Default flags
  integer, parameter :: hipEventBlockingSync = &
      1  !< Waiting will yield CPU.  Power-friendly and usage-friendly but may increase latency.
  integer, parameter :: hipEventDisableTiming = &
      2  !< Disable event's capability to record timing information.  May improve performance.
  integer, parameter :: hipEventInterprocess =  4  !< Event can support IPC.  @warning - not supported in HIP.
  integer, parameter :: hipEventReleaseToDevice = &
      1073741824 !< 0x40000000 - Use a device-scope release when recording this event.  This flag is useful to
  !integer, parameter :: hipEventReleaseToSystem = &
  !    2147483648 !< 0x80000000 - Use a system-scope release that when recording this event.  This flag is
  integer, parameter :: hipHostMallocDefault =  0
  integer, parameter :: hipHostMallocPortable =  1  !< Memory is considered allocated by all contexts.
  integer, parameter :: hipHostMallocMapped = &
      2  !< Map the allocation into the address space for the current device.  The device pointer
  integer, parameter :: hipHostMallocWriteCombined =  4
  integer, parameter :: hipHostMallocNumaUser = &
      536870912 !< 0x20000000 - Host memory allocation will follow numa policy set by user
  integer, parameter :: hipHostMallocCoherent = &
      1073741824 !< 0x40000000 - Allocate coherent memory. Overrides HIP_COHERENT_HOST_ALLOC for specific
  !integer, parameter :: hipHostMallocNonCoherent = &
  !    2147483648 !< 0x80000000 - Allocate non-coherent memory. Overrides HIP_COHERENT_HOST_ALLOC for specific
  integer, parameter :: hipMemAttachGlobal =   1    !< Memory can be accessed by any stream on any device
  integer, parameter :: hipMemAttachHost =     2    !< Memory cannot be accessed by any stream on any device
  integer, parameter :: hipMemAttachSingle =   4    !< Memory can only be accessed by a single stream on
                                      !< the associated device
  integer, parameter :: hipDeviceMallocDefault =  0
  integer, parameter :: hipDeviceMallocFinegrained =  1  !< Memory is allocated in fine grained region of device.
  
  integer, parameter :: hipHostRegisterDefault =  0   !< Memory is Mapped and Portable
  integer, parameter :: hipHostRegisterPortable =  1  !< Memory is considered registered by all contexts.
  integer, parameter :: hipHostRegisterMapped = &
      2  !< Map the allocation into the address space for the current device.  The device pointer
  integer, parameter :: hipHostRegisterIoMemory =  4  !< Not supported.
  integer, parameter :: hipExtHostRegisterCoarseGrained =  8  !< Coarse Grained host memory lock
  
  integer, parameter :: hipDeviceScheduleAuto =  0  !< Automatically select between Spin and Yield
  integer, parameter :: hipDeviceScheduleSpin = &
      1  !< Dedicate a CPU core to spin-wait.  Provides lowest latency, but burns a CPU core and
  integer, parameter :: hipDeviceScheduleYield = &
      2  !< Yield the CPU to the operating system when waiting.  May increase latency, but lowers
  integer, parameter :: hipDeviceScheduleBlockingSync =  4
  integer, parameter :: hipDeviceScheduleMask =  7
  
  integer, parameter :: hipDeviceMapHost =  8
  integer, parameter :: hipDeviceLmemResizeToMax =  22 ! 16
  
  integer, parameter :: hipArrayDefault =  0  !< Default HIP array allocation flag
  integer, parameter :: hipArrayLayered =  1
  integer, parameter :: hipArraySurfaceLoadStore =  2
  integer, parameter :: hipArrayCubemap =  4
  integer, parameter :: hipArrayTextureGather =  8
  
  integer, parameter :: hipOccupancyDefault =  0
  
  integer, parameter :: hipCooperativeLaunchMultiDeviceNoPreSync =  1
  integer, parameter :: hipCooperativeLaunchMultiDeviceNoPostSync =  2
end module hipfort_types

module hip_blas_enums

  implicit none

  enum, bind(c)
    enumerator :: HIPBLAS_STATUS_SUCCESS = 0 ! Function succeeds
    enumerator :: HIPBLAS_STATUS_NOT_INITIALIZED = 1 ! HIPBLAS library not initialized
    enumerator :: HIPBLAS_STATUS_ALLOC_FAILED = 2 ! resource allocation failed
    enumerator :: HIPBLAS_STATUS_INVALID_VALUE = 3 ! unsupported numerical value was passed to function
    enumerator :: HIPBLAS_STATUS_MAPPING_ERROR = 4 ! access to GPU memory space failed
    enumerator :: HIPBLAS_STATUS_EXECUTION_FAILED = 5 ! GPU program failed to execute
    enumerator :: HIPBLAS_STATUS_INTERNAL_ERROR = 6 ! an internal HIPBLAS operation failed
    enumerator :: HIPBLAS_STATUS_NOT_SUPPORTED = 7 ! function not implemented
    enumerator :: HIPBLAS_STATUS_ARCH_MISMATCH = 8 !
    enumerator :: HIPBLAS_STATUS_HANDLE_IS_NULLPTR = 9 !hipBLAS handle is null pointer
 end enum

 enum, bind(c)
    enumerator :: HIPBLAS_OP_N = 111
    enumerator :: HIPBLAS_OP_T = 112
    enumerator :: HIPBLAS_OP_C = 113
 end enum

end module hip_blas_enums

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_hiprand_enums
  implicit none

  enum, bind(c)
    enumerator :: HIPRAND_STATUS_SUCCESS = 0
    enumerator :: HIPRAND_STATUS_VERSION_MISMATCH = 100
    enumerator :: HIPRAND_STATUS_NOT_INITIALIZED = 101
    enumerator :: HIPRAND_STATUS_ALLOCATION_FAILED = 102
    enumerator :: HIPRAND_STATUS_TYPE_ERROR = 103
    enumerator :: HIPRAND_STATUS_OUT_OF_RANGE = 104
    enumerator :: HIPRAND_STATUS_LENGTH_NOT_MULTIPLE = 105
    enumerator :: HIPRAND_STATUS_DOUBLE_PRECISION_REQUIRED = 106
    enumerator :: HIPRAND_STATUS_LAUNCH_FAILURE = 201
    enumerator :: HIPRAND_STATUS_PREEXISTING_FAILURE = 202
    enumerator :: HIPRAND_STATUS_INITIALIZATION_FAILED = 203
    enumerator :: HIPRAND_STATUS_ARCH_MISMATCH = 204
    enumerator :: HIPRAND_STATUS_INTERNAL_ERROR = 999
    enumerator :: HIPRAND_STATUS_NOT_IMPLEMENTED = 1000
  end enum

  enum, bind(c)
    enumerator :: HIPRAND_RNG_TEST = 0
    enumerator :: HIPRAND_RNG_PSEUDO_DEFAULT = 400
    enumerator :: HIPRAND_RNG_PSEUDO_XORWOW = 401
    enumerator :: HIPRAND_RNG_PSEUDO_MRG32K3A = 402
    enumerator :: HIPRAND_RNG_PSEUDO_MTGP32 = 403
    enumerator :: HIPRAND_RNG_PSEUDO_MT19937 = 404
    enumerator :: HIPRAND_RNG_PSEUDO_PHILOX4_32_10 = 405
    enumerator :: HIPRAND_RNG_QUASI_DEFAULT = 500
    enumerator :: HIPRAND_RNG_QUASI_SOBOL32 = 501
    enumerator :: HIPRAND_RNG_QUASI_SCRAMBLED_SOBOL32 = 502
    enumerator :: HIPRAND_RNG_QUASI_SOBOL64 = 503
    enumerator :: HIPRAND_RNG_QUASI_SCRAMBLED_SOBOL64 = 504
  end enum

 

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_hiprand_enums

module hip_blas
  use hip_blas_enums
  implicit none
  interface

     function hipblasCreate(handle) bind(c, name="hipblasCreate")
       use iso_c_binding
       use hip_blas_enums
       implicit none
       integer(kind(HIPBLAS_STATUS_SUCCESS)) :: hipblasCreate
       type(c_ptr) :: handle
     end function hipblasCreate

     function hipblasDestroy(handle) bind(c, name="hipblasDestroy")
       use iso_c_binding
       use hip_blas_enums
       implicit none
       integer(kind(HIPBLAS_STATUS_SUCCESS)) :: hipblasDestroy
       type(c_ptr), value :: handle
     end function hipblasDestroy

     function hipblasDscal(handle,n,alpha,x,incx) bind(c,name="hipblasDscal")
       use iso_c_binding
       use hip_blas_enums
       implicit none
       integer(kind(HIPBLAS_STATUS_SUCCESS)) :: hipblasDscal
       type(c_ptr), value :: handle
       integer, value :: n
       double precision, intent(in) :: alpha
       type(c_ptr),value :: x
       integer, value :: incx
     end function hipblasDscal

     function hipblasDger(handle,m,n,alpha,x,incx,y,incy,A,lda) bind(c,name="hipblasDger")
       use iso_c_binding
       use hip_blas_enums
       implicit none
       integer(kind(HIPBLAS_STATUS_SUCCESS)) :: hipblasDger
       type(c_ptr), value :: handle
       integer, value :: m, n
       double precision, intent(in) :: alpha
       type(c_ptr),value :: x, y
       integer, value :: incx, incy
       type(c_ptr),value :: A
       integer, value :: lda
     end function hipblasDger

     function hipblasDgemm(handle, &
                           transa,transb,&
                           m,n,k,&
                           alpha,A,lda,&
                           B,ldb,beta,&
                           C,ldc ) bind(c,name="hipblasDgemm")
       use iso_c_binding
       use hip_blas_enums
       implicit none
       integer(kind(HIPBLAS_STATUS_SUCCESS)) :: hipblasDgemm
       type(c_ptr), value :: handle
       integer(kind(HIPBLAS_OP_N)),value :: transa,transb
       integer, value :: m, n, k, lda, ldb, ldc
       double precision, intent(in) :: alpha, beta
       type(c_ptr),value :: A,B
       type(c_ptr),value :: C
     end function hipblasDgemm

  end interface

  contains
     subroutine hipblasCheck(hipblasError_t)
       use hip_blas_enums
       implicit none
       integer(kind(HIPBLAS_STATUS_SUCCESS)) :: hipblasError_t
       if (hipblasError_t /= HIPBLAS_STATUS_SUCCESS) then
          write(*,*) "HIPBLAS ERROR: Error code = ", hipblasError_t
          call exit(hipblasError_t)
       end if
     end subroutine hipblasCheck

end module hip_blas

module rocfft
  use rocfft_enums
  implicit none
  interface

     function rocfft_setup() bind(c,name="rocfft_setup")
       use rocfft_enums
       implicit none
       integer(kind(rocfft_status_success)) :: rocfft_setup
     end function rocfft_setup

     function rocfft_cleanup() bind(c,name="rocfft_cleanup")
       use rocfft_enums
       implicit none
       integer(kind(rocfft_status_success)) :: rocfft_cleanup
     end function rocfft_cleanup

     function rocfft_plan_create(plan,&
                                 placement,&
                                 transform_type,&
                                 precision,&
                                 dimensions,&
                                 lengths,&
                                 number_of_transforms,&
                                 description) bind(c,name="rocfft_plan_create")
       use rocfft_enums
       use iso_c_binding
       implicit none
       integer(kind(rocfft_status_success)) :: rocfft_plan_create
       type(c_ptr) :: plan
       integer(kind(rocfft_placement_inplace)), value :: placement
       integer(kind(rocfft_transform_type_complex_forward)), value :: transform_type
       integer(kind(rocfft_precision_single)), value :: precision
       integer(c_size_t), value :: dimensions
       type(c_ptr), value, intent(in) :: lengths
       integer(c_size_t), value :: number_of_transforms
       type(c_ptr), value, intent(in) :: description
     end function rocfft_plan_create

     function rocfft_plan_destroy(plan) bind(c,name="rocfft_plan_destroy")
       use rocfft_enums
       use iso_c_binding
       implicit none
       integer(kind(rocfft_status_success)) :: rocfft_plan_destroy
       type(c_ptr), value :: plan
     end function rocfft_plan_destroy

     function rocfft_execute(plan,in_buffer,out_buffer,execution_info) bind(c,name="rocfft_execute")
       use rocfft_enums
       use iso_c_binding
       implicit none
       integer(kind(rocfft_status_success)) :: rocfft_execute
       type(c_ptr), value, intent(in) :: plan
       type(c_ptr) :: in_buffer, out_buffer
       type(c_ptr), value :: execution_info
     end function rocfft_execute

  end interface

  contains
     subroutine rocfftCheck(rocfft_status)
       use rocfft_enums
       implicit none
       integer(kind(rocfft_status_success)) :: rocfft_status
       if(rocfft_status /= rocfft_status_success)then
         write(*,*) "rocFFT ERROR: Error code = ", rocfft_status
         call exit(rocfft_status)
       end if
     end subroutine rocfftCheck

end module rocfft

module hipfort_auxiliary
  !>
  !>   @brief Returns device properties.
  !>
  !>   @param [out] prop written with device properties
  !>   @param [in]  deviceId which device to query for information
  !>
  !>   @return hipSuccess, hipErrorInvalidDevice
  !>   @bug HCC always returns 0 for maxThreadsPerMultiProcessor
  !>   @bug HCC always returns 0 for regsPerBlock
  !>   @bug HCC always returns 0 for l2CacheSize
  !>
  !>   Populates hipGetDeviceProperties with information for the specified device.
  !>
  interface hipGetDeviceProperties
#ifdef USE_CUDA_NAMES
    function hipGetDeviceProperties_(prop,deviceId) bind(c, name="cudaGetDeviceProperties")
#else
    function hipGetDeviceProperties_(prop,deviceId) bind(c, name="hipGetDeviceProperties")
#endif
      use iso_c_binding
#ifdef USE_CUDA_NAMES
      use hipfort_cuda_errors
#endif
      use hipfort_enums
      use hipfort_types
      implicit none
#ifdef USE_CUDA_NAMES
      integer(kind(cudaSuccess)) :: hipGetDeviceProperties_
#else
      integer(kind(hipSuccess)) :: hipGetDeviceProperties_
#endif
      type(hipDeviceProp_t),intent(out) :: prop
      integer(c_int),value :: deviceId
    end function
  end interface

end module hipfort_auxiliary

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_hipfft
  use hipfort_hipfft_enums
  use hipfort_hipfft_params
  implicit none

 
  !>  @brief Create a new one-dimensional FFT plan.
  !> 
  !>   @details Allocate and initialize a new one-dimensional FFT plan.
  !> 
  !>   @param[out] plan Pointer to the FFT plan handle.
  !>   @param[in] nx FFT length.
  !>   @param[in] type FFT type.
  !>   @param[in] batch Number of batched transforms to compute.
  interface hipfftPlan1d
#ifdef USE_CUDA_NAMES
    function hipfftPlan1d_(plan,nx,myType,batch) bind(c, name="cufftPlan1d")
#else
    function hipfftPlan1d_(plan,nx,myType,batch) bind(c, name="hipfftPlan1d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftPlan1d_
      type(c_ptr) :: plan
      integer(c_int),value :: nx
      integer(kind(HIPFFT_R2C)),value :: myType
      integer(c_int),value :: batch
    end function

  end interface
  !>  @brief Create a new two-dimensional FFT plan.
  !> 
  !>   @details Allocate and initialize a new two-dimensional FFT plan.
  !>   Two-dimensional data should be stored in C ordering (row-major
  !>   format), so that indexes in y-direction (j index) vary the
  !>   fastest.
  !> 
  !>   @param[out] plan Pointer to the FFT plan handle.
  !>   @param[in] nx Number of elements in the x-direction (slow index).
  !>   @param[in] ny Number of elements in the y-direction (fast index).
  !>   @param[in] type FFT type.
  interface hipfftPlan2d
#ifdef USE_CUDA_NAMES
    function hipfftPlan2d_(plan,nx,ny,myType) bind(c, name="cufftPlan2d")
#else
    function hipfftPlan2d_(plan,nx,ny,myType) bind(c, name="hipfftPlan2d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftPlan2d_
      type(c_ptr) :: plan
      integer(c_int),value :: nx
      integer(c_int),value :: ny
      integer(kind(HIPFFT_R2C)),value :: myType
    end function

  end interface
  !>  @brief Create a new three-dimensional FFT plan.
  !> 
  !>   @details Allocate and initialize a new three-dimensional FFT plan.
  !>   Three-dimensional data should be stored in C ordering (row-major
  !>   format), so that indexes in z-direction (k index) vary the
  !>   fastest.
  !> 
  !>   @param[out] plan Pointer to the FFT plan handle.
  !>   @param[in] nx Number of elements in the x-direction (slowest index).
  !>   @param[in] ny Number of elements in the y-direction.
  !>   @param[in] nz Number of elements in the z-direction (fastest index).
  !>   @param[in] type FFT type.
  interface hipfftPlan3d
#ifdef USE_CUDA_NAMES
    function hipfftPlan3d_(plan,nx,ny,nz,myType) bind(c, name="cufftPlan3d")
#else
    function hipfftPlan3d_(plan,nx,ny,nz,myType) bind(c, name="hipfftPlan3d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftPlan3d_
      type(c_ptr) :: plan
      integer(c_int),value :: nx
      integer(c_int),value :: ny
      integer(c_int),value :: nz
      integer(kind(HIPFFT_R2C)),value :: myType
    end function

  end interface
  !>  @brief Create a new batched rank-dimensional FFT plan.
  !> 
  !>  @details Allocate and initialize a new batched rank-dimensional
  !>   FFT.  The batch parameter tells hipFFT how many transforms to
  !>   perform.  Used in complicated usage case like flexible input and
  !>   output layout.
  !> 
  !>   @param[out] plan Pointer to the FFT plan handle.
  !>   @param[in] rank Dimension of FFT transform (1, 2, or 3).
  !>   @param[in] n Number of elements in the x/y/z directions.
  !>   @param[in] inembed
  !>   @param[in] istride
  !>   @param[in] idist Distance between input batches.
  !>   @param[in] onembed
  !>   @param[in] ostride
  !>   @param[in] odist Distance between output batches.
  !>   @param[in] type FFT type.
  !>   @param[in] batch Number of batched transforms to perform.
  interface hipfftPlanMany
#ifdef USE_CUDA_NAMES
    function hipfftPlanMany_(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch) bind(c, name="cufftPlanMany")
#else
    function hipfftPlanMany_(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch) bind(c, name="hipfftPlanMany")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftPlanMany_
      type(c_ptr) :: plan
      integer(c_int),value :: rank
      type(c_ptr),value :: n
      type(c_ptr),value :: inembed
      integer(c_int),value :: istride
      integer(c_int),value :: idist
      type(c_ptr),value :: onembed
      integer(c_int),value :: ostride
      integer(c_int),value :: odist
      integer(kind(HIPFFT_R2C)),value :: myType
      integer(c_int),value :: batch
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftPlanMany_rank_0,&
      hipfftPlanMany_rank_1
#endif
  end interface
  !>  @brief Allocate a new plan.
  interface hipfftCreate
#ifdef USE_CUDA_NAMES
    function hipfftCreate_(plan) bind(c, name="cufftCreate")
#else
    function hipfftCreate_(plan) bind(c, name="hipfftCreate")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftCreate_
      type(c_ptr) :: plan
    end function

  end interface
  !>  @brief Initialize a new one-dimensional FFT plan.
  !> 
  !>   @details Assumes that the plan has been created already, and
  !>   modifies the plan associated with the plan handle.
  !> 
  !>   @param[in] plan Handle of the FFT plan.
  !>   @param[in] nx FFT length.
  !>   @param[in] type FFT type.
  !>   @param[in] batch Number of batched transforms to compute.
  interface hipfftMakePlan1d
#ifdef USE_CUDA_NAMES
    function hipfftMakePlan1d_(plan,nx,myType,batch,workSize) bind(c, name="cufftMakePlan1d")
#else
    function hipfftMakePlan1d_(plan,nx,myType,batch,workSize) bind(c, name="hipfftMakePlan1d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlan1d_
      type(c_ptr),value :: plan
      integer(c_int),value :: nx
      integer(kind(HIPFFT_R2C)),value :: myType
      integer(c_int),value :: batch
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftMakePlan1d_rank_0,&
      hipfftMakePlan1d_rank_1
#endif
  end interface
  !>  @brief Initialize a new two-dimensional FFT plan.
  !> 
  !>   @details Assumes that the plan has been created already, and
  !>   modifies the plan associated with the plan handle.
  !>   Two-dimensional data should be stored in C ordering (row-major
  !>   format), so that indexes in y-direction (j index) vary the
  !>   fastest.
  !> 
  !>   @param[in] plan Handle of the FFT plan.
  !>   @param[in] nx Number of elements in the x-direction (slow index).
  !>   @param[in] ny Number of elements in the y-direction (fast index).
  !>   @param[in] type FFT type.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftMakePlan2d
#ifdef USE_CUDA_NAMES
    function hipfftMakePlan2d_(plan,nx,ny,myType,workSize) bind(c, name="cufftMakePlan2d")
#else
    function hipfftMakePlan2d_(plan,nx,ny,myType,workSize) bind(c, name="hipfftMakePlan2d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlan2d_
      type(c_ptr),value :: plan
      integer(c_int),value :: nx
      integer(c_int),value :: ny
      integer(kind(HIPFFT_R2C)),value :: myType
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftMakePlan2d_rank_0,&
      hipfftMakePlan2d_rank_1
#endif
  end interface
  !>  @brief Initialize a new two-dimensional FFT plan.
  !> 
  !>   @details Assumes that the plan has been created already, and
  !>   modifies the plan associated with the plan handle.
  !>   Three-dimensional data should be stored in C ordering (row-major
  !>   format), so that indexes in z-direction (k index) vary the
  !>   fastest.
  !> 
  !>   @param[in] plan Handle of the FFT plan.
  !>   @param[in] nx Number of elements in the x-direction (slowest index).
  !>   @param[in] ny Number of elements in the y-direction.
  !>   @param[in] nz Number of elements in the z-direction (fastest index).
  !>   @param[in] type FFT type.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftMakePlan3d
#ifdef USE_CUDA_NAMES
    function hipfftMakePlan3d_(plan,nx,ny,nz,myType,workSize) bind(c, name="cufftMakePlan3d")
#else
    function hipfftMakePlan3d_(plan,nx,ny,nz,myType,workSize) bind(c, name="hipfftMakePlan3d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlan3d_
      type(c_ptr),value :: plan
      integer(c_int),value :: nx
      integer(c_int),value :: ny
      integer(c_int),value :: nz
      integer(kind(HIPFFT_R2C)),value :: myType
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftMakePlan3d_rank_0,&
      hipfftMakePlan3d_rank_1
#endif
  end interface
  !>  @brief Initialize a new batched rank-dimensional FFT plan.
  !> 
  !>   @details Assumes that the plan has been created already, and
  !>   modifies the plan associated with the plan handle.  The
  !>   batch parameter tells hipFFT how many transforms to perform.  Used
  !>   in complicated usage case like flexible input and output layout.
  !> 
  !>   @param[in] plan Pointer to the FFT plan.
  !>   @param[in] rank Dimension of FFT transform (1, 2, or 3).
  !>   @param[in] n Number of elements in the x/y/z directions.
  !>   @param[in] inembed
  !>   @param[in] istride
  !>   @param[in] idist Distance between input batches.
  !>   @param[in] onembed
  !>   @param[in] ostride
  !>   @param[in] odist Distance between output batches.
  !>   @param[in] type FFT type.
  !>   @param[in] batch Number of batched transforms to perform.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftMakePlanMany
#ifdef USE_CUDA_NAMES
    function hipfftMakePlanMany_(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize) bind(c, name="cufftMakePlanMany")
#else
    function hipfftMakePlanMany_(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize) bind(c, name="hipfftMakePlanMany")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlanMany_
      type(c_ptr),value :: plan
      integer(c_int),value :: rank
      type(c_ptr),value :: n
      type(c_ptr),value :: inembed
      integer(c_int),value :: istride
      integer(c_int),value :: idist
      type(c_ptr),value :: onembed
      integer(c_int),value :: ostride
      integer(c_int),value :: odist
      integer(kind(HIPFFT_R2C)),value :: myType
      integer(c_int),value :: batch
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftMakePlanMany_rank_0,&
      hipfftMakePlanMany_rank_1
#endif
  end interface
  
  interface hipfftMakePlanMany64
#ifdef USE_CUDA_NAMES
    function hipfftMakePlanMany64_(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize) bind(c, name="cufftMakePlanMany64")
#else
    function hipfftMakePlanMany64_(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize) bind(c, name="hipfftMakePlanMany64")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlanMany64_
      type(c_ptr),value :: plan
      integer(c_int),value :: rank
      type(c_ptr),value :: n
      type(c_ptr),value :: inembed
      integer(c_long_long),value :: istride
      integer(c_long_long),value :: idist
      type(c_ptr),value :: onembed
      integer(c_long_long),value :: ostride
      integer(c_long_long),value :: odist
      integer(kind(HIPFFT_R2C)),value :: myType
      integer(c_long_long),value :: batch
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftMakePlanMany64_rank_0,&
      hipfftMakePlanMany64_rank_1
#endif
  end interface
  !>  @brief Return an estimate of the work area size required for a 1D plan.
  !> 
  !>   @param[in] nx Number of elements in the x-direction.
  !>   @param[in] type FFT type.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftEstimate1d
#ifdef USE_CUDA_NAMES
    function hipfftEstimate1d_(nx,myType,batch,workSize) bind(c, name="cufftEstimate1d")
#else
    function hipfftEstimate1d_(nx,myType,batch,workSize) bind(c, name="hipfftEstimate1d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimate1d_
      integer(c_int),value :: nx
      integer(kind(HIPFFT_R2C)),value :: myType
      integer(c_int),value :: batch
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftEstimate1d_rank_0,&
      hipfftEstimate1d_rank_1
#endif
  end interface
  !>  @brief Return an estimate of the work area size required for a 2D plan.
  !> 
  !>   @param[in] nx Number of elements in the x-direction.
  !>   @param[in] ny Number of elements in the y-direction.
  !>   @param[in] type FFT type.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftEstimate2d
#ifdef USE_CUDA_NAMES
    function hipfftEstimate2d_(nx,ny,myType,workSize) bind(c, name="cufftEstimate2d")
#else
    function hipfftEstimate2d_(nx,ny,myType,workSize) bind(c, name="hipfftEstimate2d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimate2d_
      integer(c_int),value :: nx
      integer(c_int),value :: ny
      integer(kind(HIPFFT_R2C)),value :: myType
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftEstimate2d_rank_0,&
      hipfftEstimate2d_rank_1
#endif
  end interface
  !>  @brief Return an estimate of the work area size required for a 3D plan.
  !> 
  !>   @param[in] nx Number of elements in the x-direction.
  !>   @param[in] ny Number of elements in the y-direction.
  !>   @param[in] nz Number of elements in the z-direction.
  !>   @param[in] type FFT type.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftEstimate3d
#ifdef USE_CUDA_NAMES
    function hipfftEstimate3d_(nx,ny,nz,myType,workSize) bind(c, name="cufftEstimate3d")
#else
    function hipfftEstimate3d_(nx,ny,nz,myType,workSize) bind(c, name="hipfftEstimate3d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimate3d_
      integer(c_int),value :: nx
      integer(c_int),value :: ny
      integer(c_int),value :: nz
      integer(kind(HIPFFT_R2C)),value :: myType
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftEstimate3d_rank_0,&
      hipfftEstimate3d_rank_1
#endif
  end interface
  !>  @brief Return an estimate of the work area size required for a rank-dimensional plan.
  !> 
  !>   @param[in] rank Dimension of FFT transform (1, 2, or 3).
  !>   @param[in] n Number of elements in the x/y/z directions.
  !>   @param[in] inembed
  !>   @param[in] istride
  !>   @param[in] idist Distance between input batches.
  !>   @param[in] onembed
  !>   @param[in] ostride
  !>   @param[in] odist Distance between output batches.
  !>   @param[in] type FFT type.
  !>   @param[in] batch Number of batched transforms to perform.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftEstimateMany
#ifdef USE_CUDA_NAMES
    function hipfftEstimateMany_(rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize) bind(c, name="cufftEstimateMany")
#else
    function hipfftEstimateMany_(rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize) bind(c, name="hipfftEstimateMany")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimateMany_
      integer(c_int),value :: rank
      type(c_ptr),value :: n
      type(c_ptr),value :: inembed
      integer(c_int),value :: istride
      integer(c_int),value :: idist
      type(c_ptr),value :: onembed
      integer(c_int),value :: ostride
      integer(c_int),value :: odist
      integer(kind(HIPFFT_R2C)),value :: myType
      integer(c_int),value :: batch
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftEstimateMany_rank_0,&
      hipfftEstimateMany_rank_1
#endif
  end interface
  !>  @brief Return size of the work area size required for a 1D plan.
  !> 
  !>   @param[in] plan Pointer to the FFT plan.
  !>   @param[in] nx Number of elements in the x-direction.
  !>   @param[in] type FFT type.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftGetSize1d
#ifdef USE_CUDA_NAMES
    function hipfftGetSize1d_(plan,nx,myType,batch,workSize) bind(c, name="cufftGetSize1d")
#else
    function hipfftGetSize1d_(plan,nx,myType,batch,workSize) bind(c, name="hipfftGetSize1d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize1d_
      type(c_ptr),value :: plan
      integer(c_int),value :: nx
      integer(kind(HIPFFT_R2C)),value :: myType
      integer(c_int),value :: batch
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftGetSize1d_rank_0,&
      hipfftGetSize1d_rank_1
#endif
  end interface
  !>  @brief Return size of the work area size required for a 2D plan.
  !> 
  !>   @param[in] plan Pointer to the FFT plan.
  !>   @param[in] nx Number of elements in the x-direction.
  !>   @param[in] ny Number of elements in the y-direction.
  !>   @param[in] type FFT type.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftGetSize2d
#ifdef USE_CUDA_NAMES
    function hipfftGetSize2d_(plan,nx,ny,myType,workSize) bind(c, name="cufftGetSize2d")
#else
    function hipfftGetSize2d_(plan,nx,ny,myType,workSize) bind(c, name="hipfftGetSize2d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize2d_
      type(c_ptr),value :: plan
      integer(c_int),value :: nx
      integer(c_int),value :: ny
      integer(kind(HIPFFT_R2C)),value :: myType
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftGetSize2d_rank_0,&
      hipfftGetSize2d_rank_1
#endif
  end interface
  !>  @brief Return size of the work area size required for a 3D plan.
  !> 
  !>   @param[in] plan Pointer to the FFT plan.
  !>   @param[in] nx Number of elements in the x-direction.
  !>   @param[in] ny Number of elements in the y-direction.
  !>   @param[in] nz Number of elements in the z-direction.
  !>   @param[in] type FFT type.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftGetSize3d
#ifdef USE_CUDA_NAMES
    function hipfftGetSize3d_(plan,nx,ny,nz,myType,workSize) bind(c, name="cufftGetSize3d")
#else
    function hipfftGetSize3d_(plan,nx,ny,nz,myType,workSize) bind(c, name="hipfftGetSize3d")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize3d_
      type(c_ptr),value :: plan
      integer(c_int),value :: nx
      integer(c_int),value :: ny
      integer(c_int),value :: nz
      integer(kind(HIPFFT_R2C)),value :: myType
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftGetSize3d_rank_0,&
      hipfftGetSize3d_rank_1
#endif
  end interface
  !>  @brief Return size of the work area size required for a rank-dimensional plan.
  !> 
  !>   @param[in] plan Pointer to the FFT plan.
  !>   @param[in] rank Dimension of FFT transform (1, 2, or 3).
  !>   @param[in] n Number of elements in the x/y/z directions.
  !>   @param[in] inembed
  !>   @param[in] istride
  !>   @param[in] idist Distance between input batches.
  !>   @param[in] onembed
  !>   @param[in] ostride
  !>   @param[in] odist Distance between output batches.
  !>   @param[in] type FFT type.
  !>   @param[in] batch Number of batched transforms to perform.
  !>   @param[out] workSize Pointer to work area size (returned value).
  interface hipfftGetSizeMany
#ifdef USE_CUDA_NAMES
    function hipfftGetSizeMany_(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize) bind(c, name="cufftGetSizeMany")
#else
    function hipfftGetSizeMany_(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize) bind(c, name="hipfftGetSizeMany")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSizeMany_
      type(c_ptr),value :: plan
      integer(c_int),value :: rank
      type(c_ptr),value :: n
      type(c_ptr),value :: inembed
      integer(c_int),value :: istride
      integer(c_int),value :: idist
      type(c_ptr),value :: onembed
      integer(c_int),value :: ostride
      integer(c_int),value :: odist
      integer(kind(HIPFFT_R2C)),value :: myType
      integer(c_int),value :: batch
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftGetSizeMany_rank_0,&
      hipfftGetSizeMany_rank_1
#endif
  end interface
  
  interface hipfftGetSizeMany64
#ifdef USE_CUDA_NAMES
    function hipfftGetSizeMany64_(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize) bind(c, name="cufftGetSizeMany64")
#else
    function hipfftGetSizeMany64_(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize) bind(c, name="hipfftGetSizeMany64")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSizeMany64_
      type(c_ptr),value :: plan
      integer(c_int),value :: rank
      type(c_ptr),value :: n
      type(c_ptr),value :: inembed
      integer(c_long_long),value :: istride
      integer(c_long_long),value :: idist
      type(c_ptr),value :: onembed
      integer(c_long_long),value :: ostride
      integer(c_long_long),value :: odist
      integer(kind(HIPFFT_R2C)),value :: myType
      integer(c_long_long),value :: batch
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftGetSizeMany64_rank_0,&
      hipfftGetSizeMany64_rank_1
#endif
  end interface
  !>  @brief Return size of the work area size required for a rank-dimensional plan.
  !> 
  !>   @param[in] plan Pointer to the FFT plan.
  interface hipfftGetSize
#ifdef USE_CUDA_NAMES
    function hipfftGetSize_(plan,workSize) bind(c, name="cufftGetSize")
#else
    function hipfftGetSize_(plan,workSize) bind(c, name="hipfftGetSize")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize_
      type(c_ptr),value :: plan
      type(c_ptr),value :: workSize
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftGetSize_rank_0,&
      hipfftGetSize_rank_1
#endif
  end interface
  !>  @brief Set the plan's auto-allocation flag.  The plan will allocate its own workarea.
  !> 
  !>   @param[in] plan Pointer to the FFT plan.
  !>   @param[in] autoAllocate 0 to disable auto-allocation, non-zero to enable.
  interface hipfftSetAutoAllocation
#ifdef USE_CUDA_NAMES
    function hipfftSetAutoAllocation_(plan,autoAllocate) bind(c, name="cufftSetAutoAllocation")
#else
    function hipfftSetAutoAllocation_(plan,autoAllocate) bind(c, name="hipfftSetAutoAllocation")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftSetAutoAllocation_
      type(c_ptr),value :: plan
      integer(c_int),value :: autoAllocate
    end function

  end interface
  !>  @brief Set the plan's work area.
  !> 
  !>   @param[in] plan Pointer to the FFT plan.
  !>   @param[in] workArea Pointer to the work area (on device).
  interface hipfftSetWorkArea
#ifdef USE_CUDA_NAMES
    function hipfftSetWorkArea_(plan,workArea) bind(c, name="cufftSetWorkArea")
#else
    function hipfftSetWorkArea_(plan,workArea) bind(c, name="hipfftSetWorkArea")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftSetWorkArea_
      type(c_ptr),value :: plan
      type(c_ptr),value :: workArea
    end function

  end interface
  !>  @brief Execute a (float) complex-to-complex FFT.
  !> 
  !>   @details If the input and output buffers are equal, an in-place
  !>   transform is performed.
  !> 
  !>   @param plan The FFT plan.
  !>   @param idata Input data (on device).
  !>   @param odata Output data (on device).
  !>   @param direction Either `HIPFFT_FORWARD` or `HIPFFT_BACKWARD`.
  interface hipfftExecC2C
#ifdef USE_CUDA_NAMES
    function hipfftExecC2C_(plan,idata,odata,direction) bind(c, name="cufftExecC2C")
#else
    function hipfftExecC2C_(plan,idata,odata,direction) bind(c, name="hipfftExecC2C")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecC2C_
      type(c_ptr),value :: plan
      type(c_ptr),value :: idata
      type(c_ptr),value :: odata
      integer(c_int),value :: direction
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftExecC2C_rank_0,&
      hipfftExecC2C_rank_1,&
      hipfftExecC2C_rank_2,&
      hipfftExecC2C_rank_3
#endif
  end interface
  !>  @brief Execute a (float) real-to-complex FFT.
  !> 
  !>   @details If the input and output buffers are equal, an in-place
  !>   transform is performed.
  !> 
  !>   @param plan The FFT plan.
  !>   @param idata Input data (on device).
  !>   @param odata Output data (on device).
  interface hipfftExecR2C
#ifdef USE_CUDA_NAMES
    function hipfftExecR2C_(plan,idata,odata) bind(c, name="cufftExecR2C")
#else
    function hipfftExecR2C_(plan,idata,odata) bind(c, name="hipfftExecR2C")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecR2C_
      type(c_ptr),value :: plan
      type(c_ptr),value :: idata
      type(c_ptr),value :: odata
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftExecR2C_rank_0,&
      hipfftExecR2C_rank_1,&
      hipfftExecR2C_rank_2,&
      hipfftExecR2C_rank_3
#endif
  end interface
  !>  @brief Execute a (float) complex-to-real FFT.
  !> 
  !>   @details If the input and output buffers are equal, an in-place
  !>   transform is performed.
  !> 
  !>   @param plan The FFT plan.
  !>   @param idata Input data (on device).
  !>   @param odata Output data (on device).
  interface hipfftExecC2R
#ifdef USE_CUDA_NAMES
    function hipfftExecC2R_(plan,idata,odata) bind(c, name="cufftExecC2R")
#else
    function hipfftExecC2R_(plan,idata,odata) bind(c, name="hipfftExecC2R")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecC2R_
      type(c_ptr),value :: plan
      type(c_ptr),value :: idata
      type(c_ptr),value :: odata
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftExecC2R_rank_0,&
      hipfftExecC2R_rank_1,&
      hipfftExecC2R_rank_2,&
      hipfftExecC2R_rank_3
#endif
  end interface
  !>  @brief Execute a (double) complex-to-complex FFT.
  !> 
  !>   @details If the input and output buffers are equal, an in-place
  !>   transform is performed.
  !> 
  !>   @param plan The FFT plan.
  !>   @param idata Input data (on device).
  !>   @param odata Output data (on device).
  !>   @param direction Either `HIPFFT_FORWARD` or `HIPFFT_BACKWARD`.
  interface hipfftExecZ2Z
#ifdef USE_CUDA_NAMES
    function hipfftExecZ2Z_(plan,idata,odata,direction) bind(c, name="cufftExecZ2Z")
#else
    function hipfftExecZ2Z_(plan,idata,odata,direction) bind(c, name="hipfftExecZ2Z")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecZ2Z_
      type(c_ptr),value :: plan
      type(c_ptr),value :: idata
      type(c_ptr),value :: odata
      integer(c_int),value :: direction
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftExecZ2Z_rank_0,&
      hipfftExecZ2Z_rank_1,&
      hipfftExecZ2Z_rank_2,&
      hipfftExecZ2Z_rank_3
#endif
  end interface
  !>  @brief Execute a (double) real-to-complex FFT.
  !> 
  !>   @details If the input and output buffers are equal, an in-place
  !>   transform is performed.
  !> 
  !>   @param plan The FFT plan.
  !>   @param idata Input data (on device).
  !>   @param odata Output data (on device).
  interface hipfftExecD2Z
#ifdef USE_CUDA_NAMES
    function hipfftExecD2Z_(plan,idata,odata) bind(c, name="cufftExecD2Z")
#else
    function hipfftExecD2Z_(plan,idata,odata) bind(c, name="hipfftExecD2Z")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecD2Z_
      type(c_ptr),value :: plan
      type(c_ptr),value :: idata
      type(c_ptr),value :: odata
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftExecD2Z_rank_0,&
      hipfftExecD2Z_rank_1,&
      hipfftExecD2Z_rank_2,&
      hipfftExecD2Z_rank_3
#endif
  end interface
  !>  @brief Execute a (double) complex-to-real FFT.
  !> 
  !>   @details If the input and output buffers are equal, an in-place
  !>   transform is performed.
  !> 
  !>   @param plan The FFT plan.
  !>   @param idata Input data (on device).
  !>   @param odata Output data (on device).
  interface hipfftExecZ2D
#ifdef USE_CUDA_NAMES
    function hipfftExecZ2D_(plan,idata,odata) bind(c, name="cufftExecZ2D")
#else
    function hipfftExecZ2D_(plan,idata,odata) bind(c, name="hipfftExecZ2D")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecZ2D_
      type(c_ptr),value :: plan
      type(c_ptr),value :: idata
      type(c_ptr),value :: odata
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      hipfftExecZ2D_rank_0,&
      hipfftExecZ2D_rank_1,&
      hipfftExecZ2D_rank_2,&
      hipfftExecZ2D_rank_3
#endif
  end interface
  !>  @brief Set HIP stream to execute plan on.
  !> 
  !>  @details Associates a HIP stream with a hipFFT plan.  All kernels
  !>  launched by this plan are associated with the provided stream.
  !> 
  !>  @param plan The FFT plan.
  !>  @param stream The HIP stream.
  interface hipfftSetStream
#ifdef USE_CUDA_NAMES
    function hipfftSetStream_(plan,stream) bind(c, name="cufftSetStream")
#else
    function hipfftSetStream_(plan,stream) bind(c, name="hipfftSetStream")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftSetStream_
      type(c_ptr),value :: plan
      type(c_ptr),value :: stream
    end function

  end interface
  !>  @brief Destroy and deallocate an existing plan.
  interface hipfftDestroy
#ifdef USE_CUDA_NAMES
    function hipfftDestroy_(plan) bind(c, name="cufftDestroy")
#else
    function hipfftDestroy_(plan) bind(c, name="hipfftDestroy")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftDestroy_
      type(c_ptr),value :: plan
    end function

  end interface
  !>  @brief Get rocFFT/cuFFT version.
  !> 
  !>   @param[out] version cuFFT/rocFFT version (returned value).
  interface hipfftGetVersion
#ifdef USE_CUDA_NAMES
    function hipfftGetVersion_(version) bind(c, name="cufftGetVersion")
#else
    function hipfftGetVersion_(version) bind(c, name="hipfftGetVersion")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetVersion_
      type(c_ptr),value :: version
    end function

  end interface
  !>  @brief Get library property.
  !> 
  !>   @param[in] type Property type.
  !>   @param[out] value Returned value.
  interface hipfftGetProperty
#ifdef USE_CUDA_NAMES
    function hipfftGetProperty_(myType,myValue) bind(c, name="cufftGetProperty")
#else
    function hipfftGetProperty_(myType,myValue) bind(c, name="hipfftGetProperty")
#endif
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetProperty_
      integer(kind(HIPFFT_MAJOR_VERSION)),value :: myType
      type(c_ptr),value :: myValue
    end function

  end interface

#ifdef USE_FPOINTER_INTERFACES
  contains
    function hipfftPlanMany_rank_0(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftPlanMany_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: rank
      integer(c_int),target :: n
      integer(c_int),target :: inembed
      integer(c_int) :: istride
      integer(c_int) :: idist
      integer(c_int),target :: onembed
      integer(c_int) :: ostride
      integer(c_int) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      !
      hipfftPlanMany_rank_0 = hipfftPlanMany_(plan,rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch)
    end function

    function hipfftPlanMany_rank_1(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftPlanMany_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: rank
      integer(c_int),target,dimension(:) :: n
      integer(c_int),target,dimension(:) :: inembed
      integer(c_int) :: istride
      integer(c_int) :: idist
      integer(c_int),target,dimension(:) :: onembed
      integer(c_int) :: ostride
      integer(c_int) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      !
      hipfftPlanMany_rank_1 = hipfftPlanMany_(plan,rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch)
    end function

    function hipfftMakePlan1d_rank_0(plan,nx,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlan1d_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target :: workSize
      !
      hipfftMakePlan1d_rank_0 = hipfftMakePlan1d_(plan,nx,myType,batch,c_loc(workSize))
    end function

    function hipfftMakePlan1d_rank_1(plan,nx,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlan1d_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftMakePlan1d_rank_1 = hipfftMakePlan1d_(plan,nx,myType,batch,c_loc(workSize))
    end function

    function hipfftMakePlan2d_rank_0(plan,nx,ny,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlan2d_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target :: workSize
      !
      hipfftMakePlan2d_rank_0 = hipfftMakePlan2d_(plan,nx,ny,myType,c_loc(workSize))
    end function

    function hipfftMakePlan2d_rank_1(plan,nx,ny,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlan2d_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftMakePlan2d_rank_1 = hipfftMakePlan2d_(plan,nx,ny,myType,c_loc(workSize))
    end function

    function hipfftMakePlan3d_rank_0(plan,nx,ny,nz,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlan3d_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(c_int) :: nz
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target :: workSize
      !
      hipfftMakePlan3d_rank_0 = hipfftMakePlan3d_(plan,nx,ny,nz,myType,c_loc(workSize))
    end function

    function hipfftMakePlan3d_rank_1(plan,nx,ny,nz,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlan3d_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(c_int) :: nz
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftMakePlan3d_rank_1 = hipfftMakePlan3d_(plan,nx,ny,nz,myType,c_loc(workSize))
    end function

    function hipfftMakePlanMany_rank_0(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlanMany_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: rank
      integer(c_int),target :: n
      integer(c_int),target :: inembed
      integer(c_int) :: istride
      integer(c_int) :: idist
      integer(c_int),target :: onembed
      integer(c_int) :: ostride
      integer(c_int) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target :: workSize
      !
      hipfftMakePlanMany_rank_0 = hipfftMakePlanMany_(plan,rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch,c_loc(workSize))
    end function

    function hipfftMakePlanMany_rank_1(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlanMany_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: rank
      integer(c_int),target,dimension(:) :: n
      integer(c_int),target,dimension(:) :: inembed
      integer(c_int) :: istride
      integer(c_int) :: idist
      integer(c_int),target,dimension(:) :: onembed
      integer(c_int) :: ostride
      integer(c_int) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftMakePlanMany_rank_1 = hipfftMakePlanMany_(plan,rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch,c_loc(workSize))
    end function

    function hipfftMakePlanMany64_rank_0(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlanMany64_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: rank
      integer(c_long_long),target :: n
      integer(c_long_long),target :: inembed
      integer(c_long_long) :: istride
      integer(c_long_long) :: idist
      integer(c_long_long),target :: onembed
      integer(c_long_long) :: ostride
      integer(c_long_long) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_long_long) :: batch
      integer(c_size_t),target :: workSize
      !
      hipfftMakePlanMany64_rank_0 = hipfftMakePlanMany64_(plan,rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch,c_loc(workSize))
    end function

    function hipfftMakePlanMany64_rank_1(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftMakePlanMany64_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: rank
      integer(c_long_long),target,dimension(:) :: n
      integer(c_long_long),target,dimension(:) :: inembed
      integer(c_long_long) :: istride
      integer(c_long_long) :: idist
      integer(c_long_long),target,dimension(:) :: onembed
      integer(c_long_long) :: ostride
      integer(c_long_long) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_long_long) :: batch
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftMakePlanMany64_rank_1 = hipfftMakePlanMany64_(plan,rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch,c_loc(workSize))
    end function

    function hipfftEstimate1d_rank_0(nx,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimate1d_rank_0
      integer(c_int) :: nx
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target :: workSize
      !
      hipfftEstimate1d_rank_0 = hipfftEstimate1d_(nx,myType,batch,c_loc(workSize))
    end function

    function hipfftEstimate1d_rank_1(nx,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimate1d_rank_1
      integer(c_int) :: nx
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftEstimate1d_rank_1 = hipfftEstimate1d_(nx,myType,batch,c_loc(workSize))
    end function

    function hipfftEstimate2d_rank_0(nx,ny,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimate2d_rank_0
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target :: workSize
      !
      hipfftEstimate2d_rank_0 = hipfftEstimate2d_(nx,ny,myType,c_loc(workSize))
    end function

    function hipfftEstimate2d_rank_1(nx,ny,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimate2d_rank_1
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftEstimate2d_rank_1 = hipfftEstimate2d_(nx,ny,myType,c_loc(workSize))
    end function

    function hipfftEstimate3d_rank_0(nx,ny,nz,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimate3d_rank_0
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(c_int) :: nz
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target :: workSize
      !
      hipfftEstimate3d_rank_0 = hipfftEstimate3d_(nx,ny,nz,myType,c_loc(workSize))
    end function

    function hipfftEstimate3d_rank_1(nx,ny,nz,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimate3d_rank_1
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(c_int) :: nz
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftEstimate3d_rank_1 = hipfftEstimate3d_(nx,ny,nz,myType,c_loc(workSize))
    end function

    function hipfftEstimateMany_rank_0(rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimateMany_rank_0
      integer(c_int) :: rank
      integer(c_int),target :: n
      integer(c_int),target :: inembed
      integer(c_int) :: istride
      integer(c_int) :: idist
      integer(c_int),target :: onembed
      integer(c_int) :: ostride
      integer(c_int) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target :: workSize
      !
      hipfftEstimateMany_rank_0 = hipfftEstimateMany_(rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch,c_loc(workSize))
    end function

    function hipfftEstimateMany_rank_1(rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftEstimateMany_rank_1
      integer(c_int) :: rank
      integer(c_int),target,dimension(:) :: n
      integer(c_int),target,dimension(:) :: inembed
      integer(c_int) :: istride
      integer(c_int) :: idist
      integer(c_int),target,dimension(:) :: onembed
      integer(c_int) :: ostride
      integer(c_int) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftEstimateMany_rank_1 = hipfftEstimateMany_(rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch,c_loc(workSize))
    end function

    function hipfftGetSize1d_rank_0(plan,nx,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize1d_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target :: workSize
      !
      hipfftGetSize1d_rank_0 = hipfftGetSize1d_(plan,nx,myType,batch,c_loc(workSize))
    end function

    function hipfftGetSize1d_rank_1(plan,nx,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize1d_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftGetSize1d_rank_1 = hipfftGetSize1d_(plan,nx,myType,batch,c_loc(workSize))
    end function

    function hipfftGetSize2d_rank_0(plan,nx,ny,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize2d_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target :: workSize
      !
      hipfftGetSize2d_rank_0 = hipfftGetSize2d_(plan,nx,ny,myType,c_loc(workSize))
    end function

    function hipfftGetSize2d_rank_1(plan,nx,ny,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize2d_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftGetSize2d_rank_1 = hipfftGetSize2d_(plan,nx,ny,myType,c_loc(workSize))
    end function

    function hipfftGetSize3d_rank_0(plan,nx,ny,nz,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize3d_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(c_int) :: nz
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target :: workSize
      !
      hipfftGetSize3d_rank_0 = hipfftGetSize3d_(plan,nx,ny,nz,myType,c_loc(workSize))
    end function

    function hipfftGetSize3d_rank_1(plan,nx,ny,nz,myType,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize3d_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: nx
      integer(c_int) :: ny
      integer(c_int) :: nz
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftGetSize3d_rank_1 = hipfftGetSize3d_(plan,nx,ny,nz,myType,c_loc(workSize))
    end function

    function hipfftGetSizeMany_rank_0(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSizeMany_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: rank
      integer(c_int),target :: n
      integer(c_int),target :: inembed
      integer(c_int) :: istride
      integer(c_int) :: idist
      integer(c_int),target :: onembed
      integer(c_int) :: ostride
      integer(c_int) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target :: workSize
      !
      hipfftGetSizeMany_rank_0 = hipfftGetSizeMany_(plan,rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch,c_loc(workSize))
    end function

    function hipfftGetSizeMany_rank_1(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSizeMany_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: rank
      integer(c_int),target,dimension(:) :: n
      integer(c_int),target,dimension(:) :: inembed
      integer(c_int) :: istride
      integer(c_int) :: idist
      integer(c_int),target,dimension(:) :: onembed
      integer(c_int) :: ostride
      integer(c_int) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_int) :: batch
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftGetSizeMany_rank_1 = hipfftGetSizeMany_(plan,rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch,c_loc(workSize))
    end function

    function hipfftGetSizeMany64_rank_0(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSizeMany64_rank_0
      type(c_ptr) :: plan
      integer(c_int) :: rank
      integer(c_long_long),target :: n
      integer(c_long_long),target :: inembed
      integer(c_long_long) :: istride
      integer(c_long_long) :: idist
      integer(c_long_long),target :: onembed
      integer(c_long_long) :: ostride
      integer(c_long_long) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_long_long) :: batch
      integer(c_size_t),target :: workSize
      !
      hipfftGetSizeMany64_rank_0 = hipfftGetSizeMany64_(plan,rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch,c_loc(workSize))
    end function

    function hipfftGetSizeMany64_rank_1(plan,rank,n,inembed,istride,idist,onembed,ostride,odist,myType,batch,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSizeMany64_rank_1
      type(c_ptr) :: plan
      integer(c_int) :: rank
      integer(c_long_long),target,dimension(:) :: n
      integer(c_long_long),target,dimension(:) :: inembed
      integer(c_long_long) :: istride
      integer(c_long_long) :: idist
      integer(c_long_long),target,dimension(:) :: onembed
      integer(c_long_long) :: ostride
      integer(c_long_long) :: odist
      integer(kind(HIPFFT_R2C)) :: myType
      integer(c_long_long) :: batch
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftGetSizeMany64_rank_1 = hipfftGetSizeMany64_(plan,rank,c_loc(n),c_loc(inembed),istride,idist,c_loc(onembed),ostride,odist,myType,batch,c_loc(workSize))
    end function

    function hipfftGetSize_rank_0(plan,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize_rank_0
      type(c_ptr) :: plan
      integer(c_size_t),target :: workSize
      !
      hipfftGetSize_rank_0 = hipfftGetSize_(plan,c_loc(workSize))
    end function

    function hipfftGetSize_rank_1(plan,workSize)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftGetSize_rank_1
      type(c_ptr) :: plan
      integer(c_size_t),target,dimension(:) :: workSize
      !
      hipfftGetSize_rank_1 = hipfftGetSize_(plan,c_loc(workSize))
    end function

    function hipfftExecC2C_rank_0(plan,idata,odata,direction)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecC2C_rank_0
      type(c_ptr) :: plan
      complex(c_float_complex),target :: idata
      complex(c_float_complex),target :: odata
      integer(c_int) :: direction
      !
      hipfftExecC2C_rank_0 = hipfftExecC2C_(plan,c_loc(idata),c_loc(odata),direction)
    end function

    function hipfftExecC2C_rank_1(plan,idata,odata,direction)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecC2C_rank_1
      type(c_ptr) :: plan
      complex(c_float_complex),target,dimension(:) :: idata
      complex(c_float_complex),target,dimension(:) :: odata
      integer(c_int) :: direction
      !
      hipfftExecC2C_rank_1 = hipfftExecC2C_(plan,c_loc(idata),c_loc(odata),direction)
    end function

    function hipfftExecR2C_rank_0(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecR2C_rank_0
      type(c_ptr) :: plan
      real(c_float),target :: idata
      complex(c_float_complex),target :: odata
      !
      hipfftExecR2C_rank_0 = hipfftExecR2C_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecR2C_rank_1(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecR2C_rank_1
      type(c_ptr) :: plan
      real(c_float),target,dimension(:) :: idata
      complex(c_float_complex),target,dimension(:) :: odata
      !
      hipfftExecR2C_rank_1 = hipfftExecR2C_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecC2R_rank_0(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecC2R_rank_0
      type(c_ptr) :: plan
      complex(c_float_complex),target :: idata
      real(c_float),target :: odata
      !
      hipfftExecC2R_rank_0 = hipfftExecC2R_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecC2R_rank_1(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecC2R_rank_1
      type(c_ptr) :: plan
      complex(c_float_complex),target,dimension(:) :: idata
      real(c_float),target,dimension(:) :: odata
      !
      hipfftExecC2R_rank_1 = hipfftExecC2R_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecZ2Z_rank_0(plan,idata,odata,direction)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecZ2Z_rank_0
      type(c_ptr) :: plan
      complex(c_double_complex),target :: idata
      complex(c_double_complex),target :: odata
      integer(c_int) :: direction
      !
      hipfftExecZ2Z_rank_0 = hipfftExecZ2Z_(plan,c_loc(idata),c_loc(odata),direction)
    end function

    function hipfftExecZ2Z_rank_1(plan,idata,odata,direction)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecZ2Z_rank_1
      type(c_ptr) :: plan
      complex(c_double_complex),target,dimension(:) :: idata
      complex(c_double_complex),target,dimension(:) :: odata
      integer(c_int) :: direction
      !
      hipfftExecZ2Z_rank_1 = hipfftExecZ2Z_(plan,c_loc(idata),c_loc(odata),direction)
    end function

    function hipfftExecD2Z_rank_0(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecD2Z_rank_0
      type(c_ptr) :: plan
      real(c_double),target :: idata
      complex(c_double_complex),target :: odata
      !
      hipfftExecD2Z_rank_0 = hipfftExecD2Z_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecD2Z_rank_1(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecD2Z_rank_1
      type(c_ptr) :: plan
      real(c_double),target,dimension(:) :: idata
      complex(c_double_complex),target,dimension(:) :: odata
      !
      hipfftExecD2Z_rank_1 = hipfftExecD2Z_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecZ2D_rank_0(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecZ2D_rank_0
      type(c_ptr) :: plan
      complex(c_double_complex),target :: idata
      real(c_double),target :: odata
      !
      hipfftExecZ2D_rank_0 = hipfftExecZ2D_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecZ2D_rank_1(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecZ2D_rank_1
      type(c_ptr) :: plan
      complex(c_double_complex),target,dimension(:) :: idata
      real(c_double),target,dimension(:) :: odata
      !
      hipfftExecZ2D_rank_1 = hipfftExecZ2D_(plan,c_loc(idata),c_loc(odata))
    end function

    ! 2D    
    function hipfftExecC2C_rank_2(plan,idata,odata,direction)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecC2C_rank_2
      type(c_ptr),value :: plan
      complex(c_float_complex),target,dimension(:,:) :: idata
      complex(c_float_complex),target,dimension(:,:) :: odata
      integer(c_int),value :: direction
      !
      hipfftExecC2C_rank_2 = hipfftExecC2C_(plan,c_loc(idata),c_loc(odata),direction)
    end function

    function hipfftExecR2C_rank_2(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecR2C_rank_2
      type(c_ptr),value :: plan
      real(c_float),target,dimension(:,:) :: idata
      complex(c_float_complex),target,dimension(:,:) :: odata
      !
      hipfftExecR2C_rank_2 = hipfftExecR2C_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecC2R_rank_2(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecC2R_rank_2
      type(c_ptr),value :: plan
      complex(c_float_complex),target,dimension(:,:) :: idata
      real(c_float),target,dimension(:,:) :: odata
      !
      hipfftExecC2R_rank_2 = hipfftExecC2R_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecZ2Z_rank_2(plan,idata,odata,direction)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecZ2Z_rank_2
      type(c_ptr),value :: plan
      complex(c_double_complex),target,dimension(:,:) :: idata
      complex(c_double_complex),target,dimension(:,:) :: odata
      integer(c_int),value :: direction
      !
      hipfftExecZ2Z_rank_2 = hipfftExecZ2Z_(plan,c_loc(idata),c_loc(odata),direction)
    end function

    function hipfftExecD2Z_rank_2(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecD2Z_rank_2
      type(c_ptr),value :: plan
      real(c_double),target,dimension(:,:) :: idata
      complex(c_double_complex),target,dimension(:,:) :: odata
      !
      hipfftExecD2Z_rank_2 = hipfftExecD2Z_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecZ2D_rank_2(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecZ2D_rank_2
      type(c_ptr),value :: plan
      complex(c_double_complex),target,dimension(:,:) :: idata
      real(c_double),target,dimension(:,:) :: odata
      !
      hipfftExecZ2D_rank_2 = hipfftExecZ2D_(plan,c_loc(idata),c_loc(odata))
    end function

    ! 3D
    function hipfftExecC2C_rank_3(plan,idata,odata,direction)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecC2C_rank_3
      type(c_ptr),value :: plan
      complex(c_float_complex),target,dimension(:,:,:) :: idata
      complex(c_float_complex),target,dimension(:,:,:) :: odata
      integer(c_int),value :: direction
      !
      hipfftExecC2C_rank_3 = hipfftExecC2C_(plan,c_loc(idata),c_loc(odata),direction)
    end function

    function hipfftExecR2C_rank_3(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecR2C_rank_3
      type(c_ptr),value :: plan
      real(c_float),target,dimension(:,:,:) :: idata
      complex(c_float_complex),target,dimension(:,:,:) :: odata
      !
      hipfftExecR2C_rank_3 = hipfftExecR2C_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecC2R_rank_3(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecC2R_rank_3
      type(c_ptr),value :: plan
      complex(c_float_complex),target,dimension(:,:,:) :: idata
      real(c_float),target,dimension(:,:,:) :: odata
      !
      hipfftExecC2R_rank_3 = hipfftExecC2R_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecZ2Z_rank_3(plan,idata,odata,direction)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecZ2Z_rank_3
      type(c_ptr),value :: plan
      complex(c_double_complex),target,dimension(:,:,:) :: idata
      complex(c_double_complex),target,dimension(:,:,:) :: odata
      integer(c_int),value :: direction
      !
      hipfftExecZ2Z_rank_3 = hipfftExecZ2Z_(plan,c_loc(idata),c_loc(odata),direction)
    end function

    function hipfftExecD2Z_rank_3(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecD2Z_rank_3
      type(c_ptr),value :: plan
      real(c_double),target,dimension(:,:,:) :: idata
      complex(c_double_complex),target,dimension(:,:,:) :: odata
      !
      hipfftExecD2Z_rank_3 = hipfftExecD2Z_(plan,c_loc(idata),c_loc(odata))
    end function

    function hipfftExecZ2D_rank_3(plan,idata,odata)
      use iso_c_binding
      use hipfort_hipfft_enums
      implicit none
      integer(kind(HIPFFT_SUCCESS)) :: hipfftExecZ2D_rank_3
      type(c_ptr),value :: plan
      complex(c_double_complex),target,dimension(:,:,:) :: idata
      real(c_double),target,dimension(:,:,:) :: odata
      !
      hipfftExecZ2D_rank_3 = hipfftExecZ2D_(plan,c_loc(idata),c_loc(odata))
    end function
#endif
end module hipfort_hipfft

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_hipsparse_enums
  implicit none

  enum, bind(c)
    enumerator :: HIPSPARSE_STATUS_SUCCESS = 0
    enumerator :: HIPSPARSE_STATUS_NOT_INITIALIZED = 1
    enumerator :: HIPSPARSE_STATUS_ALLOC_FAILED = 2
    enumerator :: HIPSPARSE_STATUS_INVALID_VALUE = 3
    enumerator :: HIPSPARSE_STATUS_ARCH_MISMATCH = 4
    enumerator :: HIPSPARSE_STATUS_MAPPING_ERROR = 5
    enumerator :: HIPSPARSE_STATUS_EXECUTION_FAILED = 6
    enumerator :: HIPSPARSE_STATUS_INTERNAL_ERROR = 7
    enumerator :: HIPSPARSE_STATUS_MATRIX_TYPE_NOT_SUPPORTED = 8
    enumerator :: HIPSPARSE_STATUS_ZERO_PIVOT = 9
    enumerator :: HIPSPARSE_STATUS_NOT_SUPPORTED = 10
    enumerator :: HIPSPARSE_STATUS_INSUFFICIENT_RESOURCES = 11
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_POINTER_MODE_HOST = 0
    enumerator :: HIPSPARSE_POINTER_MODE_DEVICE = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_ACTION_SYMBOLIC = 0
    enumerator :: HIPSPARSE_ACTION_NUMERIC = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_MATRIX_TYPE_GENERAL = 0
    enumerator :: HIPSPARSE_MATRIX_TYPE_SYMMETRIC = 1
    enumerator :: HIPSPARSE_MATRIX_TYPE_HERMITIAN = 2
    enumerator :: HIPSPARSE_MATRIX_TYPE_TRIANGULAR = 3
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_FILL_MODE_LOWER = 0
    enumerator :: HIPSPARSE_FILL_MODE_UPPER = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_DIAG_TYPE_NON_UNIT = 0
    enumerator :: HIPSPARSE_DIAG_TYPE_UNIT = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_INDEX_BASE_ZERO = 0
    enumerator :: HIPSPARSE_INDEX_BASE_ONE = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_OPERATION_NON_TRANSPOSE = 0
    enumerator :: HIPSPARSE_OPERATION_TRANSPOSE = 1
    enumerator :: HIPSPARSE_OPERATION_CONJUGATE_TRANSPOSE = 2
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_HYB_PARTITION_AUTO = 0
    enumerator :: HIPSPARSE_HYB_PARTITION_USER = 1
    enumerator :: HIPSPARSE_HYB_PARTITION_MAX = 2
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_SOLVE_POLICY_NO_LEVEL = 0
    enumerator :: HIPSPARSE_SOLVE_POLICY_USE_LEVEL = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_SIDE_LEFT = 0
    enumerator :: HIPSPARSE_SIDE_RIGHT = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_DIRECTION_ROW = 0
    enumerator :: HIPSPARSE_DIRECTION_COLUMN = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_FORMAT_CSR = 1
    enumerator :: HIPSPARSE_FORMAT_COO = 3
    enumerator :: HIPSPARSE_FORMAT_COO_AOS = 4
    enumerator :: HIPSPARSE_FORMAT_BLOCKED_ELL = 5
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_ORDER_ROW = 0
    enumerator :: HIPSPARSE_ORDER_COLUMN = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_INDEX_16U = 1
    enumerator :: HIPSPARSE_INDEX_32I = 2
    enumerator :: HIPSPARSE_INDEX_64I = 3
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_MV_ALG_DEFAULT = 0
    enumerator :: HIPSPARSE_COOMV_ALG = 1
    enumerator :: HIPSPARSE_CSRMV_ALG1 = 2
    enumerator :: HIPSPARSE_CSRMV_ALG2 = 3
    enumerator :: HIPSPARSE_SPMV_ALG_DEFAULT = 4
    enumerator :: HIPSPARSE_SPMV_COO_ALG1 = 5
    enumerator :: HIPSPARSE_SPMV_COO_ALG2 = 6
    enumerator :: HIPSPARSE_SPMV_CSR_ALG1 = 7
    enumerator :: HIPSPARSE_SPMV_CSR_ALG2 = 8
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_MM_ALG_DEFAULT = 0
    enumerator :: HIPSPARSE_COOMM_ALG1 = 1
    enumerator :: HIPSPARSE_COOMM_ALG2 = 2
    enumerator :: HIPSPARSE_COOMM_ALG3 = 3
    enumerator :: HIPSPARSE_CSRMM_ALG1 = 4
    enumerator :: HIPSPARSE_SPMM_ALG_DEFAULT = 5
    enumerator :: HIPSPARSE_SPMM_COO_ALG1 = 6
    enumerator :: HIPSPARSE_SPMM_COO_ALG2 = 7
    enumerator :: HIPSPARSE_SPMM_COO_ALG3 = 8
    enumerator :: HIPSPARSE_SPMM_COO_ALG4 = 9
    enumerator :: HIPSPARSE_SPMM_CSR_ALG1 = 10
    enumerator :: HIPSPARSE_SPMM_CSR_ALG2 = 11
    enumerator :: HIPSPARSE_SPMM_BLOCKED_ELL_ALG1 = 12
    enumerator :: HIPSPARSE_SPMM_CSR_ALG3 = 13
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_SPARSETODENSE_ALG_DEFAULT = 0
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_DENSETOSPARSE_ALG_DEFAULT = 0
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_SDDMM_ALG_DEFAULT = 0
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_SPSV_ALG_DEFAULT = 0
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_SPSM_ALG_DEFAULT = 0
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_SPMAT_FILL_MODE = 0
    enumerator :: HIPSPARSE_SPMAT_DIAG_TYPE = 1
  end enum

  enum, bind(c)
    enumerator :: HIPSPARSE_SPGEMM_DEFAULT = 0
  end enum

 

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_hipsparse_enums

program hip_sgemv
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none

  integer :: m = 6
  integer :: n = 5
  integer :: i, j

  real, parameter :: alpha = 1.0
  real, parameter :: beta = 0.0

  type(c_ptr) :: handle = c_null_ptr

  real(kind=4), allocatable, target, dimension(:) :: a, x, y

  real(kind=4), pointer, dimension(:) :: da, dx, dy

  real :: error
  real, parameter :: error_max = 10*epsilon(error)

  allocate(x(n))
  allocate(y(m))
  allocate(a(m*n))

  a(:) = 1.0
  x(:) = 1.0
  y(:) = 1.0

  write(*,"(a)",advance="no") "-- Running test 'SGEMV' (Fortran 2008 interfaces) - "

  call hipblasCheck(hipblasCreate(handle))

  call hipCheck(hipMalloc(dx,source=x))
  call hipCheck(hipMalloc(dy,source=y))
  call hipCheck(hipMalloc(da,source=a))

  call hipCheck(hipblasSgemv(handle,HIPBLAS_OP_N,m,n,alpha,da,m,dx,1,beta,dy,1))

  call hipCheck(hipMemcpy(y, dy, hipMemcpyDeviceToHost))

  do i = 1,m
    error = abs(5.0 - y(i))
      if( error > 10*epsilon(error) )then
        write(*,*) "FAILED! Error bigger than max! Error = ", error, "y(i) = ", y(i)
        call exit(1)
     end if
  end do

  call hipblasCheck(hipblasDestroy(handle))

  call hipCheck(hipFree(da))
  call hipCheck(hipFree(dx))
  call hipCheck(hipFree(dy))

  deallocate(a,x,y)

  write(*,*) "PASSED!"

end program hip_sgemv

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_rocfft
  use hipfort_rocfft_enums
  implicit none

 
  !>  @brief Library setup function, called once in program before start of
  !>  library use
  interface rocfft_setup
    function rocfft_setup_() bind(c, name="rocfft_setup")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_setup_
    end function

  end interface
  !>  @brief Library cleanup function, called once in program after end of library
  !>  use
  interface rocfft_cleanup
    function rocfft_cleanup_() bind(c, name="rocfft_cleanup")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_cleanup_
    end function

  end interface
  !>  @brief Create an FFT plan
  !> 
  !>   @details This API creates a plan, which the user can execute
  !>   subsequently.  This function takes many of the fundamental
  !>   parameters needed to specify a transform.
  !> 
  !>   The dimensions parameter can take a value of 1, 2, or 3. The
  !>   'lengths' array specifies the size of data in each dimension. Note
  !>   that lengths[0] is the size of the innermost dimension, lengths[1]
  !>   is the next higher dimension and so on (column-major ordering).
  !> 
  !>   The 'number_of_transforms' parameter specifies how many
  !>   transforms (of the same kind) needs to be computed. By specifying
  !>   a value greater than 1, a batch of transforms can be computed
  !>   with a single API call.
  !> 
  !>   Additionally, a handle to a plan description can be passed for
  !>   more detailed transforms. For simple transforms, this parameter
  !>   can be set to NULL.
  !> 
  !>   The plan must be destroyed with a call to rocfft_plan_destroy.
  !> 
  !>   @param[out] plan plan handle
  !>   @param[in] placement placement of result
  !>   @param[in] transform_type type of transform
  !>   @param[in] precision precision
  !>   @param[in] dimensions dimensions
  !>   @param[in] lengths dimensions-sized array of transform lengths
  !>   @param[in] number_of_transforms number of transforms
  !>   @param[in] description description handle created by
  !>  rocfft_plan_description_create; can be
  !>   NULL for simple transforms
  interface rocfft_plan_create
    function rocfft_plan_create_(plan,placement,transform_type,myPrecision,dimensions,lengths,number_of_transforms,description) bind(c, name="rocfft_plan_create")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_create_
      type(c_ptr) :: plan
      integer(kind(rocfft_placement_inplace)),value :: placement
      integer(kind(rocfft_transform_type_complex_forward)),value :: transform_type
      integer(kind(rocfft_precision_single)),value :: myPrecision
      integer(c_size_t),value :: dimensions
      type(c_ptr),value :: lengths
      integer(c_size_t),value :: number_of_transforms
      type(c_ptr),value :: description
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      rocfft_plan_create_rank_0,&
      rocfft_plan_create_rank_1
#endif
  end interface
  !>  @brief Execute an FFT plan
  !> 
  !>   @details This API executes an FFT plan on buffers given by the user.
  !> 
  !>   If the transform is in-place, only the input buffer is needed and
  !>   the output buffer parameter can be set to NULL. For not in-place
  !>   transforms, output buffers have to be specified.
  !> 
  !>   Input and output buffer are arrays of pointers.  Interleaved
  !>   array formats are the default, and require just one pointer per
  !>   input or output buffer.  Planar array formats require two
  !>   pointers per input or output buffer - real and imaginary
  !>   pointers, in that order.
  !> 
  !>   Note that input buffers may still be overwritten during execution
  !>   of a transform, even if the transform is not in-place.
  !> 
  !>   The final parameter in this function is a rocfft_execution_info
  !>   handle. This optional parameter serves as a way for the user to control
  !>   execution streams and work buffers.
  !> 
  !>   @param[in] plan plan handle
  !>   @param[in,out] in_buffer array (of size 1 for interleaved data, of size 2
  !>  for planar data) of input buffers
  !>   @param[in,out] out_buffer array (of size 1 for interleaved data, of size 2
  !>  for planar data) of output buffers, ignored for in-place transforms
  !>   @param[in] info execution info handle created by
  !>  rocfft_execution_info_create
  interface rocfft_execute
    function rocfft_execute_(plan,in_buffer,out_buffer,myInfo) bind(c, name="rocfft_execute")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_execute_
      type(c_ptr),value :: plan
      type(c_ptr) :: in_buffer
      type(c_ptr) :: out_buffer
      type(c_ptr),value :: myInfo
    end function

  end interface
  !>  @brief Destroy an FFT plan
  !>   @details This API frees the plan after it is no longer needed.
  !>   @param[in] plan plan handle
  interface rocfft_plan_destroy
    function rocfft_plan_destroy_(plan) bind(c, name="rocfft_plan_destroy")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_destroy_
      type(c_ptr),value :: plan
    end function

  end interface
  !>  @brief Set scaling factor in single precision
  !>   @details This is one of plan description functions to specify optional additional plan properties using the description handle. This API specifies scaling factor.
  !>   @param[in] description description handle
  !>   @param[in] scale scaling factor
  interface rocfft_plan_description_set_scale_float
    function rocfft_plan_description_set_scale_float_(description,scale) bind(c, name="rocfft_plan_description_set_scale_float")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_description_set_scale_float_
      type(c_ptr),value :: description
      real(c_float),value :: scale
    end function

  end interface
  !>  @brief Set scaling factor in double precision
  !>   @details This is one of plan description functions to specify optional additional plan properties using the description handle. This API specifies scaling factor.
  !>   @param[in] description description handle
  !>   @param[in] scale scaling factor
  interface rocfft_plan_description_set_scale_double
    function rocfft_plan_description_set_scale_double_(description,scale) bind(c, name="rocfft_plan_description_set_scale_double")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_description_set_scale_double_
      type(c_ptr),value :: description
      real(c_double),value :: scale
    end function

  end interface
  !>   @brief Set advanced data layout parameters on a plan description
  !>  
  !>   @details This API specifies advanced layout of input/output
  !>   buffers for a plan description.
  !>  
  !>   The following parameters are supported for inputs and outputs:
  !> 
  !>   * Array type (real, hermitian, or complex data, in either
  !>     interleaved or planar format).
  !>       * Real forward transforms require real input and hermitian output.
  !>       * Real inverse transforms require hermitian input and real output.
  !>       * Complex transforms require complex input and output.
  !>       * Hermitian and complex data defaults to interleaved if a specific
  !>           format is not specified.
  !>   * Offset of first data element in the data buffer.  Defaults to 0 if unspecified.
  !>   * Stride between consecutive elements in each dimension.  Defaults
  !>       to contiguous data in all dimensions if unspecified.
  !>   * Distance between consecutive batches.  Defaults to contiguous
  !>       batches if unspecified.
  !> 
  !>   Not all combinations of array types are supported and error codes
  !>   will be returned for unsupported cases.
  !> 
  !>   @param[in, out] description description handle
  !>   @param[in] in_array_type array type of input buffer
  !>   @param[in] out_array_type array type of output buffer
  !>   @param[in] in_offsets offsets, in element units, to start of data in input buffer
  !>   @param[in] out_offsets offsets, in element units, to start of data in output buffer
  !>   @param[in] in_strides_size size of in_strides array (must be equal to transform dimensions)
  !>   @param[in] in_strides array of strides, in each dimension, of
  !>    input buffer; if set to null ptr library chooses defaults
  !>   @param[in] in_distance distance between start of each data instance in input buffer
  !>   @param[in] out_strides_size size of out_strides array (must be
  !>   equal to transform dimensions)
  !>   @param[in] out_strides array of strides, in each dimension, of
  !>    output buffer; if set to null ptr library chooses defaults
  !>   @param[in] out_distance distance between start of each data instance in output buffer
  interface rocfft_plan_description_set_data_layout
    function rocfft_plan_description_set_data_layout_(description,in_array_type,out_array_type,in_offsets,out_offsets,in_strides_size,in_strides,in_distance,out_strides_size,out_strides,out_distance) bind(c, name="rocfft_plan_description_set_data_layout")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_description_set_data_layout_
      type(c_ptr),value :: description
      integer(kind(rocfft_array_type_complex_interleaved)),value :: in_array_type
      integer(kind(rocfft_array_type_complex_interleaved)),value :: out_array_type
      type(c_ptr),value :: in_offsets
      type(c_ptr),value :: out_offsets
      integer(c_size_t),value :: in_strides_size
      type(c_ptr),value :: in_strides
      integer(c_size_t),value :: in_distance
      integer(c_size_t),value :: out_strides_size
      type(c_ptr),value :: out_strides
      integer(c_size_t),value :: out_distance
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure &
      rocfft_plan_description_set_data_layout_rank_0,&
      rocfft_plan_description_set_data_layout_rank_1
#endif
  end interface
  !>  @brief Get library version string
  !> 
  !>  @param[in, out] buf buffer that receives the version string
  !>  @param[in] len length of buf, minimum 30 characters
  interface rocfft_get_version_string
    function rocfft_get_version_string_(buf,len) bind(c, name="rocfft_get_version_string")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_get_version_string_
      type(c_ptr),value :: buf
      integer(c_size_t),value :: len
    end function

  end interface
  !>  @brief Set devices in plan description
  !>   @details This is one of plan description functions to specify optional additional plan properties using the description handle. This API specifies what compute devices to target.
  !>   @param[in] description description handle
  !>   @param[in] devices array of device identifiers
  !>   @param[in] number_of_devices number of devices (size of devices array)
  interface rocfft_plan_description_set_devices
    function rocfft_plan_description_set_devices_(description,devices,number_of_devices) bind(c, name="rocfft_plan_description_set_devices")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_description_set_devices_
      type(c_ptr),value :: description
      type(c_ptr),value :: devices
      integer(c_size_t),value :: number_of_devices
    end function

  end interface
  !>  @brief Get work buffer size
  !>   @details Get the work buffer size required for a plan.
  !>   @param[in] plan plan handle
  !>   @param[out] size_in_bytes size of needed work buffer in bytes
  interface rocfft_plan_get_work_buffer_size
    function rocfft_plan_get_work_buffer_size_(plan,size_in_bytes) bind(c, name="rocfft_plan_get_work_buffer_size")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_get_work_buffer_size_
      type(c_ptr),value :: plan
      integer(c_size_t) :: size_in_bytes
    end function

  end interface
  !>  @brief Print all plan information
  !>   @details Prints plan details to stdout, to aid debugging
  !>   @param[in] plan plan handle
  interface rocfft_plan_get_print
    function rocfft_plan_get_print_(plan) bind(c, name="rocfft_plan_get_print")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_get_print_
      type(c_ptr),value :: plan
    end function

  end interface
  !>  @brief Create plan description
  !>   @details This API creates a plan description with which the user
  !>  can set extra plan properties.  The plan description must be freed
  !>  with a call to rocfft_plan_description_destroy.
  !>   @param[out] description plan description handle
  interface rocfft_plan_description_create
    function rocfft_plan_description_create_(description) bind(c, name="rocfft_plan_description_create")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_description_create_
      type(c_ptr) :: description
    end function

  end interface
  !>  @brief Destroy a plan description
  !>   @details This API frees the plan description.  A plan description
  !>   can be freed any time after it is passed to rocfft_plan_create.
  !>   @param[in] description plan description handle
  interface rocfft_plan_description_destroy
    function rocfft_plan_description_destroy_(description) bind(c, name="rocfft_plan_description_destroy")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_description_destroy_
      type(c_ptr),value :: description
    end function

  end interface
  !>  @brief Create execution info
  !>   @details This API creates an execution info with which the user
  !>  can control plan execution and work buffers.  The execution info must be freed
  !>  with a call to rocfft_execution_info_destroy.
  !>   @param[out] info execution info handle
  interface rocfft_execution_info_create
    function rocfft_execution_info_create_(myInfo) bind(c, name="rocfft_execution_info_create")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_execution_info_create_
      type(c_ptr) :: myInfo
    end function

  end interface
  !>  @brief Destroy an execution info
  !>   @details This API frees the execution info.  An execution info
  !>   object can be freed any time after it is passed to
  !>   rocfft_execute.
  !>   @param[in] info execution info handle
  interface rocfft_execution_info_destroy
    function rocfft_execution_info_destroy_(myInfo) bind(c, name="rocfft_execution_info_destroy")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_execution_info_destroy_
      type(c_ptr),value :: myInfo
    end function

  end interface
  !>  @brief Set work buffer in execution info
  !> 
  !>   @details This is one of the execution info functions to specify
  !>   optional additional information to control execution.  This API
  !>   provides a work buffer for the transform. It must be called
  !>   before rocfft_execute.
  !> 
  !>   When a non-zero value is obtained from
  !>   rocfft_plan_get_work_buffer_size, that means the library needs a
  !>   work buffer to compute the transform. In this case, the user
  !>   should allocate the work buffer and pass it to the library via
  !>   this API.
  !> 
  !>   If a work buffer is required for the transform but is not
  !>   specified using this function, rocfft_execute will automatically
  !>   allocate the required buffer and free it when execution is
  !>   finished.
  !> 
  !>   Users should allocate their own work buffers if they need precise
  !>   control over the lifetimes of those buffers, or if multiple plans
  !>   need to share the same buffer.
  !> 
  !>   @param[in] info execution info handle
  !>   @param[in] work_buffer work buffer
  !>   @param[in] size_in_bytes size of work buffer in bytes
  interface rocfft_execution_info_set_work_buffer
    function rocfft_execution_info_set_work_buffer_(myInfo,work_buffer,size_in_bytes) bind(c, name="rocfft_execution_info_set_work_buffer")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_execution_info_set_work_buffer_
      type(c_ptr),value :: myInfo
      type(c_ptr),value :: work_buffer
      integer(c_size_t),value :: size_in_bytes
    end function

  end interface
  !>  @brief Set execution mode in execution info
  !>   @details This is one of the execution info functions to specify optional additional information to control execution.
  !>   This API specifies execution mode. It has to be called before the call to rocfft_execute.
  !>   Appropriate enumeration value can be specified to control blocking/non-blocking behavior of the rocfft_execute call.
  !>   @param[in] info execution info handle
  !>   @param[in] mode execution mode
  interface rocfft_execution_info_set_mode
    function rocfft_execution_info_set_mode_(myInfo,mode) bind(c, name="rocfft_execution_info_set_mode")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_execution_info_set_mode_
      type(c_ptr),value :: myInfo
      integer(kind(rocfft_exec_mode_nonblocking)),value :: mode
    end function

  end interface
  !>  @brief Set stream in execution info
  !>   @details Associates an existing compute stream to a plan.  This
  !>  must be called before the call to rocfft_execute.
  !> 
  !>   Once the association is made, execution of the FFT will run the
  !>   computation through the specified stream.
  !> 
  !>   The stream must be of type hipStream_t. It is an error to pass
  !>   the address of a hipStream_t object.
  !> 
  !>   @param[in] info execution info handle
  !>   @param[in] stream underlying compute stream
  interface rocfft_execution_info_set_stream
    function rocfft_execution_info_set_stream_(myInfo,stream) bind(c, name="rocfft_execution_info_set_stream")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_execution_info_set_stream_
      type(c_ptr),value :: myInfo
      type(c_ptr),value :: stream
    end function

  end interface
  !>  @brief Set a load callback for a plan execution (experimental)
  !>   @details This function specifies a user-defined callback function
  !>   that is run to load input from global memory at the start of the
  !>   transform.  Callbacks are an experimental feature in rocFFT.
  !> 
  !>   Callback function pointers/data are given as arrays, with one
  !>   function/data pointer per device executing this plan.  Currently,
  !>   plans can only use one device.
  !> 
  !>   The provided function pointers replace any previously-specified
  !>   load callback for this execution info handle.
  !> 
  !>   Load callbacks have the following signature:
  !> 
  !>   @code
  !>   T load_cb(T* data, size_t offset, void* cbdata, void* sharedMem);
  !>   @endcode
  !> 
  !>   'T' is the type of a single element of the input buffer.  It is
  !>   the caller's responsibility to ensure that the function type is
  !>   appropriate for the plan (for example, a single-precision
  !>   real-to-complex transform would load single-precision real
  !>   elements).
  !> 
  !>   A null value for 'cb' may be specified to clear any previously
  !>   registered load callback.
  !> 
  !>   Currently, 'shared_mem_bytes' must be 0.  Callbacks are not
  !>   supported on transforms that use planar formats for either input
  !>   or output.
  !> 
  !>   @param[in] info execution info handle
  !>   @param[in] cb callback function pointers
  !>   @param[in] cbdata callback function data, passed to the function pointer when it is called
  !>   @param[in] shared_mem_bytes amount of shared memory to allocate for the callback function to use
  interface rocfft_execution_info_set_load_callback
    function rocfft_execution_info_set_load_callback_(myInfo,cb_functions,cb_data,shared_mem_bytes) bind(c, name="rocfft_execution_info_set_load_callback")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_execution_info_set_load_callback_
      type(c_ptr),value :: myInfo
      type(c_ptr) :: cb_functions
      type(c_ptr) :: cb_data
      integer(c_size_t),value :: shared_mem_bytes
    end function

  end interface
  !>  @brief Set a store callback for a plan execution (experimental)
  !>   @details This function specifies a user-defined callback function
  !>   that is run to store output to global memory at the end of the
  !>   transform.  Callbacks are an experimental feature in rocFFT.
  !> 
  !>   Callback function pointers/data are given as arrays, with one
  !>   function/data pointer per device executing this plan.  Currently,
  !>   plans can only use one device.
  !> 
  !>   The provided function pointers replace any previously-specified
  !>   store callback for this execution info handle.
  !> 
  !>   Store callbacks have the following signature:
  !> 
  !>   @code
  !>   void store_cb(T* data, size_t offset, T element, void* cbdata, void* sharedMem);
  !>   @endcode
  !> 
  !>   'T' is the type of a single element of the output buffer.  It is
  !>   the caller's responsibility to ensure that the function type is
  !>   appropriate for the plan (for example, a single-precision
  !>   real-to-complex transform would store single-precision complex
  !>   elements).
  !> 
  !>   A null value for 'cb' may be specified to clear any previously
  !>   registered store callback.
  !> 
  !>   Currently, 'shared_mem_bytes' must be 0.  Callbacks are not
  !>   supported on transforms that use planar formats for either input
  !>   or output.
  !> 
  !>   @param[in] info execution info handle
  !>   @param[in] cb callbacks function pointers
  !>   @param[in] cbdata callback function data, passed to the function pointer when it is called
  !>   @param[in] shared_mem_bytes amount of shared memory to allocate for the callback function to use
  interface rocfft_execution_info_set_store_callback
    function rocfft_execution_info_set_store_callback_(myInfo,cb_functions,cb_data,shared_mem_bytes) bind(c, name="rocfft_execution_info_set_store_callback")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_execution_info_set_store_callback_
      type(c_ptr),value :: myInfo
      type(c_ptr) :: cb_functions
      type(c_ptr) :: cb_data
      integer(c_size_t),value :: shared_mem_bytes
    end function

  end interface
  !>  @brief Get events from execution info
  !>   @details This is one of the execution info functions to retrieve information from execution.
  !>   This API obtains event information. It has to be called after the call to rocfft_execute.
  !>   This gets handles to events that the library created around one or more kernel launches during execution.
  !>   @param[in] info execution info handle
  !>   @param[out] events array of events
  !>   @param[out] number_of_events number of events (size of events array)
  interface rocfft_execution_info_get_events
    function rocfft_execution_info_get_events_(myInfo,events,number_of_events) bind(c, name="rocfft_execution_info_get_events")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_execution_info_get_events_
      type(c_ptr),value :: myInfo
      type(c_ptr) :: events
      integer(c_size_t) :: number_of_events
    end function

  end interface
  !>  @brief Serialize compiled kernel cache
  !> 
  !>   @details Serialize rocFFT's cache of compiled kernels into a
  !>   buffer.  This buffer is allocated by rocFFT and must be freed
  !>   with a call to rocfft_cache_buffer_free.  The length of the
  !>   buffer in bytes is written to 'buffer_len_bytes'.
  interface rocfft_cache_serialize
    function rocfft_cache_serialize_(buffer,buffer_len_bytes) bind(c, name="rocfft_cache_serialize")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_cache_serialize_
      type(c_ptr) :: buffer
      type(c_ptr),value :: buffer_len_bytes
    end function

  end interface
  !>  @brief Free cache serialization buffer
  !> 
  !>   @details Deallocate a buffer allocated by rocfft_cache_serialize.
  interface rocfft_cache_buffer_free
    function rocfft_cache_buffer_free_(buffer) bind(c, name="rocfft_cache_buffer_free")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_cache_buffer_free_
      type(c_ptr),value :: buffer
    end function

  end interface
  !>  @brief Deserialize a buffer into the compiled kernel cache.
  !> 
  !>   @details Kernels in the buffer that match already-cached kernels
  !>   will replace those kernels that are in the cache.  Already-cached
  !>   kernels that do not match those in the buffer are unmodified by
  !>   this operation.  The cache is unmodified if either a null buffer
  !>   pointer or a zero length is passed.
  interface rocfft_cache_deserialize
    function rocfft_cache_deserialize_(buffer,buffer_len_bytes) bind(c, name="rocfft_cache_deserialize")
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_cache_deserialize_
      type(c_ptr),value :: buffer
      integer(c_size_t),value :: buffer_len_bytes
    end function

  end interface

#ifdef USE_FPOINTER_INTERFACES
  contains
    function rocfft_plan_create_rank_0(plan,placement,transform_type,myPrecision,dimensions,lengths,number_of_transforms,description)
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_create_rank_0
      type(c_ptr) :: plan
      integer(kind(rocfft_placement_inplace)) :: placement
      integer(kind(rocfft_transform_type_complex_forward)) :: transform_type
      integer(kind(rocfft_precision_single)) :: myPrecision
      integer(c_size_t) :: dimensions
      integer(c_size_t),target :: lengths
      integer(c_size_t) :: number_of_transforms
      type(c_ptr) :: description
      !
      rocfft_plan_create_rank_0 = rocfft_plan_create_(plan,placement,transform_type,myPrecision,dimensions,c_loc(lengths),number_of_transforms,description)
    end function

    function rocfft_plan_create_rank_1(plan,placement,transform_type,myPrecision,dimensions,lengths,number_of_transforms,description)
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_create_rank_1
      type(c_ptr) :: plan
      integer(kind(rocfft_placement_inplace)) :: placement
      integer(kind(rocfft_transform_type_complex_forward)) :: transform_type
      integer(kind(rocfft_precision_single)) :: myPrecision
      integer(c_size_t) :: dimensions
      integer(c_size_t),target,dimension(:) :: lengths
      integer(c_size_t) :: number_of_transforms
      type(c_ptr) :: description
      !
      rocfft_plan_create_rank_1 = rocfft_plan_create_(plan,placement,transform_type,myPrecision,dimensions,c_loc(lengths),number_of_transforms,description)
    end function

    function rocfft_plan_description_set_data_layout_rank_0(description,in_array_type,out_array_type,in_offsets,out_offsets,in_strides_size,in_strides,in_distance,out_strides_size,out_strides,out_distance)
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_description_set_data_layout_rank_0
      type(c_ptr) :: description
      integer(kind(rocfft_array_type_complex_interleaved)) :: in_array_type
      integer(kind(rocfft_array_type_complex_interleaved)) :: out_array_type
      integer(c_size_t),target :: in_offsets
      integer(c_size_t),target :: out_offsets
      integer(c_size_t) :: in_strides_size
      integer(c_size_t),target :: in_strides
      integer(c_size_t) :: in_distance
      integer(c_size_t) :: out_strides_size
      integer(c_size_t),target :: out_strides
      integer(c_size_t) :: out_distance
      !
      rocfft_plan_description_set_data_layout_rank_0 = rocfft_plan_description_set_data_layout_(description,in_array_type,out_array_type,c_loc(in_offsets),c_loc(out_offsets),in_strides_size,c_loc(in_strides),in_distance,out_strides_size,c_loc(out_strides),out_distance)
    end function

    function rocfft_plan_description_set_data_layout_rank_1(description,in_array_type,out_array_type,in_offsets,out_offsets,in_strides_size,in_strides,in_distance,out_strides_size,out_strides,out_distance)
      use iso_c_binding
      use hipfort_rocfft_enums
      implicit none
      integer(kind(rocfft_status_success)) :: rocfft_plan_description_set_data_layout_rank_1
      type(c_ptr) :: description
      integer(kind(rocfft_array_type_complex_interleaved)) :: in_array_type
      integer(kind(rocfft_array_type_complex_interleaved)) :: out_array_type
      integer(c_size_t),target,dimension(:) :: in_offsets
      integer(c_size_t),target,dimension(:) :: out_offsets
      integer(c_size_t) :: in_strides_size
      integer(c_size_t),target,dimension(:) :: in_strides
      integer(c_size_t) :: in_distance
      integer(c_size_t) :: out_strides_size
      integer(c_size_t),target,dimension(:) :: out_strides
      integer(c_size_t) :: out_distance
      !
      rocfft_plan_description_set_data_layout_rank_1 = rocfft_plan_description_set_data_layout_(description,in_array_type,out_array_type,c_loc(in_offsets),c_loc(out_offsets),in_strides_size,c_loc(in_strides),in_distance,out_strides_size,c_loc(out_strides),out_distance)
    end function

  
#endif
end module hipfort_rocfft

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module hipfort_hipblas_auxiliary

  interface hipblasSetVector
#ifdef USE_CUDA_NAMES
    function hipblasSetVector_(n,elem_size,x,incx,y,incy) bind(c, name="cublasSetVector") result(ret)
#else
    function hipblasSetVector_(n,elem_size,x,incx,y,incy) bind(c, name="hipblasSetVector") result(ret)
#endif
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),value :: elem_size
      type(c_ptr),value :: x
      integer(c_int),value :: incx
      type(c_ptr),value :: y
      integer(c_int),value :: incy
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure hipblasSetVector_l_rank_0,hipblasSetVector_l_full_rank,&
      hipblasSetVector_i4_rank_0,hipblasSetVector_i4_full_rank,&
      hipblasSetVector_i8_rank_0,hipblasSetVector_i8_full_rank,&
      hipblasSetVector_r4_rank_0,hipblasSetVector_r4_full_rank,&
      hipblasSetVector_r8_rank_0,hipblasSetVector_r8_full_rank,&
      hipblasSetVector_c4_rank_0,hipblasSetVector_c4_full_rank,&
      hipblasSetVector_c8_rank_0,hipblasSetVector_c8_full_rank 
#endif
  end interface

  interface hipblasGetVector
#ifdef USE_CUDA_NAMES
    function hipblasGetVector_(n,elem_size,x,incx,y,incy) bind(c, name="cublasGetVector") result(ret)
#else
    function hipblasGetVector_(n,elem_size,x,incx,y,incy) bind(c, name="hipblasGetVector") result(ret)
#endif
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),value :: elem_size
      type(c_ptr),value :: x
      integer(c_int),value :: incx
      type(c_ptr),value :: y
      integer(c_int),value :: incy
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure hipblasGetVector_l_rank_0,hipblasGetVector_l_full_rank,&
      hipblasGetVector_i4_rank_0,hipblasGetVector_i4_full_rank,&
      hipblasGetVector_i8_rank_0,hipblasGetVector_i8_full_rank,&
      hipblasGetVector_r4_rank_0,hipblasGetVector_r4_full_rank,&
      hipblasGetVector_r8_rank_0,hipblasGetVector_r8_full_rank,&
      hipblasGetVector_c4_rank_0,hipblasGetVector_c4_full_rank,&
      hipblasGetVector_c8_rank_0,hipblasGetVector_c8_full_rank 
#endif
  end interface

  interface hipblasSetMatrix
#ifdef USE_CUDA_NAMES
    function hipblasSetMatrix_(rows,cols,elem_size,A,lda,B,ldb) bind(c, name="cublasSetMatrix") result(ret)
#else
    function hipblasSetMatrix_(rows,cols,elem_size,A,lda,B,ldb) bind(c, name="hipblasSetMatrix") result(ret)
#endif
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),value :: elem_size
      type(c_ptr),value :: A
      integer(c_int),value :: lda
      type(c_ptr),value :: B
      integer(c_int),value :: ldb
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure hipblasSetMatrix_l_full_rank,hipblasSetMatrix_l_rank_0,hipblasSetMatrix_l_rank_1,&
      hipblasSetMatrix_i4_full_rank,hipblasSetMatrix_i4_rank_0,hipblasSetMatrix_i4_rank_1,&
      hipblasSetMatrix_i8_full_rank,hipblasSetMatrix_i8_rank_0,hipblasSetMatrix_i8_rank_1,&
      hipblasSetMatrix_r4_full_rank,hipblasSetMatrix_r4_rank_0,hipblasSetMatrix_r4_rank_1,&
      hipblasSetMatrix_r8_full_rank,hipblasSetMatrix_r8_rank_0,hipblasSetMatrix_r8_rank_1,&
      hipblasSetMatrix_c4_full_rank,hipblasSetMatrix_c4_rank_0,hipblasSetMatrix_c4_rank_1,&
      hipblasSetMatrix_c8_full_rank,hipblasSetMatrix_c8_rank_0,hipblasSetMatrix_c8_rank_1 
#endif
  end interface

  interface hipblasGetMatrix
#ifdef USE_CUDA_NAMES
    function hipblasGetMatrix_(rows,cols,elem_size,A,lda,B,ldb) bind(c, name="cublasGetMatrix") result(ret)
#else
    function hipblasGetMatrix_(rows,cols,elem_size,A,lda,B,ldb) bind(c, name="hipblasGetMatrix") result(ret)
#endif
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),value :: elem_size
      type(c_ptr),value :: A
      integer(c_int),value :: lda
      type(c_ptr),value :: B
      integer(c_int),value :: ldb
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure hipblasGetMatrix_l_full_rank,hipblasGetMatrix_l_rank_0,hipblasGetMatrix_l_rank_1,&
      hipblasGetMatrix_i4_full_rank,hipblasGetMatrix_i4_rank_0,hipblasGetMatrix_i4_rank_1,&
      hipblasGetMatrix_i8_full_rank,hipblasGetMatrix_i8_rank_0,hipblasGetMatrix_i8_rank_1,&
      hipblasGetMatrix_r4_full_rank,hipblasGetMatrix_r4_rank_0,hipblasGetMatrix_r4_rank_1,&
      hipblasGetMatrix_r8_full_rank,hipblasGetMatrix_r8_rank_0,hipblasGetMatrix_r8_rank_1,&
      hipblasGetMatrix_c4_full_rank,hipblasGetMatrix_c4_rank_0,hipblasGetMatrix_c4_rank_1,&
      hipblasGetMatrix_c8_full_rank,hipblasGetMatrix_c8_rank_0,hipblasGetMatrix_c8_rank_1 
#endif
  end interface

  interface hipblasSetVectorAsync
#ifdef USE_CUDA_NAMES
    function hipblasSetVectorAsync_(n,elem_size,x,incx,y,incy,stream) bind(c, name="cublasSetVectorAsync") result(ret)
#else
    function hipblasSetVectorAsync_(n,elem_size,x,incx,y,incy,stream) bind(c, name="hipblasSetVectorAsync") result(ret)
#endif
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),value :: elem_size
      type(c_ptr),value :: x
      integer(c_int),value :: incx
      type(c_ptr),value :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure hipblasSetVectorAsync_l_rank_0,hipblasSetVectorAsync_l_full_rank,&
      hipblasSetVectorAsync_i4_rank_0,hipblasSetVectorAsync_i4_full_rank,&
      hipblasSetVectorAsync_i8_rank_0,hipblasSetVectorAsync_i8_full_rank,&
      hipblasSetVectorAsync_r4_rank_0,hipblasSetVectorAsync_r4_full_rank,&
      hipblasSetVectorAsync_r8_rank_0,hipblasSetVectorAsync_r8_full_rank,&
      hipblasSetVectorAsync_c4_rank_0,hipblasSetVectorAsync_c4_full_rank,&
      hipblasSetVectorAsync_c8_rank_0,hipblasSetVectorAsync_c8_full_rank 
#endif
  end interface

  interface hipblasGetVectorAsync
#ifdef USE_CUDA_NAMES
    function hipblasGetVectorAsync_(n,elem_size,x,incx,y,incy,stream) bind(c, name="cublasGetVectorAsync") result(ret)
#else
    function hipblasGetVectorAsync_(n,elem_size,x,incx,y,incy,stream) bind(c, name="hipblasGetVectorAsync") result(ret)
#endif
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),value :: elem_size
      type(c_ptr),value :: x
      integer(c_int),value :: incx
      type(c_ptr),value :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure hipblasGetVectorAsync_l_rank_0,hipblasGetVectorAsync_l_full_rank,&
      hipblasGetVectorAsync_i4_rank_0,hipblasGetVectorAsync_i4_full_rank,&
      hipblasGetVectorAsync_i8_rank_0,hipblasGetVectorAsync_i8_full_rank,&
      hipblasGetVectorAsync_r4_rank_0,hipblasGetVectorAsync_r4_full_rank,&
      hipblasGetVectorAsync_r8_rank_0,hipblasGetVectorAsync_r8_full_rank,&
      hipblasGetVectorAsync_c4_rank_0,hipblasGetVectorAsync_c4_full_rank,&
      hipblasGetVectorAsync_c8_rank_0,hipblasGetVectorAsync_c8_full_rank 
#endif
  end interface

  interface hipblasSetMatrixAsync
#ifdef USE_CUDA_NAMES
    function hipblasSetMatrixAsync_(rows,cols,elem_size,A,lda,B,ldb,stream) bind(c, name="cublasSetMatrixAsync") result(ret)
#else
    function hipblasSetMatrixAsync_(rows,cols,elem_size,A,lda,B,ldb,stream) bind(c, name="hipblasSetMatrixAsync") result(ret)
#endif
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),value :: elem_size
      type(c_ptr),value :: A
      integer(c_int),value :: lda
      type(c_ptr),value :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure hipblasSetMatrixAsync_l_full_rank,hipblasSetMatrixAsync_l_rank_0,hipblasSetMatrixAsync_l_rank_1,&
      hipblasSetMatrixAsync_i4_full_rank,hipblasSetMatrixAsync_i4_rank_0,hipblasSetMatrixAsync_i4_rank_1,&
      hipblasSetMatrixAsync_i8_full_rank,hipblasSetMatrixAsync_i8_rank_0,hipblasSetMatrixAsync_i8_rank_1,&
      hipblasSetMatrixAsync_r4_full_rank,hipblasSetMatrixAsync_r4_rank_0,hipblasSetMatrixAsync_r4_rank_1,&
      hipblasSetMatrixAsync_r8_full_rank,hipblasSetMatrixAsync_r8_rank_0,hipblasSetMatrixAsync_r8_rank_1,&
      hipblasSetMatrixAsync_c4_full_rank,hipblasSetMatrixAsync_c4_rank_0,hipblasSetMatrixAsync_c4_rank_1,&
      hipblasSetMatrixAsync_c8_full_rank,hipblasSetMatrixAsync_c8_rank_0,hipblasSetMatrixAsync_c8_rank_1 
#endif
  end interface

  interface hipblasGetMatrixAsync
#ifdef USE_CUDA_NAMES
    function hipblasGetMatrixAsync_(rows,cols,elem_size,A,lda,B,ldb,stream) bind(c, name="cublasGetMatrixAsync") result(ret)
#else
    function hipblasGetMatrixAsync_(rows,cols,elem_size,A,lda,B,ldb,stream) bind(c, name="hipblasGetMatrixAsync") result(ret)
#endif
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),value :: elem_size
      type(c_ptr),value :: A
      integer(c_int),value :: lda
      type(c_ptr),value :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure hipblasGetMatrixAsync_l_full_rank,hipblasGetMatrixAsync_l_rank_0,hipblasGetMatrixAsync_l_rank_1,&
      hipblasGetMatrixAsync_i4_full_rank,hipblasGetMatrixAsync_i4_rank_0,hipblasGetMatrixAsync_i4_rank_1,&
      hipblasGetMatrixAsync_i8_full_rank,hipblasGetMatrixAsync_i8_rank_0,hipblasGetMatrixAsync_i8_rank_1,&
      hipblasGetMatrixAsync_r4_full_rank,hipblasGetMatrixAsync_r4_rank_0,hipblasGetMatrixAsync_r4_rank_1,&
      hipblasGetMatrixAsync_r8_full_rank,hipblasGetMatrixAsync_r8_rank_0,hipblasGetMatrixAsync_r8_rank_1,&
      hipblasGetMatrixAsync_c4_full_rank,hipblasGetMatrixAsync_c4_rank_0,hipblasGetMatrixAsync_c4_rank_1,&
      hipblasGetMatrixAsync_c8_full_rank,hipblasGetMatrixAsync_c8_rank_0,hipblasGetMatrixAsync_c8_rank_1 
#endif
  end interface

#ifdef USE_FPOINTER_INTERFACES
contains

    function hipblasSetVector_l_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target :: x
      integer(c_int),value :: incx
      logical(c_bool),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,1,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetVector_l_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target,dimension(:) :: x
      integer(c_int),value :: incx
      logical(c_bool),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,1,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_l_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target :: x
      integer(c_int),value :: incx
      logical(c_bool),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,1,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_l_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target,dimension(:) :: x
      integer(c_int),value :: incx
      logical(c_bool),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,1,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetMatrix_l_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:,:) :: A
      logical(c_bool),target,dimension(:,:) :: B
      !
      ret = hipblasSetMatrix_(rows,cols,1,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasSetMatrix_l_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target :: A
      integer(c_int),value :: lda
      logical(c_bool),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetMatrix_l_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:) :: A
      integer(c_int),value :: lda
      logical(c_bool),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_l_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:,:) :: A
      logical(c_bool),target,dimension(:,:) :: B
      !
      ret = hipblasGetMatrix_(rows,cols,1,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasGetMatrix_l_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target :: A
      integer(c_int),value :: lda
      logical(c_bool),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_l_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:) :: A
      integer(c_int),value :: lda
      logical(c_bool),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetVectorAsync_l_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target :: x
      integer(c_int),value :: incx
      logical(c_bool),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,1,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetVectorAsync_l_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target,dimension(:) :: x
      integer(c_int),value :: incx
      logical(c_bool),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,1,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_l_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target :: x
      integer(c_int),value :: incx
      logical(c_bool),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,1,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_l_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target,dimension(:) :: x
      integer(c_int),value :: incx
      logical(c_bool),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,1,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetMatrixAsync_l_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:,:) :: A
      logical(c_bool),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,1,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasSetMatrixAsync_l_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target :: A
      integer(c_int),value :: lda
      logical(c_bool),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasSetMatrixAsync_l_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:) :: A
      integer(c_int),value :: lda
      logical(c_bool),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_l_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:,:) :: A
      logical(c_bool),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,1,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasGetMatrixAsync_l_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target :: A
      integer(c_int),value :: lda
      logical(c_bool),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_l_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:) :: A
      integer(c_int),value :: lda
      logical(c_bool),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function hipblasSetVector_i4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),target :: x
      integer(c_int),value :: incx
      integer(c_int),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetVector_i4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_int),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_i4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),target :: x
      integer(c_int),value :: incx
      integer(c_int),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_i4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_int),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetMatrix_i4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:,:) :: A
      integer(c_int),target,dimension(:,:) :: B
      !
      ret = hipblasSetMatrix_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasSetMatrix_i4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target :: A
      integer(c_int),value :: lda
      integer(c_int),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetMatrix_i4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_int),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_i4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:,:) :: A
      integer(c_int),target,dimension(:,:) :: B
      !
      ret = hipblasGetMatrix_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasGetMatrix_i4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target :: A
      integer(c_int),value :: lda
      integer(c_int),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_i4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_int),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetVectorAsync_i4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),target :: x
      integer(c_int),value :: incx
      integer(c_int),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetVectorAsync_i4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_int),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_i4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),target :: x
      integer(c_int),value :: incx
      integer(c_int),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_i4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_int),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_int),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetMatrixAsync_i4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:,:) :: A
      integer(c_int),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasSetMatrixAsync_i4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target :: A
      integer(c_int),value :: lda
      integer(c_int),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasSetMatrixAsync_i4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_int),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_i4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:,:) :: A
      integer(c_int),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasGetMatrixAsync_i4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target :: A
      integer(c_int),value :: lda
      integer(c_int),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_i4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_int),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function hipblasSetVector_i8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_long),target :: x
      integer(c_int),value :: incx
      integer(c_long),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetVector_i8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_long),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_long),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_i8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_long),target :: x
      integer(c_int),value :: incx
      integer(c_long),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_i8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_long),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_long),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetMatrix_i8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:,:) :: A
      integer(c_long),target,dimension(:,:) :: B
      !
      ret = hipblasSetMatrix_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasSetMatrix_i8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target :: A
      integer(c_int),value :: lda
      integer(c_long),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetMatrix_i8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_long),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_i8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:,:) :: A
      integer(c_long),target,dimension(:,:) :: B
      !
      ret = hipblasGetMatrix_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasGetMatrix_i8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target :: A
      integer(c_int),value :: lda
      integer(c_long),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_i8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_long),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetVectorAsync_i8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_long),target :: x
      integer(c_int),value :: incx
      integer(c_long),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetVectorAsync_i8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_long),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_long),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_i8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_long),target :: x
      integer(c_int),value :: incx
      integer(c_long),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_i8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      integer(c_long),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_long),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetMatrixAsync_i8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:,:) :: A
      integer(c_long),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasSetMatrixAsync_i8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target :: A
      integer(c_int),value :: lda
      integer(c_long),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasSetMatrixAsync_i8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_long),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_i8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:,:) :: A
      integer(c_long),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasGetMatrixAsync_i8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target :: A
      integer(c_int),value :: lda
      integer(c_long),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_i8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_long),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function hipblasSetVector_r4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_float),target :: x
      integer(c_int),value :: incx
      real(c_float),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetVector_r4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_float),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_float),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_r4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_float),target :: x
      integer(c_int),value :: incx
      real(c_float),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_r4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_float),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_float),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetMatrix_r4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:,:) :: A
      real(c_float),target,dimension(:,:) :: B
      !
      ret = hipblasSetMatrix_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasSetMatrix_r4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target :: A
      integer(c_int),value :: lda
      real(c_float),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetMatrix_r4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_float),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_r4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:,:) :: A
      real(c_float),target,dimension(:,:) :: B
      !
      ret = hipblasGetMatrix_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasGetMatrix_r4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target :: A
      integer(c_int),value :: lda
      real(c_float),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_r4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_float),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetVectorAsync_r4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_float),target :: x
      integer(c_int),value :: incx
      real(c_float),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetVectorAsync_r4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_float),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_float),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_r4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_float),target :: x
      integer(c_int),value :: incx
      real(c_float),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_r4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_float),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_float),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetMatrixAsync_r4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:,:) :: A
      real(c_float),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasSetMatrixAsync_r4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target :: A
      integer(c_int),value :: lda
      real(c_float),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasSetMatrixAsync_r4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_float),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_r4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:,:) :: A
      real(c_float),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasGetMatrixAsync_r4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target :: A
      integer(c_int),value :: lda
      real(c_float),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_r4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_float),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function hipblasSetVector_r8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_double),target :: x
      integer(c_int),value :: incx
      real(c_double),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetVector_r8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_double),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_double),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_r8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_double),target :: x
      integer(c_int),value :: incx
      real(c_double),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_r8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_double),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_double),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetMatrix_r8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:,:) :: A
      real(c_double),target,dimension(:,:) :: B
      !
      ret = hipblasSetMatrix_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasSetMatrix_r8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target :: A
      integer(c_int),value :: lda
      real(c_double),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetMatrix_r8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_double),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_r8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:,:) :: A
      real(c_double),target,dimension(:,:) :: B
      !
      ret = hipblasGetMatrix_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasGetMatrix_r8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target :: A
      integer(c_int),value :: lda
      real(c_double),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_r8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_double),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetVectorAsync_r8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_double),target :: x
      integer(c_int),value :: incx
      real(c_double),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetVectorAsync_r8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_double),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_double),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_r8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_double),target :: x
      integer(c_int),value :: incx
      real(c_double),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_r8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      real(c_double),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_double),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetMatrixAsync_r8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:,:) :: A
      real(c_double),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasSetMatrixAsync_r8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target :: A
      integer(c_int),value :: lda
      real(c_double),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasSetMatrixAsync_r8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_double),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_r8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:,:) :: A
      real(c_double),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasGetMatrixAsync_r8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target :: A
      integer(c_int),value :: lda
      real(c_double),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_r8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_double),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function hipblasSetVector_c4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,2*4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetVector_c4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,2*4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_c4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,2*4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_c4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,2*4,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetMatrix_c4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:,:) :: A
      complex(c_float_complex),target,dimension(:,:) :: B
      !
      ret = hipblasSetMatrix_(rows,cols,2*4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasSetMatrix_c4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetMatrix_c4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_c4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:,:) :: A
      complex(c_float_complex),target,dimension(:,:) :: B
      !
      ret = hipblasGetMatrix_(rows,cols,2*4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasGetMatrix_c4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_c4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetVectorAsync_c4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,2*4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetVectorAsync_c4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,2*4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_c4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,2*4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_c4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,2*4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetMatrixAsync_c4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:,:) :: A
      complex(c_float_complex),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,2*4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasSetMatrixAsync_c4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasSetMatrixAsync_c4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_c4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:,:) :: A
      complex(c_float_complex),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,2*4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasGetMatrixAsync_c4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_c4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function hipblasSetVector_c8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,2*8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetVector_c8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasSetVector_(n,2*8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_c8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,2*8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasGetVector_c8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = hipblasGetVector_(n,2*8,c_loc(x),incx,c_loc(y),incy)
    end function

    function hipblasSetMatrix_c8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:,:) :: A
      complex(c_double_complex),target,dimension(:,:) :: B
      !
      ret = hipblasSetMatrix_(rows,cols,2*8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasSetMatrix_c8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetMatrix_c8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasSetMatrix_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_c8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:,:) :: A
      complex(c_double_complex),target,dimension(:,:) :: B
      !
      ret = hipblasGetMatrix_(rows,cols,2*8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function hipblasGetMatrix_c8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasGetMatrix_c8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = hipblasGetMatrix_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function hipblasSetVectorAsync_c8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,2*8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetVectorAsync_c8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasSetVectorAsync_(n,2*8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_c8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,2*8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasGetVectorAsync_c8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = hipblasGetVectorAsync_(n,2*8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function hipblasSetMatrixAsync_c8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:,:) :: A
      complex(c_double_complex),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,2*8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasSetMatrixAsync_c8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasSetMatrixAsync_c8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasSetMatrixAsync_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_c8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:,:) :: A
      complex(c_double_complex),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,2*8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function hipblasGetMatrixAsync_c8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function hipblasGetMatrixAsync_c8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_hipblas_enums
      implicit none
      integer(kind(HIPBLAS_STATUS_SUCCESS)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = hipblasGetMatrixAsync_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
 

#endif
end module

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_rocrand
  use hipfort_rocrand_enums
  implicit none

 
  !>  \brief Creates a new random number generator.
  !> 
  !>  Creates a new pseudo random number generator of type \p rng_type
  !>  and returns it in \p generator.
  !> 
  !>  Values for \p rng_type are:
  !>  - ROCRAND_RNG_PSEUDO_XORWOW
  !>  - ROCRAND_RNG_PSEUDO_MRG32K3A
  !>  - ROCRAND_RNG_PSEUDO_MTGP32
  !>  - ROCRAND_RNG_PSEUDO_PHILOX4_32_10
  !>  - ROCRAND_RNG_QUASI_SOBOL32
  !> 
  !>  \param generator - Pointer to generator
  !>  \param rng_type - Type of generator to create
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_ALLOCATION_FAILED, if memory could not be allocated \n
  !>  - ROCRAND_STATUS_VERSION_MISMATCH if the header file version does not match the
  !>    dynamically linked library version \n
  !>  - ROCRAND_STATUS_TYPE_ERROR if the value for \p rng_type is invalid \n
  !>  - ROCRAND_STATUS_SUCCESS if generator was created successfully \n
  !>
  interface rocrand_create_generator
    function rocrand_create_generator_(generator,rng_type) bind(c, name="rocrand_create_generator")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_create_generator_
      type(c_ptr) :: generator
      integer(kind(ROCRAND_RNG_PSEUDO_DEFAULT)),value :: rng_type
    end function

  end interface
  !>  \brief Destroys random number generator.
  !> 
  !>  Destroys random number generator and frees related memory.
  !> 
  !>  \param generator - Generator to be destroyed
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_SUCCESS if generator was destroyed successfully \n
  interface rocrand_destroy_generator
    function rocrand_destroy_generator_(generator) bind(c, name="rocrand_destroy_generator")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_destroy_generator_
      type(c_ptr),value :: generator
    end function

  end interface
  !>  \brief Generates uniformly distributed 32-bit unsigned integers.
  !> 
  !>  Generates \p n uniformly distributed 32-bit unsigned integers and
  !>  saves them to \p output_data.
  !> 
  !>  Generated numbers are between \p 0 and \p 2^32, including \p 0 and
  !>  excluding \p 2^32.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of 32-bit unsigned integers to generate
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - ROCRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface rocrand_generate
    function rocrand_generate_(generator,output_data,n) bind(c, name="rocrand_generate")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_generate_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
    end function

  end interface
  !>  \brief Generates uniformly distributed 8-bit unsigned integers.
  !> 
  !>  Generates \p n uniformly distributed 8-bit unsigned integers and
  !>  saves them to \p output_data.
  !> 
  !>  Generated numbers are between \p 0 and \p 2^8, including \p 0 and
  !>  excluding \p 2^8.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of 8-bit unsigned integers to generate
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - ROCRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface rocrand_generate_char
    function rocrand_generate_char_(generator,output_data,n) bind(c, name="rocrand_generate_char")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_generate_char_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
    end function

  end interface
  !>  \brief Generates uniformly distributed 16-bit unsigned integers.
  !> 
  !>  Generates \p n uniformly distributed 16-bit unsigned integers and
  !>  saves them to \p output_data.
  !> 
  !>  Generated numbers are between \p 0 and \p 2^16, including \p 0 and
  !>  excluding \p 2^16.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of 16-bit unsigned integers to generate
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - ROCRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface rocrand_generate_short
    function rocrand_generate_short_(generator,output_data,n) bind(c, name="rocrand_generate_short")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_generate_short_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
    end function

  end interface
  !>  \brief Generates uniformly distributed \p float values.
  !> 
  !>  Generates \p n uniformly distributed 32-bit floating-point values
  !>  and saves them to \p output_data.
  !> 
  !>  Generated numbers are between \p 0.0f and \p 1.0f, excluding \p 0.0f and
  !>  including \p 1.0f.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of <tt>float</tt>s to generate
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - ROCRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface rocrand_generate_uniform
    function rocrand_generate_uniform_(generator,output_data,n) bind(c, name="rocrand_generate_uniform")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_generate_uniform_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
    end function

  end interface
  !>  \brief Generates uniformly distributed double-precision floating-point values.
  !> 
  !>  Generates \p n uniformly distributed 64-bit double-precision floating-point
  !>  values and saves them to \p output_data.
  !> 
  !>  Generated numbers are between \p 0.0 and \p 1.0, excluding \p 0.0 and
  !>  including \p 1.0.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of <tt>double</tt>s to generate
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - ROCRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface rocrand_generate_uniform_double
    function rocrand_generate_uniform_double_(generator,output_data,n) bind(c, name="rocrand_generate_uniform_double")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_generate_uniform_double_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
    end function

  end interface
  !>  \brief Generates normally distributed \p float values.
  !> 
  !>  Generates \p n normally distributed distributed 32-bit floating-point
  !>  values and saves them to \p output_data.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of <tt>float</tt>s to generate
  !>  \param mean - Mean value of normal distribution
  !>  \param stddev - Standard deviation value of normal distribution
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - ROCRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface rocrand_generate_normal
    function rocrand_generate_normal_(generator,output_data,n,mean,stddev) bind(c, name="rocrand_generate_normal")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_generate_normal_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
      real(c_float),value :: mean
      real(c_float),value :: stddev
    end function

  end interface
  !>  \brief Generates normally distributed \p double values.
  !> 
  !>  Generates \p n normally distributed 64-bit double-precision floating-point
  !>  numbers and saves them to \p output_data.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of <tt>double</tt>s to generate
  !>  \param mean - Mean value of normal distribution
  !>  \param stddev - Standard deviation value of normal distribution
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - ROCRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface rocrand_generate_normal_double
    function rocrand_generate_normal_double_(generator,output_data,n,mean,stddev) bind(c, name="rocrand_generate_normal_double")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_generate_normal_double_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
      real(c_double),value :: mean
      real(c_double),value :: stddev
    end function

  end interface
  !>  \brief Generates log-normally distributed \p float values.
  !> 
  !>  Generates \p n log-normally distributed 32-bit floating-point values
  !>  and saves them to \p output_data.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of <tt>float</tt>s to generate
  !>  \param mean - Mean value of log normal distribution
  !>  \param stddev - Standard deviation value of log normal distribution
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - ROCRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface rocrand_generate_log_normal
    function rocrand_generate_log_normal_(generator,output_data,n,mean,stddev) bind(c, name="rocrand_generate_log_normal")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_generate_log_normal_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
      real(c_float),value :: mean
      real(c_float),value :: stddev
    end function

  end interface
  !>  \brief Generates log-normally distributed \p double values.
  !> 
  !>  Generates \p n log-normally distributed 64-bit double-precision floating-point
  !>  values and saves them to \p output_data.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of <tt>double</tt>s to generate
  !>  \param mean - Mean value of log normal distribution
  !>  \param stddev - Standard deviation value of log normal distribution
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - ROCRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface rocrand_generate_log_normal_double
    function rocrand_generate_log_normal_double_(generator,output_data,n,mean,stddev) bind(c, name="rocrand_generate_log_normal_double")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_generate_log_normal_double_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
      real(c_double),value :: mean
      real(c_double),value :: stddev
    end function

  end interface
  !>  \brief Generates Poisson-distributed 32-bit unsigned integers.
  !> 
  !>  Generates \p n Poisson-distributed 32-bit unsigned integers and
  !>  saves them to \p output_data.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of 32-bit unsigned integers to generate
  !>  \param lambda - lambda for the Poisson distribution
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_OUT_OF_RANGE if lambda is non-positive \n
  !>  - ROCRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - ROCRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface rocrand_generate_poisson
    function rocrand_generate_poisson_(generator,output_data,n,lambda) bind(c, name="rocrand_generate_poisson")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_generate_poisson_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
      real(c_double),value :: lambda
    end function

  end interface
  !>  \brief Initializes the generator's state on GPU or host.
  !> 
  !>  Initializes the generator's state on GPU or host. User it not
  !>  required to call this function before using a generator.
  !> 
  !>  If rocrand_initialize() was not called for a generator, it will be
  !>  automatically called by functions which generates random numbers like
  !>  rocrand_generate(), rocrang_generate_uniform() etc.
  !> 
  !>  \param generator - Generator to initialize
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_LAUNCH_FAILURE if a HIP kernel launch failed \n
  !>  - ROCRAND_STATUS_SUCCESS if the seeds were generated successfully \n
  interface rocrand_initialize_generator
    function rocrand_initialize_generator_(generator) bind(c, name="rocrand_initialize_generator")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_initialize_generator_
      type(c_ptr),value :: generator
    end function

  end interface
  !>  \brief Sets the current stream for kernel launches.
  !> 
  !>  Sets the current stream for all kernel launches of the generator.
  !>  All functions will use this stream.
  !> 
  !>  \param generator - Generator to modify
  !>  \param stream - Stream to use or NULL for default stream
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_SUCCESS if stream was set successfully \n
  interface rocrand_set_stream
    function rocrand_set_stream_(generator,stream) bind(c, name="rocrand_set_stream")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_set_stream_
      type(c_ptr),value :: generator
      type(c_ptr),value :: stream
    end function

  end interface
  !>  \brief Sets the seed of a pseudo-random number generator.
  !> 
  !>  Sets the seed of the pseudo-random number generator.
  !> 
  !>  - This operation resets the generator's internal state.
  !>  - This operation does not change the generator's offset.
  !> 
  !>  For a MRG32K3a generator seed value can't be zero. If \p seed is
  !>  equal zero and generator's type is ROCRAND_RNG_PSEUDO_MRG32K3A,
  !>  value \p 12345 is used as a seed instead.
  !> 
  !>  \param generator - Pseudo-random number generator
  !>  \param seed - New seed value
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_TYPE_ERROR if the generator is a quasi-random number generator \n
  !>  - ROCRAND_STATUS_SUCCESS if seed was set successfully \n
  interface rocrand_set_seed
    function rocrand_set_seed_(generator,seed) bind(c, name="rocrand_set_seed")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_set_seed_
      type(c_ptr),value :: generator
      integer(c_long_long),value :: seed
    end function

  end interface
  !>  \brief Sets the offset of a random number generator.
  !> 
  !>  Sets the absolute offset of the random number generator.
  !> 
  !>  - This operation resets the generator's internal state.
  !>  - This operation does not change the generator's seed.
  !> 
  !>  Absolute offset cannot be set if generator's type is ROCRAND_RNG_PSEUDO_MTGP32.
  !> 
  !>  \param generator - Random number generator
  !>  \param offset - New absolute offset
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_SUCCESS if offset was successfully set \n
  !>  - ROCRAND_STATUS_TYPE_ERROR if generator's type is ROCRAND_RNG_PSEUDO_MTGP32
  interface rocrand_set_offset
    function rocrand_set_offset_(generator,offset) bind(c, name="rocrand_set_offset")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_set_offset_
      type(c_ptr),value :: generator
      integer(c_long_long),value :: offset
    end function

  end interface
  !>  \brief Set the number of dimensions of a quasi-random number generator.
  !> 
  !>  Set the number of dimensions of a quasi-random number generator.
  !>  Supported values of \p dimensions are 1 to 20000.
  !> 
  !>  - This operation resets the generator's internal state.
  !>  - This operation does not change the generator's offset.
  !> 
  !>  \param generator - Quasi-random number generator
  !>  \param dimensions - Number of dimensions
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - ROCRAND_STATUS_TYPE_ERROR if the generator is not a quasi-random number generator \n
  !>  - ROCRAND_STATUS_OUT_OF_RANGE if \p dimensions is out of range \n
  !>  - ROCRAND_STATUS_SUCCESS if the number of dimensions was set successfully \n
  interface rocrand_set_quasi_random_generator_dimensions
    function rocrand_set_quasi_random_generator_dimensions_(generator,dimensions) bind(c, name="rocrand_set_quasi_random_generator_dimensions")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_set_quasi_random_generator_dimensions_
      type(c_ptr),value :: generator
      integer(c_int),value :: dimensions
    end function

  end interface
  !>  \brief Returns the version number of the library.
  !> 
  !>  Returns in \p version the version number of the dynamically linked
  !>  rocRAND library.
  !> 
  !>  \param version - Version of the library
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_OUT_OF_RANGE if \p version is NULL \n
  !>  - ROCRAND_STATUS_SUCCESS if the version number was successfully returned \n
  interface rocrand_get_version
    function rocrand_get_version_(version) bind(c, name="rocrand_get_version")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_get_version_
      type(c_ptr),value :: version
    end function

  end interface
  !>  \brief Construct the histogram for a Poisson distribution.
  !> 
  !>  Construct the histogram for the Poisson distribution with lambda \p lambda.
  !> 
  !>  \param lambda - lambda for the Poisson distribution
  !>  \param discrete_distribution - pointer to the histogram in device memory
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_ALLOCATION_FAILED if memory could not be allocated \n
  !>  - ROCRAND_STATUS_OUT_OF_RANGE if \p discrete_distribution pointer was null \n
  !>  - ROCRAND_STATUS_OUT_OF_RANGE if lambda is non-positive \n
  !>  - ROCRAND_STATUS_SUCCESS if the histogram was ructed successfully \n
  interface rocrand_create_poisson_distribution
    function rocrand_create_poisson_distribution_(lambda,discrete_distribution) bind(c, name="rocrand_create_poisson_distribution")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_create_poisson_distribution_
      real(c_double),value :: lambda
      type(c_ptr) :: discrete_distribution
    end function

  end interface
  !>  \brief Construct the histogram for a custom discrete distribution.
  !> 
  !>  Construct the histogram for the discrete distribution of \p size
  !>  32-bit unsigned integers from the range [\p offset, \p offset + \p size)
  !>  using \p probabilities as probabilities.
  !> 
  !>  \param probabilities - probabilities of the the distribution in host memory
  !>  \param size - size of \p probabilities
  !>  \param offset - offset of values
  !>  \param discrete_distribution - pointer to the histogram in device memory
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_ALLOCATION_FAILED if memory could not be allocated \n
  !>  - ROCRAND_STATUS_OUT_OF_RANGE if \p discrete_distribution pointer was null \n
  !>  - ROCRAND_STATUS_OUT_OF_RANGE if \p size was zero \n
  !>  - ROCRAND_STATUS_SUCCESS if the histogram was ructed successfully \n
  interface rocrand_create_discrete_distribution
    function rocrand_create_discrete_distribution_(probabilities,mySize,offset,discrete_distribution) bind(c, name="rocrand_create_discrete_distribution")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_create_discrete_distribution_
      type(c_ptr),value :: probabilities
      integer(c_int),value :: mySize
      integer(c_int),value :: offset
      type(c_ptr) :: discrete_distribution
    end function

  end interface
  !>  \brief Destroy the histogram array for a discrete distribution.
  !> 
  !>  Destroy the histogram array for a discrete distribution created by
  !>  rocrand_create_poisson_distribution.
  !> 
  !>  \param discrete_distribution - pointer to the histogram in device memory
  !> 
  !>  \return
  !>  - ROCRAND_STATUS_OUT_OF_RANGE if \p discrete_distribution was null \n
  !>  - ROCRAND_STATUS_SUCCESS if the histogram was destroyed successfully \n
  interface rocrand_destroy_discrete_distribution
    function rocrand_destroy_discrete_distribution_(discrete_distribution) bind(c, name="rocrand_destroy_discrete_distribution")
      use iso_c_binding
      use hipfort_rocrand_enums
      implicit none
      integer(kind(ROCRAND_STATUS_SUCCESS)) :: rocrand_destroy_discrete_distribution_
      type(c_ptr),value :: discrete_distribution
    end function

  end interface

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_rocrand

module hipfort_hipfft_params
  use iso_c_binding
  implicit none

  integer(c_int), parameter, public :: HIPFFT_FORWARD = -1, HIPFFT_BACKWARD = 1
  integer(c_int), parameter, public :: HIPFFT_INVERSE = 1 

end module hipfort_hipfft_params

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc.
!
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
!
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


module rocblas
    use iso_c_binding

    !!!!!!!!!!!!!!!!!!!!!!!
    !    rocBLAS types    !
    !!!!!!!!!!!!!!!!!!!!!!!
    enum, bind(c)
        enumerator :: rocblas_operation_none = 111
        enumerator :: rocblas_operation_transpose = 112
        enumerator :: rocblas_operation_conjugate_transpose = 113
    end enum

    enum, bind(c)
        enumerator :: rocblas_fill_upper = 121
        enumerator :: rocblas_fill_lower = 122
        enumerator :: rocblas_fill_full  = 123
    end enum

    enum, bind(c)
        enumerator :: rocblas_diagonal_non_unit = 131
        enumerator :: rocblas_diagonal_unit     = 132
    end enum

    enum, bind(c)
        enumerator :: rocblas_side_left  = 141
        enumerator :: rocblas_side_right = 142
        enumerator :: rocblas_side_both  = 143
    end enum

    enum, bind(c)
        enumerator :: rocblas_status_success         = 0
        enumerator :: rocblas_status_invalid_handle  = 1
        enumerator :: rocblas_status_not_implemented = 2
        enumerator :: rocblas_status_invalid_pointer = 3
        enumerator :: rocblas_status_invalid_size    = 4
        enumerator :: rocblas_status_memory_error    = 5
        enumerator :: rocblas_status_internal_error  = 6
        enumerator :: rocblas_status_perf_degraded   = 7
        enumerator :: rocblas_status_size_query_mismatch = 8
        enumerator :: rocblas_status_size_increased      = 9
        enumerator :: rocblas_status_size_unchanged      = 10
        enumerator :: rocblas_status_invalid_value       = 11
        enumerator :: rocblas_status_continue            = 12
    end enum

    enum, bind(c)
        enumerator :: rocblas_pointer_mode_host = 0
        enumerator :: rocblas_pointer_mode_device = 1
    end enum

    

    !!!!!!!!!!!!!!!!!!!!!!!
    ! rocblas-auxiliary.h !
    !!!!!!!!!!!!!!!!!!!!!!!

    interface
        function rocblas_create_handle(handle) &
                result(c_int) &
                bind(c, name = 'rocblas_create_handle')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
        end function rocblas_create_handle
    end interface

    interface
        function rocblas_destroy_handle(handle) &
                result(c_int) &
                bind(c, name = 'rocblas_destroy_handle')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
        end function rocblas_destroy_handle
    end interface

    interface
        function rocblas_add_stream(handle, stream) &
                result(c_int) &
                bind(c, name = 'rocblas_add_stream')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: stream
        end function rocblas_add_stream
    end interface

    interface
        function rocblas_set_stream(handle, stream) &
                result(c_int) &
                bind(c, name = 'rocblas_set_stream')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: stream
        end function rocblas_set_stream
    end interface

    interface
        function rocblas_get_stream(handle, stream) &
                result(c_int) &
                bind(c, name = 'rocblas_get_stream')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: stream
        end function rocblas_get_stream
    end interface

    interface
        function rocblas_set_pointer_mode(handle, pointer_mode) &
                result(c_int) &
                bind(c, name = 'rocblas_set_pointer_mode')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: pointer_mode
        end function rocblas_set_pointer_mode
    end interface

    interface
        function rocblas_get_pointer_mode(handle, pointer_mode) &
                result(c_int) &
                bind(c, name = 'rocblas_get_pointer_mode')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int) :: pointer_mode
        end function rocblas_get_pointer_mode
    end interface

    ! TODO: is this good?
    interface
        function rocblas_pointer_to_mode(ptr) &
                result(c_int) &
                bind(c, name = 'rocblas_pointer_to_mode')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: ptr
        end function rocblas_pointer_to_mode
    end interface

    interface
        function rocblas_set_vector(n, elem_size, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_set_vector')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n
            integer(c_int), value :: elem_size
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_set_vector
    end interface

    interface
        function rocblas_get_vector(n, elem_size, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_get_vector')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n
            integer(c_int), value :: elem_size
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_get_vector
    end interface

    interface
        function rocblas_set_matrix(rows, cols, elem_size, a, lda, b, ldb) &
                result(c_int) &
                bind(c, name = 'rocblas_set_matrix')
            use iso_c_binding
            implicit none
            integer(c_int), value :: rows
            integer(c_int), value :: cols
            integer(c_int), value :: elem_size
            type(c_ptr), value :: a
            integer(c_int), value :: lda
            type(c_ptr), value :: b
            integer(c_int), value :: ldb
        end function rocblas_set_matrix
    end interface

    interface
        function rocblas_get_matrix(rows, cols, elem_size, a, lda, b, ldb) &
                result(c_int) &
                bind(c, name = 'rocblas_get_matrix')
            use iso_c_binding
            implicit none
            integer(c_int), value :: rows
            integer(c_int), value :: cols
            integer(c_int), value :: elem_size
            type(c_ptr), value :: a
            integer(c_int), value :: lda
            type(c_ptr), value :: b
            integer(c_int), value :: ldb
        end function rocblas_get_matrix
    end interface

    interface
        function rocblas_set_vector_async(n, elem_size, x, incx, y, incy, stream) &
                result(c_int) &
                bind(c, name = 'rocblas_set_vector_async')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n
            integer(c_int), value :: elem_size
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: stream
        end function rocblas_set_vector_async
    end interface

    interface
        function rocblas_get_vector_async(n, elem_size, x, incx, y, incy, stream) &
                result(c_int) &
                bind(c, name = 'rocblas_get_vector_async')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n
            integer(c_int), value :: elem_size
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: stream
        end function rocblas_get_vector_async
    end interface

    interface
        function rocblas_set_matrix_async(rows, cols, elem_size, a, lda, b, ldb, stream) &
                result(c_int) &
                bind(c, name = 'rocblas_set_matrix_async')
            use iso_c_binding
            implicit none
            integer(c_int), value :: rows
            integer(c_int), value :: cols
            integer(c_int), value :: elem_size
            type(c_ptr), value :: a
            integer(c_int), value :: lda
            type(c_ptr), value :: b
            integer(c_int), value :: ldb
            type(c_ptr), value :: stream
        end function rocblas_set_matrix_async
    end interface

    interface
        function rocblas_get_matrix_async(rows, cols, elem_size, a, lda, b, ldb, stream) &
                result(c_int) &
                bind(c, name = 'rocblas_get_matrix_async')
            use iso_c_binding
            implicit none
            integer(c_int), value :: rows
            integer(c_int), value :: cols
            integer(c_int), value :: elem_size
            type(c_ptr), value :: a
            integer(c_int), value :: lda
            type(c_ptr), value :: b
            integer(c_int), value :: ldb
            type(c_ptr), value :: stream
        end function rocblas_get_matrix_async
    end interface

    ! TODO: ?
    interface
        function rocblas_set_start_stop_events(handle, start_event, stop_event) &
                result(c_int) &
                bind(c, name = 'rocblas_set_start_stop_events')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: start_event
            type(c_ptr), value :: stop_event
        end function rocblas_set_start_stop_events
    end interface

    !!!!!!!!!!!!!!!!!!!!!!!
    ! rocblas-functions.h !
    !!!!!!!!!!!!!!!!!!!!!!!

    !--------!
    ! blas 1 !
    !--------!

    ! scal
    interface
        function rocblas_sscal(handle, n, alpha, x, incx) &
                result(c_int) &
                bind(c, name = 'rocblas_sscal')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
        end function rocblas_sscal
    end interface

    interface
        function rocblas_dscal(handle, n, alpha, x, incx) &
                result(c_int) &
                bind(c, name = 'rocblas_dscal')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
        end function rocblas_dscal
    end interface

    interface
        function rocblas_cscal(handle, n, alpha, x, incx) &
                result(c_int) &
                bind(c, name = 'rocblas_cscal')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
        end function rocblas_cscal
    end interface

    interface
        function rocblas_zscal(handle, n, alpha, x, incx) &
                result(c_int) &
                bind(c, name = 'rocblas_zscal')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
        end function rocblas_zscal
    end interface

    interface
        function rocblas_csscal(handle, n, alpha, x, incx) &
                result(c_int) &
                bind(c, name = 'rocblas_csscal')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
        end function rocblas_csscal
    end interface

    interface
        function rocblas_zdscal(handle, n, alpha, x, incx) &
                result(c_int) &
                bind(c, name = 'rocblas_zdscal')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
        end function rocblas_zdscal
    end interface

    ! scal_batched
    interface
        function rocblas_sscal_batched(handle, n, alpha, x, incx, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_sscal_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
        end function rocblas_sscal_batched
    end interface

    interface
        function rocblas_dscal_batched(handle, n, alpha, x, incx, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_dscal_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
        end function rocblas_dscal_batched
    end interface

    interface
        function rocblas_cscal_batched(handle, n, alpha, x, incx, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_cscal_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
        end function rocblas_cscal_batched
    end interface

    interface
        function rocblas_zscal_batched(handle, n, alpha, x, incx, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zscal_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
        end function rocblas_zscal_batched
    end interface

    interface
        function rocblas_csscal_batched(handle, n, alpha, x, incx, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_csscal_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
        end function rocblas_csscal_batched
    end interface

    interface
        function rocblas_zdscal_batched(handle, n, alpha, x, incx, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zdscal_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
        end function rocblas_zdscal_batched
    end interface

    ! scal_strided_batched
    interface
        function rocblas_sscal_strided_batched(handle, n, alpha, x, incx, stride_x, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_sscal_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
        end function rocblas_sscal_strided_batched
    end interface

    interface
        function rocblas_dscal_strided_batched(handle, n, alpha, x, incx, stride_x, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_dscal_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
        end function rocblas_dscal_strided_batched
    end interface

    interface
        function rocblas_cscal_strided_batched(handle, n, alpha, x, incx, stride_x, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_cscal_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
        end function rocblas_cscal_strided_batched
    end interface

    interface
        function rocblas_zscal_strided_batched(handle, n, alpha, x, incx, stride_x, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zscal_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
        end function rocblas_zscal_strided_batched
    end interface

    interface
        function rocblas_csscal_strided_batched(handle, n, alpha, x, incx, stride_x, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_csscal_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
        end function rocblas_csscal_strided_batched
    end interface

    interface
        function rocblas_zdscal_strided_batched(handle, n, alpha, x, incx, stride_x, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zdscal_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
        end function rocblas_zdscal_strided_batched
    end interface

    ! copy
    interface
        function rocblas_scopy(handle, n, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_scopy')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_scopy
    end interface

    interface
        function rocblas_dcopy(handle, n, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_dcopy')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_dcopy
    end interface

    interface
        function rocblas_ccopy(handle, n, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_ccopy')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_ccopy
    end interface

    interface
        function rocblas_zcopy(handle, n, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_zcopy')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_zcopy
    end interface

    ! copy_batched
    interface
        function rocblas_scopy_batched(handle, n, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_scopy_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_scopy_batched
    end interface

    interface
        function rocblas_dcopy_batched(handle, n, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_dcopy_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_dcopy_batched
    end interface

    interface
        function rocblas_ccopy_batched(handle, n, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_ccopy_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_ccopy_batched
    end interface

    interface
        function rocblas_zcopy_batched(handle, n, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zcopy_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_zcopy_batched
    end interface

    ! copy_strided_batched
    interface
        function rocblas_scopy_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_scopy_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_scopy_strided_batched
    end interface

    interface
        function rocblas_dcopy_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_dcopy_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_dcopy_strided_batched
    end interface

    interface
        function rocblas_ccopy_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_ccopy_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_ccopy_strided_batched
    end interface

    interface
        function rocblas_zcopy_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zcopy_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_zcopy_strided_batched
    end interface

    ! dot
    interface
        function rocblas_sdot(handle, n, x, incx, y, incy, result) &
                result(c_int) &
                bind(c, name = 'rocblas_sdot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: result
        end function rocblas_sdot
    end interface

    interface
        function rocblas_ddot(handle, n, x, incx, y, incy, result) &
                result(c_int) &
                bind(c, name = 'rocblas_ddot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: result
        end function rocblas_ddot
    end interface

    interface
        function rocblas_hdot(handle, n, x, incx, y, incy, result) &
                result(c_int) &
                bind(c, name = 'rocblas_hdot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: result
        end function rocblas_hdot
    end interface

    interface
        function rocblas_bfdot(handle, n, x, incx, y, incy, result) &
                result(c_int) &
                bind(c, name = 'rocblas_bfdot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: result
        end function rocblas_bfdot
    end interface

    interface
        function rocblas_cdotu(handle, n, x, incx, y, incy, result) &
                result(c_int) &
                bind(c, name = 'rocblas_cdotu')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: result
        end function rocblas_cdotu
    end interface

    interface
        function rocblas_cdotc(handle, n, x, incx, y, incy, result) &
                result(c_int) &
                bind(c, name = 'rocblas_cdotc')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: result
        end function rocblas_cdotc
    end interface

    interface
        function rocblas_zdotu(handle, n, x, incx, y, incy, result) &
                result(c_int) &
                bind(c, name = 'rocblas_zdotu')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: result
        end function rocblas_zdotu
    end interface

    interface
        function rocblas_zdotc(handle, n, x, incx, y, incy, result) &
                result(c_int) &
                bind(c, name = 'rocblas_zdotc')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: result
        end function rocblas_zdotc
    end interface

    ! dot_batched
    interface
        function rocblas_sdot_batched(handle, n, x, incx, y, incy, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_sdot_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_sdot_batched
    end interface

    interface
        function rocblas_ddot_batched(handle, n, x, incx, y, incy, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_ddot_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_ddot_batched
    end interface

    interface
        function rocblas_hdot_batched(handle, n, x, incx, y, incy, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_hdot_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_hdot_batched
    end interface

    interface
        function rocblas_bfdot_batched(handle, n, x, incx, y, incy, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_bfdot_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_bfdot_batched
    end interface

    interface
        function rocblas_cdotu_batched(handle, n, x, incx, y, incy, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_cdotu_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_cdotu_batched
    end interface

    interface
        function rocblas_cdotc_batched(handle, n, x, incx, y, incy, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_cdotc_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_cdotc_batched
    end interface

    interface
        function rocblas_zdotu_batched(handle, n, x, incx, y, incy, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_zdotu_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_zdotu_batched
    end interface

    interface
        function rocblas_zdotc_batched(handle, n, x, incx, y, incy, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_zdotc_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_zdotc_batched
    end interface

    ! dot_strided_batched
    interface
        function rocblas_sdot_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_sdot_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_sdot_strided_batched
    end interface

    interface
        function rocblas_ddot_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_ddot_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_ddot_strided_batched
    end interface

    interface
        function rocblas_hdot_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_hdot_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_hdot_strided_batched
    end interface

    interface
        function rocblas_bfdot_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_bfdot_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_bfdot_strided_batched
    end interface

    interface
        function rocblas_cdotu_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_cdotu_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_cdotu_strided_batched
    end interface

    interface
        function rocblas_cdotc_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_cdotc_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_cdotc_strided_batched
    end interface

    interface
        function rocblas_zdotu_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_zdotu_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_zdotu_strided_batched
    end interface

    interface
        function rocblas_zdotc_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_zdotc_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_zdotc_strided_batched
    end interface

    ! swap
    interface
        function rocblas_sswap(handle, n, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_sswap')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_sswap
    end interface

    interface
        function rocblas_dswap(handle, n, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_dswap')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_dswap
    end interface

    interface
        function rocblas_cswap(handle, n, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_cswap')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_cswap
    end interface

    interface
        function rocblas_zswap(handle, n, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_zswap')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_zswap
    end interface

    ! swap_batched
    interface
        function rocblas_sswap_batched(handle, n, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_sswap_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_sswap_batched
    end interface

    interface
        function rocblas_dswap_batched(handle, n, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_dswap_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_dswap_batched
    end interface

    interface
        function rocblas_cswap_batched(handle, n, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_cswap_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_cswap_batched
    end interface

    interface
        function rocblas_zswap_batched(handle, n, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zswap_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_zswap_batched
    end interface

    ! swap_strided_batched
    interface
        function rocblas_sswap_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_sswap_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_sswap_strided_batched
    end interface

    interface
        function rocblas_dswap_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_dswap_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_dswap_strided_batched
    end interface

    interface
        function rocblas_cswap_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_cswap_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_cswap_strided_batched
    end interface

    interface
        function rocblas_zswap_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zswap_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_zswap_strided_batched
    end interface

    ! axpy
    interface
        function rocblas_haxpy(handle, n, alpha, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_haxpy')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_haxpy
    end interface

    interface
        function rocblas_saxpy(handle, n, alpha, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_saxpy')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_saxpy
    end interface

    interface
        function rocblas_daxpy(handle, n, alpha, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_daxpy')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_daxpy
    end interface

    interface
        function rocblas_caxpy(handle, n, alpha, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_caxpy')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_caxpy
    end interface

    interface
        function rocblas_zaxpy(handle, n, alpha, x, incx, y, incy) &
                result(c_int) &
                bind(c, name = 'rocblas_zaxpy')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
        end function rocblas_zaxpy
    end interface

    ! axpy_batched
    interface
        function rocblas_haxpy_batched(handle, n, alpha, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_haxpy_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_haxpy_batched
    end interface

    interface
        function rocblas_saxpy_batched(handle, n, alpha, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_saxpy_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_saxpy_batched
    end interface

    interface
        function rocblas_daxpy_batched(handle, n, alpha, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_daxpy_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_daxpy_batched
    end interface

    interface
        function rocblas_caxpy_batched(handle, n, alpha, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_caxpy_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_caxpy_batched
    end interface

    interface
        function rocblas_zaxpy_batched(handle, n, alpha, x, incx, y, incy, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zaxpy_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: batch_count
        end function rocblas_zaxpy_batched
    end interface

    ! axpy_strided_batched
    interface
        function rocblas_haxpy_strided_batched(handle, n, alpha, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_haxpy_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_haxpy_strided_batched
    end interface

    interface
        function rocblas_saxpy_strided_batched(handle, n, alpha, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_saxpy_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_saxpy_strided_batched
    end interface

    interface
        function rocblas_daxpy_strided_batched(handle, n, alpha, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_daxpy_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_daxpy_strided_batched
    end interface

    interface
        function rocblas_caxpy_strided_batched(handle, n, alpha, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_caxpy_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_caxpy_strided_batched
    end interface

    interface
        function rocblas_zaxpy_strided_batched(handle, n, alpha, x, incx, stride_x, y, incy, stride_y, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zaxpy_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: alpha
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            integer(c_int), value :: batch_count
        end function rocblas_zaxpy_strided_batched
    end interface

    ! asum
    interface
        function rocblas_sasum(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_sasum')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_sasum
    end interface

    interface
        function rocblas_dasum(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dasum')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_dasum
    end interface

    interface
        function rocblas_scasum(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_scasum')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_scasum
    end interface

    interface
        function rocblas_dzasum(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dzasum')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_dzasum
    end interface

    ! asum_batched
    interface
        function rocblas_sasum_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_sasum_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_sasum_batched
    end interface

    interface
        function rocblas_dasum_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dasum_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_dasum_batched
    end interface

    interface
        function rocblas_scasum_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_scasum_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_scasum_batched
    end interface

    interface
        function rocblas_dzasum_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dzasum_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_dzasum_batched
    end interface

    ! asum_strided_batched
    interface
        function rocblas_sasum_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_sasum_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_sasum_strided_batched
    end interface

    interface
        function rocblas_dasum_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dasum_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_dasum_strided_batched
    end interface

    interface
        function rocblas_scasum_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_scasum_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_scasum_strided_batched
    end interface

    interface
        function rocblas_dzasum_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dzasum_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_dzasum_strided_batched
    end interface

    ! nrm2
    interface
        function rocblas_snrm2(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_snrm2')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_snrm2
    end interface

    interface
        function rocblas_dnrm2(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dnrm2')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_dnrm2
    end interface

    interface
        function rocblas_scnrm2(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_scnrm2')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_scnrm2
    end interface

    interface
        function rocblas_dznrm2(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dznrm2')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_dznrm2
    end interface

    ! nrm2_batched
    interface
        function rocblas_snrm2_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_snrm2_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_snrm2_batched
    end interface

    interface
        function rocblas_dnrm2_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dnrm2_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_dnrm2_batched
    end interface

    interface
        function rocblas_scnrm2_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_scnrm2_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_scnrm2_batched
    end interface

    interface
        function rocblas_dznrm2_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dznrm2_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_dznrm2_batched
    end interface

    ! nrm2_strided_batched
    interface
        function rocblas_snrm2_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_snrm2_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_snrm2_strided_batched
    end interface

    interface
        function rocblas_dnrm2_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dnrm2_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_dnrm2_strided_batched
    end interface

    interface
        function rocblas_scnrm2_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_scnrm2_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_scnrm2_strided_batched
    end interface

    interface
        function rocblas_dznrm2_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_dznrm2_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_dznrm2_strided_batched
    end interface

    ! amax
    interface
        function rocblas_isamax(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_isamax')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_isamax
    end interface

    interface
        function rocblas_idamax(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_idamax')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_idamax
    end interface

    interface
        function rocblas_icamax(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_icamax')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_icamax
    end interface

    interface
        function rocblas_izamax(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_izamax')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_izamax
    end interface

    ! amax_batched
    interface
        function rocblas_isamax_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_isamax_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_isamax_batched
    end interface

    interface
        function rocblas_idamax_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_idamax_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_idamax_batched
    end interface

    interface
        function rocblas_icamax_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_icamax_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_icamax_batched
    end interface

    interface
        function rocblas_izamax_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_izamax_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_izamax_batched
    end interface

    ! amax_strided_batched
    interface
        function rocblas_isamax_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_isamax_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_isamax_strided_batched
    end interface

    interface
        function rocblas_idamax_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_idamax_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_idamax_strided_batched
    end interface

    interface
        function rocblas_icamax_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_icamax_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_icamax_strided_batched
    end interface

    interface
        function rocblas_izamax_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_izamax_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_izamax_strided_batched
    end interface

    ! amin
    interface
        function rocblas_isamin(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_isamin')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_isamin
    end interface

    interface
        function rocblas_idamin(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_idamin')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_idamin
    end interface

    interface
        function rocblas_icamin(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_icamin')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_icamin
    end interface

    interface
        function rocblas_izamin(handle, n, x, incx, result) &
                result(c_int) &
                bind(c, name = 'rocblas_izamin')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: result
        end function rocblas_izamin
    end interface

    ! amin_batched
    interface
        function rocblas_isamin_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_isamin_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_isamin_batched
    end interface

    interface
        function rocblas_idamin_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_idamin_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_idamin_batched
    end interface

    interface
        function rocblas_icamin_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_icamin_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_icamin_batched
    end interface

    interface
        function rocblas_izamin_batched(handle, n, x, incx, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_izamin_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_izamin_batched
    end interface

    ! amin_strided_batched
    interface
        function rocblas_isamin_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_isamin_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_isamin_strided_batched
    end interface

    interface
        function rocblas_idamin_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_idamin_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_idamin_strided_batched
    end interface

    interface
        function rocblas_icamin_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_icamin_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_icamin_strided_batched
    end interface

    interface
        function rocblas_izamin_strided_batched(handle, n, x, incx, stride_x, batch_count, result) &
                result(c_int) &
                bind(c, name = 'rocblas_izamin_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            integer(c_int), value :: batch_count
            type(c_ptr), value :: result
        end function rocblas_izamin_strided_batched
    end interface

    ! rot
    interface
        function rocblas_srot(handle, n, x, incx, y, incy, c, s) &
                result(c_int) &
                bind(c, name = 'rocblas_srot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
        end function rocblas_srot
    end interface

    interface
        function rocblas_drot(handle, n, x, incx, y, incy, c, s) &
                result(c_int) &
                bind(c, name = 'rocblas_drot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
        end function rocblas_drot
    end interface

    interface
        function rocblas_crot(handle, n, x, incx, y, incy, c, s) &
                result(c_int) &
                bind(c, name = 'rocblas_crot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
        end function rocblas_crot
    end interface

    interface
        function rocblas_csrot(handle, n, x, incx, y, incy, c, s) &
                result(c_int) &
                bind(c, name = 'rocblas_csrot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
        end function rocblas_csrot
    end interface

    interface
        function rocblas_zrot(handle, n, x, incx, y, incy, c, s) &
                result(c_int) &
                bind(c, name = 'rocblas_zrot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
        end function rocblas_zrot
    end interface

    interface
        function rocblas_zdrot(handle, n, x, incx, y, incy, c, s) &
                result(c_int) &
                bind(c, name = 'rocblas_zdrot')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
        end function rocblas_zdrot
    end interface

    ! rot_batched
    interface
        function rocblas_srot_batched(handle, n, x, incx, y, incy, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_srot_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_srot_batched
    end interface

    interface
        function rocblas_drot_batched(handle, n, x, incx, y, incy, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_drot_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_drot_batched
    end interface

    interface
        function rocblas_crot_batched(handle, n, x, incx, y, incy, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_crot_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_crot_batched
    end interface

    interface
        function rocblas_csrot_batched(handle, n, x, incx, y, incy, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_csrot_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_csrot_batched
    end interface

    interface
        function rocblas_zrot_batched(handle, n, x, incx, y, incy, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zrot_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_zrot_batched
    end interface

    interface
        function rocblas_zdrot_batched(handle, n, x, incx, y, incy, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zdrot_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_zdrot_batched
    end interface

    ! rot_strided_batched
    interface
        function rocblas_srot_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_srot_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_srot_strided_batched
    end interface

    interface
        function rocblas_drot_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_drot_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_drot_strided_batched
    end interface

    interface
        function rocblas_crot_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_crot_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_crot_strided_batched
    end interface

    interface
        function rocblas_csrot_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_csrot_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_csrot_strided_batched
    end interface

    interface
        function rocblas_zrot_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zrot_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_zrot_strided_batched
    end interface

    interface
        function rocblas_zdrot_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zdrot_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_zdrot_strided_batched
    end interface

    ! rotg
    interface
        function rocblas_srotg(handle, a, b, c, s) &
                result(c_int) &
                bind(c, name = 'rocblas_srotg')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            type(c_ptr), value :: b
            type(c_ptr), value :: c
            type(c_ptr), value :: s
        end function rocblas_srotg
    end interface

    interface
        function rocblas_drotg(handle, a, b, c, s) &
                result(c_int) &
                bind(c, name = 'rocblas_drotg')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            type(c_ptr), value :: b
            type(c_ptr), value :: c
            type(c_ptr), value :: s
        end function rocblas_drotg
    end interface

    interface
        function rocblas_crotg(handle, a, b, c, s) &
                result(c_int) &
                bind(c, name = 'rocblas_crotg')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            type(c_ptr), value :: b
            type(c_ptr), value :: c
            type(c_ptr), value :: s
        end function rocblas_crotg
    end interface

    interface
        function rocblas_zrotg(handle, a, b, c, s) &
                result(c_int) &
                bind(c, name = 'rocblas_zrotg')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            type(c_ptr), value :: b
            type(c_ptr), value :: c
            type(c_ptr), value :: s
        end function rocblas_zrotg
    end interface

    ! rotg_batched
    interface
        function rocblas_srotg_batched(handle, a, b, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_srotg_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            type(c_ptr), value :: b
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_srotg_batched
    end interface

    interface
        function rocblas_drotg_batched(handle, a, b, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_drotg_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            type(c_ptr), value :: b
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_drotg_batched
    end interface

    interface
        function rocblas_crotg_batched(handle, a, b, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_crotg_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            type(c_ptr), value :: b
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_crotg_batched
    end interface

    interface
        function rocblas_zrotg_batched(handle, a, b, c, s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zrotg_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            type(c_ptr), value :: b
            type(c_ptr), value :: c
            type(c_ptr), value :: s
            integer(c_int), value :: batch_count
        end function rocblas_zrotg_batched
    end interface

    ! rotg_strided_batched
    interface
        function rocblas_srotg_strided_batched(handle, a, stride_a, b, stride_b, c, stride_c, s, stride_s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_srotg_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            integer(c_int), value :: stride_a
            type(c_ptr), value :: b
            integer(c_int), value :: stride_b
            type(c_ptr), value :: c
            integer(c_int), value :: stride_c
            type(c_ptr), value :: s
            integer(c_int), value :: stride_s
            integer(c_int), value :: batch_count
        end function rocblas_srotg_strided_batched
    end interface

    interface
        function rocblas_drotg_strided_batched(handle, a, stride_a, b, stride_b, c, stride_c, s, stride_s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_drotg_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            integer(c_int), value :: stride_a
            type(c_ptr), value :: b
            integer(c_int), value :: stride_b
            type(c_ptr), value :: c
            integer(c_int), value :: stride_c
            type(c_ptr), value :: s
            integer(c_int), value :: stride_s
            integer(c_int), value :: batch_count
        end function rocblas_drotg_strided_batched
    end interface

    interface
        function rocblas_crotg_strided_batched(handle, a, stride_a, b, stride_b, c, stride_c, s, stride_s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_crotg_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            integer(c_int), value :: stride_a
            type(c_ptr), value :: b
            integer(c_int), value :: stride_b
            type(c_ptr), value :: c
            integer(c_int), value :: stride_c
            type(c_ptr), value :: s
            integer(c_int), value :: stride_s
            integer(c_int), value :: batch_count
        end function rocblas_crotg_strided_batched
    end interface

    interface
        function rocblas_zrotg_strided_batched(handle, a, stride_a, b, stride_b, c, stride_c, s, stride_s, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_zrotg_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: a
            integer(c_int), value :: stride_a
            type(c_ptr), value :: b
            integer(c_int), value :: stride_b
            type(c_ptr), value :: c
            integer(c_int), value :: stride_c
            type(c_ptr), value :: s
            integer(c_int), value :: stride_s
            integer(c_int), value :: batch_count
        end function rocblas_zrotg_strided_batched
    end interface

    ! rotm
    interface
        function rocblas_srotm(handle, n, x, incx, y, incy, param) &
                result(c_int) &
                bind(c, name = 'rocblas_srotm')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: param
        end function rocblas_srotm
    end interface

    interface
        function rocblas_drotm(handle, n, x, incx, y, incy, param) &
                result(c_int) &
                bind(c, name = 'rocblas_drotm')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: param
        end function rocblas_drotm
    end interface

    ! rotm_batched
    interface
        function rocblas_srotm_batched(handle, n, x, incx, y, incy, param, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_srotm_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: param
            integer(c_int), value :: batch_count
        end function rocblas_srotm_batched
    end interface

    interface
        function rocblas_drotm_batched(handle, n, x, incx, y, incy, param, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_drotm_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            type(c_ptr), value :: param
            integer(c_int), value :: batch_count
        end function rocblas_drotm_batched
    end interface

    ! rotm_strided_batched
    interface
        function rocblas_srotm_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, param, stride_param, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_srotm_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            type(c_ptr), value :: param
            integer(c_int), value :: stride_param
            integer(c_int), value :: batch_count
        end function rocblas_srotm_strided_batched
    end interface

    interface
        function rocblas_drotm_strided_batched(handle, n, x, incx, stride_x, y, incy, stride_y, param, stride_param, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_drotm_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            integer(c_int), value :: n
            type(c_ptr), value :: x
            integer(c_int), value :: incx
            integer(c_int), value :: stride_x
            type(c_ptr), value :: y
            integer(c_int), value :: incy
            integer(c_int), value :: stride_y
            type(c_ptr), value :: param
            integer(c_int), value :: stride_param
            integer(c_int), value :: batch_count
        end function rocblas_drotm_strided_batched
    end interface

    ! rotmg
    interface
        function rocblas_srotmg(handle, d1, d2, x1, y1, param) &
                result(c_int) &
                bind(c, name = 'rocblas_srotmg')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: d1
            type(c_ptr), value :: d2
            type(c_ptr), value :: x1
            type(c_ptr), value :: y1
            type(c_ptr), value :: param
        end function rocblas_srotmg
    end interface

    interface
        function rocblas_drotmg(handle, d1, d2, x1, y1, param) &
                result(c_int) &
                bind(c, name = 'rocblas_drotmg')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: d1
            type(c_ptr), value :: d2
            type(c_ptr), value :: x1
            type(c_ptr), value :: y1
            type(c_ptr), value :: param
        end function rocblas_drotmg
    end interface

    ! rotmg_batched
    interface
        function rocblas_srotmg_batched(handle, d1, d2, x1, y1, param, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_srotmg_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: d1
            type(c_ptr), value :: d2
            type(c_ptr), value :: x1
            type(c_ptr), value :: y1
            type(c_ptr), value :: param
            integer(c_int), value :: batch_count
        end function rocblas_srotmg_batched
    end interface

    interface
        function rocblas_drotmg_batched(handle, d1, d2, x1, y1, param, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_drotmg_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: d1
            type(c_ptr), value :: d2
            type(c_ptr), value :: x1
            type(c_ptr), value :: y1
            type(c_ptr), value :: param
            integer(c_int), value :: batch_count
        end function rocblas_drotmg_batched
    end interface

    ! rotmg_strided_batched
    interface
        function rocblas_srotmg_strided_batched(handle, d1, stride_d1, d2, stride_d2, x1, stride_x1, &
             y1, stride_y1, param, stride_param, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_srotmg_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: d1
            integer(c_int), value :: stride_d1
            type(c_ptr), value :: d2
            integer(c_int), value :: stride_d2
            type(c_ptr), value :: x1
            integer(c_int), value :: stride_x1
            type(c_ptr), value :: y1
            integer(c_int), value :: stride_y1
            type(c_ptr), value :: param
            integer(c_int), value :: stride_param
            integer(c_int), value :: batch_count
        end function rocblas_srotmg_strided_batched
    end interface

    interface
        function rocblas_drotmg_strided_batched(handle, d1, stride_d1, d2, stride_d2, x1, stride_x1, &
             y1, stride_y1, param, stride_param, batch_count) &
                result(c_int) &
                bind(c, name = 'rocblas_drotmg_strided_batched')
            use iso_c_binding
            implicit none
            type(c_ptr), value :: handle
            type(c_ptr), value :: d1
            integer(c_int), value :: stride_d1
            type(c_ptr), value :: d2
            integer(c_int), value :: stride_d2
            type(c_ptr), value :: x1
            integer(c_int), value :: stride_x1
            type(c_ptr), value :: y1
            integer(c_int), value :: stride_y1
            type(c_ptr), value :: param
            integer(c_int), value :: stride_param
            integer(c_int), value :: batch_count
        end function rocblas_drotmg_strided_batched
    end interface

    contains
     subroutine rocblasCheck(rocblasError_t)
       implicit none
       integer(kind(rocblas_status_success)) :: rocblasError_t
       if (rocblasError_t /= rocblas_status_success) then
          write(*,*) "ROCBLAS ERROR: Error code = ", rocblasError_t
          call exit(rocblasError_t)
       end if
     end subroutine rocblasCheck

end module rocblas

module hipfort_check

contains

#ifdef USE_CUDA_NAMES
   subroutine hipCheck(cudaError_t)
      use hipfort_cuda_errors
      use hipfort_enums
      implicit none
      integer(kind(cudaSuccess)) :: cudaError_t
      integer(kind(hipSuccess)) :: hipError_t

      hipError_t = hipCUDAErrorTohipError(cudaError_t)

      if (hipError_t /= hipSuccess) then
         write (*, *) "HIP ERROR: Error code = ", hipError_t, ", CUDA error code = ", cudaError_t
         call exit(hipError_t)
      end if
   end subroutine hipCheck
#else
   subroutine hipCheck(hipError_t)
      use hipfort_enums
      implicit none

      integer(kind(hipSuccess)) :: hipError_t

      if (hipError_t /= hipSuccess) then
         write (*, *) "HIP ERROR: Error code = ", hipError_t
         call exit(hipError_t)
      end if
   end subroutine hipCheck
#endif

#ifdef USE_CUDA_NAMES
   function hipCUDAErrorTohipError(cudaError_t)
      use hipfort_enums
      use hipfort_cuda_errors
      implicit none
      integer(kind(hipSuccess))  :: hipCUDAErrorTohipError
      integer(kind(cudaSuccess)) :: cudaError_t

      select case (cudaError_t)
      case (cudaSuccess)
         hipCUDAErrorTohipError = hipSuccess
      case (cudaErrorProfilerDisabled)
         hipCUDAErrorTohipError = hipErrorProfilerDisabled
      case (cudaErrorProfilerNotInitialized)
         hipCUDAErrorTohipError = hipErrorProfilerNotInitialized
      case (cudaErrorProfilerAlreadyStarted)
         hipCUDAErrorTohipError = hipErrorProfilerAlreadyStarted
      case (cudaErrorProfilerAlreadyStopped)
         hipCUDAErrorTohipError = hipErrorProfilerAlreadyStopped
      case (cudaErrorInsufficientDriver)
         hipCUDAErrorTohipError = hipErrorInsufficientDriver
      case (cudaErrorUnsupportedLimit)
         hipCUDAErrorTohipError = hipErrorUnsupportedLimit
      case (cudaErrorPeerAccessUnsupported)
         hipCUDAErrorTohipError = hipErrorPeerAccessUnsupported
      case (cudaErrorInvalidGraphicsContext)
         hipCUDAErrorTohipError = hipErrorInvalidGraphicsContext
      case (cudaErrorSharedObjectSymbolNotFound)
         hipCUDAErrorTohipError = hipErrorSharedObjectSymbolNotFound
      case (cudaErrorSharedObjectInitFailed)
         hipCUDAErrorTohipError = hipErrorSharedObjectInitFailed
      case (cudaErrorOperatingSystem)
         hipCUDAErrorTohipError = hipErrorOperatingSystem
      case (cudaErrorSetOnActiveProcess)
         hipCUDAErrorTohipError = hipErrorSetOnActiveProcess
      case (cudaErrorIllegalAddress)
         hipCUDAErrorTohipError = hipErrorIllegalAddress
      case (cudaErrorInvalidSymbol)
         hipCUDAErrorTohipError = hipErrorInvalidSymbol
      case (cudaErrorMissingConfiguration)
         hipCUDAErrorTohipError = hipErrorMissingConfiguration
      case (cudaErrorMemoryAllocation)
         hipCUDAErrorTohipError = hipErrorOutOfMemory
      case (cudaErrorInitializationError)
         hipCUDAErrorTohipError = hipErrorNotInitialized
      case (cudaErrorLaunchFailure)
         hipCUDAErrorTohipError = hipErrorLaunchFailure
      case (cudaErrorCooperativeLaunchTooLarge)
         hipCUDAErrorTohipError = hipErrorCooperativeLaunchTooLarge
      case (cudaErrorPriorLaunchFailure)
         hipCUDAErrorTohipError = hipErrorPriorLaunchFailure
      case (cudaErrorLaunchOutOfResources)
         hipCUDAErrorTohipError = hipErrorLaunchOutOfResources
      case (cudaErrorInvalidDeviceFunction)
         hipCUDAErrorTohipError = hipErrorInvalidDeviceFunction
      case (cudaErrorInvalidConfiguration)
         hipCUDAErrorTohipError = hipErrorInvalidConfiguration
      case (cudaErrorInvalidDevice)
         hipCUDAErrorTohipError = hipErrorInvalidDevice
      case (cudaErrorInvalidValue)
         hipCUDAErrorTohipError = hipErrorInvalidValue
      case (cudaErrorInvalidDevicePointer)
         hipCUDAErrorTohipError = hipErrorInvalidDevicePointer
      case (cudaErrorInvalidMemcpyDirection)
         hipCUDAErrorTohipError = hipErrorInvalidMemcpyDirection
      case (cudaErrorInvalidResourceHandle)
         hipCUDAErrorTohipError = hipErrorInvalidHandle
      case (cudaErrorNotReady)
         hipCUDAErrorTohipError = hipErrorNotReady
      case (cudaErrorNoDevice)
         hipCUDAErrorTohipError = hipErrorNoDevice
      case (cudaErrorPeerAccessAlreadyEnabled)
         hipCUDAErrorTohipError = hipErrorPeerAccessAlreadyEnabled
      case (cudaErrorPeerAccessNotEnabled)
         hipCUDAErrorTohipError = hipErrorPeerAccessNotEnabled
      case (cudaErrorHostMemoryAlreadyRegistered)
         hipCUDAErrorTohipError = hipErrorHostMemoryAlreadyRegistered
      case (cudaErrorHostMemoryNotRegistered)
         hipCUDAErrorTohipError = hipErrorHostMemoryNotRegistered
      case (cudaErrorMapBufferObjectFailed)
         hipCUDAErrorTohipError = hipErrorMapFailed
      case (cudaErrorAssert)
         hipCUDAErrorTohipError = hipErrorAssert
      case (cudaErrorNotSupported)
         hipCUDAErrorTohipError = hipErrorNotSupported
      case (cudaErrorCudartUnloading)
         hipCUDAErrorTohipError = hipErrorDeinitialized
      case (cudaErrorInvalidKernelImage)
         hipCUDAErrorTohipError = hipErrorInvalidImage
      case (cudaErrorUnmapBufferObjectFailed)
         hipCUDAErrorTohipError = hipErrorUnmapFailed
      case (cudaErrorNoKernelImageForDevice)
         hipCUDAErrorTohipError = hipErrorNoBinaryForGpu
      case (cudaErrorECCUncorrectable)
         hipCUDAErrorTohipError = hipErrorECCNotCorrectable
      case (cudaErrorDeviceAlreadyInUse)
         hipCUDAErrorTohipError = hipErrorContextAlreadyInUse
      case (cudaErrorInvalidPtx)
         hipCUDAErrorTohipError = hipErrorInvalidKernelFile
      case (cudaErrorLaunchTimeout)
         hipCUDAErrorTohipError = hipErrorLaunchTimeOut
#if CUDA_VERSION >= 10010
      case (cudaErrorInvalidSource)
         hipCUDAErrorTohipError = hipErrorInvalidSource
      case (cudaErrorFileNotFound)
         hipCUDAErrorTohipError = hipErrorFileNotFound
      case (cudaErrorSymbolNotFound)
         hipCUDAErrorTohipError = hipErrorNotFound
      case (cudaErrorArrayIsMapped)
         hipCUDAErrorTohipError = hipErrorArrayIsMapped
      case (cudaErrorNotMappedAsPointer)
         hipCUDAErrorTohipError = hipErrorNotMappedAsPointer
      case (cudaErrorNotMappedAsArray)
         hipCUDAErrorTohipError = hipErrorNotMappedAsArray
      case (cudaErrorNotMapped)
         hipCUDAErrorTohipError = hipErrorNotMapped
      case (cudaErrorAlreadyAcquired)
         hipCUDAErrorTohipError = hipErrorAlreadyAcquired
      case (cudaErrorAlreadyMapped)
         hipCUDAErrorTohipError = hipErrorAlreadyMapped
#endif
#if CUDA_VERSION >= 10020
      case (cudaErrorDeviceUninitialized)
         hipCUDAErrorTohipError = hipErrorInvalidContext
#endif
      case (cudaErrorUnknown)
      case default
         hipCUDAErrorTohipError = hipErrorUnknown  ! Note - translated error.
      end select
   end function hipCUDAErrorTohipError

   function hipErrorToCudaError(hipError_t)
      use hipfort_enums
      use hipfort_cuda_errors
      implicit none
      integer(kind(cudaSuccess)) :: hipErrorToCudaError
      integer(kind(hipSuccess))  :: hipError_t
      select case (hipError_t)
      case (hipSuccess)
         hipErrorToCudaError = cudaSuccess
      case (hipErrorOutOfMemory)
         hipErrorToCudaError = cudaErrorMemoryAllocation
      case (hipErrorProfilerDisabled)
         hipErrorToCudaError = cudaErrorProfilerDisabled
      case (hipErrorProfilerNotInitialized)
         hipErrorToCudaError = cudaErrorProfilerNotInitialized
      case (hipErrorProfilerAlreadyStarted)
         hipErrorToCudaError = cudaErrorProfilerAlreadyStarted
      case (hipErrorProfilerAlreadyStopped)
         hipErrorToCudaError = cudaErrorProfilerAlreadyStopped
      case (hipErrorInvalidConfiguration)
         hipErrorToCudaError = cudaErrorInvalidConfiguration
      case (hipErrorLaunchOutOfResources)
         hipErrorToCudaError = cudaErrorLaunchOutOfResources
      case (hipErrorInvalidValue)
         hipErrorToCudaError = cudaErrorInvalidValue
      case (hipErrorInvalidHandle)
         hipErrorToCudaError = cudaErrorInvalidResourceHandle
      case (hipErrorInvalidDevice)
         hipErrorToCudaError = cudaErrorInvalidDevice
      case (hipErrorInvalidMemcpyDirection)
         hipErrorToCudaError = cudaErrorInvalidMemcpyDirection
      case (hipErrorInvalidDevicePointer)
         hipErrorToCudaError = cudaErrorInvalidDevicePointer
      case (hipErrorNotInitialized)
         hipErrorToCudaError = cudaErrorInitializationError
      case (hipErrorNoDevice)
         hipErrorToCudaError = cudaErrorNoDevice
      case (hipErrorNotReady)
         hipErrorToCudaError = cudaErrorNotReady
      case (hipErrorPeerAccessNotEnabled)
         hipErrorToCudaError = cudaErrorPeerAccessNotEnabled
      case (hipErrorPeerAccessAlreadyEnabled)
         hipErrorToCudaError = cudaErrorPeerAccessAlreadyEnabled
      case (hipErrorHostMemoryAlreadyRegistered)
         hipErrorToCudaError = cudaErrorHostMemoryAlreadyRegistered
      case (hipErrorHostMemoryNotRegistered)
         hipErrorToCudaError = cudaErrorHostMemoryNotRegistered
      case (hipErrorDeinitialized)
         hipErrorToCudaError = cudaErrorCudartUnloading
      case (hipErrorInvalidSymbol)
         hipErrorToCudaError = cudaErrorInvalidSymbol
      case (hipErrorInsufficientDriver)
         hipErrorToCudaError = cudaErrorInsufficientDriver
      case (hipErrorMissingConfiguration)
         hipErrorToCudaError = cudaErrorMissingConfiguration
      case (hipErrorPriorLaunchFailure)
         hipErrorToCudaError = cudaErrorPriorLaunchFailure
      case (hipErrorInvalidDeviceFunction)
         hipErrorToCudaError = cudaErrorInvalidDeviceFunction
      case (hipErrorInvalidImage)
         hipErrorToCudaError = cudaErrorInvalidKernelImage
      case (hipErrorInvalidContext)
#if CUDA_VERSION >= 10020
         hipErrorToCudaError = cudaErrorDeviceUninitialized
#else
         hipErrorToCudaError = cudaErrorUnknown
#endif
      case (hipErrorMapFailed)
         hipErrorToCudaError = cudaErrorMapBufferObjectFailed
      case (hipErrorUnmapFailed)
         hipErrorToCudaError = cudaErrorUnmapBufferObjectFailed
      case (hipErrorArrayIsMapped)
#if CUDA_VERSION >= 10010
         hipErrorToCudaError = cudaErrorArrayIsMapped
#else
         hipErrorToCudaError = cudaErrorUnknown
#endif
      case (hipErrorAlreadyMapped)
#if CUDA_VERSION >= 10010
         hipErrorToCudaError = cudaErrorAlreadyMapped
#else
         hipErrorToCudaError = cudaErrorUnknown
#endif
      case (hipErrorNoBinaryForGpu)
         hipErrorToCudaError = cudaErrorNoKernelImageForDevice
      case (hipErrorAlreadyAcquired)
#if CUDA_VERSION >= 10010
         hipErrorToCudaError = cudaErrorAlreadyAcquired
#else
         hipErrorToCudaError = cudaErrorUnknown
#endif
      case (hipErrorNotMapped)
#if CUDA_VERSION >= 10010
         hipErrorToCudaError = cudaErrorNotMapped
#else
         hipErrorToCudaError = cudaErrorUnknown
#endif
      case (hipErrorNotMappedAsArray)
#if CUDA_VERSION >= 10010
         hipErrorToCudaError = cudaErrorNotMappedAsArray
#else
         hipErrorToCudaError = cudaErrorUnknown
#endif
      case (hipErrorNotMappedAsPointer)
#if CUDA_VERSION >= 10010
         hipErrorToCudaError = cudaErrorNotMappedAsPointer
#else
         hipErrorToCudaError = cudaErrorUnknown
#endif
      case (hipErrorECCNotCorrectable)
         hipErrorToCudaError = cudaErrorECCUncorrectable
      case (hipErrorUnsupportedLimit)
         hipErrorToCudaError = cudaErrorUnsupportedLimit
      case (hipErrorContextAlreadyInUse)
         hipErrorToCudaError = cudaErrorDeviceAlreadyInUse
      case (hipErrorPeerAccessUnsupported)
         hipErrorToCudaError = cudaErrorPeerAccessUnsupported
      case (hipErrorInvalidKernelFile)
         hipErrorToCudaError = cudaErrorInvalidPtx
      case (hipErrorInvalidGraphicsContext)
         hipErrorToCudaError = cudaErrorInvalidGraphicsContext
      case (hipErrorInvalidSource)
#if CUDA_VERSION >= 10010
         hipErrorToCudaError = cudaErrorInvalidSource
#else
         hipErrorToCudaError = cudaErrorUnknown
#endif
      case (hipErrorFileNotFound)
#if CUDA_VERSION >= 10010
         hipErrorToCudaError = cudaErrorFileNotFound
#else
         hipErrorToCudaError = cudaErrorUnknown
#endif
      case (hipErrorSharedObjectSymbolNotFound)
         hipErrorToCudaError = cudaErrorSharedObjectSymbolNotFound
      case (hipErrorSharedObjectInitFailed)
         hipErrorToCudaError = cudaErrorSharedObjectInitFailed
      case (hipErrorOperatingSystem)
         hipErrorToCudaError = cudaErrorOperatingSystem
      case (hipErrorNotFound)
#if CUDA_VERSION >= 10010
         hipErrorToCudaError = cudaErrorSymbolNotFound
#else
         hipErrorToCudaError = cudaErrorUnknown
#endif
      case (hipErrorIllegalAddress)
         hipErrorToCudaError = cudaErrorIllegalAddress
      case (hipErrorLaunchTimeOut)
         hipErrorToCudaError = cudaErrorLaunchTimeout
      case (hipErrorSetOnActiveProcess)
         hipErrorToCudaError = cudaErrorSetOnActiveProcess
      case (hipErrorLaunchFailure)
         hipErrorToCudaError = cudaErrorLaunchFailure
      case (hipErrorCooperativeLaunchTooLarge)
         hipErrorToCudaError = cudaErrorCooperativeLaunchTooLarge
      case (hipErrorNotSupported)
         hipErrorToCudaError = cudaErrorNotSupported
         ! HSA:does not exist in CUDA
      case (hipErrorRuntimeMemory)
         ! HSA:does not exist in CUDA
      case (hipErrorRuntimeOther)
      case (hipErrorUnknown)
      case (hipErrorTbd)
      case default
         hipErrorToCudaError = cudaErrorUnknown  ! Note - translated error.
      end select
   end function hipErrorToCudaError
#endif
  
  ! HIP math libs
  ! TODO: Currently, only AMDGPU is supported
  
  subroutine hipblasCheck(hipblasError_t)
    use hipfort_hipblas_enums

    implicit none

    integer(kind(HIPBLAS_STATUS_SUCCESS)) :: hipblasError_t

    if(hipblasError_t /= HIPBLAS_STATUS_SUCCESS)then
       write(*,*) "HIPBLAS ERROR: Error code = ", hipblasError_t
       call exit(hipblasError_t)
    end if
  end subroutine hipblasCheck

  subroutine hipfftCheck(hipfft_status)
    use hipfort_hipfft_enums

    implicit none

    integer(kind(hipfft_success)) :: hipfft_status

    if(hipfft_status /= hipfft_success)then
       write(*,*) "HIPFFT ERROR: Error code = ", hipfft_status
       call exit(hipfft_status)
    end if
  end subroutine hipfftCheck
  
  subroutine hipsparseCheck(hipsparseError_t)
    use hipfort_hipsparse_enums

    implicit none

    integer(kind(HIPSPARSE_STATUS_SUCCESS)) :: hipsparseError_t

    if(hipsparseError_t /= HIPSPARSE_STATUS_SUCCESS)then
       write(*,*) "HIPSPARSE ERROR: Error code = ", hipsparseError_t
       call exit(hipsparseError_t)
    end if
  end subroutine hipsparseCheck
  
  subroutine hipsolverCheck(hipsolverError_t)
    use hipfort_hipsolver_enums

    implicit none

    integer(kind(HIPSOLVER_STATUS_SUCCESS)) :: hipsolverError_t

    if(hipsolverError_t /= HIPSOLVER_STATUS_SUCCESS)then
       write(*,*) "HIPSOLVER ERROR: Error code = ", hipsolverError_t
       call exit(hipsolverError_t)
    end if
  end subroutine hipsolverCheck
  
  subroutine rocblasCheck(rocblasError_t)
    use hipfort_rocblas_enums

    implicit none

    integer(kind(ROCBLAS_STATUS_SUCCESS)) :: rocblasError_t

    if(rocblasError_t /= ROCBLAS_STATUS_SUCCESS)then
       write(*,*) "ROCBLAS ERROR: Error code = ", rocblasError_t
       call exit(rocblasError_t)
    end if
  end subroutine rocblasCheck

  ! ROCm math libs

  subroutine rocfftCheck(rocfft_status)
    use hipfort_rocfft_enums

    implicit none

    integer(kind(rocfft_status_success)) :: rocfft_status

    if(rocfft_status /= rocfft_status_success)then
       write(*,*) "ROCFFT ERROR: Error code = ", rocfft_status
       call exit(rocfft_status)
    end if
  end subroutine rocfftCheck
  
  subroutine rocsparseCheck(rocsparseError_t)
    use hipfort_rocsparse_enums

    implicit none

    integer(kind(ROCSPARSE_STATUS_SUCCESS)) :: rocsparseError_t

    if(rocsparseError_t /= ROCSPARSE_STATUS_SUCCESS)then
       write(*,*) "ROCSPARSE ERROR: Error code = ", rocsparseError_t
       call exit(rocsparseError_t)
    end if
  end subroutine rocsparseCheck
  
  subroutine rocsolverCheck(rocsolverError_t)
    use hipfort_rocblas_enums
    use hipfort_rocsolver_enums

    implicit none

    integer(kind(ROCBLAS_STATUS_SUCCESS)) :: rocsolverError_t

    if(rocsolverError_t /= ROCBLAS_STATUS_SUCCESS)then
       write(*,*) "ROCSOLVER ERROR: Error code = ", rocsolverError_t
       call exit(rocsolverError_t)
    end if
  end subroutine rocsolverCheck

end module hipfort_check

program hip_dscal

  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none

  integer, parameter :: N = 10240;
  integer, parameter :: bytes_per_element = 8 !double precision
  integer(c_size_t), parameter :: Nbytes = N*bytes_per_element

  double precision, parameter :: alpha = 10.d0

  type(c_ptr) :: dx = c_null_ptr

  double precision,allocatable,target,dimension(:) :: hx
  double precision,allocatable,dimension(:) ::hx_scaled

  double precision :: error
  double precision, parameter :: error_max = 10*epsilon(error_max)

  type(c_ptr) :: hip_blas_handle = c_null_ptr

  integer :: i

  write(*,"(a)",advance="no") "-- Running test 'dscal' (Fortran 2003 interfaces) - "
  allocate(hx(N))
  allocate(hx_scaled(N))

  hx(:) = 10.d0

  hx_scaled = alpha*hx

  call hipblasCheck(hipblasCreate(hip_blas_handle))

  call hipCheck(hipMalloc(dx,Nbytes))

   ! Transfer data from host to device memory
  call hipCheck(hipMemcpy(dx, c_loc(hx(1)), Nbytes, hipMemcpyHostToDevice))

  call hipblasCheck(hipblasDscal(hip_blas_handle, N, alpha, dx, 1))

  call hipCheck(hipDeviceSynchronize())

  ! Transfer data back to host memory
  call hipCheck(hipMemcpy(c_loc(hx(1)), dx, Nbytes, hipMemcpyDeviceToHost))

  call hipCheck(hipFree(dx))

  ! Verification
  do i = 1,N
     error = abs(hx(i) - hx_scaled(i) )
     if( error .gt. error_max ) then
        write(*,*) "FAILED! Error bigger than max! Error = ", error, " hx(i) = ", hx(i)
        call exit
     endif
  end do

  call hipblasCheck(hipblasDestroy(hip_blas_handle))

  deallocate(hx_scaled)
  deallocate(hx)

  write(*,*) "PASSED!"

end program hip_dscal

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_enums
  implicit none

  enum, bind(c)
    enumerator :: HIP_SUCCESS = 0
    enumerator :: HIP_ERROR_INVALID_VALUE
    enumerator :: HIP_ERROR_NOT_INITIALIZED
    enumerator :: HIP_ERROR_LAUNCH_OUT_OF_RESOURCES
  end enum

  enum, bind(c)
    enumerator :: hipMemoryTypeHost
    enumerator :: hipMemoryTypeDevice
    enumerator :: hipMemoryTypeArray
    enumerator :: hipMemoryTypeUnified
  end enum
 
  enum, bind(c)
    enumerator :: hipSuccess = 0 !> Successful completion.
    enumerator :: hipErrorInvalidValue = 1 !> One or more of the parameters passed to the API call is NULL or not in an acceptable range.
    enumerator :: hipErrorOutOfMemory = 2 !> Out of memory range.
    enumerator :: hipErrorMemoryAllocation = 2 !> Memory allocation error.
    enumerator :: hipErrorNotInitialized = 3 !> Invalid not initialized
    enumerator :: hipErrorInitializationError = 3
    enumerator :: hipErrorDeinitialized = 4
    enumerator :: hipErrorProfilerDisabled = 5
    enumerator :: hipErrorProfilerNotInitialized = 6
    enumerator :: hipErrorProfilerAlreadyStarted = 7
    enumerator :: hipErrorProfilerAlreadyStopped = 8
    enumerator :: hipErrorInvalidConfiguration = 9
    enumerator :: hipErrorInvalidPitchValue = 12
    enumerator :: hipErrorInvalidSymbol = 13
    enumerator :: hipErrorInvalidDevicePointer = 17
    enumerator :: hipErrorInvalidMemcpyDirection = 21
    enumerator :: hipErrorInsufficientDriver = 35
    enumerator :: hipErrorMissingConfiguration = 52
    enumerator :: hipErrorPriorLaunchFailure = 53
    enumerator :: hipErrorInvalidDeviceFunction = 98
    enumerator :: hipErrorNoDevice = 100
    enumerator :: hipErrorInvalidDevice = 101
    enumerator :: hipErrorInvalidImage = 200
    enumerator :: hipErrorInvalidContext = 201
    enumerator :: hipErrorContextAlreadyCurrent = 202
    enumerator :: hipErrorMapFailed = 205
    enumerator :: hipErrorMapBufferObjectFailed = 205
    enumerator :: hipErrorUnmapFailed = 206
    enumerator :: hipErrorArrayIsMapped = 207
    enumerator :: hipErrorAlreadyMapped = 208
    enumerator :: hipErrorNoBinaryForGpu = 209
    enumerator :: hipErrorAlreadyAcquired = 210
    enumerator :: hipErrorNotMapped = 211
    enumerator :: hipErrorNotMappedAsArray = 212
    enumerator :: hipErrorNotMappedAsPointer = 213
    enumerator :: hipErrorECCNotCorrectable = 214
    enumerator :: hipErrorUnsupportedLimit = 215
    enumerator :: hipErrorContextAlreadyInUse = 216
    enumerator :: hipErrorPeerAccessUnsupported = 217
    enumerator :: hipErrorInvalidKernelFile = 218
    enumerator :: hipErrorInvalidGraphicsContext = 219
    enumerator :: hipErrorInvalidSource = 300
    enumerator :: hipErrorFileNotFound = 301
    enumerator :: hipErrorSharedObjectSymbolNotFound = 302
    enumerator :: hipErrorSharedObjectInitFailed = 303
    enumerator :: hipErrorOperatingSystem = 304
    enumerator :: hipErrorInvalidHandle = 400
    enumerator :: hipErrorInvalidResourceHandle = 400
    enumerator :: hipErrorIllegalState = 401
    enumerator :: hipErrorNotFound = 500
    enumerator :: hipErrorNotReady = 600
    enumerator :: hipErrorIllegalAddress = 700
    enumerator :: hipErrorLaunchOutOfResources = 701
    enumerator :: hipErrorLaunchTimeOut = 702
    enumerator :: hipErrorPeerAccessAlreadyEnabled = 704
    enumerator :: hipErrorPeerAccessNotEnabled = 705
    enumerator :: hipErrorSetOnActiveProcess = 708
    enumerator :: hipErrorContextIsDestroyed = 709
    enumerator :: hipErrorAssert = 710
    enumerator :: hipErrorHostMemoryAlreadyRegistered = 712
    enumerator :: hipErrorHostMemoryNotRegistered = 713
    enumerator :: hipErrorLaunchFailure = 719
    enumerator :: hipErrorCooperativeLaunchTooLarge = 720
    enumerator :: hipErrorNotSupported = 801
    enumerator :: hipErrorStreamCaptureUnsupported = 900
    enumerator :: hipErrorStreamCaptureInvalidated = 901
    enumerator :: hipErrorStreamCaptureMerge = 902
    enumerator :: hipErrorStreamCaptureUnmatched = 903
    enumerator :: hipErrorStreamCaptureUnjoined = 904
    enumerator :: hipErrorStreamCaptureIsolation = 905
    enumerator :: hipErrorStreamCaptureImplicit = 906
    enumerator :: hipErrorCapturedEvent = 907
    enumerator :: hipErrorStreamCaptureWrongThread = 908
    enumerator :: hipErrorGraphExecUpdateFailure = 910
    enumerator :: hipErrorUnknown = 999
    enumerator :: hipErrorRuntimeMemory = 1052
    enumerator :: hipErrorRuntimeOther = 1053
    enumerator :: hipErrorTbd
  end enum

  enum, bind(c)
    enumerator :: hipDeviceAttributeCudaCompatibleBegin = 0
    enumerator :: hipDeviceAttributeEccEnabled = hipDeviceAttributeCudaCompatibleBegin
    enumerator :: hipDeviceAttributeAccessPolicyMaxWindowSize
    enumerator :: hipDeviceAttributeAsyncEngineCount
    enumerator :: hipDeviceAttributeCanMapHostMemory
    enumerator :: hipDeviceAttributeCanUseHostPointerForRegisteredMem
    enumerator :: hipDeviceAttributeClockRate
    enumerator :: hipDeviceAttributeComputeMode
    enumerator :: hipDeviceAttributeComputePreemptionSupported
    enumerator :: hipDeviceAttributeConcurrentKernels
    enumerator :: hipDeviceAttributeConcurrentManagedAccess
    enumerator :: hipDeviceAttributeCooperativeLaunch
    enumerator :: hipDeviceAttributeCooperativeMultiDeviceLaunch
    enumerator :: hipDeviceAttributeDeviceOverlap
    enumerator :: hipDeviceAttributeDirectManagedMemAccessFromHost
    enumerator :: hipDeviceAttributeGlobalL1CacheSupported
    enumerator :: hipDeviceAttributeHostNativeAtomicSupported
    enumerator :: hipDeviceAttributeIntegrated
    enumerator :: hipDeviceAttributeIsMultiGpuBoard
    enumerator :: hipDeviceAttributeKernelExecTimeout
    enumerator :: hipDeviceAttributeL2CacheSize
    enumerator :: hipDeviceAttributeLocalL1CacheSupported
    enumerator :: hipDeviceAttributeLuid
    enumerator :: hipDeviceAttributeLuidDeviceNodeMask
    enumerator :: hipDeviceAttributeComputeCapabilityMajor
    enumerator :: hipDeviceAttributeManagedMemory
    enumerator :: hipDeviceAttributeMaxBlocksPerMultiProcessor
    enumerator :: hipDeviceAttributeMaxBlockDimX
    enumerator :: hipDeviceAttributeMaxBlockDimY
    enumerator :: hipDeviceAttributeMaxBlockDimZ
    enumerator :: hipDeviceAttributeMaxGridDimX
    enumerator :: hipDeviceAttributeMaxGridDimY
    enumerator :: hipDeviceAttributeMaxGridDimZ
    enumerator :: hipDeviceAttributeMaxSurface1D
    enumerator :: hipDeviceAttributeMaxSurface1DLayered
    enumerator :: hipDeviceAttributeMaxSurface2D
    enumerator :: hipDeviceAttributeMaxSurface2DLayered
    enumerator :: hipDeviceAttributeMaxSurface3D
    enumerator :: hipDeviceAttributeMaxSurfaceCubemap
    enumerator :: hipDeviceAttributeMaxSurfaceCubemapLayered
    enumerator :: hipDeviceAttributeMaxTexture1DWidth
    enumerator :: hipDeviceAttributeMaxTexture1DLayered
    enumerator :: hipDeviceAttributeMaxTexture1DLinear
    enumerator :: hipDeviceAttributeMaxTexture1DMipmap
    enumerator :: hipDeviceAttributeMaxTexture2DWidth
    enumerator :: hipDeviceAttributeMaxTexture2DHeight
    enumerator :: hipDeviceAttributeMaxTexture2DGather
    enumerator :: hipDeviceAttributeMaxTexture2DLayered
    enumerator :: hipDeviceAttributeMaxTexture2DLinear
    enumerator :: hipDeviceAttributeMaxTexture2DMipmap
    enumerator :: hipDeviceAttributeMaxTexture3DWidth
    enumerator :: hipDeviceAttributeMaxTexture3DHeight
    enumerator :: hipDeviceAttributeMaxTexture3DDepth
    enumerator :: hipDeviceAttributeMaxTexture3DAlt
    enumerator :: hipDeviceAttributeMaxTextureCubemap
    enumerator :: hipDeviceAttributeMaxTextureCubemapLayered
    enumerator :: hipDeviceAttributeMaxThreadsDim
    enumerator :: hipDeviceAttributeMaxThreadsPerBlock
    enumerator :: hipDeviceAttributeMaxThreadsPerMultiProcessor
    enumerator :: hipDeviceAttributeMaxPitch
    enumerator :: hipDeviceAttributeMemoryBusWidth
    enumerator :: hipDeviceAttributeMemoryClockRate
    enumerator :: hipDeviceAttributeComputeCapabilityMinor
    enumerator :: hipDeviceAttributeMultiGpuBoardGroupID
    enumerator :: hipDeviceAttributeMultiprocessorCount
    enumerator :: hipDeviceAttributeName
    enumerator :: hipDeviceAttributePageableMemoryAccess
    enumerator :: hipDeviceAttributePageableMemoryAccessUsesHostPageTables
    enumerator :: hipDeviceAttributePciBusId
    enumerator :: hipDeviceAttributePciDeviceId
    enumerator :: hipDeviceAttributePciDomainID
    enumerator :: hipDeviceAttributePersistingL2CacheMaxSize
    enumerator :: hipDeviceAttributeMaxRegistersPerBlock
    enumerator :: hipDeviceAttributeMaxRegistersPerMultiprocessor
    enumerator :: hipDeviceAttributeReservedSharedMemPerBlock
    enumerator :: hipDeviceAttributeMaxSharedMemoryPerBlock
    enumerator :: hipDeviceAttributeSharedMemPerBlockOptin
    enumerator :: hipDeviceAttributeSharedMemPerMultiprocessor
    enumerator :: hipDeviceAttributeSingleToDoublePrecisionPerfRatio
    enumerator :: hipDeviceAttributeStreamPrioritiesSupported
    enumerator :: hipDeviceAttributeSurfaceAlignment
    enumerator :: hipDeviceAttributeTccDriver
    enumerator :: hipDeviceAttributeTextureAlignment
    enumerator :: hipDeviceAttributeTexturePitchAlignment
    enumerator :: hipDeviceAttributeTotalConstantMemory
    enumerator :: hipDeviceAttributeTotalGlobalMem
    enumerator :: hipDeviceAttributeUnifiedAddressing
    enumerator :: hipDeviceAttributeUuid
    enumerator :: hipDeviceAttributeWarpSize
    enumerator :: hipDeviceAttributeCudaCompatibleEnd = 9999
    enumerator :: hipDeviceAttributeAmdSpecificBegin = 10000
    enumerator :: hipDeviceAttributeClockInstructionRate = hipDeviceAttributeAmdSpecificBegin
    enumerator :: hipDeviceAttributeArch
    enumerator :: hipDeviceAttributeMaxSharedMemoryPerMultiprocessor
    enumerator :: hipDeviceAttributeGcnArch
    enumerator :: hipDeviceAttributeGcnArchName
    enumerator :: hipDeviceAttributeHdpMemFlushCntl
    enumerator :: hipDeviceAttributeHdpRegFlushCntl
    enumerator :: hipDeviceAttributeCooperativeMultiDeviceUnmatchedFunc
    enumerator :: hipDeviceAttributeCooperativeMultiDeviceUnmatchedGridDim
    enumerator :: hipDeviceAttributeCooperativeMultiDeviceUnmatchedBlockDim
    enumerator :: hipDeviceAttributeCooperativeMultiDeviceUnmatchedSharedMem
    enumerator :: hipDeviceAttributeIsLargeBar
    enumerator :: hipDeviceAttributeAsicRevision
    enumerator :: hipDeviceAttributeCanUseStreamWaitValue
    enumerator :: hipDeviceAttributeImageSupport
    enumerator :: hipDeviceAttributeAmdSpecificEnd = 19999
    enumerator :: hipDeviceAttributeVendorSpecificBegin = 20000
  end enum

  enum, bind(c)
    enumerator :: hipComputeModeDefault = 0
    enumerator :: hipComputeModeExclusive = 1
    enumerator :: hipComputeModeProhibited = 2
    enumerator :: hipComputeModeExclusiveProcess = 3
  end enum

  enum, bind(c)
    enumerator :: hipDevP2PAttrPerformanceRank = 0
    enumerator :: hipDevP2PAttrAccessSupported
    enumerator :: hipDevP2PAttrNativeAtomicSupported
    enumerator :: hipDevP2PAttrHipArrayAccessSupported
  end enum

  enum, bind(c)
    enumerator :: hipLimitPrintfFifoSize = 1
    enumerator :: hipLimitMallocHeapSize = 2
  end enum

  enum, bind(c)
    enumerator :: hipMemAdviseSetReadMostly = 1
    enumerator :: hipMemAdviseUnsetReadMostly = 2
    enumerator :: hipMemAdviseSetPreferredLocation = 3
    enumerator :: hipMemAdviseUnsetPreferredLocation = 4
    enumerator :: hipMemAdviseSetAccessedBy = 5
    enumerator :: hipMemAdviseUnsetAccessedBy = 6
    enumerator :: hipMemAdviseSetCoarseGrain = 100
    enumerator :: hipMemAdviseUnsetCoarseGrain = 101
  end enum

  enum, bind(c)
    enumerator :: hipMemRangeCoherencyModeFineGrain = 0
    enumerator :: hipMemRangeCoherencyModeCoarseGrain = 1
    enumerator :: hipMemRangeCoherencyModeIndeterminate = 2
  end enum

  enum, bind(c)
    enumerator :: hipMemRangeAttributeReadMostly = 1
    enumerator :: hipMemRangeAttributePreferredLocation = 2
    enumerator :: hipMemRangeAttributeAccessedBy = 3
    enumerator :: hipMemRangeAttributeLastPrefetchLocation = 4
    enumerator :: hipMemRangeAttributeCoherencyMode = 100
  end enum

  enum, bind(c)
    enumerator :: hipJitOptionMaxRegisters = 0
    enumerator :: hipJitOptionThreadsPerBlock
    enumerator :: hipJitOptionWallTime
    enumerator :: hipJitOptionInfoLogBuffer
    enumerator :: hipJitOptionInfoLogBufferSizeBytes
    enumerator :: hipJitOptionErrorLogBuffer
    enumerator :: hipJitOptionErrorLogBufferSizeBytes
    enumerator :: hipJitOptionOptimizationLevel
    enumerator :: hipJitOptionTargetFromContext
    enumerator :: hipJitOptionTarget
    enumerator :: hipJitOptionFallbackStrategy
    enumerator :: hipJitOptionGenerateDebugInfo
    enumerator :: hipJitOptionLogVerbose
    enumerator :: hipJitOptionGenerateLineInfo
    enumerator :: hipJitOptionCacheMode
    enumerator :: hipJitOptionSm3xOpt
    enumerator :: hipJitOptionFastCompile
    enumerator :: hipJitOptionNumOptions
  end enum

  enum, bind(c)
    enumerator :: hipFuncAttributeMaxDynamicSharedMemorySize = 8
    enumerator :: hipFuncAttributePreferredSharedMemoryCarveout = 9
    enumerator :: hipFuncAttributeMax
  end enum

  enum, bind(c)
    enumerator :: hipFuncCachePreferNone
    enumerator :: hipFuncCachePreferShared
    enumerator :: hipFuncCachePreferL1
    enumerator :: hipFuncCachePreferEqual
  end enum

  enum, bind(c)
    enumerator :: hipSharedMemBankSizeDefault
    enumerator :: hipSharedMemBankSizeFourByte
    enumerator :: hipSharedMemBankSizeEightByte
  end enum

  enum, bind(c)
    enumerator :: hipExternalMemoryHandleTypeOpaqueFd = 1
    enumerator :: hipExternalMemoryHandleTypeOpaqueWin32 = 2
    enumerator :: hipExternalMemoryHandleTypeOpaqueWin32Kmt = 3
    enumerator :: hipExternalMemoryHandleTypeD3D12Heap = 4
    enumerator :: hipExternalMemoryHandleTypeD3D12Resource = 5
    enumerator :: hipExternalMemoryHandleTypeD3D11Resource = 6
    enumerator :: hipExternalMemoryHandleTypeD3D11ResourceKmt = 7
  end enum

  enum, bind(c)
    enumerator :: hipExternalSemaphoreHandleTypeOpaqueFd = 1
    enumerator :: hipExternalSemaphoreHandleTypeOpaqueWin32 = 2
    enumerator :: hipExternalSemaphoreHandleTypeOpaqueWin32Kmt = 3
    enumerator :: hipExternalSemaphoreHandleTypeD3D12Fence = 4
  end enum

  enum, bind(c)
    enumerator :: hipGLDeviceListAll = 1
    enumerator :: hipGLDeviceListCurrentFrame = 2
    enumerator :: hipGLDeviceListNextFrame = 3
  end enum

  enum, bind(c)
    enumerator :: hipGraphicsRegisterFlagsNone = 0
    enumerator :: hipGraphicsRegisterFlagsReadOnly = 1
    enumerator :: hipGraphicsRegisterFlagsWriteDiscard = 2
    enumerator :: hipGraphicsRegisterFlagsSurfaceLoadStore = 4
    enumerator :: hipGraphicsRegisterFlagsTextureGather = 8
  end enum

  enum, bind(c)
    enumerator :: hipGraphNodeTypeKernel = 1
    enumerator :: hipGraphNodeTypeMemcpy = 2
    enumerator :: hipGraphNodeTypeMemset = 3
    enumerator :: hipGraphNodeTypeHost = 4
    enumerator :: hipGraphNodeTypeGraph = 5
    enumerator :: hipGraphNodeTypeEmpty = 6
    enumerator :: hipGraphNodeTypeWaitEvent = 7
    enumerator :: hipGraphNodeTypeEventRecord = 8
    enumerator :: hipGraphNodeTypeMemcpy1D = 9
    enumerator :: hipGraphNodeTypeMemcpyFromSymbol = 10
    enumerator :: hipGraphNodeTypeMemcpyToSymbol = 11
    enumerator :: hipGraphNodeTypeCount
  end enum

  enum, bind(c)
    enumerator :: hipGraphExecUpdateSuccess = 0
    enumerator :: hipGraphExecUpdateError = 1
    enumerator :: hipGraphExecUpdateErrorTopologyChanged = 2
    enumerator :: hipGraphExecUpdateErrorNodeTypeChanged = 3
    enumerator :: hipGraphExecUpdateErrorFunctionChanged = 4
    enumerator :: hipGraphExecUpdateErrorParametersChanged = 5
    enumerator :: hipGraphExecUpdateErrorNotSupported = 6
    enumerator :: hipGraphExecUpdateErrorUnsupportedFunctionChange = 7
  end enum

  enum, bind(c)
    enumerator :: hipStreamCaptureModeGlobal = 0
    enumerator :: hipStreamCaptureModeThreadLocal
    enumerator :: hipStreamCaptureModeRelaxed
  end enum

  enum, bind(c)
    enumerator :: hipStreamCaptureStatusNone = 0
    enumerator :: hipStreamCaptureStatusActive
    enumerator :: hipStreamCaptureStatusInvalidated
  end enum

  enum, bind(c)
    enumerator :: hipStreamAddCaptureDependencies = 0
    enumerator :: hipStreamSetCaptureDependencies
  end enum

  enum, bind(c)
    enumerator :: hipChannelFormatKindSigned = 0
    enumerator :: hipChannelFormatKindUnsigned = 1
    enumerator :: hipChannelFormatKindFloat = 2
    enumerator :: hipChannelFormatKindNone = 3
  end enum

  enum, bind(c)
    enumerator :: HIP_AD_FORMAT_UNSIGNED_INT8 = 1
    enumerator :: HIP_AD_FORMAT_UNSIGNED_INT16 = 2
    enumerator :: HIP_AD_FORMAT_UNSIGNED_INT32 = 3
    enumerator :: HIP_AD_FORMAT_SIGNED_INT8 = 8
    enumerator :: HIP_AD_FORMAT_SIGNED_INT16 = 9
    enumerator :: HIP_AD_FORMAT_SIGNED_INT32 = 10
    enumerator :: HIP_AD_FORMAT_HALF = 16
    enumerator :: HIP_AD_FORMAT_FLOAT = 32
  end enum

  enum, bind(c)
    enumerator :: hipResourceTypeArray = 0
    enumerator :: hipResourceTypeMipmappedArray = 1
    enumerator :: hipResourceTypeLinear = 2
    enumerator :: hipResourceTypePitch2D = 3
  end enum

  enum, bind(c)
    enumerator :: HIP_RESOURCE_TYPE_ARRAY = 0
    enumerator :: HIP_RESOURCE_TYPE_MIPMAPPED_ARRAY = 1
    enumerator :: HIP_RESOURCE_TYPE_LINEAR = 2
    enumerator :: HIP_RESOURCE_TYPE_PITCH2D = 3
  end enum

  enum, bind(c)
    enumerator :: HIP_TR_ADDRESS_MODE_WRAP = 0
    enumerator :: HIP_TR_ADDRESS_MODE_CLAMP = 1
    enumerator :: HIP_TR_ADDRESS_MODE_MIRROR = 2
    enumerator :: HIP_TR_ADDRESS_MODE_BORDER = 3
  end enum

  enum, bind(c)
    enumerator :: HIP_TR_FILTER_MODE_POINT = 0
    enumerator :: HIP_TR_FILTER_MODE_LINEAR = 1
  end enum

  enum, bind(c)
    enumerator :: hipResViewFormatNone = 0
    enumerator :: hipResViewFormatUnsignedChar1 = 1
    enumerator :: hipResViewFormatUnsignedChar2 = 2
    enumerator :: hipResViewFormatUnsignedChar4 = 3
    enumerator :: hipResViewFormatSignedChar1 = 4
    enumerator :: hipResViewFormatSignedChar2 = 5
    enumerator :: hipResViewFormatSignedChar4 = 6
    enumerator :: hipResViewFormatUnsignedShort1 = 7
    enumerator :: hipResViewFormatUnsignedShort2 = 8
    enumerator :: hipResViewFormatUnsignedShort4 = 9
    enumerator :: hipResViewFormatSignedShort1 = 10
    enumerator :: hipResViewFormatSignedShort2 = 11
    enumerator :: hipResViewFormatSignedShort4 = 12
    enumerator :: hipResViewFormatUnsignedInt1 = 13
    enumerator :: hipResViewFormatUnsignedInt2 = 14
    enumerator :: hipResViewFormatUnsignedInt4 = 15
    enumerator :: hipResViewFormatSignedInt1 = 16
    enumerator :: hipResViewFormatSignedInt2 = 17
    enumerator :: hipResViewFormatSignedInt4 = 18
    enumerator :: hipResViewFormatHalf1 = 19
    enumerator :: hipResViewFormatHalf2 = 20
    enumerator :: hipResViewFormatHalf4 = 21
    enumerator :: hipResViewFormatFloat1 = 22
    enumerator :: hipResViewFormatFloat2 = 23
    enumerator :: hipResViewFormatFloat4 = 24
    enumerator :: hipResViewFormatUnsignedBlockCompressed1 = 25
    enumerator :: hipResViewFormatUnsignedBlockCompressed2 = 26
    enumerator :: hipResViewFormatUnsignedBlockCompressed3 = 27
    enumerator :: hipResViewFormatUnsignedBlockCompressed4 = 28
    enumerator :: hipResViewFormatSignedBlockCompressed4 = 29
    enumerator :: hipResViewFormatUnsignedBlockCompressed5 = 30
    enumerator :: hipResViewFormatSignedBlockCompressed5 = 31
    enumerator :: hipResViewFormatUnsignedBlockCompressed6H = 32
    enumerator :: hipResViewFormatSignedBlockCompressed6H = 33
    enumerator :: hipResViewFormatUnsignedBlockCompressed7 = 34
  end enum

  enum, bind(c)
    enumerator :: HIP_RES_VIEW_FORMAT_NONE = 0
    enumerator :: HIP_RES_VIEW_FORMAT_UINT_1X8 = 1
    enumerator :: HIP_RES_VIEW_FORMAT_UINT_2X8 = 2
    enumerator :: HIP_RES_VIEW_FORMAT_UINT_4X8 = 3
    enumerator :: HIP_RES_VIEW_FORMAT_SINT_1X8 = 4
    enumerator :: HIP_RES_VIEW_FORMAT_SINT_2X8 = 5
    enumerator :: HIP_RES_VIEW_FORMAT_SINT_4X8 = 6
    enumerator :: HIP_RES_VIEW_FORMAT_UINT_1X16 = 7
    enumerator :: HIP_RES_VIEW_FORMAT_UINT_2X16 = 8
    enumerator :: HIP_RES_VIEW_FORMAT_UINT_4X16 = 9
    enumerator :: HIP_RES_VIEW_FORMAT_SINT_1X16 = 10
    enumerator :: HIP_RES_VIEW_FORMAT_SINT_2X16 = 11
    enumerator :: HIP_RES_VIEW_FORMAT_SINT_4X16 = 12
    enumerator :: HIP_RES_VIEW_FORMAT_UINT_1X32 = 13
    enumerator :: HIP_RES_VIEW_FORMAT_UINT_2X32 = 14
    enumerator :: HIP_RES_VIEW_FORMAT_UINT_4X32 = 15
    enumerator :: HIP_RES_VIEW_FORMAT_SINT_1X32 = 16
    enumerator :: HIP_RES_VIEW_FORMAT_SINT_2X32 = 17
    enumerator :: HIP_RES_VIEW_FORMAT_SINT_4X32 = 18
    enumerator :: HIP_RES_VIEW_FORMAT_FLOAT_1X16 = 19
    enumerator :: HIP_RES_VIEW_FORMAT_FLOAT_2X16 = 20
    enumerator :: HIP_RES_VIEW_FORMAT_FLOAT_4X16 = 21
    enumerator :: HIP_RES_VIEW_FORMAT_FLOAT_1X32 = 22
    enumerator :: HIP_RES_VIEW_FORMAT_FLOAT_2X32 = 23
    enumerator :: HIP_RES_VIEW_FORMAT_FLOAT_4X32 = 24
    enumerator :: HIP_RES_VIEW_FORMAT_UNSIGNED_BC1 = 25
    enumerator :: HIP_RES_VIEW_FORMAT_UNSIGNED_BC2 = 26
    enumerator :: HIP_RES_VIEW_FORMAT_UNSIGNED_BC3 = 27
    enumerator :: HIP_RES_VIEW_FORMAT_UNSIGNED_BC4 = 28
    enumerator :: HIP_RES_VIEW_FORMAT_SIGNED_BC4 = 29
    enumerator :: HIP_RES_VIEW_FORMAT_UNSIGNED_BC5 = 30
    enumerator :: HIP_RES_VIEW_FORMAT_SIGNED_BC5 = 31
    enumerator :: HIP_RES_VIEW_FORMAT_UNSIGNED_BC6H = 32
    enumerator :: HIP_RES_VIEW_FORMAT_SIGNED_BC6H = 33
    enumerator :: HIP_RES_VIEW_FORMAT_UNSIGNED_BC7 = 34
  end enum

  enum, bind(c)
    enumerator :: hipMemcpyHostToHost = 0
    enumerator :: hipMemcpyHostToDevice = 1
    enumerator :: hipMemcpyDeviceToHost = 2
    enumerator :: hipMemcpyDeviceToDevice = 3
    enumerator :: hipMemcpyDefault = 4
  end enum

  enum, bind(c)
    enumerator :: HIP_FUNC_ATTRIBUTE_MAX_THREADS_PER_BLOCK
    enumerator :: HIP_FUNC_ATTRIBUTE_SHARED_SIZE_BYTES
    enumerator :: HIP_FUNC_ATTRIBUTE_CONST_SIZE_BYTES
    enumerator :: HIP_FUNC_ATTRIBUTE_LOCAL_SIZE_BYTES
    enumerator :: HIP_FUNC_ATTRIBUTE_NUM_REGS
    enumerator :: HIP_FUNC_ATTRIBUTE_PTX_VERSION
    enumerator :: HIP_FUNC_ATTRIBUTE_BINARY_VERSION
    enumerator :: HIP_FUNC_ATTRIBUTE_CACHE_MODE_CA
    enumerator :: HIP_FUNC_ATTRIBUTE_MAX_DYNAMIC_SHARED_SIZE_BYTES
    enumerator :: HIP_FUNC_ATTRIBUTE_PREFERRED_SHARED_MEMORY_CARVEOUT
    enumerator :: HIP_FUNC_ATTRIBUTE_MAX
  end enum

  enum, bind(c)
    enumerator :: HIP_POINTER_ATTRIBUTE_CONTEXT = 1
    enumerator :: HIP_POINTER_ATTRIBUTE_MEMORY_TYPE
    enumerator :: HIP_POINTER_ATTRIBUTE_DEVICE_POINTER
    enumerator :: HIP_POINTER_ATTRIBUTE_HOST_POINTER
    enumerator :: HIP_POINTER_ATTRIBUTE_P2P_TOKENS
    enumerator :: HIP_POINTER_ATTRIBUTE_SYNC_MEMOPS
    enumerator :: HIP_POINTER_ATTRIBUTE_BUFFER_ID
    enumerator :: HIP_POINTER_ATTRIBUTE_IS_MANAGED
    enumerator :: HIP_POINTER_ATTRIBUTE_DEVICE_ORDINAL
    enumerator :: HIP_POINTER_ATTRIBUTE_IS_LEGACY_HIP_IPC_CAPABLE
    enumerator :: HIP_POINTER_ATTRIBUTE_RANGE_START_ADDR
    enumerator :: HIP_POINTER_ATTRIBUTE_RANGE_SIZE
    enumerator :: HIP_POINTER_ATTRIBUTE_MAPPED
    enumerator :: HIP_POINTER_ATTRIBUTE_ALLOWED_HANDLE_TYPES
    enumerator :: HIP_POINTER_ATTRIBUTE_IS_GPU_DIRECT_RDMA_CAPABLE
    enumerator :: HIP_POINTER_ATTRIBUTE_ACCESS_FLAGS
    enumerator :: HIP_POINTER_ATTRIBUTE_MEMPOOL_HANDLE
  end enum

  enum, bind(c)
    enumerator :: hipAddressModeWrap = 0
    enumerator :: hipAddressModeClamp = 1
    enumerator :: hipAddressModeMirror = 2
    enumerator :: hipAddressModeBorder = 3
  end enum

  enum, bind(c)
    enumerator :: hipFilterModePoint = 0
    enumerator :: hipFilterModeLinear = 1
  end enum

  enum, bind(c)
    enumerator :: hipReadModeElementType = 0
    enumerator :: hipReadModeNormalizedFloat = 1
  end enum

  enum, bind(c)
    enumerator :: HIP_R_32F = 0
    enumerator :: HIP_R_64F = 1
    enumerator :: HIP_R_16F = 2
    enumerator :: HIP_R_8I = 3
    enumerator :: HIP_C_32F = 4
    enumerator :: HIP_C_64F = 5
    enumerator :: HIP_C_16F = 6
    enumerator :: HIP_C_8I = 7
    enumerator :: HIP_R_8U = 8
    enumerator :: HIP_C_8U = 9
    enumerator :: HIP_R_32I = 10
    enumerator :: HIP_C_32I = 11
    enumerator :: HIP_R_32U = 12
    enumerator :: HIP_C_32U = 13
    enumerator :: HIP_R_16BF = 14
    enumerator :: HIP_C_16BF = 15
    enumerator :: HIP_R_4I = 16
    enumerator :: HIP_C_4I = 17
    enumerator :: HIP_R_4U = 18
    enumerator :: HIP_C_4U = 19
    enumerator :: HIP_R_16I = 20
    enumerator :: HIP_C_16I = 21
    enumerator :: HIP_R_16U = 22
    enumerator :: HIP_C_16U = 23
    enumerator :: HIP_R_64I = 24
    enumerator :: HIP_C_64I = 25
    enumerator :: HIP_R_64U = 26
    enumerator :: HIP_C_64U = 27
    enumerator :: HIP_R_8F_E4M3_FNUZ = 1000
    enumerator :: HIP_R_8F_E5M2_FNUZ = 1001
  end enum

  enum, bind(c)
    enumerator :: HIP_LIBRARY_MAJOR_VERSION
    enumerator :: HIP_LIBRARY_MINOR_VERSION
    enumerator :: HIP_LIBRARY_PATCH_LEVEL
  end enum

 

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_enums

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc.
!
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
!
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program rocblas_saxpy_test

    use iso_c_binding
    use hipfort
    use hipfort_check
    use hipfort_rocblas

    implicit none

    integer, parameter :: N = 12000
    integer, parameter :: bytes_per_element = 4 ! single precision
    integer(c_size_t), parameter :: Nbytes = N * bytes_per_element

    real(c_float), target :: alpha = 12.5

    type(c_ptr) :: dx = c_null_ptr
    type(c_ptr) :: dy = c_null_ptr

    real,allocatable,target,dimension(:) :: hx
    real,allocatable,target,dimension(:) :: hy
    real,allocatable,target,dimension(:) :: hz

    real :: error
    real :: result
    real, parameter :: error_max = 10 * epsilon(error_max)

    type(c_ptr) :: rocblas_handle

    integer :: i

    write(*,"(a)",advance="no") "-- Running test 'saxpy' (Fortran 2003 interfaces) - "

    ! Create rocblas handle
    call rocblasCheck(rocblas_create_handle(rocblas_handle))

    ! Allocate host-side memory
    allocate(hx(N))
    allocate(hy(N))
    allocate(hz(N))

    ! Allocate device-side memory
    call hipCheck(hipMalloc(dx, Nbytes))
    call hipCheck(hipMalloc(dy, Nbytes))

    ! Initialize host memory
    do i = 1, n
        hx(i) = i
        hy(i) = n - i
        hz(i) = n - i
    end do
    
    ! Transfer data from host to deivce memory
    call hipCheck(hipMemcpy(dx, c_loc(hx(1)), Nbytes, hipMemcpyHostToDevice))
    call hipCheck(hipmemcpy(dy, c_loc(hy(1)), Nbytes, hipMemcpyHostToDevice))

    ! Call rocblas function
    call rocblasCheck(rocblas_set_pointer_mode(rocblas_handle, 0))
    call rocblasCheck(rocblas_saxpy(rocblas_handle, N, alpha, dx, 1, dy, 1))
    call hipCheck(hipDeviceSynchronize())

    ! Transfer data back to host memory
    call hipcheck(hipMemcpy(c_loc(hy(1)), dy, Nbytes, hipMemcpyDeviceToHost))

    ! Verification
    do i = 1, N
        result = alpha * hx(i) + hz(i)
        error = abs(hy(i) - result)
        if(error .gt. error_max) then
            write(*,*) "FAILED! Error bigger than max! Error = ", error, " hy(", i, ") = ", hy(i)
            call exit
        end if
    end do

    ! Cleanup
    call hipCheck(hipFree(dx))
    call hipCheck(hipFree(dy))
    deallocate(hx, hy, hz)
    call rocblasCheck(rocblas_destroy_handle(rocblas_handle))

    write(*,*) "PASSED!"

end program rocblas_saxpy_test

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_hiprand
  use hipfort_hiprand_enums
  implicit none

 
  !>  \brief Creates a new random number generator.
  !> 
  !>  Creates a new random number generator of type \p rng_type,
  !>  and returns it in \p generator. That generator will use
  !>  GPU to create random numbers.
  !> 
  !>  Values for \p rng_type are:
  !>  - HIPRAND_RNG_PSEUDO_DEFAULT
  !>  - HIPRAND_RNG_PSEUDO_XORWOW
  !>  - HIPRAND_RNG_PSEUDO_MRG32K3A
  !>  - HIPRAND_RNG_PSEUDO_MTGP32
  !>  - HIPRAND_RNG_PSEUDO_MT19937
  !>  - HIPRAND_RNG_PSEUDO_PHILOX4_32_10
  !>  - HIPRAND_RNG_QUASI_DEFAULT
  !>  - HIPRAND_RNG_QUASI_SOBOL32
  !>  - HIPRAND_RNG_QUASI_SCRAMBLED_SOBOL32
  !>  - HIPRAND_RNG_QUASI_SOBOL64
  !>  - HIPRAND_RNG_QUASI_SCRAMBLED_SOBOL64
  !> 
  !>  \param generator - Pointer to generator
  !>  \param rng_type - Type of random number generator to create
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_ALLOCATION_FAILED, if memory allocation failed \n
  !>  - HIPRAND_STATUS_INITIALIZATION_FAILED if there was a problem setting up the GPU \n
  !>  - HIPRAND_STATUS_VERSION_MISMATCH if the header file version does not match the
  !>    dynamically linked library version \n
  !>  - HIPRAND_STATUS_TYPE_ERROR if the value for \p rng_type is invalid \n
  !>  - HIPRAND_STATUS_NOT_IMPLEMENTED if generator of type \p rng_type is not implemented yet \n
  !>  - HIPRAND_STATUS_SUCCESS if generator was created successfully \n
  !>
  interface hiprandCreateGenerator
#ifdef USE_CUDA_NAMES
    function hiprandCreateGenerator_(generator,rng_type) bind(c, name="curandCreateGenerator")
#else
    function hiprandCreateGenerator_(generator,rng_type) bind(c, name="hiprandCreateGenerator")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandCreateGenerator_
      type(c_ptr) :: generator
      integer(kind(HIPRAND_RNG_TEST)),value :: rng_type
    end function

  end interface
  !>  \brief Creates a new random number generator on host.
  !> 
  !>  Creates a new host random number generator of type \p rng_type
  !>  and returns it in \p generator. Created generator will use
  !>  host CPU to generate random numbers.
  !> 
  !>  Values for \p rng_type are:
  !>  - HIPRAND_RNG_PSEUDO_DEFAULT
  !>  - HIPRAND_RNG_PSEUDO_XORWOW
  !>  - HIPRAND_RNG_PSEUDO_MRG32K3A
  !>  - HIPRAND_RNG_PSEUDO_MTGP32
  !>  - HIPRAND_RNG_PSEUDO_MT19937
  !>  - HIPRAND_RNG_PSEUDO_PHILOX4_32_10
  !>  - HIPRAND_RNG_QUASI_DEFAULT
  !>  - HIPRAND_RNG_QUASI_SOBOL32
  !>  - HIPRAND_RNG_QUASI_SCRAMBLED_SOBOL32
  !>  - HIPRAND_RNG_QUASI_SOBOL64
  !>  - HIPRAND_RNG_QUASI_SCRAMBLED_SOBOL64
  !> 
  !>  \param generator - Pointer to generator
  !>  \param rng_type - Type of random number generator to create
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_ALLOCATION_FAILED, if memory allocation failed \n
  !>  - HIPRAND_STATUS_VERSION_MISMATCH if the header file version does not match the
  !>    dynamically linked library version \n
  !>  - HIPRAND_STATUS_TYPE_ERROR if the value for \p rng_type is invalid \n
  !>  - HIPRAND_STATUS_NOT_IMPLEMENTED if host generator of type \p rng_type is not implemented yet \n
  !>  - HIPRAND_STATUS_SUCCESS if generator was created successfully \n
  interface hiprandCreateGeneratorHost
#ifdef USE_CUDA_NAMES
    function hiprandCreateGeneratorHost_(generator,rng_type) bind(c, name="curandCreateGeneratorHost")
#else
    function hiprandCreateGeneratorHost_(generator,rng_type) bind(c, name="hiprandCreateGeneratorHost")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandCreateGeneratorHost_
      type(c_ptr) :: generator
      integer(kind(HIPRAND_RNG_TEST)),value :: rng_type
    end function

  end interface
  !>  \brief Destroys random number generator.
  !> 
  !>  Destroys random number generator and frees related memory.
  !> 
  !>  \param generator - Generator to be destroyed
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_SUCCESS if generator was destroyed successfully \n
  interface hiprandDestroyGenerator
#ifdef USE_CUDA_NAMES
    function hiprandDestroyGenerator_(generator) bind(c, name="curandDestroyGenerator")
#else
    function hiprandDestroyGenerator_(generator) bind(c, name="hiprandDestroyGenerator")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandDestroyGenerator_
      type(c_ptr),value :: generator
    end function

  end interface
  !>  \brief Generates uniformly distributed 32-bit unsigned integers.
  !> 
  !>  Generates \p n uniformly distributed 32-bit unsigned integers and
  !>  saves them to \p output_data.
  !> 
  !>  Generated numbers are between \p 0 and \p 2^32, including \p 0 and
  !>  excluding \p 2^32.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of 32-bit unsigned integers to generate
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if generator failed to launch kernel \n
  !>  - HIPRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface hiprandGenerate
#ifdef USE_CUDA_NAMES
    function hiprandGenerate_(generator,output_data,n) bind(c, name="curandGenerate")
#else
    function hiprandGenerate_(generator,output_data,n) bind(c, name="hiprandGenerate")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGenerate_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
    end function

  end interface
  !>  \brief Generates uniformly distributed 8-bit unsigned integers.
  !> 
  !>  Generates \p n uniformly distributed 8-bit unsigned integers and
  !>  saves them to \p output_data.
  !> 
  !>  Generated numbers are between \p 0 and \p 2^8, including \p 0 and
  !>  excluding \p 2^8.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of 8-bit unsigned integers to generate
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if generator failed to launch kernel \n
  !>  - HIPRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface hiprandGenerateChar
#ifdef USE_CUDA_NAMES
    function hiprandGenerateChar_(generator,output_data,n) bind(c, name="curandGenerateChar")
#else
    function hiprandGenerateChar_(generator,output_data,n) bind(c, name="hiprandGenerateChar")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGenerateChar_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
    end function

  end interface
  !>  \brief Generates uniformly distributed 16-bit unsigned integers.
  !> 
  !>  Generates \p n uniformly distributed 16-bit unsigned integers and
  !>  saves them to \p output_data.
  !> 
  !>  Generated numbers are between \p 0 and \p 2^16, including \p 0 and
  !>  excluding \p 2^16.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of 16-bit unsigned integers to generate
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if generator failed to launch kernel \n
  !>  - HIPRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface hiprandGenerateShort
#ifdef USE_CUDA_NAMES
    function hiprandGenerateShort_(generator,output_data,n) bind(c, name="curandGenerateShort")
#else
    function hiprandGenerateShort_(generator,output_data,n) bind(c, name="hiprandGenerateShort")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGenerateShort_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
    end function

  end interface
  !>  \brief Generates uniformly distributed floats.
  !> 
  !>  Generates \p n uniformly distributed 32-bit floating-point values
  !>  and saves them to \p output_data.
  !> 
  !>  Generated numbers are between \p 0.0f and \p 1.0f, excluding \p 0.0f and
  !>  including \p 1.0f.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of floats to generate
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if generator failed to launch kernel \n
  !>  - HIPRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - HIPRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface hiprandGenerateUniform
#ifdef USE_CUDA_NAMES
    function hiprandGenerateUniform_(generator,output_data,n) bind(c, name="curandGenerateUniform")
#else
    function hiprandGenerateUniform_(generator,output_data,n) bind(c, name="hiprandGenerateUniform")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGenerateUniform_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
    end function

  end interface
  !>  \brief Generates uniformly distributed double-precision floating-point values.
  !> 
  !>  Generates \p n uniformly distributed 64-bit double-precision floating-point
  !>  values and saves them to \p output_data.
  !> 
  !>  Generated numbers are between \p 0.0 and \p 1.0, excluding \p 0.0 and
  !>  including \p 1.0.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of floats to generate
  !> 
  !>  Note: When \p generator is of type: \p HIPRAND_RNG_PSEUDO_MRG32K3A,
  !>  \p HIPRAND_RNG_PSEUDO_MTGP32, or \p HIPRAND_RNG_QUASI_SOBOL32,
  !>  then the returned \p double values are generated from only 32 random bits
  !>  each (one <tt>unsigned int</tt> value per one generated \p double).
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if generator failed to launch kernel \n
  !>  - HIPRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - HIPRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface hiprandGenerateUniformDouble
#ifdef USE_CUDA_NAMES
    function hiprandGenerateUniformDouble_(generator,output_data,n) bind(c, name="curandGenerateUniformDouble")
#else
    function hiprandGenerateUniformDouble_(generator,output_data,n) bind(c, name="hiprandGenerateUniformDouble")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGenerateUniformDouble_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
    end function

  end interface
  !>  \brief Generates normally distributed floats.
  !> 
  !>  Generates \p n normally distributed 32-bit floating-point
  !>  values and saves them to \p output_data.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of floats to generate
  !>  \param mean - Mean value of normal distribution
  !>  \param stddev - Standard deviation value of normal distribution
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if generator failed to launch kernel \n
  !>  - HIPRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not even, \p output_data is not
  !>  aligned to \p sizeof(float2) bytes, or \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - HIPRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface hiprandGenerateNormal
#ifdef USE_CUDA_NAMES
    function hiprandGenerateNormal_(generator,output_data,n,mean,stddev) bind(c, name="curandGenerateNormal")
#else
    function hiprandGenerateNormal_(generator,output_data,n,mean,stddev) bind(c, name="hiprandGenerateNormal")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGenerateNormal_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
      real(c_float),value :: mean
      real(c_float),value :: stddev
    end function

  end interface
  !>  \brief Generates normally distributed doubles.
  !> 
  !>  Generates \p n normally distributed 64-bit double-precision floating-point
  !>  numbers and saves them to \p output_data.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of doubles to generate
  !>  \param mean - Mean value of normal distribution
  !>  \param stddev - Standard deviation value of normal distribution
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if generator failed to launch kernel \n
  !>  - HIPRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not even, \p output_data is not
  !>  aligned to \p sizeof(double2) bytes, or \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - HIPRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface hiprandGenerateNormalDouble
#ifdef USE_CUDA_NAMES
    function hiprandGenerateNormalDouble_(generator,output_data,n,mean,stddev) bind(c, name="curandGenerateNormalDouble")
#else
    function hiprandGenerateNormalDouble_(generator,output_data,n,mean,stddev) bind(c, name="hiprandGenerateNormalDouble")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGenerateNormalDouble_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
      real(c_double),value :: mean
      real(c_double),value :: stddev
    end function

  end interface
  !>  \brief Generates log-normally distributed floats.
  !> 
  !>  Generates \p n log-normally distributed 32-bit floating-point values
  !>  and saves them to \p output_data.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of floats to generate
  !>  \param mean - Mean value of log normal distribution
  !>  \param stddev - Standard deviation value of log normal distribution
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if generator failed to launch kernel \n
  !>  - HIPRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not even, \p output_data is not
  !>  aligned to \p sizeof(float2) bytes, or \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - HIPRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface hiprandGenerateLogNormal
#ifdef USE_CUDA_NAMES
    function hiprandGenerateLogNormal_(generator,output_data,n,mean,stddev) bind(c, name="curandGenerateLogNormal")
#else
    function hiprandGenerateLogNormal_(generator,output_data,n,mean,stddev) bind(c, name="hiprandGenerateLogNormal")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGenerateLogNormal_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
      real(c_float),value :: mean
      real(c_float),value :: stddev
    end function

  end interface
  !>  \brief Generates log-normally distributed doubles.
  !> 
  !>  Generates \p n log-normally distributed 64-bit double-precision floating-point
  !>  values and saves them to \p output_data.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of doubles to generate
  !>  \param mean - Mean value of log normal distribution
  !>  \param stddev - Standard deviation value of log normal distribution
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if generator failed to launch kernel \n
  !>  - HIPRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not even, \p output_data is not
  !>  aligned to \p sizeof(double2) bytes, or \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - HIPRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface hiprandGenerateLogNormalDouble
#ifdef USE_CUDA_NAMES
    function hiprandGenerateLogNormalDouble_(generator,output_data,n,mean,stddev) bind(c, name="curandGenerateLogNormalDouble")
#else
    function hiprandGenerateLogNormalDouble_(generator,output_data,n,mean,stddev) bind(c, name="hiprandGenerateLogNormalDouble")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGenerateLogNormalDouble_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
      real(c_double),value :: mean
      real(c_double),value :: stddev
    end function

  end interface
  !>  \brief Generates Poisson-distributed 32-bit unsigned integers.
  !> 
  !>  Generates \p n Poisson-distributed 32-bit unsigned integers and
  !>  saves them to \p output_data.
  !> 
  !>  \param generator - Generator to use
  !>  \param output_data - Pointer to memory to store generated numbers
  !>  \param n - Number of 32-bit unsigned integers to generate
  !>  \param lambda - lambda for the Poisson distribution
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if generator failed to launch kernel \n
  !>  - HIPRAND_STATUS_OUT_OF_RANGE if lambda is non-positive \n
  !>  - HIPRAND_STATUS_LENGTH_NOT_MULTIPLE if \p n is not a multiple of the dimension
  !>  of used quasi-random generator \n
  !>  - HIPRAND_STATUS_SUCCESS if random numbers were successfully generated \n
  interface hiprandGeneratePoisson
#ifdef USE_CUDA_NAMES
    function hiprandGeneratePoisson_(generator,output_data,n,lambda) bind(c, name="curandGeneratePoisson")
#else
    function hiprandGeneratePoisson_(generator,output_data,n,lambda) bind(c, name="hiprandGeneratePoisson")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGeneratePoisson_
      type(c_ptr),value :: generator
      type(c_ptr),value :: output_data
      integer(c_size_t),value :: n
      real(c_double),value :: lambda
    end function

  end interface
  !>  \brief Initializes the generator's state on GPU or host.
  !> 
  !>  Initializes the generator's state on GPU or host.
  !> 
  !>  If hiprandGenerateSeeds() was not called for a generator, it will be
  !>  automatically called by functions which generates random numbers like
  !>  hiprandGenerate(), hiprandGenerateUniform(), hiprandGenerateNormal() etc.
  !> 
  !>  \param generator - Generator to initialize
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was never created \n
  !>  - HIPRAND_STATUS_PREEXISTING_FAILURE if there was an existing error from
  !>    a previous kernel launch \n
  !>  - HIPRAND_STATUS_LAUNCH_FAILURE if the kernel launch failed for any reason \n
  !>  - HIPRAND_STATUS_SUCCESS if the seeds were generated successfully \n
  interface hiprandGenerateSeeds
#ifdef USE_CUDA_NAMES
    function hiprandGenerateSeeds_(generator) bind(c, name="curandGenerateSeeds")
#else
    function hiprandGenerateSeeds_(generator) bind(c, name="hiprandGenerateSeeds")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGenerateSeeds_
      type(c_ptr),value :: generator
    end function

  end interface
  !>  \brief Sets the current stream for kernel launches.
  !> 
  !>  Sets the current stream for all kernel launches of the generator.
  !>  All functions will use this stream.
  !> 
  !>  \param generator - Generator to modify
  !>  \param stream - Stream to use or NULL for default stream
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_SUCCESS if stream was set successfully \n
  interface hiprandSetStream
#ifdef USE_CUDA_NAMES
    function hiprandSetStream_(generator,stream) bind(c, name="curandSetStream")
#else
    function hiprandSetStream_(generator,stream) bind(c, name="hiprandSetStream")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandSetStream_
      type(c_ptr),value :: generator
      type(c_ptr),value :: stream
    end function

  end interface
  !>  \brief Sets the seed of a pseudo-random number generator.
  !> 
  !>  Sets the seed of the pseudo-random number generator.
  !> 
  !>  - This operation resets the generator's internal state.
  !>  - This operation does not change the generator's offset.
  !> 
  !>  \param generator - Pseudo-random number generator
  !>  \param seed - New seed value
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_TYPE_ERROR if the generator is a quasi random number generator \n
  !>  - HIPRAND_STATUS_SUCCESS if seed was set successfully \n
  interface hiprandSetPseudoRandomGeneratorSeed
#ifdef USE_CUDA_NAMES
    function hiprandSetPseudoRandomGeneratorSeed_(generator,seed) bind(c, name="curandSetPseudoRandomGeneratorSeed")
#else
    function hiprandSetPseudoRandomGeneratorSeed_(generator,seed) bind(c, name="hiprandSetPseudoRandomGeneratorSeed")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandSetPseudoRandomGeneratorSeed_
      type(c_ptr),value :: generator
      integer(c_long_long),value :: seed
    end function

  end interface
  !>  \brief Sets the offset of a random number generator.
  !> 
  !>  Sets the absolute offset of the random number generator.
  !> 
  !>  - This operation resets the generator's internal state.
  !>  - This operation does not change the generator's seed.
  !> 
  !>  Absolute offset cannot be set if generator's type is
  !>  HIPRAND_RNG_PSEUDO_MTGP32 or HIPRAND_RNG_PSEUDO_MT19937.
  !> 
  !>  \param generator - Random number generator
  !>  \param offset - New absolute offset
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_INITIALIZED if the generator was not initialized \n
  !>  - HIPRAND_STATUS_SUCCESS if offset was successfully set \n
  !>  - HIPRAND_STATUS_TYPE_ERROR if generator's type is HIPRAND_RNG_PSEUDO_MTGP32
  !>  or HIPRAND_RNG_PSEUDO_MT19937 \n
  interface hiprandSetGeneratorOffset
#ifdef USE_CUDA_NAMES
    function hiprandSetGeneratorOffset_(generator,offset) bind(c, name="curandSetGeneratorOffset")
#else
    function hiprandSetGeneratorOffset_(generator,offset) bind(c, name="hiprandSetGeneratorOffset")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandSetGeneratorOffset_
      type(c_ptr),value :: generator
      integer(c_long_long),value :: offset
    end function

  end interface
  !>  \brief Set the number of dimensions of a quasi-random number generator.
  !> 
  !>  Set the number of dimensions of a quasi-random number generator.
  !>  Supported values of \p dimensions are 1 to 20000.
  !> 
  !>  - This operation resets the generator's internal state.
  !>  - This operation does not change the generator's offset.
  !> 
  !>  \param generator - Quasi-random number generator
  !>  \param dimensions - Number of dimensions
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_NOT_CREATED if the generator wasn't created \n
  !>  - HIPRAND_STATUS_TYPE_ERROR if the generator is not a quasi-random number generator \n
  !>  - HIPRAND_STATUS_OUT_OF_RANGE if \p dimensions is out of range \n
  !>  - HIPRAND_STATUS_SUCCESS if the number of dimensions was set successfully \n
  interface hiprandSetQuasiRandomGeneratorDimensions
#ifdef USE_CUDA_NAMES
    function hiprandSetQuasiRandomGeneratorDimensions_(generator,dimensions) bind(c, name="curandSetQuasiRandomGeneratorDimensions")
#else
    function hiprandSetQuasiRandomGeneratorDimensions_(generator,dimensions) bind(c, name="hiprandSetQuasiRandomGeneratorDimensions")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandSetQuasiRandomGeneratorDimensions_
      type(c_ptr),value :: generator
      integer(c_int),value :: dimensions
    end function

  end interface
  !>  \brief Returns the version number of the cuRAND or rocRAND library.
  !> 
  !>  Returns in \p version the version number of the underlying cuRAND or
  !>  rocRAND library.
  !> 
  !>  \param version - Version of the library
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_OUT_OF_RANGE if \p version is NULL \n
  !>  - HIPRAND_STATUS_SUCCESS if the version number was successfully returned \n
  interface hiprandGetVersion
#ifdef USE_CUDA_NAMES
    function hiprandGetVersion_(version) bind(c, name="curandGetVersion")
#else
    function hiprandGetVersion_(version) bind(c, name="hiprandGetVersion")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandGetVersion_
      type(c_ptr),value :: version
    end function

  end interface
  !>  \brief Construct the histogram for a Poisson distribution.
  !> 
  !>  Construct the histogram for the Poisson distribution with lambda \p lambda.
  !> 
  !>  \param lambda - lambda for the Poisson distribution
  !>  \param discrete_distribution - pointer to the histogram in device memory
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_ALLOCATION_FAILED if memory could not be allocated \n
  !>  - HIPRAND_STATUS_OUT_OF_RANGE if \p discrete_distribution pointer was null \n
  !>  - HIPRAND_STATUS_OUT_OF_RANGE if lambda is non-positive \n
  !>  - HIPRAND_STATUS_SUCCESS if the histogram was ructed successfully \n
  interface hiprandCreatePoissonDistribution
#ifdef USE_CUDA_NAMES
    function hiprandCreatePoissonDistribution_(lambda,discrete_distribution) bind(c, name="curandCreatePoissonDistribution")
#else
    function hiprandCreatePoissonDistribution_(lambda,discrete_distribution) bind(c, name="hiprandCreatePoissonDistribution")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandCreatePoissonDistribution_
      real(c_double),value :: lambda
      type(c_ptr) :: discrete_distribution
    end function

  end interface
  !>  \brief Destroy the histogram array for a discrete distribution.
  !> 
  !>  Destroy the histogram array for a discrete distribution created by
  !>  hiprandCreatePoissonDistribution.
  !> 
  !>  \param discrete_distribution - pointer to the histogram in device memory
  !> 
  !>  \return
  !>  - HIPRAND_STATUS_OUT_OF_RANGE if \p discrete_distribution was null \n
  !>  - HIPRAND_STATUS_SUCCESS if the histogram was destroyed successfully \n
  interface hiprandDestroyDistribution
#ifdef USE_CUDA_NAMES
    function hiprandDestroyDistribution_(discrete_distribution) bind(c, name="curandDestroyDistribution")
#else
    function hiprandDestroyDistribution_(discrete_distribution) bind(c, name="hiprandDestroyDistribution")
#endif
      use iso_c_binding
      use hipfort_hiprand_enums
      implicit none
      integer(kind(HIPRAND_STATUS_SUCCESS)) :: hiprandDestroyDistribution_
      type(c_ptr),value :: discrete_distribution
    end function

  end interface

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_hiprand

program hip_sswap
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none
  
  integer :: n = 6
  integer :: i
  real(kind=4), allocatable, target, dimension(:) :: x, y, x_exact, y_exact
  real(kind=4), pointer, dimension(:) :: dx, dy
  type(c_ptr) :: handle = c_null_ptr

  real :: error
  real, parameter :: error_max = 10*epsilon(error)
  
  allocate(x(n))
  allocate(y(n))
  allocate(x_exact(n))
  allocate(y_exact(n))
  
  do i = 1,n
    x(i) = i
    x_exact(i) = x(i)
    y(i) = 2 * i
    y_exact(i) = y(i)
  end do
  
  write(*,"(a)",advance="no") "-- Running test 'SSWAP' (Fortran 2008 interfaces) - "
  
  call hipblasCheck(hipblasCreate(handle))
  
  call hipCheck(hipMalloc(dx,shape(x)))  
  call hipCheck(hipMalloc(dy,shape(y)))
  
  call hipCheck(hipMemcpy(dx, x, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dy, y, hipMemcpyHostToDevice))
  
  call hipblasCheck(hipblasSswap(handle,n,dx,1,dy,1))
  
  call hipCheck(hipMemcpy(x, dx, hipMemcpyDeviceToHost))
  call hipCheck(hipMemcpy(y, dy, hipMemcpyDeviceToHost))
  
  do i = 1,n
    error = MAX(abs((y_exact(i) - x(i))/y_exact(i)), abs((x_exact(i) - y(i))/x_exact(i)))
      if( error > error_max )then
        write(*,*) "FAILED! Error bigger than max! Error = ", error
        call exit(1)
      end if
  end do
  
  call hipblasCheck(hipblasDestroy(handle))
  
  call hipCheck(hipFree(dx))
  call hipCheck(hipFree(dy))
  
  deallocate(x,y)
  
  write(*,*) "PASSED!"
  
end program hip_sswap

module rocfft_enums
  implicit none

  ! rocfft_status
  enum, bind(c)
     enumerator :: rocfft_status_success
     enumerator :: rocfft_status_failure
     enumerator :: rocfft_status_invalid_arg_value
     enumerator :: rocfft_status_invalid_dimensions
     enumerator :: rocfft_status_invalid_array_type
     enumerator :: rocfft_status_invalid_strides
     enumerator :: rocfft_status_invalid_distance
     enumerator :: rocfft_status_invalid_offset
  end enum

  !rocfft_transform_type
  enum, bind(c)
     enumerator :: rocfft_transform_type_complex_forward
     enumerator :: rocfft_transform_type_complex_inverse
     enumerator :: rocfft_transform_type_real_forward
     enumerator :: rocfft_transform_type_real_inverse
  end enum

  !rocfft_precision
  enum, bind(c)
     enumerator :: rocfft_precision_single
     enumerator :: rocfft_precision_double
  end enum

  !rocfft_result_placement
  enum, bind(c)
     enumerator :: rocfft_placement_inplace
     enumerator :: rocfft_placement_notinplace
  end enum

end module rocfft_enums

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_hipfft_enums
  implicit none

  enum, bind(c)
    enumerator :: HIPFFT_SUCCESS = 0
    enumerator :: HIPFFT_INVALID_PLAN = 1
    enumerator :: HIPFFT_ALLOC_FAILED = 2
    enumerator :: HIPFFT_INVALID_TYPE = 3
    enumerator :: HIPFFT_INVALID_VALUE = 4
    enumerator :: HIPFFT_INTERNAL_ERROR = 5
    enumerator :: HIPFFT_EXEC_FAILED = 6
    enumerator :: HIPFFT_SETUP_FAILED = 7
    enumerator :: HIPFFT_INVALID_SIZE = 8
    enumerator :: HIPFFT_UNALIGNED_DATA = 9
    enumerator :: HIPFFT_INCOMPLETE_PARAMETER_LIST = 10
    enumerator :: HIPFFT_INVALID_DEVICE = 11
    enumerator :: HIPFFT_PARSE_ERROR = 12
    enumerator :: HIPFFT_NO_WORKSPACE = 13
    enumerator :: HIPFFT_NOT_IMPLEMENTED = 14
    enumerator :: HIPFFT_NOT_SUPPORTED = 16
  end enum

  enum, bind(c)
    enumerator :: HIPFFT_R2C = 42
    enumerator :: HIPFFT_C2R = 44
    enumerator :: HIPFFT_C2C = 41
    enumerator :: HIPFFT_D2Z = 106
    enumerator :: HIPFFT_Z2D = 108
    enumerator :: HIPFFT_Z2Z = 105
  end enum

  enum, bind(c)
    enumerator :: HIPFFT_MAJOR_VERSION
    enumerator :: HIPFFT_MINOR_VERSION
    enumerator :: HIPFFT_PATCH_LEVEL
  end enum

 

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_hipfft_enums

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module hipfort_rocblas_auxiliary

  interface rocblas_set_vector
    function rocblas_set_vector_(n,elem_size,x,incx,y,incy) bind(c, name="rocblas_set_vector") result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),value :: elem_size
      type(c_ptr),value :: x
      integer(c_int),value :: incx
      type(c_ptr),value :: y
      integer(c_int),value :: incy
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure rocblas_set_vector_l_rank_0,rocblas_set_vector_l_full_rank,&
      rocblas_set_vector_i4_rank_0,rocblas_set_vector_i4_full_rank,&
      rocblas_set_vector_i8_rank_0,rocblas_set_vector_i8_full_rank,&
      rocblas_set_vector_r4_rank_0,rocblas_set_vector_r4_full_rank,&
      rocblas_set_vector_r8_rank_0,rocblas_set_vector_r8_full_rank,&
      rocblas_set_vector_c4_rank_0,rocblas_set_vector_c4_full_rank,&
      rocblas_set_vector_c8_rank_0,rocblas_set_vector_c8_full_rank 
#endif
  end interface

  interface rocblas_get_vector
    function rocblas_get_vector_(n,elem_size,x,incx,y,incy) bind(c, name="rocblas_get_vector") result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),value :: elem_size
      type(c_ptr),value :: x
      integer(c_int),value :: incx
      type(c_ptr),value :: y
      integer(c_int),value :: incy
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure rocblas_get_vector_l_rank_0,rocblas_get_vector_l_full_rank,&
      rocblas_get_vector_i4_rank_0,rocblas_get_vector_i4_full_rank,&
      rocblas_get_vector_i8_rank_0,rocblas_get_vector_i8_full_rank,&
      rocblas_get_vector_r4_rank_0,rocblas_get_vector_r4_full_rank,&
      rocblas_get_vector_r8_rank_0,rocblas_get_vector_r8_full_rank,&
      rocblas_get_vector_c4_rank_0,rocblas_get_vector_c4_full_rank,&
      rocblas_get_vector_c8_rank_0,rocblas_get_vector_c8_full_rank 
#endif
  end interface

  interface rocblas_set_matrix
    function rocblas_set_matrix_(rows,cols,elem_size,A,lda,B,ldb) bind(c, name="rocblas_set_matrix") result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),value :: elem_size
      type(c_ptr),value :: A
      integer(c_int),value :: lda
      type(c_ptr),value :: B
      integer(c_int),value :: ldb
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure rocblas_set_matrix_l_full_rank,rocblas_set_matrix_l_rank_0,rocblas_set_matrix_l_rank_1,&
      rocblas_set_matrix_i4_full_rank,rocblas_set_matrix_i4_rank_0,rocblas_set_matrix_i4_rank_1,&
      rocblas_set_matrix_i8_full_rank,rocblas_set_matrix_i8_rank_0,rocblas_set_matrix_i8_rank_1,&
      rocblas_set_matrix_r4_full_rank,rocblas_set_matrix_r4_rank_0,rocblas_set_matrix_r4_rank_1,&
      rocblas_set_matrix_r8_full_rank,rocblas_set_matrix_r8_rank_0,rocblas_set_matrix_r8_rank_1,&
      rocblas_set_matrix_c4_full_rank,rocblas_set_matrix_c4_rank_0,rocblas_set_matrix_c4_rank_1,&
      rocblas_set_matrix_c8_full_rank,rocblas_set_matrix_c8_rank_0,rocblas_set_matrix_c8_rank_1 
#endif
  end interface

  interface rocblas_get_matrix
    function rocblas_get_matrix_(rows,cols,elem_size,A,lda,B,ldb) bind(c, name="rocblas_get_matrix") result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),value :: elem_size
      type(c_ptr),value :: A
      integer(c_int),value :: lda
      type(c_ptr),value :: B
      integer(c_int),value :: ldb
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure rocblas_get_matrix_l_full_rank,rocblas_get_matrix_l_rank_0,rocblas_get_matrix_l_rank_1,&
      rocblas_get_matrix_i4_full_rank,rocblas_get_matrix_i4_rank_0,rocblas_get_matrix_i4_rank_1,&
      rocblas_get_matrix_i8_full_rank,rocblas_get_matrix_i8_rank_0,rocblas_get_matrix_i8_rank_1,&
      rocblas_get_matrix_r4_full_rank,rocblas_get_matrix_r4_rank_0,rocblas_get_matrix_r4_rank_1,&
      rocblas_get_matrix_r8_full_rank,rocblas_get_matrix_r8_rank_0,rocblas_get_matrix_r8_rank_1,&
      rocblas_get_matrix_c4_full_rank,rocblas_get_matrix_c4_rank_0,rocblas_get_matrix_c4_rank_1,&
      rocblas_get_matrix_c8_full_rank,rocblas_get_matrix_c8_rank_0,rocblas_get_matrix_c8_rank_1 
#endif
  end interface

  interface rocblas_set_vector_async
    function rocblas_set_vector_async_(n,elem_size,x,incx,y,incy,stream) bind(c, name="rocblas_set_vector_async") result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),value :: elem_size
      type(c_ptr),value :: x
      integer(c_int),value :: incx
      type(c_ptr),value :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure rocblas_set_vector_async_l_rank_0,rocblas_set_vector_async_l_full_rank,&
      rocblas_set_vector_async_i4_rank_0,rocblas_set_vector_async_i4_full_rank,&
      rocblas_set_vector_async_i8_rank_0,rocblas_set_vector_async_i8_full_rank,&
      rocblas_set_vector_async_r4_rank_0,rocblas_set_vector_async_r4_full_rank,&
      rocblas_set_vector_async_r8_rank_0,rocblas_set_vector_async_r8_full_rank,&
      rocblas_set_vector_async_c4_rank_0,rocblas_set_vector_async_c4_full_rank,&
      rocblas_set_vector_async_c8_rank_0,rocblas_set_vector_async_c8_full_rank 
#endif
  end interface

  interface rocblas_get_vector_async
    function rocblas_get_vector_async_(n,elem_size,x,incx,y,incy,stream) bind(c, name="rocblas_get_vector_async") result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),value :: elem_size
      type(c_ptr),value :: x
      integer(c_int),value :: incx
      type(c_ptr),value :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure rocblas_get_vector_async_l_rank_0,rocblas_get_vector_async_l_full_rank,&
      rocblas_get_vector_async_i4_rank_0,rocblas_get_vector_async_i4_full_rank,&
      rocblas_get_vector_async_i8_rank_0,rocblas_get_vector_async_i8_full_rank,&
      rocblas_get_vector_async_r4_rank_0,rocblas_get_vector_async_r4_full_rank,&
      rocblas_get_vector_async_r8_rank_0,rocblas_get_vector_async_r8_full_rank,&
      rocblas_get_vector_async_c4_rank_0,rocblas_get_vector_async_c4_full_rank,&
      rocblas_get_vector_async_c8_rank_0,rocblas_get_vector_async_c8_full_rank 
#endif
  end interface

  interface rocblas_set_matrix_async
    function rocblas_set_matrix_async_(rows,cols,elem_size,A,lda,B,ldb,stream) bind(c, name="rocblas_set_matrix_async") result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),value :: elem_size
      type(c_ptr),value :: A
      integer(c_int),value :: lda
      type(c_ptr),value :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure rocblas_set_matrix_async_l_full_rank,rocblas_set_matrix_async_l_rank_0,rocblas_set_matrix_async_l_rank_1,&
      rocblas_set_matrix_async_i4_full_rank,rocblas_set_matrix_async_i4_rank_0,rocblas_set_matrix_async_i4_rank_1,&
      rocblas_set_matrix_async_i8_full_rank,rocblas_set_matrix_async_i8_rank_0,rocblas_set_matrix_async_i8_rank_1,&
      rocblas_set_matrix_async_r4_full_rank,rocblas_set_matrix_async_r4_rank_0,rocblas_set_matrix_async_r4_rank_1,&
      rocblas_set_matrix_async_r8_full_rank,rocblas_set_matrix_async_r8_rank_0,rocblas_set_matrix_async_r8_rank_1,&
      rocblas_set_matrix_async_c4_full_rank,rocblas_set_matrix_async_c4_rank_0,rocblas_set_matrix_async_c4_rank_1,&
      rocblas_set_matrix_async_c8_full_rank,rocblas_set_matrix_async_c8_rank_0,rocblas_set_matrix_async_c8_rank_1 
#endif
  end interface

  interface rocblas_get_matrix_async
    function rocblas_get_matrix_async_(rows,cols,elem_size,A,lda,B,ldb,stream) bind(c, name="rocblas_get_matrix_async") result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),value :: elem_size
      type(c_ptr),value :: A
      integer(c_int),value :: lda
      type(c_ptr),value :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
    end function

#ifdef USE_FPOINTER_INTERFACES
    module procedure rocblas_get_matrix_async_l_full_rank,rocblas_get_matrix_async_l_rank_0,rocblas_get_matrix_async_l_rank_1,&
      rocblas_get_matrix_async_i4_full_rank,rocblas_get_matrix_async_i4_rank_0,rocblas_get_matrix_async_i4_rank_1,&
      rocblas_get_matrix_async_i8_full_rank,rocblas_get_matrix_async_i8_rank_0,rocblas_get_matrix_async_i8_rank_1,&
      rocblas_get_matrix_async_r4_full_rank,rocblas_get_matrix_async_r4_rank_0,rocblas_get_matrix_async_r4_rank_1,&
      rocblas_get_matrix_async_r8_full_rank,rocblas_get_matrix_async_r8_rank_0,rocblas_get_matrix_async_r8_rank_1,&
      rocblas_get_matrix_async_c4_full_rank,rocblas_get_matrix_async_c4_rank_0,rocblas_get_matrix_async_c4_rank_1,&
      rocblas_get_matrix_async_c8_full_rank,rocblas_get_matrix_async_c8_rank_0,rocblas_get_matrix_async_c8_rank_1 
#endif
  end interface

#ifdef USE_FPOINTER_INTERFACES
contains

    function rocblas_set_vector_l_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target :: x
      integer(c_int),value :: incx
      logical(c_bool),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,1,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_vector_l_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target,dimension(:) :: x
      integer(c_int),value :: incx
      logical(c_bool),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,1,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_l_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target :: x
      integer(c_int),value :: incx
      logical(c_bool),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,1,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_l_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target,dimension(:) :: x
      integer(c_int),value :: incx
      logical(c_bool),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,1,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_matrix_l_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:,:) :: A
      logical(c_bool),target,dimension(:,:) :: B
      !
      ret = rocblas_set_matrix_(rows,cols,1,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_set_matrix_l_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target :: A
      integer(c_int),value :: lda
      logical(c_bool),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_matrix_l_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:) :: A
      integer(c_int),value :: lda
      logical(c_bool),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_l_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:,:) :: A
      logical(c_bool),target,dimension(:,:) :: B
      !
      ret = rocblas_get_matrix_(rows,cols,1,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_get_matrix_l_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target :: A
      integer(c_int),value :: lda
      logical(c_bool),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_l_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:) :: A
      integer(c_int),value :: lda
      logical(c_bool),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_vector_async_l_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target :: x
      integer(c_int),value :: incx
      logical(c_bool),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,1,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_vector_async_l_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target,dimension(:) :: x
      integer(c_int),value :: incx
      logical(c_bool),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,1,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_l_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target :: x
      integer(c_int),value :: incx
      logical(c_bool),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,1,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_l_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      logical(c_bool),target,dimension(:) :: x
      integer(c_int),value :: incx
      logical(c_bool),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,1,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_matrix_async_l_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:,:) :: A
      logical(c_bool),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,1,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_set_matrix_async_l_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target :: A
      integer(c_int),value :: lda
      logical(c_bool),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_set_matrix_async_l_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:) :: A
      integer(c_int),value :: lda
      logical(c_bool),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_l_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:,:) :: A
      logical(c_bool),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,1,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_get_matrix_async_l_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target :: A
      integer(c_int),value :: lda
      logical(c_bool),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_l_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      logical(c_bool),target,dimension(:) :: A
      integer(c_int),value :: lda
      logical(c_bool),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,1,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function rocblas_set_vector_i4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),target :: x
      integer(c_int),value :: incx
      integer(c_int),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_vector_i4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_int),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_i4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),target :: x
      integer(c_int),value :: incx
      integer(c_int),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_i4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_int),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_matrix_i4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:,:) :: A
      integer(c_int),target,dimension(:,:) :: B
      !
      ret = rocblas_set_matrix_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_set_matrix_i4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target :: A
      integer(c_int),value :: lda
      integer(c_int),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_matrix_i4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_int),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_i4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:,:) :: A
      integer(c_int),target,dimension(:,:) :: B
      !
      ret = rocblas_get_matrix_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_get_matrix_i4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target :: A
      integer(c_int),value :: lda
      integer(c_int),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_i4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_int),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_vector_async_i4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),target :: x
      integer(c_int),value :: incx
      integer(c_int),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_vector_async_i4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_int),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_i4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),target :: x
      integer(c_int),value :: incx
      integer(c_int),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_i4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_int),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_int),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_matrix_async_i4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:,:) :: A
      integer(c_int),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_set_matrix_async_i4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target :: A
      integer(c_int),value :: lda
      integer(c_int),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_set_matrix_async_i4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_int),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_i4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:,:) :: A
      integer(c_int),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_get_matrix_async_i4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target :: A
      integer(c_int),value :: lda
      integer(c_int),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_i4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_int),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_int),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function rocblas_set_vector_i8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_long),target :: x
      integer(c_int),value :: incx
      integer(c_long),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_vector_i8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_long),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_long),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_i8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_long),target :: x
      integer(c_int),value :: incx
      integer(c_long),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_i8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_long),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_long),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_matrix_i8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:,:) :: A
      integer(c_long),target,dimension(:,:) :: B
      !
      ret = rocblas_set_matrix_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_set_matrix_i8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target :: A
      integer(c_int),value :: lda
      integer(c_long),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_matrix_i8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_long),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_i8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:,:) :: A
      integer(c_long),target,dimension(:,:) :: B
      !
      ret = rocblas_get_matrix_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_get_matrix_i8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target :: A
      integer(c_int),value :: lda
      integer(c_long),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_i8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_long),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_vector_async_i8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_long),target :: x
      integer(c_int),value :: incx
      integer(c_long),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_vector_async_i8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_long),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_long),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_i8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_long),target :: x
      integer(c_int),value :: incx
      integer(c_long),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_i8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      integer(c_long),target,dimension(:) :: x
      integer(c_int),value :: incx
      integer(c_long),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_matrix_async_i8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:,:) :: A
      integer(c_long),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_set_matrix_async_i8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target :: A
      integer(c_int),value :: lda
      integer(c_long),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_set_matrix_async_i8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_long),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_i8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:,:) :: A
      integer(c_long),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_get_matrix_async_i8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target :: A
      integer(c_int),value :: lda
      integer(c_long),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_i8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      integer(c_long),target,dimension(:) :: A
      integer(c_int),value :: lda
      integer(c_long),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function rocblas_set_vector_r4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_float),target :: x
      integer(c_int),value :: incx
      real(c_float),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_vector_r4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_float),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_float),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_r4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_float),target :: x
      integer(c_int),value :: incx
      real(c_float),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_r4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_float),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_float),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_matrix_r4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:,:) :: A
      real(c_float),target,dimension(:,:) :: B
      !
      ret = rocblas_set_matrix_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_set_matrix_r4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target :: A
      integer(c_int),value :: lda
      real(c_float),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_matrix_r4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_float),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_r4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:,:) :: A
      real(c_float),target,dimension(:,:) :: B
      !
      ret = rocblas_get_matrix_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_get_matrix_r4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target :: A
      integer(c_int),value :: lda
      real(c_float),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_r4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_float),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_vector_async_r4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_float),target :: x
      integer(c_int),value :: incx
      real(c_float),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_vector_async_r4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_float),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_float),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_r4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_float),target :: x
      integer(c_int),value :: incx
      real(c_float),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_r4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_float),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_float),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_matrix_async_r4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:,:) :: A
      real(c_float),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_set_matrix_async_r4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target :: A
      integer(c_int),value :: lda
      real(c_float),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_set_matrix_async_r4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_float),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_r4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:,:) :: A
      real(c_float),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_get_matrix_async_r4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target :: A
      integer(c_int),value :: lda
      real(c_float),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_r4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_float),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_float),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function rocblas_set_vector_r8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_double),target :: x
      integer(c_int),value :: incx
      real(c_double),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_vector_r8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_double),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_double),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_r8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_double),target :: x
      integer(c_int),value :: incx
      real(c_double),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_r8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_double),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_double),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_matrix_r8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:,:) :: A
      real(c_double),target,dimension(:,:) :: B
      !
      ret = rocblas_set_matrix_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_set_matrix_r8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target :: A
      integer(c_int),value :: lda
      real(c_double),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_matrix_r8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_double),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_r8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:,:) :: A
      real(c_double),target,dimension(:,:) :: B
      !
      ret = rocblas_get_matrix_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_get_matrix_r8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target :: A
      integer(c_int),value :: lda
      real(c_double),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_r8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_double),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_vector_async_r8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_double),target :: x
      integer(c_int),value :: incx
      real(c_double),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_vector_async_r8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_double),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_double),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_r8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_double),target :: x
      integer(c_int),value :: incx
      real(c_double),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_r8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      real(c_double),target,dimension(:) :: x
      integer(c_int),value :: incx
      real(c_double),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_matrix_async_r8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:,:) :: A
      real(c_double),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_set_matrix_async_r8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target :: A
      integer(c_int),value :: lda
      real(c_double),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_set_matrix_async_r8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_double),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_r8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:,:) :: A
      real(c_double),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_get_matrix_async_r8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target :: A
      integer(c_int),value :: lda
      real(c_double),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_r8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      real(c_double),target,dimension(:) :: A
      integer(c_int),value :: lda
      real(c_double),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function rocblas_set_vector_c4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,2*4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_vector_c4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,2*4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_c4_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,2*4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_c4_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,2*4,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_matrix_c4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:,:) :: A
      complex(c_float_complex),target,dimension(:,:) :: B
      !
      ret = rocblas_set_matrix_(rows,cols,2*4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_set_matrix_c4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_matrix_c4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_c4_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:,:) :: A
      complex(c_float_complex),target,dimension(:,:) :: B
      !
      ret = rocblas_get_matrix_(rows,cols,2*4,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_get_matrix_c4_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_c4_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_vector_async_c4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,2*4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_vector_async_c4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,2*4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_c4_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,2*4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_c4_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_float_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_float_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,2*4,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_matrix_async_c4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:,:) :: A
      complex(c_float_complex),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,2*4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_set_matrix_async_c4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_set_matrix_async_c4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_c4_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:,:) :: A
      complex(c_float_complex),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,2*4,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_get_matrix_async_c4_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_c4_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_float_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_float_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,2*4,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
    function rocblas_set_vector_c8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,2*8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_vector_c8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_set_vector_(n,2*8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_c8_rank_0(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,2*8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_get_vector_c8_full_rank(n,x,incx,y,incy) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      !
      ret = rocblas_get_vector_(n,2*8,c_loc(x),incx,c_loc(y),incy)
    end function

    function rocblas_set_matrix_c8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:,:) :: A
      complex(c_double_complex),target,dimension(:,:) :: B
      !
      ret = rocblas_set_matrix_(rows,cols,2*8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_set_matrix_c8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_matrix_c8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_set_matrix_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_c8_full_rank(rows,cols,A,B) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:,:) :: A
      complex(c_double_complex),target,dimension(:,:) :: B
      !
      ret = rocblas_get_matrix_(rows,cols,2*8,c_loc(A),size(A,1),c_loc(B),size(B,1))
    end function

    function rocblas_get_matrix_c8_rank_0(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_get_matrix_c8_rank_1(rows,cols,A,lda,B,ldb) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      !
      ret = rocblas_get_matrix_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb)
    end function

    function rocblas_set_vector_async_c8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,2*8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_vector_async_c8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_vector_async_(n,2*8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_c8_rank_0(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,2*8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_get_vector_async_c8_full_rank(n,x,incx,y,incy,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: n
      complex(c_double_complex),target,dimension(:) :: x
      integer(c_int),value :: incx
      complex(c_double_complex),target,dimension(:) :: y
      integer(c_int),value :: incy
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_vector_async_(n,2*8,c_loc(x),incx,c_loc(y),incy,stream)
    end function

    function rocblas_set_matrix_async_c8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:,:) :: A
      complex(c_double_complex),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,2*8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_set_matrix_async_c8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_set_matrix_async_c8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_set_matrix_async_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_c8_full_rank(rows,cols,A,B,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:,:) :: A
      complex(c_double_complex),target,dimension(:,:) :: B
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,2*8,c_loc(A),size(A,1),c_loc(B),size(B,1),stream)
    end function

    function rocblas_get_matrix_async_c8_rank_0(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function

    function rocblas_get_matrix_async_c8_rank_1(rows,cols,A,lda,B,ldb,stream) result(ret)
      use iso_c_binding
      use hipfort_rocblas_enums
      implicit none
      integer(kind(rocblas_status_success)) :: ret
      integer(c_int),value :: rows
      integer(c_int),value :: cols
      complex(c_double_complex),target,dimension(:) :: A
      integer(c_int),value :: lda
      complex(c_double_complex),target,dimension(:) :: B
      integer(c_int),value :: ldb
      type(c_ptr),value :: stream
      !
      ret = rocblas_get_matrix_async_(rows,cols,2*8,c_loc(A),lda,c_loc(B),ldb,stream)
    end function
 

#endif
end module

program fortran_hip
  use iso_c_binding
  use hipfort
  use hipfort_check

  implicit none

  interface
     subroutine launch(out,a,b,N) bind(c)
       use iso_c_binding
       implicit none
       type(c_ptr) :: a, b, out
       integer, value :: N
     end subroutine
  end interface

  type(c_ptr) :: da = c_null_ptr
  type(c_ptr) :: db = c_null_ptr
  type(c_ptr) :: dout = c_null_ptr

  integer, parameter :: N = 1000000
  integer, parameter :: bytes_per_element = 8 !double precision
  integer(c_size_t), parameter :: Nbytes = N*bytes_per_element

  ! Plain real should be equivalent to float
  double precision,allocatable,target,dimension(:) :: a, b, out
  double precision :: error
  double precision, parameter :: error_max = 1.0d-10

  integer :: i
  type(hipDeviceProp_t),target :: props
  !
  call hipCheck(hipGetDeviceProperties(props,0))  
  write(*,"(a)",advance="no") "-- Running test 'vecadd' (Fortran 2003 interfaces)"
  write(*,"(a)",advance="no") "- device: "
  i=1
  do while ( iachar(props%name(i)) .ne. 0 ) ! print till end char
    write(*,"(a)",advance="no") props%name(i)
    i = i+1
  end do 
  write(*,"(a)",advance="no") " - "

  ! Allocate host memory
  allocate(a(N))
  allocate(b(N))
  allocate(out(N))

  ! Initialize host arrays
  a(:) = 1.0
  b(:) = 2.0

  ! Allocate array space on the device
  call hipCheck(hipMalloc(da,Nbytes))
  call hipCheck(hipMalloc(db,Nbytes))
  call hipCheck(hipMalloc(dout,Nbytes))

  ! Transfer data from host to device memory
  call hipCheck(hipMemcpy(da, c_loc(a(1)), Nbytes, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(db, c_loc(b(1)), Nbytes, hipMemcpyHostToDevice))

  call launch(dout,da,db,N)

  call hipCheck(hipDeviceSynchronize())

  ! Transfer data back to host memory
  call hipCheck(hipMemcpy(c_loc(out(1)), dout, Nbytes, hipMemcpyDeviceToHost))

  ! Verification
  do i = 1,N
     error = abs(out(i) - (a(i)+b(i)) )
     if( error .gt. error_max ) then
        write(*,*) "FAILED! Error bigger than max! Error = ", error, " Out = ", out(i)
        call exit
     endif
  end do

  call hipCheck(hipFree(da))
  call hipCheck(hipFree(db))
  call hipCheck(hipFree(dout))

  ! Deallocate host memory
  deallocate(a)
  deallocate(b)
  deallocate(out)

  write(*,*) "PASSED!"

end program fortran_hip

! HIPBLAS, i.e. cuBLAS and rocBLAS, assumes column-major matrix memory layouts.
! Hence, no matrix must be transposed when interfacing with Fortran.
program hip_sger
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none
  
  integer :: m = 6 
  integer :: n = 5
  real, parameter :: alpha = 2.0
  type(c_ptr) :: handle = c_null_ptr
  integer :: i, j
  
  real :: error
  real, parameter :: error_max = 10*epsilon(error)

  real(kind=4), allocatable, target, dimension(:,:) :: a
  real(kind=4), allocatable, target, dimension(:) :: x, y
 
  type(c_ptr) :: da = c_null_ptr, dx = c_null_ptr, dy = c_null_ptr
  
  integer(c_size_t) :: Nabytes, Nxbytes, Nybytes
  integer, parameter :: bytes_per_element = 4 !float precision
  
  Nxbytes = m * bytes_per_element
  Nybytes = n * bytes_per_element
  Nabytes = m * n * bytes_per_element
  
  allocate(x(m))
  allocate(y(n))
  allocate(a(m,n))
  
  do i = 1,m
    do j = 1,n
      a(i,j) = 1.0 
    end do
  end do
  
  do i = 1,m
    x(i) = 1.0
  end do

  do i = 1,n
    y(i) = 1.0
  end do
 

  write(*,"(a)",advance="no") "-- Running test 'SGER' (Fortran 2003 interfaces) - "
  
  call hipblasCheck(hipblasCreate(handle))
  
  call hipCheck(hipMalloc(dx,Nxbytes))  
  call hipCheck(hipMalloc(dy,Nybytes))
  call hipCheck(hipMalloc(da,Nabytes))
  
  !call hipCheck(hipblasSetMatrix(m,n,bytes_per_element,a,m,da,m))
  !call hipCheck(hipblasSetVector(m,bytes_per_element,x,1,dx,1))
  !call hipCheck(hipblasSetVector(n,bytes_per_element,y,1,dy,1))
  
  call hipCheck(hipMemcpy(da, c_loc(a(1,1)), Nabytes, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dx, c_loc(x(1)), Nxbytes, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dy, c_loc(y(1)), Nybytes, hipMemcpyHostToDevice)) 

  call hipCheck(hipblasSger(handle,m,n,alpha,dx,1,dy,1,da,m))
  
  !call hipCheck(hipblasGetMatrix(m,n,bytes_per_element,da,m,a,m));
  call hipCheck(hipDeviceSynchronize())

  call hipCheck(hipMemcpy(c_loc(a(1,1)), da, Nabytes, hipMemcpyDeviceToHost))

  !do i=1,m
  !  do j = 1,n
  !    write(*,*) a(i,j) 
  !  end do
  !end do

  do i = 1,m
  do j = 1,n
    error = abs(3.0 - a(i,j))
      if( error > 10*epsilon(error) )then
        write(*,*) "FAILED! Error bigger than max! Error = ", error, "a(i,j) = ", a(i,j)
        call exit(1)
     end if
  end do
  end do

  call hipblasCheck(hipblasDestroy(handle))

  call hipCheck(hipFree(da))
  call hipCheck(hipFree(dx))
  call hipCheck(hipFree(dy))
  
  deallocate(a)
  deallocate(x)
  deallocate(y)
  
  write(*,*) "PASSED!"
  
end program hip_sger

! Example: Compute the LU Factorization of a matrix on the GPU
program main
  use hipfort
  use hipfort_check
  use hipfort_hipsolver
  implicit none
  integer(c_int),parameter    :: M   = 3,&
                                 N   = 3,&
                                 lda = 3
  integer(c_size_t),parameter :: size_piv = min(M, N) ! count of pivot indices
  real(c_double)              :: hA(lda,N)
  integer(c_int)              :: hInfo           ! provides information about algorithm completion
  integer(c_int)              :: hIpiv(size_piv) ! array for pivot indices on CPU
  !
  type(c_ptr)            :: handle = c_null_ptr
  integer(c_int),pointer :: dInfo
  integer(c_int),pointer :: dIpiv(:)
  real(c_double),pointer :: dA(:,:)
  type(c_ptr)            :: dWork
  integer(c_int)         :: size_work_bytes ! size of workspace to pass to getrf (in bytes)
  !
  hA = reshape((/12,-51,4, 6,167,-68, -4,24,-41/),shape(hA))
  
  write(*,"(a)",advance="no") "-- Running test 'hipsolverDgetrf' (Fortran 2008 interfaces) - "

  ! let's print the input matrix, just to see it
  ! print *, hA
  
  ! initialization
  call hipsolverCheck(hipsolverCreate(handle))

  ! calculate the sizes of our arrays
  ! allocate memory on GPU & copy hA to device
  call hipCheck(hipMalloc(dInfo))
  call hipCheck(hipMalloc(dIpiv, mold=hIpiv))
  call hipCheck(hipMalloc(dA, source=hA))

  ! create the workspace
  call hipsolverCheck(hipsolverDgetrf_bufferSize(handle, M, N, dA, lda, size_work_bytes))
  call hipCheck(hipMalloc(dWork, int(size_work_bytes,c_size_t)))

  ! compute the LU factorization on the GPU
  call hipsolverCheck(hipsolverDgetrf(handle, M, N, dA, lda, dWork, size_work_bytes, dIpiv, dInfo))

  ! copy the results back to CPU
  call hipCheck(hipMemcpy(hInfo, dInfo, hipMemcpyDeviceToHost))
  call hipCheck(hipMemcpy(hIpiv, dIpiv, hipMemcpyDeviceToHost))
  call hipCheck(hipMemcpy(hA, dA, hipMemcpyDeviceToHost))

  ! the results are now in hA and hIpiv
  ! we can print some of the results if we want to see them
  ! print *, "hInfo=",hInfo
  ! print *, "hA=",hA
  ! print *, "hIpiv=",hA

  ! clean up
  call hipCheck(hipFree(dWork))
  call hipCheck(hipFree(dInfo))
  call hipCheck(hipFree(dIpiv))
  call hipCheck(hipFree(dA))
  call hipsolverCheck(hipsolverDestroy(handle))
 
  ! TODO: add correctness check 
  write(*,*) "PASSED!"
end program

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_rocsolver_enums
  implicit none

  enum, bind(c)
    enumerator :: rocblas_layer_mode_ex_log_kernel = 16
  end enum

  enum, bind(c)
    enumerator :: rocblas_forward_direction = 171
    enumerator :: rocblas_backward_direction = 172
  end enum

  enum, bind(c)
    enumerator :: rocblas_column_wise = 181
    enumerator :: rocblas_row_wise = 182
  end enum

  enum, bind(c)
    enumerator :: rocblas_svect_all = 191
    enumerator :: rocblas_svect_singular = 192
    enumerator :: rocblas_svect_overwrite = 193
    enumerator :: rocblas_svect_none = 194
  end enum

  enum, bind(c)
    enumerator :: rocblas_outofplace = 201
    enumerator :: rocblas_inplace = 202
  end enum

  enum, bind(c)
    enumerator :: rocblas_evect_original = 211
    enumerator :: rocblas_evect_tridiagonal = 212
    enumerator :: rocblas_evect_none = 213
  end enum

  enum, bind(c)
    enumerator :: rocblas_eform_ax = 221
    enumerator :: rocblas_eform_abx = 222
    enumerator :: rocblas_eform_bax = 223
  end enum

 

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_rocsolver_enums

program hip_dger

  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none

  integer, parameter ::  m = 100, n = 100
  double precision, parameter ::  alpha = 1.1d0
  integer, parameter :: bytes_per_element = 8 !double precision

  double precision, allocatable, target, dimension(:) :: hx, hy, hA

  type(c_ptr) :: handle = c_null_ptr
  type(c_ptr) :: dx = c_null_ptr, dy = c_null_ptr, dA = c_null_ptr
  integer(c_size_t), parameter :: Nbytes = m*bytes_per_element

  integer :: i
  double precision :: error

  write(*,"(a)",advance="no") "-- Running test 'dger' (Fortran 2003 interfaces) - "

  call hipblasCheck(hipblasCreate(handle))

  allocate(hx(m))
  allocate(hy(n))
  allocate(ha(m*n))

  hx(:) = 1.d0
  hy(:) = 1.d0
  hA(:) = 1.d0

  ! Allocate device memory
  call hipCheck(hipMalloc(dx,Nbytes))
  call hipCheck(hipMalloc(dy,Nbytes))
  call hipCheck(hipMalloc(dA,Nbytes*n))

  !Transfer from host to device
  call hipCheck(hipMemcpy(dx, c_loc(hx(1)), Nbytes, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dy, c_loc(hy(1)), Nbytes, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dA, c_loc(hA(1)), Nbytes*n, hipMemcpyHostToDevice))

  call hipblasCheck(hipblasDger(handle,m,n,alpha,dx,1,dy,1,dA,m))

  call hipCheck(hipDeviceSynchronize())

  ! Transfer data back to host memory
  call hipCheck(hipMemcpy(c_loc(hA(1)), dA, Nbytes*n, hipMemcpyDeviceToHost))

  do i = 1,m*n
     error = abs(2.1d0 - hA(i))
     if( error > 10*epsilon(error) )then
        write(*,*) "FAILED! Error bigger than max! Error = ", error, "hA(i) = ", hA(i)
        call exit(1)
     end if
  end do

  call hipCheck(hipFree(dx))
  call hipCheck(hipFree(dy))
  call hipCheck(hipFree(dA))

  call hipblasCheck(hipblasDestroy(handle))

  deallocate(hx)
  deallocate(hy)
  deallocate(hA)

  write(*,*) "PASSED!"

end program hip_dger

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_rocfft_enums
  implicit none

  enum, bind(c)
    enumerator :: rocfft_status_success
    enumerator :: rocfft_status_failure
    enumerator :: rocfft_status_invalid_arg_value
    enumerator :: rocfft_status_invalid_dimensions
    enumerator :: rocfft_status_invalid_array_type
    enumerator :: rocfft_status_invalid_strides
    enumerator :: rocfft_status_invalid_distance
    enumerator :: rocfft_status_invalid_offset
    enumerator :: rocfft_status_invalid_work_buffer
  end enum

  enum, bind(c)
    enumerator :: rocfft_transform_type_complex_forward
    enumerator :: rocfft_transform_type_complex_inverse
    enumerator :: rocfft_transform_type_real_forward
    enumerator :: rocfft_transform_type_real_inverse
  end enum

  enum, bind(c)
    enumerator :: rocfft_precision_single
    enumerator :: rocfft_precision_double
  end enum

  enum, bind(c)
    enumerator :: rocfft_placement_inplace
    enumerator :: rocfft_placement_notinplace
  end enum

  enum, bind(c)
    enumerator :: rocfft_array_type_complex_interleaved
    enumerator :: rocfft_array_type_complex_planar
    enumerator :: rocfft_array_type_real
    enumerator :: rocfft_array_type_hermitian_interleaved
    enumerator :: rocfft_array_type_hermitian_planar
    enumerator :: rocfft_array_type_unset
  end enum

  enum, bind(c)
    enumerator :: rocfft_exec_mode_nonblocking
    enumerator :: rocfft_exec_mode_nonblocking_with_flush
    enumerator :: rocfft_exec_mode_blocking
  end enum

 

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_rocfft_enums

program fortran_hip
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_roctx

  implicit none

  interface
     subroutine launch() bind(c)
       use iso_c_binding
       implicit none
     end subroutine
  end interface

  integer :: i
  integer :: ret
  type(hipDeviceProp_t),target :: props

  call hipCheck(hipGetDeviceProperties(props,0))
  write(*,"(a)",advance="no") "-- Running test 'roctx' (Fortran 2003 interfaces)"
  write(*,"(a)",advance="no") "- device: "
  i=1
  do while ( iachar(props%name(i)) .ne. 0 ) ! print till end char
    write(*,"(a)",advance="no") props%name(i)
    i = i+1
  end do
  write(*,"(a)",advance="no") " - "

  ret = roctxRangePush(c_char_"hello_world"//c_null_char)
  if (ret /= 0) then
    write (*, *) "ROCTX ERROR: roctxRangePush: Invalid nested range level ", ret
  end if

  call launch()
  call hipCheck(hipDeviceSynchronize())

  ret = roctxRangePop()
  if (ret /= 0) then
    write (*, *) "ROCTX ERROR: roctxRangePop: Invalid nested range level ", ret
  end if

  write(*,*) "PASSED!"

end program fortran_hip

program hip_dgemm

  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas

  implicit none

  integer(kind(HIPBLAS_OP_N)), parameter :: transa = HIPBLAS_OP_N, transb = HIPBLAS_OP_N;
  double precision, parameter ::  alpha = 1.1d0, beta = 0.9d0;

  integer, parameter ::  m = 1024, n = 1024, k = 1024;

  double precision, allocatable, dimension(:,:) :: ha, hb, hc, hc_exact

  double precision, pointer, dimension(:,:) :: da, db, dc
  type(c_ptr) :: handle = c_null_ptr

  integer :: i,j
  double precision :: error
  double precision, parameter :: error_max = 10*epsilon(error)

  write(*,"(a)",advance="no") "-- Running test 'DGEMM' (Fortran 2008 interfaces) - "

  call hipblasCheck(hipblasCreate(handle))

  allocate(ha(m,k))
  allocate(hb(k,n))
  allocate(hc(m,n))
  allocate(hc_exact(m,n))

  ! Use these constant matrices so the exact answer is also a
  ! constant matrix and therefore easy to check
  ha(:,:) = 1.d0
  hb(:,:) = 2.d0
  hc(:,:) = 3.d0
  hc_exact = alpha*k*2.d0 + beta*3.d0

  ! Allocate device memory
  call hipCheck(hipMalloc(da,source=ha)) ! implies (blocking) memcpy
  call hipCheck(hipMalloc(db,source=hb))
  call hipCheck(hipMalloc(dc,source=hc))

  call hipblasCheck(hipblasDgemm(handle,transa,transb,m,n,k,alpha,da,size(da,1),db,size(db,1),beta,dc,size(dc,1)))

  call hipCheck(hipDeviceSynchronize())

  ! Transfer data back to host memory
  call hipCheck(hipMemcpy(hc, dc, hipMemcpyDeviceToHost))

  do j = 1,n
    do i = 1,m
       error = abs((hc_exact(i,j) - hc(i,j))/hc_exact(i,j))
       if( error > error_max )then
          write(*,*) "FAILED! Error bigger than max! Error = ", error
          call exit(1)
       end if
    end do
  end do

  call hipCheck(hipFree(da))
  call hipCheck(hipFree(db))
  call hipCheck(hipFree(dc))

  call hipblasCheck(hipblasDestroy(handle))

  deallocate(ha,hb,hc,hc_exact)

  write(*,*) "PASSED!"

end program hip_dgemm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2024 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
!
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
!
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module hipfort_roctx

   interface
      subroutine roctxMark(message) bind(c, name="roctxMarkA")
         use iso_c_binding, only: c_char
         implicit none
         character(kind=c_char) :: message(*)
      end subroutine roctxMark

      function roctxRangePush(message) bind(c, name="roctxRangePushA")
         use iso_c_binding, only: c_int,&
                                  c_char
         implicit none
         integer(c_int) :: roctxRangePush
         character(kind=c_char) :: message(*)
      end function roctxRangePush

      function roctxRangePop() bind(c, name="roctxRangePop")
         use iso_c_binding, only: c_int
         implicit none
         integer(c_int) :: roctxRangePop
      end function roctxRangePop

      function roctxRangeStart(message) bind(c, name="roctxRangeStartA")
         use iso_c_binding, only: c_size_t,&
                                  c_char
         implicit none
         integer(c_size_t) :: roctxRangeStart
         character(kind=c_char) :: message(*)
      end function roctxRangeStart

      subroutine roctxRangeStop(range_id) bind (c, name="roctxRangeStop")
         use iso_c_binding, only: c_size_t
         implicit none
         integer(c_size_t) :: range_id
      end subroutine roctxRangeStop
   end interface

end module hipfort_roctx

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ==============================================================================
! hipfort: FORTRAN Interfaces for GPU kernels
! ==============================================================================
! Copyright (c) 2020-2022 Advanced Micro Devices, Inc. All rights reserved.
! [MITx11 License]
! 
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
! 
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
! 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_rocblas_enums
  implicit none

  enum, bind(c)
    enumerator :: rocblas_operation_none = 111
    enumerator :: rocblas_operation_transpose = 112
    enumerator :: rocblas_operation_conjugate_transpose = 113
  end enum

  enum, bind(c)
    enumerator :: rocblas_fill_upper = 121
    enumerator :: rocblas_fill_lower = 122
    enumerator :: rocblas_fill_full = 123
  end enum

  enum, bind(c)
    enumerator :: rocblas_diagonal_non_unit = 131
    enumerator :: rocblas_diagonal_unit = 132
  end enum

  enum, bind(c)
    enumerator :: rocblas_side_left = 141
    enumerator :: rocblas_side_right = 142
    enumerator :: rocblas_side_both = 143
  end enum

  enum, bind(c)
    enumerator :: rocblas_status_success = 0
    enumerator :: rocblas_status_invalid_handle = 1
    enumerator :: rocblas_status_not_implemented = 2
    enumerator :: rocblas_status_invalid_pointer = 3
    enumerator :: rocblas_status_invalid_size = 4
    enumerator :: rocblas_status_memory_error = 5
    enumerator :: rocblas_status_internal_error = 6
    enumerator :: rocblas_status_perf_degraded = 7
    enumerator :: rocblas_status_size_query_mismatch = 8
    enumerator :: rocblas_status_size_increased = 9
    enumerator :: rocblas_status_size_unchanged = 10
    enumerator :: rocblas_status_invalid_value = 11
    enumerator :: rocblas_status_continue = 12
    enumerator :: rocblas_status_check_numerics_fail = 13
  end enum

  enum, bind(c)
    enumerator :: rocblas_datatype_f16_r = 150
    enumerator :: rocblas_datatype_f32_r = 151
    enumerator :: rocblas_datatype_f64_r = 152
    enumerator :: rocblas_datatype_f16_c = 153
    enumerator :: rocblas_datatype_f32_c = 154
    enumerator :: rocblas_datatype_f64_c = 155
    enumerator :: rocblas_datatype_i8_r = 160
    enumerator :: rocblas_datatype_u8_r = 161
    enumerator :: rocblas_datatype_i32_r = 162
    enumerator :: rocblas_datatype_u32_r = 163
    enumerator :: rocblas_datatype_i8_c = 164
    enumerator :: rocblas_datatype_u8_c = 165
    enumerator :: rocblas_datatype_i32_c = 166
    enumerator :: rocblas_datatype_u32_c = 167
    enumerator :: rocblas_datatype_bf16_r = 168
    enumerator :: rocblas_datatype_bf16_c = 169
  end enum

  enum, bind(c)
    enumerator :: rocblas_pointer_mode_host = 0
    enumerator :: rocblas_pointer_mode_device = 1
  end enum

  enum, bind(c)
    enumerator :: rocblas_atomics_not_allowed = 0
    enumerator :: rocblas_atomics_allowed = 1
  end enum

  enum, bind(c)
    enumerator :: rocblas_default_performance_metric = 0
    enumerator :: rocblas_device_efficiency_performance_metric = 1
    enumerator :: rocblas_cu_efficiency_performance_metric = 2
  end enum

  enum, bind(c)
    enumerator :: rocblas_layer_mode_none = 0
    enumerator :: rocblas_layer_mode_log_trace = 1
    enumerator :: rocblas_layer_mode_log_bench = 2
    enumerator :: rocblas_layer_mode_log_profile = 4
  end enum

  enum, bind(c)
    enumerator :: rocblas_gemm_algo_standard = 0
  end enum

  enum, bind(c)
    enumerator :: rocblas_gemm_flags_none = 0
    enumerator :: rocblas_gemm_flags_pack_int8x4 = 1
    enumerator :: rocblas_gemm_flags_use_cu_efficiency = 2
    enumerator :: rocblas_gemm_flags_fp16_alt_impl = 4
  end enum

  enum, bind(c)
    enumerator :: rocblas_check_numerics_mode_no_check = 0
    enumerator :: rocblas_check_numerics_mode_info = 1
    enumerator :: rocblas_check_numerics_mode_warn = 2
    enumerator :: rocblas_check_numerics_mode_fail = 4
  end enum

 

#ifdef USE_FPOINTER_INTERFACES

  
#endif
end module hipfort_rocblas_enums

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright (c) 2021 Advanced Micro Devices, Inc.
!
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
!
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
! THE SOFTWARE.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          
           
module hipfort_cuda_errors
  implicit none

  enum, bind(c)
    enumerator :: cudaSuccess = 0
    enumerator :: cudaErrorInvalidValue = 1
    enumerator :: cudaErrorMemoryAllocation = 2
    enumerator :: cudaErrorInitializationError = 3
    enumerator :: cudaErrorCudartUnloading = 4
    enumerator :: cudaErrorProfilerDisabled = 5
    enumerator :: cudaErrorProfilerNotInitialized = 6
    enumerator :: cudaErrorProfilerAlreadyStarted = 7
    enumerator :: cudaErrorProfilerAlreadyStopped = 8
    enumerator :: cudaErrorInvalidConfiguration = 9
    enumerator :: cudaErrorInvalidPitchValue = 12
    enumerator :: cudaErrorInvalidSymbol = 13
    enumerator :: cudaErrorInvalidHostPointer = 16
    enumerator :: cudaErrorInvalidDevicePointer = 17
    enumerator :: cudaErrorInvalidTexture = 18
    enumerator :: cudaErrorInvalidTextureBinding = 19
    enumerator :: cudaErrorInvalidChannelDescriptor = 20
    enumerator :: cudaErrorInvalidMemcpyDirection = 21
    enumerator :: cudaErrorAddressOfConstant = 22
    enumerator :: cudaErrorTextureFetchFailed = 23
    enumerator :: cudaErrorTextureNotBound = 24
    enumerator :: cudaErrorSynchronizationError = 25
    enumerator :: cudaErrorInvalidFilterSetting = 26
    enumerator :: cudaErrorInvalidNormSetting = 27
    enumerator :: cudaErrorMixedDeviceExecution = 28
    enumerator :: cudaErrorNotYetImplemented = 31
    enumerator :: cudaErrorMemoryValueTooLarge = 32
    enumerator :: cudaErrorInsufficientDriver = 35
    enumerator :: cudaErrorInvalidSurface = 37
    enumerator :: cudaErrorDuplicateVariableName = 43
    enumerator :: cudaErrorDuplicateTextureName = 44
    enumerator :: cudaErrorDuplicateSurfaceName = 45
    enumerator :: cudaErrorDevicesUnavailable = 46
    enumerator :: cudaErrorIncompatibleDriverContext = 49
    enumerator :: cudaErrorMissingConfiguration = 52
    enumerator :: cudaErrorPriorLaunchFailure = 53
    enumerator :: cudaErrorLaunchMaxDepthExceeded = 65
    enumerator :: cudaErrorLaunchFileScopedTex = 66
    enumerator :: cudaErrorLaunchFileScopedSurf = 67
    enumerator :: cudaErrorSyncDepthExceeded = 68
    enumerator :: cudaErrorLaunchPendingCountExceeded = 69
    enumerator :: cudaErrorInvalidDeviceFunction = 98
    enumerator :: cudaErrorNoDevice = 100
    enumerator :: cudaErrorInvalidDevice = 101
    enumerator :: cudaErrorStartupFailure = 127
    enumerator :: cudaErrorInvalidKernelImage = 200
    enumerator :: cudaErrorDeviceUninitialized = 201
    enumerator :: cudaErrorMapBufferObjectFailed = 205
    enumerator :: cudaErrorUnmapBufferObjectFailed = 206
    enumerator :: cudaErrorArrayIsMapped = 207
    enumerator :: cudaErrorAlreadyMapped = 208
    enumerator :: cudaErrorNoKernelImageForDevice = 209
    enumerator :: cudaErrorAlreadyAcquired = 210
    enumerator :: cudaErrorNotMapped = 211
    enumerator :: cudaErrorNotMappedAsArray = 212
    enumerator :: cudaErrorNotMappedAsPointer = 213
    enumerator :: cudaErrorECCUncorrectable = 214
    enumerator :: cudaErrorUnsupportedLimit = 215
    enumerator :: cudaErrorDeviceAlreadyInUse = 216
    enumerator :: cudaErrorPeerAccessUnsupported = 217
    enumerator :: cudaErrorInvalidPtx = 218
    enumerator :: cudaErrorInvalidGraphicsContext = 219
    enumerator :: cudaErrorNvlinkUncorrectable = 220
    enumerator :: cudaErrorJitCompilerNotFound = 221
    enumerator :: cudaErrorInvalidSource = 300
    enumerator :: cudaErrorFileNotFound = 301
    enumerator :: cudaErrorSharedObjectSymbolNotFound = 302
    enumerator :: cudaErrorSharedObjectInitFailed = 303
    enumerator :: cudaErrorOperatingSystem = 304
    enumerator :: cudaErrorInvalidResourceHandle = 400
    enumerator :: cudaErrorIllegalState = 401
    enumerator :: cudaErrorSymbolNotFound = 500
    enumerator :: cudaErrorNotReady = 600
    enumerator :: cudaErrorIllegalAddress = 700
    enumerator :: cudaErrorLaunchOutOfResources = 701
    enumerator :: cudaErrorLaunchTimeout = 702
    enumerator :: cudaErrorLaunchIncompatibleTexturing = 703
    enumerator :: cudaErrorPeerAccessAlreadyEnabled = 704
    enumerator :: cudaErrorPeerAccessNotEnabled = 705
    enumerator :: cudaErrorSetOnActiveProcess = 708
    enumerator :: cudaErrorContextIsDestroyed = 709
    enumerator :: cudaErrorAssert = 710
    enumerator :: cudaErrorTooManyPeers = 711
    enumerator :: cudaErrorHostMemoryAlreadyRegistered = 712
    enumerator :: cudaErrorHostMemoryNotRegistered = 713
    enumerator :: cudaErrorHardwareStackError = 714
    enumerator :: cudaErrorIllegalInstruction = 715
    enumerator :: cudaErrorMisalignedAddress = 716
    enumerator :: cudaErrorInvalidAddressSpace = 717
    enumerator :: cudaErrorInvalidPc = 718
    enumerator :: cudaErrorLaunchFailure = 719
    enumerator :: cudaErrorCooperativeLaunchTooLarge = 720
    enumerator :: cudaErrorNotPermitted = 800
    enumerator :: cudaErrorNotSupported = 801
    enumerator :: cudaErrorSystemNotReady = 802
    enumerator :: cudaErrorSystemDriverMismatch = 803
    enumerator :: cudaErrorCompatNotSupportedOnDevice = 804
    enumerator :: cudaErrorStreamCaptureUnsupported = 900
    enumerator :: cudaErrorStreamCaptureInvalidated = 901
    enumerator :: cudaErrorStreamCaptureMerge = 902
    enumerator :: cudaErrorStreamCaptureUnmatched = 903
    enumerator :: cudaErrorStreamCaptureUnjoined = 904
    enumerator :: cudaErrorStreamCaptureIsolation = 905
    enumerator :: cudaErrorStreamCaptureImplicit = 906
    enumerator :: cudaErrorCapturedEvent = 907
    enumerator :: cudaErrorStreamCaptureWrongThread = 908
    enumerator :: cudaErrorTimeout = 909
    enumerator :: cudaErrorGraphExecUpdateFailure = 910
    enumerator :: cudaErrorUnknown = 999
    enumerator :: cudaErrorApiFailureBase = 10000
  end enum

end module hipfort_cuda_errors

program hip_saxpy
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_hipblas


  implicit none

  integer :: n = 6
  type(c_ptr) :: handle = c_null_ptr
  integer :: j
  real, allocatable, target, dimension(:) :: x, y, y_exact

  real, parameter :: alpha = 2.0
  type(c_ptr) :: dx = c_null_ptr, dy = c_null_ptr

  integer, parameter :: bytes_per_element = 4 !float precision

  integer(c_size_t) :: Nxbytes
  integer(c_size_t) :: Nybytes

  real :: error
  real, parameter :: error_max = 10*epsilon(error)

  Nxbytes = n * bytes_per_element
  Nybytes = n * bytes_per_element
  allocate(x(n))
  allocate(y(n))
  allocate(y_exact(n))

  do j = 1,n
    x(j) = j
    y(j) = j
  end do

  do j = 1,n
    y_exact(j) = alpha*x(j) + y(j)
  end do
 
  write(*,"(a)",advance="no") "-- Running test 'SAXPY' (Fortran 2003 interfaces) - "

  call hipblasCheck(hipblasCreate(handle))

  call hipCheck(hipMalloc(dx,Nxbytes))
  call hipCheck(hipMalloc(dy,Nybytes))

  call hipCheck(hipMemcpy(dx, c_loc(x(1)), Nxbytes, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(dy, c_loc(y(1)), Nybytes, hipMemcpyHostToDevice))

  call hipblasCheck(hipblasSaxpy(handle,n,alpha,dx,1,dy,1))

  call hipCheck(hipDeviceSynchronize())

  call hipCheck(hipMemcpy(c_loc(y(1)), dy, Nybytes, hipMemcpyDeviceToHost))

  do j = 1,n
    error = abs((y_exact(j) - y(j))/y_exact(j))
      if( error > error_max )then
        write(*,*) "FAILED! Error bigger than max! Error = ", error
        call exit(1)
      end if
  end do

  call hipCheck(hipFree(dx))
  call hipCheck(hipFree(dy))

  call hipblasCheck(hipblasDestroy(handle))

  deallocate(x)
  deallocate(y)

  write(*,*) "PASSED!"

end program hip_saxpy

!!!!!!!!!!!!!/
! dgeqrf example
! see: http:!www.netlib.org/lapack/explore-html/df/dc5/group__variants_g_ecomputational_ga3766ea903391b5cf9008132f7440ec7b.html
!!!!!!!!!!!!!!/
!
program dgeqrf
  use iso_c_binding
  use hipfort
  use hipfort_check
  use hipfort_rocblas
  use hipfort_rocsolver

  implicit none
  integer :: i, j ! indices for iterating over results

  ! Define our input data
  real(c_double), target :: hA(3,3) = reshape((/12, 6, -4, -51, 167, 24, 4, -68, -41/), (/3, 3/))
  real(c_double), target :: hResult(3,3) = reshape((/&
  -14.000000000000000,       -21.000000000000000,        14.000000000000002,&
  0.23076923076923078,       -175.00000000000000,        70.000000000000000,&
 -0.15384615384615385,        5.5555555555555559E-002,  -35.000000000000000/), shape(hResult), order=(/2,1/))
  integer(c_int), parameter :: M = 3
  integer(c_int), parameter :: N = 3
  integer(c_int), parameter :: lda = 3

  real(c_double), target :: hIpiv(3) ! CPU buffer for Householder scalars
  integer(c_size_t) :: size_A = size(hA)
  integer(c_size_t) :: size_Ipiv = size(hIpiv)

  type(c_ptr) :: dA     ! GPU buffer for A
  type(c_ptr) :: dIpiv  ! GPU buffer for Householder scalars

  type(c_ptr) :: handle ! rocblas_handle
    
  real :: error
  real, parameter :: error_max = 10 * epsilon(error_max)
  !
  write(*,"(a)",advance="no") "-- Running test 'rocsolver_dgeqrf' (Fortran 2003 interfaces) - "

  ! Allocate device-side memory
  call hipCheck(hipMalloc(dA, size_A * 8))
  call hipCheck(hipMalloc(dIpiv, size_Ipiv * 8))

  ! Create rocBLAS handle
  call hipCheck(rocblas_create_handle(handle))

  ! Copy memory from host to device
  call hipCheck(hipMemcpy(dA, c_loc(hA(1,1)), size_A * 8, hipMemcpyHostToDevice))

  ! Compute the QR factorization on the devi ce
  call hipCheck(rocsolver_dgeqrf(handle, M, N, dA, lda, dIpiv))

  ! Copy result from device to host
  call hipCheck(hipMemcpy(c_loc(hA(1,1)), dA, size_A * 8, hipMemcpyDeviceToHost))
  call hipCheck(hipMemcpy(c_loc(hIpiv(1)), dIpiv, size_Ipiv * 8, hipMemcpyDeviceToHost))

  ! Output results
  do j = 1,size(hA,2)
    do i = 1,size(hA,1)
        error = abs(hA(i,j) - hResult(i,j))
        if(error .gt. error_max) then
            write(*,*) "FAILED! Error bigger than max! Error = ", error, " hA(", i, ",", j, ") = ", hA(i,j)
            call exit
        end if
      ! print *, (hA(i,j), j=1,size(hA,2))
      ! print *, (hResult(i,j), j=1,size(hA,2))
    end do
  end do

  ! Clean up
  call hipCheck(hipFree(dA))
  call hipCheck(hipFree(dIpiv))
  call hipCheck(rocblas_destroy_handle(handle))
  call hipCheck(hipDeviceReset())
    
  write(*,*) "PASSED!"

end program dgeqrf

program fortran_hip
  use hipfort
  use hipfort_check
  
  implicit none

  interface
     ! dim3(320), dim3(256), 0, 0
     subroutine launch(grid,block,shmem,stream,out,a,b,N) bind(c)
       use iso_c_binding
       use hipfort_types
       implicit none
       type(c_ptr),value :: a, b, out
       integer(c_int), value :: N, shmem
       type(dim3) :: grid, block
       type(c_ptr),value :: stream
     end subroutine
  end interface

  integer(c_int), parameter :: N = 1000000

  real(8),allocatable,dimension(:) :: a,b,out
  real(8),pointer,dimension(:) :: da => null(), db => null(),dout => null()

  !type(dim3) :: grid  = dim3(320,1,1) 
  !type(dim3) :: block = dim3(256,1,1) 
  
  integer :: i
  type(hipDeviceProp_t),target :: props
  !
  call hipCheck(hipGetDeviceProperties(props,0))  
  write(*,"(a)",advance="no") "-- Running test 'vecadd' (Fortran 2008 interfaces)"
  write(*,"(a)",advance="no") "- device: "
  i=1
  do while ( iachar(props%name(i)) .ne. 0 ) ! print till end char
    write(*,"(a)",advance="no") props%name(i)
    i = i+1
  end do 
  write(*,"(a)",advance="no") " - "

  ! Allocate host memory
  allocate(a(N),b(N),out(N))

  ! Initialize host arrays
  a(:) = 1.0
  b(:) = 1.0

  ! Allocate array space on the device
  call hipCheck(hipMalloc(da,N))
  call hipCheck(hipMalloc(db,N))
  call hipCheck(hipMalloc(dout,N))

  ! Transfer data from host to device memory
  call hipCheck(hipMemcpy(da, a, N, hipMemcpyHostToDevice))
  call hipCheck(hipMemcpy(db, b, N, hipMemcpyHostToDevice))

  ! launch kernel
  call launch(dim3(320),dim3(256),0,c_null_ptr,c_loc(dout),c_loc(da),c_loc(db),N)
  !call launch(grid,block,0,c_null_ptr,c_loc(dout),c_loc(da),c_loc(db),N)
  call hipCheck(hipDeviceSynchronize())

  ! Transfer data back to host memory
  call hipCheck(hipMemcpy(out, dout, N, hipMemcpyDeviceToHost))

  if ( sum(out) .eq. N*2.0 ) then
     print *, "PASSED!"
  else
     print *, "FAILED!"
  endif

  call hipCheck(hipFree(da))
  call hipCheck(hipFree(db))
  call hipCheck(hipFree(dout))

  ! Deallocate host memory
  deallocate(a,b,out)

end program fortran_hip

# rocSPARSE API Support

\# | API Name | Variants
----|---------------|---------
1 | [rocsparse_create_handle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__handle.html "Interface documentation") | C binding
2 | [rocsparse_destroy_handle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__destroy__handle.html "Interface documentation") | C binding
3 | [rocsparse_set_stream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__set__stream.html "Interface documentation") | C binding
4 | [rocsparse_get_stream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__get__stream.html "Interface documentation") | C binding
5 | [rocsparse_set_pointer_mode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__set__pointer__mode.html "Interface documentation") | C binding
6 | [rocsparse_get_pointer_mode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__get__pointer__mode.html "Interface documentation") | C binding
7 | [rocsparse_get_version](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__get__version.html "Interface documentation") | C binding
8 | [rocsparse_get_git_rev](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__get__git__rev.html "Interface documentation") | C binding
9 | [rocsparse_create_mat_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__mat__descr.html "Interface documentation") | C binding
10 | [rocsparse_copy_mat_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__copy__mat__descr.html "Interface documentation") | C binding
11 | [rocsparse_destroy_mat_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__destroy__mat__descr.html "Interface documentation") | C binding
12 | [rocsparse_set_mat_index_base](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__set__mat__index__base.html "Interface documentation") | C binding
13 | [rocsparse_set_mat_type](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__set__mat__type.html "Interface documentation") | C binding
14 | [rocsparse_set_mat_fill_mode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__set__mat__fill__mode.html "Interface documentation") | C binding
15 | [rocsparse_set_mat_diag_type](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__set__mat__diag__type.html "Interface documentation") | C binding
16 | [rocsparse_create_hyb_mat](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__hyb__mat.html "Interface documentation") | C binding
17 | [rocsparse_destroy_hyb_mat](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__destroy__hyb__mat.html "Interface documentation") | C binding
18 | [rocsparse_create_mat_info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__mat__info.html "Interface documentation") | C binding
19 | [rocsparse_destroy_mat_info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__destroy__mat__info.html "Interface documentation") | C binding
20 | [rocsparse_create_color_info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__color__info.html "Interface documentation") | C binding
21 | [rocsparse_destroy_color_info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__destroy__color__info.html "Interface documentation") | C binding
22 | [rocsparse_create_spvec_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__spvec__descr.html "Interface documentation") | C binding
23 | [rocsparse_destroy_spvec_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__destroy__spvec__descr.html "Interface documentation") | C binding
24 | [rocsparse_spvec_get](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spvec__get.html "Interface documentation") | C binding
25 | [rocsparse_spvec_get_index_base](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spvec__get__index__base.html "Interface documentation") | C binding
26 | [rocsparse_spvec_get_values](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spvec__get__values.html "Interface documentation") | C binding
27 | [rocsparse_spvec_set_values](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spvec__set__values.html "Interface documentation") | C binding
28 | [rocsparse_create_coo_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__coo__descr.html "Interface documentation") | C binding
29 | [rocsparse_create_coo_aos_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__coo__aos__descr.html "Interface documentation") | C binding
30 | [rocsparse_create_csr_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__csr__descr.html "Interface documentation") | C binding
31 | [rocsparse_create_csc_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__csc__descr.html "Interface documentation") | C binding
32 | [rocsparse_create_ell_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__ell__descr.html "Interface documentation") | C binding
33 | [rocsparse_create_bell_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__bell__descr.html "Interface documentation") | C binding
34 | [rocsparse_destroy_spmat_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__destroy__spmat__descr.html "Interface documentation") | C binding
35 | [rocsparse_coo_aos_get](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__coo__aos__get.html "Interface documentation") | C binding
36 | [rocsparse_coo_get](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__coo__get.html "Interface documentation") | C binding
37 | [rocsparse_csr_get](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csr__get.html "Interface documentation") | C binding
38 | [rocsparse_ell_get](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ell__get.html "Interface documentation") | C binding
39 | [rocsparse_bell_get](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__bell__get.html "Interface documentation") | C binding
40 | [rocsparse_coo_set_pointers](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__coo__set__pointers.html "Interface documentation") | C binding
41 | [rocsparse_coo_aos_set_pointers](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__coo__aos__set__pointers.html "Interface documentation") | C binding
42 | [rocsparse_csr_set_pointers](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csr__set__pointers.html "Interface documentation") | C binding
43 | [rocsparse_csc_set_pointers](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csc__set__pointers.html "Interface documentation") | C binding
44 | [rocsparse_ell_set_pointers](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ell__set__pointers.html "Interface documentation") | C binding
45 | [rocsparse_spmat_get_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spmat__get__size.html "Interface documentation") | C binding
46 | [rocsparse_spmat_get_format](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spmat__get__format.html "Interface documentation") | C binding
47 | [rocsparse_spmat_get_index_base](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spmat__get__index__base.html "Interface documentation") | C binding
48 | [rocsparse_spmat_get_values](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spmat__get__values.html "Interface documentation") | C binding
49 | [rocsparse_spmat_set_values](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spmat__set__values.html "Interface documentation") | C binding
50 | [rocsparse_spmat_get_attribute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spmat__get__attribute.html "Interface documentation") | C binding
51 | [rocsparse_spmat_set_attribute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spmat__set__attribute.html "Interface documentation") | C binding
52 | [rocsparse_create_dnvec_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__dnvec__descr.html "Interface documentation") | C binding
53 | [rocsparse_destroy_dnvec_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__destroy__dnvec__descr.html "Interface documentation") | C binding
54 | [rocsparse_dnvec_get](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dnvec__get.html "Interface documentation") | C binding
55 | [rocsparse_dnvec_get_values](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dnvec__get__values.html "Interface documentation") | C binding
56 | [rocsparse_dnvec_set_values](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dnvec__set__values.html "Interface documentation") | C binding
57 | [rocsparse_create_dnmat_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__dnmat__descr.html "Interface documentation") | C binding
58 | [rocsparse_destroy_dnmat_descr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__destroy__dnmat__descr.html "Interface documentation") | C binding
59 | [rocsparse_dnmat_get](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dnmat__get.html "Interface documentation") | C binding
60 | [rocsparse_dnmat_get_values](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dnmat__get__values.html "Interface documentation") | C binding
61 | [rocsparse_dnmat_set_values](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dnmat__set__values.html "Interface documentation") | C binding
62 | [rocsparse_saxpyi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__saxpyi.html "Interface documentation") | C binding, rank_0, rank_1
63 | [rocsparse_daxpyi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__daxpyi.html "Interface documentation") | C binding, rank_0, rank_1
64 | [rocsparse_caxpyi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__caxpyi.html "Interface documentation") | C binding, rank_0, rank_1
65 | [rocsparse_zaxpyi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zaxpyi.html "Interface documentation") | C binding, rank_0, rank_1
66 | [rocsparse_sdoti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sdoti.html "Interface documentation") | C binding, rank_0, rank_1
67 | [rocsparse_ddoti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ddoti.html "Interface documentation") | C binding, rank_0, rank_1
68 | [rocsparse_cdoti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cdoti.html "Interface documentation") | C binding, rank_0, rank_1
69 | [rocsparse_zdoti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zdoti.html "Interface documentation") | C binding, rank_0, rank_1
70 | [rocsparse_cdotci](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cdotci.html "Interface documentation") | C binding, rank_0, rank_1
71 | [rocsparse_zdotci](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zdotci.html "Interface documentation") | C binding, rank_0, rank_1
72 | [rocsparse_sgthr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgthr.html "Interface documentation") | C binding, rank_0, rank_1
73 | [rocsparse_dgthr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgthr.html "Interface documentation") | C binding, rank_0, rank_1
74 | [rocsparse_cgthr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgthr.html "Interface documentation") | C binding, rank_0, rank_1
75 | [rocsparse_zgthr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgthr.html "Interface documentation") | C binding, rank_0, rank_1
76 | [rocsparse_sgthrz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgthrz.html "Interface documentation") | C binding, rank_0, rank_1
77 | [rocsparse_dgthrz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgthrz.html "Interface documentation") | C binding, rank_0, rank_1
78 | [rocsparse_cgthrz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgthrz.html "Interface documentation") | C binding, rank_0, rank_1
79 | [rocsparse_zgthrz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgthrz.html "Interface documentation") | C binding, rank_0, rank_1
80 | [rocsparse_sroti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sroti.html "Interface documentation") | C binding, rank_0, rank_1
81 | [rocsparse_droti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__droti.html "Interface documentation") | C binding, rank_0, rank_1
82 | [rocsparse_ssctr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ssctr.html "Interface documentation") | C binding, rank_0, rank_1
83 | [rocsparse_dsctr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dsctr.html "Interface documentation") | C binding, rank_0, rank_1
84 | [rocsparse_csctr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csctr.html "Interface documentation") | C binding, rank_0, rank_1
85 | [rocsparse_zsctr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zsctr.html "Interface documentation") | C binding, rank_0, rank_1
86 | [rocsparse_isctr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__isctr.html "Interface documentation") | C binding, rank_0, rank_1
87 | [rocsparse_sbsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrmv.html "Interface documentation") | C binding, rank_0, rank_1
88 | [rocsparse_dbsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrmv.html "Interface documentation") | C binding, rank_0, rank_1
89 | [rocsparse_cbsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrmv.html "Interface documentation") | C binding, rank_0, rank_1
90 | [rocsparse_zbsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrmv.html "Interface documentation") | C binding, rank_0, rank_1
91 | [rocsparse_sbsrxmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrxmv.html "Interface documentation") | C binding, rank_0, rank_1
92 | [rocsparse_dbsrxmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrxmv.html "Interface documentation") | C binding, rank_0, rank_1
93 | [rocsparse_cbsrxmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrxmv.html "Interface documentation") | C binding, rank_0, rank_1
94 | [rocsparse_zbsrxmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrxmv.html "Interface documentation") | C binding, rank_0, rank_1
95 | [rocsparse_bsrsv_zero_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__bsrsv__zero__pivot.html "Interface documentation") | C binding
96 | [rocsparse_sbsrsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrsv__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
97 | [rocsparse_dbsrsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrsv__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
98 | [rocsparse_cbsrsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrsv__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
99 | [rocsparse_zbsrsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrsv__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
100 | [rocsparse_sbsrsv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrsv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
101 | [rocsparse_dbsrsv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrsv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
102 | [rocsparse_cbsrsv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrsv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
103 | [rocsparse_zbsrsv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrsv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
104 | [rocsparse_bsrsv_clear](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__bsrsv__clear.html "Interface documentation") | C binding
105 | [rocsparse_sbsrsv_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrsv__solve.html "Interface documentation") | C binding, rank_0, rank_1
106 | [rocsparse_dbsrsv_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrsv__solve.html "Interface documentation") | C binding, rank_0, rank_1
107 | [rocsparse_cbsrsv_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrsv__solve.html "Interface documentation") | C binding, rank_0, rank_1
108 | [rocsparse_zbsrsv_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrsv__solve.html "Interface documentation") | C binding, rank_0, rank_1
109 | [rocsparse_scoomv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scoomv.html "Interface documentation") | C binding, rank_0, rank_1
110 | [rocsparse_dcoomv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcoomv.html "Interface documentation") | C binding, rank_0, rank_1
111 | [rocsparse_ccoomv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccoomv.html "Interface documentation") | C binding, rank_0, rank_1
112 | [rocsparse_zcoomv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcoomv.html "Interface documentation") | C binding, rank_0, rank_1
113 | [rocsparse_scsrmv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrmv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
114 | [rocsparse_dcsrmv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrmv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
115 | [rocsparse_ccsrmv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrmv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
116 | [rocsparse_zcsrmv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrmv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
117 | [rocsparse_csrmv_clear](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrmv__clear.html "Interface documentation") | C binding
118 | [rocsparse_scsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrmv.html "Interface documentation") | C binding, rank_0, rank_1
119 | [rocsparse_dcsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrmv.html "Interface documentation") | C binding, rank_0, rank_1
120 | [rocsparse_ccsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrmv.html "Interface documentation") | C binding, rank_0, rank_1
121 | [rocsparse_zcsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrmv.html "Interface documentation") | C binding, rank_0, rank_1
122 | [rocsparse_csrsv_zero_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrsv__zero__pivot.html "Interface documentation") | C binding
123 | [rocsparse_scsrsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrsv__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
124 | [rocsparse_dcsrsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrsv__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
125 | [rocsparse_ccsrsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrsv__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
126 | [rocsparse_zcsrsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrsv__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
127 | [rocsparse_scsrsv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrsv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
128 | [rocsparse_dcsrsv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrsv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
129 | [rocsparse_ccsrsv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrsv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
130 | [rocsparse_zcsrsv_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrsv__analysis.html "Interface documentation") | C binding, rank_0, rank_1
131 | [rocsparse_csrsv_clear](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrsv__clear.html "Interface documentation") | C binding
132 | [rocsparse_scsrsv_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrsv__solve.html "Interface documentation") | C binding, rank_0, rank_1
133 | [rocsparse_dcsrsv_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrsv__solve.html "Interface documentation") | C binding, rank_0, rank_1
134 | [rocsparse_ccsrsv_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrsv__solve.html "Interface documentation") | C binding, rank_0, rank_1
135 | [rocsparse_zcsrsv_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrsv__solve.html "Interface documentation") | C binding, rank_0, rank_1
136 | [rocsparse_sellmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sellmv.html "Interface documentation") | C binding, rank_0, rank_1
137 | [rocsparse_dellmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dellmv.html "Interface documentation") | C binding, rank_0, rank_1
138 | [rocsparse_cellmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cellmv.html "Interface documentation") | C binding, rank_0, rank_1
139 | [rocsparse_zellmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zellmv.html "Interface documentation") | C binding, rank_0, rank_1
140 | [rocsparse_shybmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__shybmv.html "Interface documentation") | C binding, rank_0, rank_1
141 | [rocsparse_dhybmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dhybmv.html "Interface documentation") | C binding, rank_0, rank_1
142 | [rocsparse_chybmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__chybmv.html "Interface documentation") | C binding, rank_0, rank_1
143 | [rocsparse_zhybmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zhybmv.html "Interface documentation") | C binding, rank_0, rank_1
144 | [rocsparse_sgebsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgebsrmv.html "Interface documentation") | C binding, rank_0, rank_1
145 | [rocsparse_dgebsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgebsrmv.html "Interface documentation") | C binding, rank_0, rank_1
146 | [rocsparse_cgebsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgebsrmv.html "Interface documentation") | C binding, rank_0, rank_1
147 | [rocsparse_zgebsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgebsrmv.html "Interface documentation") | C binding, rank_0, rank_1
148 | [rocsparse_sgemvi_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgemvi__buffer__size.html "Interface documentation") | C binding
149 | [rocsparse_dgemvi_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgemvi__buffer__size.html "Interface documentation") | C binding
150 | [rocsparse_cgemvi_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgemvi__buffer__size.html "Interface documentation") | C binding
151 | [rocsparse_zgemvi_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgemvi__buffer__size.html "Interface documentation") | C binding
152 | [rocsparse_sgemvi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgemvi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
153 | [rocsparse_dgemvi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgemvi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
154 | [rocsparse_cgemvi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgemvi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
155 | [rocsparse_zgemvi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgemvi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
156 | [rocsparse_sbsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
157 | [rocsparse_dbsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
158 | [rocsparse_cbsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
159 | [rocsparse_zbsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
160 | [rocsparse_sgebsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgebsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
161 | [rocsparse_dgebsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgebsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
162 | [rocsparse_cgebsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgebsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
163 | [rocsparse_zgebsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgebsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
164 | [rocsparse_scsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
165 | [rocsparse_dcsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
166 | [rocsparse_ccsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
167 | [rocsparse_zcsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
168 | [rocsparse_csrsm_zero_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrsm__zero__pivot.html "Interface documentation") | C binding
169 | [rocsparse_scsrsm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrsm__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
170 | [rocsparse_dcsrsm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrsm__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
171 | [rocsparse_ccsrsm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrsm__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
172 | [rocsparse_zcsrsm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrsm__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
173 | [rocsparse_scsrsm_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrsm__analysis.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
174 | [rocsparse_dcsrsm_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrsm__analysis.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
175 | [rocsparse_ccsrsm_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrsm__analysis.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
176 | [rocsparse_zcsrsm_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrsm__analysis.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
177 | [rocsparse_csrsm_clear](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrsm__clear.html "Interface documentation") | C binding
178 | [rocsparse_scsrsm_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrsm__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
179 | [rocsparse_dcsrsm_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrsm__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
180 | [rocsparse_ccsrsm_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrsm__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
181 | [rocsparse_zcsrsm_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrsm__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
182 | [rocsparse_bsrsm_zero_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__bsrsm__zero__pivot.html "Interface documentation") | C binding
183 | [rocsparse_sbsrsm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrsm__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
184 | [rocsparse_dbsrsm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrsm__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
185 | [rocsparse_cbsrsm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrsm__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
186 | [rocsparse_zbsrsm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrsm__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
187 | [rocsparse_sbsrsm_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrsm__analysis.html "Interface documentation") | C binding, rank_0, rank_1
188 | [rocsparse_dbsrsm_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrsm__analysis.html "Interface documentation") | C binding, rank_0, rank_1
189 | [rocsparse_cbsrsm_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrsm__analysis.html "Interface documentation") | C binding, rank_0, rank_1
190 | [rocsparse_zbsrsm_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrsm__analysis.html "Interface documentation") | C binding, rank_0, rank_1
191 | [rocsparse_bsrsm_clear](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__bsrsm__clear.html "Interface documentation") | C binding
192 | [rocsparse_sbsrsm_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrsm__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
193 | [rocsparse_dbsrsm_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrsm__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
194 | [rocsparse_cbsrsm_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrsm__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
195 | [rocsparse_zbsrsm_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrsm__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
196 | [rocsparse_sgemmi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgemmi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
197 | [rocsparse_dgemmi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgemmi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
198 | [rocsparse_cgemmi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgemmi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
199 | [rocsparse_zgemmi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgemmi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
200 | [rocsparse_csrgeam_nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrgeam__nnz.html "Interface documentation") | C binding, rank_0, rank_1
201 | [rocsparse_scsrgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrgeam.html "Interface documentation") | C binding, rank_0, rank_1
202 | [rocsparse_dcsrgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrgeam.html "Interface documentation") | C binding, rank_0, rank_1
203 | [rocsparse_ccsrgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrgeam.html "Interface documentation") | C binding, rank_0, rank_1
204 | [rocsparse_zcsrgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrgeam.html "Interface documentation") | C binding, rank_0, rank_1
205 | [rocsparse_scsrgemm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrgemm__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
206 | [rocsparse_dcsrgemm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrgemm__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
207 | [rocsparse_ccsrgemm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrgemm__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
208 | [rocsparse_zcsrgemm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrgemm__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
209 | [rocsparse_csrgemm_nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrgemm__nnz.html "Interface documentation") | C binding, rank_0, rank_1
210 | [rocsparse_scsrgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrgemm.html "Interface documentation") | C binding, rank_0, rank_1
211 | [rocsparse_dcsrgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrgemm.html "Interface documentation") | C binding, rank_0, rank_1
212 | [rocsparse_ccsrgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrgemm.html "Interface documentation") | C binding, rank_0, rank_1
213 | [rocsparse_zcsrgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrgemm.html "Interface documentation") | C binding, rank_0, rank_1
214 | [rocsparse_bsric0_zero_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__bsric0__zero__pivot.html "Interface documentation") | C binding
215 | [rocsparse_sbsric0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsric0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
216 | [rocsparse_dbsric0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsric0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
217 | [rocsparse_cbsric0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsric0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
218 | [rocsparse_zbsric0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsric0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
219 | [rocsparse_sbsric0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsric0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
220 | [rocsparse_dbsric0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsric0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
221 | [rocsparse_cbsric0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsric0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
222 | [rocsparse_zbsric0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsric0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
223 | [rocsparse_bsric0_clear](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__bsric0__clear.html "Interface documentation") | C binding
224 | [rocsparse_sbsric0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsric0.html "Interface documentation") | C binding, rank_0, rank_1
225 | [rocsparse_dbsric0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsric0.html "Interface documentation") | C binding, rank_0, rank_1
226 | [rocsparse_cbsric0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsric0.html "Interface documentation") | C binding, rank_0, rank_1
227 | [rocsparse_zbsric0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsric0.html "Interface documentation") | C binding, rank_0, rank_1
228 | [rocsparse_bsrilu0_zero_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__bsrilu0__zero__pivot.html "Interface documentation") | C binding
229 | [rocsparse_sbsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrilu0__numeric__boost.html "Interface documentation") | C binding
230 | [rocsparse_dbsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrilu0__numeric__boost.html "Interface documentation") | C binding
231 | [rocsparse_cbsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrilu0__numeric__boost.html "Interface documentation") | C binding
232 | [rocsparse_zbsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrilu0__numeric__boost.html "Interface documentation") | C binding
233 | [rocsparse_dsbsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dsbsrilu0__numeric__boost.html "Interface documentation") | C binding
234 | [rocsparse_dcbsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcbsrilu0__numeric__boost.html "Interface documentation") | C binding
235 | [rocsparse_sbsrilu0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrilu0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
236 | [rocsparse_dbsrilu0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrilu0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
237 | [rocsparse_cbsrilu0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrilu0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
238 | [rocsparse_zbsrilu0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrilu0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
239 | [rocsparse_sbsrilu0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrilu0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
240 | [rocsparse_dbsrilu0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrilu0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
241 | [rocsparse_cbsrilu0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrilu0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
242 | [rocsparse_zbsrilu0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrilu0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
243 | [rocsparse_bsrilu0_clear](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__bsrilu0__clear.html "Interface documentation") | C binding
244 | [rocsparse_sbsrilu0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsrilu0.html "Interface documentation") | C binding, rank_0, rank_1
245 | [rocsparse_dbsrilu0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsrilu0.html "Interface documentation") | C binding, rank_0, rank_1
246 | [rocsparse_cbsrilu0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsrilu0.html "Interface documentation") | C binding, rank_0, rank_1
247 | [rocsparse_zbsrilu0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsrilu0.html "Interface documentation") | C binding, rank_0, rank_1
248 | [rocsparse_csric0_zero_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csric0__zero__pivot.html "Interface documentation") | C binding
249 | [rocsparse_scsric0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsric0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
250 | [rocsparse_dcsric0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsric0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
251 | [rocsparse_ccsric0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsric0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
252 | [rocsparse_zcsric0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsric0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
253 | [rocsparse_scsric0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsric0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
254 | [rocsparse_dcsric0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsric0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
255 | [rocsparse_ccsric0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsric0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
256 | [rocsparse_zcsric0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsric0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
257 | [rocsparse_csric0_clear](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csric0__clear.html "Interface documentation") | C binding
258 | [rocsparse_scsric0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsric0.html "Interface documentation") | C binding, rank_0, rank_1
259 | [rocsparse_dcsric0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsric0.html "Interface documentation") | C binding, rank_0, rank_1
260 | [rocsparse_ccsric0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsric0.html "Interface documentation") | C binding, rank_0, rank_1
261 | [rocsparse_zcsric0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsric0.html "Interface documentation") | C binding, rank_0, rank_1
262 | [rocsparse_csrilu0_zero_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrilu0__zero__pivot.html "Interface documentation") | C binding
263 | [rocsparse_scsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrilu0__numeric__boost.html "Interface documentation") | C binding
264 | [rocsparse_dcsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrilu0__numeric__boost.html "Interface documentation") | C binding
265 | [rocsparse_ccsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrilu0__numeric__boost.html "Interface documentation") | C binding
266 | [rocsparse_zcsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrilu0__numeric__boost.html "Interface documentation") | C binding
267 | [rocsparse_dscsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dscsrilu0__numeric__boost.html "Interface documentation") | C binding
268 | [rocsparse_dccsrilu0_numeric_boost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dccsrilu0__numeric__boost.html "Interface documentation") | C binding
269 | [rocsparse_scsrilu0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrilu0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
270 | [rocsparse_dcsrilu0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrilu0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
271 | [rocsparse_ccsrilu0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrilu0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
272 | [rocsparse_zcsrilu0_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrilu0__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
273 | [rocsparse_scsrilu0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrilu0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
274 | [rocsparse_dcsrilu0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrilu0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
275 | [rocsparse_ccsrilu0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrilu0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
276 | [rocsparse_zcsrilu0_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrilu0__analysis.html "Interface documentation") | C binding, rank_0, rank_1
277 | [rocsparse_csrilu0_clear](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrilu0__clear.html "Interface documentation") | C binding
278 | [rocsparse_scsrilu0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrilu0.html "Interface documentation") | C binding, rank_0, rank_1
279 | [rocsparse_dcsrilu0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrilu0.html "Interface documentation") | C binding, rank_0, rank_1
280 | [rocsparse_ccsrilu0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrilu0.html "Interface documentation") | C binding, rank_0, rank_1
281 | [rocsparse_zcsrilu0](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrilu0.html "Interface documentation") | C binding, rank_0, rank_1
282 | [rocsparse_sgtsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgtsv__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
283 | [rocsparse_dgtsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgtsv__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
284 | [rocsparse_cgtsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgtsv__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
285 | [rocsparse_zgtsv_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgtsv__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
286 | [rocsparse_sgtsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgtsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
287 | [rocsparse_dgtsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgtsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
288 | [rocsparse_cgtsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgtsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
289 | [rocsparse_zgtsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgtsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
290 | [rocsparse_sgtsv_no_pivot_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgtsv__no__pivot__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
291 | [rocsparse_dgtsv_no_pivot_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgtsv__no__pivot__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
292 | [rocsparse_cgtsv_no_pivot_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgtsv__no__pivot__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
293 | [rocsparse_zgtsv_no_pivot_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgtsv__no__pivot__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
294 | [rocsparse_sgtsv_no_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgtsv__no__pivot.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
295 | [rocsparse_dgtsv_no_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgtsv__no__pivot.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
296 | [rocsparse_cgtsv_no_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgtsv__no__pivot.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
297 | [rocsparse_zgtsv_no_pivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgtsv__no__pivot.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
298 | [rocsparse_sgtsv_no_pivot_strided_batch_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgtsv__no__pivot__strided__batch__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
299 | [rocsparse_dgtsv_no_pivot_strided_batch_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgtsv__no__pivot__strided__batch__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
300 | [rocsparse_cgtsv_no_pivot_strided_batch_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgtsv__no__pivot__strided__batch__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
301 | [rocsparse_zgtsv_no_pivot_strided_batch_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgtsv__no__pivot__strided__batch__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
302 | [rocsparse_sgtsv_no_pivot_strided_batch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgtsv__no__pivot__strided__batch.html "Interface documentation") | C binding, rank_0, rank_1
303 | [rocsparse_dgtsv_no_pivot_strided_batch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgtsv__no__pivot__strided__batch.html "Interface documentation") | C binding, rank_0, rank_1
304 | [rocsparse_cgtsv_no_pivot_strided_batch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgtsv__no__pivot__strided__batch.html "Interface documentation") | C binding, rank_0, rank_1
305 | [rocsparse_zgtsv_no_pivot_strided_batch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgtsv__no__pivot__strided__batch.html "Interface documentation") | C binding, rank_0, rank_1
306 | [rocsparse_snnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__snnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
307 | [rocsparse_dnnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dnnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
308 | [rocsparse_cnnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cnnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
309 | [rocsparse_znnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__znnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
310 | [rocsparse_sdense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sdense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
311 | [rocsparse_ddense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ddense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
312 | [rocsparse_cdense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cdense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
313 | [rocsparse_zdense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zdense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
314 | [rocsparse_sprune_dense2csr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__dense2csr__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
315 | [rocsparse_dprune_dense2csr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__dense2csr__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
316 | [rocsparse_sprune_dense2csr_nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__dense2csr__nnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
317 | [rocsparse_dprune_dense2csr_nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__dense2csr__nnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
318 | [rocsparse_sprune_dense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__dense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
319 | [rocsparse_dprune_dense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__dense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
320 | [rocsparse_sprune_dense2csr_by_percentage_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__dense2csr__by__percentage__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
321 | [rocsparse_dprune_dense2csr_by_percentage_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__dense2csr__by__percentage__buffer__size.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
322 | [rocsparse_sprune_dense2csr_nnz_by_percentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__dense2csr__nnz__by__percentage.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
323 | [rocsparse_dprune_dense2csr_nnz_by_percentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__dense2csr__nnz__by__percentage.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
324 | [rocsparse_sprune_dense2csr_by_percentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__dense2csr__by__percentage.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
325 | [rocsparse_dprune_dense2csr_by_percentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__dense2csr__by__percentage.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
326 | [rocsparse_sdense2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sdense2csc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
327 | [rocsparse_ddense2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ddense2csc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
328 | [rocsparse_cdense2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cdense2csc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
329 | [rocsparse_zdense2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zdense2csc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
330 | [rocsparse_sdense2coo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sdense2coo.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
331 | [rocsparse_ddense2coo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ddense2coo.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
332 | [rocsparse_cdense2coo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cdense2coo.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
333 | [rocsparse_zdense2coo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zdense2coo.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
334 | [rocsparse_scsr2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsr2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
335 | [rocsparse_dcsr2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsr2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
336 | [rocsparse_ccsr2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsr2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
337 | [rocsparse_zcsr2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsr2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
338 | [rocsparse_scsc2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsc2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
339 | [rocsparse_dcsc2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsc2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
340 | [rocsparse_ccsc2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsc2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
341 | [rocsparse_zcsc2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsc2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
342 | [rocsparse_scoo2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scoo2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
343 | [rocsparse_dcoo2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcoo2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
344 | [rocsparse_ccoo2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccoo2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
345 | [rocsparse_zcoo2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcoo2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
346 | [rocsparse_snnz_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__snnz__compress.html "Interface documentation") | C binding, rank_0, rank_1
347 | [rocsparse_dnnz_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dnnz__compress.html "Interface documentation") | C binding, rank_0, rank_1
348 | [rocsparse_cnnz_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cnnz__compress.html "Interface documentation") | C binding, rank_0, rank_1
349 | [rocsparse_znnz_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__znnz__compress.html "Interface documentation") | C binding, rank_0, rank_1
350 | [rocsparse_csr2coo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csr2coo.html "Interface documentation") | C binding, rank_0, rank_1
351 | [rocsparse_csr2csc_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csr2csc__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
352 | [rocsparse_scsr2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsr2csc.html "Interface documentation") | C binding, rank_0, rank_1
353 | [rocsparse_dcsr2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsr2csc.html "Interface documentation") | C binding, rank_0, rank_1
354 | [rocsparse_ccsr2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsr2csc.html "Interface documentation") | C binding, rank_0, rank_1
355 | [rocsparse_zcsr2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsr2csc.html "Interface documentation") | C binding, rank_0, rank_1
356 | [rocsparse_sgebsr2gebsc_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgebsr2gebsc__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
357 | [rocsparse_dgebsr2gebsc_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgebsr2gebsc__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
358 | [rocsparse_cgebsr2gebsc_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgebsr2gebsc__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
359 | [rocsparse_zgebsr2gebsc_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgebsr2gebsc__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
360 | [rocsparse_sgebsr2gebsc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgebsr2gebsc.html "Interface documentation") | C binding, rank_0, rank_1
361 | [rocsparse_dgebsr2gebsc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgebsr2gebsc.html "Interface documentation") | C binding, rank_0, rank_1
362 | [rocsparse_cgebsr2gebsc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgebsr2gebsc.html "Interface documentation") | C binding, rank_0, rank_1
363 | [rocsparse_zgebsr2gebsc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgebsr2gebsc.html "Interface documentation") | C binding, rank_0, rank_1
364 | [rocsparse_csr2ell_width](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csr2ell__width.html "Interface documentation") | C binding, rank_0, rank_1
365 | [rocsparse_scsr2ell](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsr2ell.html "Interface documentation") | C binding, rank_0, rank_1
366 | [rocsparse_dcsr2ell](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsr2ell.html "Interface documentation") | C binding, rank_0, rank_1
367 | [rocsparse_ccsr2ell](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsr2ell.html "Interface documentation") | C binding, rank_0, rank_1
368 | [rocsparse_zcsr2ell](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsr2ell.html "Interface documentation") | C binding, rank_0, rank_1
369 | [rocsparse_scsr2hyb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsr2hyb.html "Interface documentation") | C binding, rank_0, rank_1
370 | [rocsparse_dcsr2hyb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsr2hyb.html "Interface documentation") | C binding, rank_0, rank_1
371 | [rocsparse_ccsr2hyb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsr2hyb.html "Interface documentation") | C binding, rank_0, rank_1
372 | [rocsparse_zcsr2hyb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsr2hyb.html "Interface documentation") | C binding, rank_0, rank_1
373 | [rocsparse_csr2bsr_nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csr2bsr__nnz.html "Interface documentation") | C binding, rank_0, rank_1
374 | [rocsparse_scsr2bsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsr2bsr.html "Interface documentation") | C binding, rank_0, rank_1
375 | [rocsparse_dcsr2bsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsr2bsr.html "Interface documentation") | C binding, rank_0, rank_1
376 | [rocsparse_ccsr2bsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsr2bsr.html "Interface documentation") | C binding, rank_0, rank_1
377 | [rocsparse_zcsr2bsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsr2bsr.html "Interface documentation") | C binding, rank_0, rank_1
378 | [rocsparse_scsr2gebsr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsr2gebsr__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
379 | [rocsparse_dcsr2gebsr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsr2gebsr__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
380 | [rocsparse_ccsr2gebsr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsr2gebsr__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
381 | [rocsparse_zcsr2gebsr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsr2gebsr__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
382 | [rocsparse_csr2gebsr_nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csr2gebsr__nnz.html "Interface documentation") | C binding, rank_0, rank_1
383 | [rocsparse_scsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
384 | [rocsparse_dcsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
385 | [rocsparse_ccsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
386 | [rocsparse_zcsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
387 | [rocsparse_scsr2csr_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsr2csr__compress.html "Interface documentation") | C binding, rank_0, rank_1
388 | [rocsparse_dcsr2csr_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsr2csr__compress.html "Interface documentation") | C binding, rank_0, rank_1
389 | [rocsparse_ccsr2csr_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsr2csr__compress.html "Interface documentation") | C binding, rank_0, rank_1
390 | [rocsparse_zcsr2csr_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsr2csr__compress.html "Interface documentation") | C binding, rank_0, rank_1
391 | [rocsparse_sprune_csr2csr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__csr2csr__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
392 | [rocsparse_dprune_csr2csr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__csr2csr__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
393 | [rocsparse_sprune_csr2csr_nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__csr2csr__nnz.html "Interface documentation") | C binding, rank_0, rank_1
394 | [rocsparse_dprune_csr2csr_nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__csr2csr__nnz.html "Interface documentation") | C binding, rank_0, rank_1
395 | [rocsparse_sprune_csr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__csr2csr.html "Interface documentation") | C binding, rank_0, rank_1
396 | [rocsparse_dprune_csr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__csr2csr.html "Interface documentation") | C binding, rank_0, rank_1
397 | [rocsparse_sprune_csr2csr_by_percentage_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__csr2csr__by__percentage__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
398 | [rocsparse_dprune_csr2csr_by_percentage_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__csr2csr__by__percentage__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
399 | [rocsparse_sprune_csr2csr_nnz_by_percentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__csr2csr__nnz__by__percentage.html "Interface documentation") | C binding, rank_0, rank_1
400 | [rocsparse_dprune_csr2csr_nnz_by_percentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__csr2csr__nnz__by__percentage.html "Interface documentation") | C binding, rank_0, rank_1
401 | [rocsparse_sprune_csr2csr_by_percentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sprune__csr2csr__by__percentage.html "Interface documentation") | C binding, rank_0, rank_1
402 | [rocsparse_dprune_csr2csr_by_percentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dprune__csr2csr__by__percentage.html "Interface documentation") | C binding, rank_0, rank_1
403 | [rocsparse_coo2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__coo2csr.html "Interface documentation") | C binding, rank_0, rank_1
404 | [rocsparse_ell2csr_nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ell2csr__nnz.html "Interface documentation") | C binding, rank_0, rank_1
405 | [rocsparse_sell2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sell2csr.html "Interface documentation") | C binding, rank_0, rank_1
406 | [rocsparse_dell2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dell2csr.html "Interface documentation") | C binding, rank_0, rank_1
407 | [rocsparse_cell2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cell2csr.html "Interface documentation") | C binding, rank_0, rank_1
408 | [rocsparse_zell2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zell2csr.html "Interface documentation") | C binding, rank_0, rank_1
409 | [rocsparse_hyb2csr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__hyb2csr__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
410 | [rocsparse_shyb2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__shyb2csr.html "Interface documentation") | C binding, rank_0, rank_1
411 | [rocsparse_dhyb2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dhyb2csr.html "Interface documentation") | C binding, rank_0, rank_1
412 | [rocsparse_chyb2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__chyb2csr.html "Interface documentation") | C binding, rank_0, rank_1
413 | [rocsparse_zhyb2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zhyb2csr.html "Interface documentation") | C binding, rank_0, rank_1
414 | [rocsparse_create_identity_permutation](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__create__identity__permutation.html "Interface documentation") | C binding, rank_0, rank_1
415 | [rocsparse_csrsort_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrsort__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
416 | [rocsparse_csrsort](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__csrsort.html "Interface documentation") | C binding, rank_0, rank_1
417 | [rocsparse_cscsort_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cscsort__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
418 | [rocsparse_cscsort](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cscsort.html "Interface documentation") | C binding, rank_0, rank_1
419 | [rocsparse_coosort_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__coosort__buffer__size.html "Interface documentation") | C binding, rank_0, rank_1
420 | [rocsparse_coosort_by_row](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__coosort__by__row.html "Interface documentation") | C binding, rank_0, rank_1
421 | [rocsparse_coosort_by_column](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__coosort__by__column.html "Interface documentation") | C binding, rank_0, rank_1
422 | [rocsparse_sbsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sbsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
423 | [rocsparse_dbsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dbsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
424 | [rocsparse_cbsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cbsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
425 | [rocsparse_zbsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zbsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
426 | [rocsparse_sgebsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgebsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
427 | [rocsparse_dgebsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgebsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
428 | [rocsparse_cgebsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgebsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
429 | [rocsparse_zgebsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgebsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
430 | [rocsparse_sgebsr2gebsr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgebsr2gebsr__buffer__size.html "Interface documentation") | C binding
431 | [rocsparse_dgebsr2gebsr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgebsr2gebsr__buffer__size.html "Interface documentation") | C binding
432 | [rocsparse_cgebsr2gebsr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgebsr2gebsr__buffer__size.html "Interface documentation") | C binding
433 | [rocsparse_zgebsr2gebsr_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgebsr2gebsr__buffer__size.html "Interface documentation") | C binding
434 | [rocsparse_gebsr2gebsr_nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__gebsr2gebsr__nnz.html "Interface documentation") | C binding
435 | [rocsparse_sgebsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sgebsr2gebsr.html "Interface documentation") | C binding
436 | [rocsparse_dgebsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dgebsr2gebsr.html "Interface documentation") | C binding
437 | [rocsparse_cgebsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__cgebsr2gebsr.html "Interface documentation") | C binding
438 | [rocsparse_zgebsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zgebsr2gebsr.html "Interface documentation") | C binding
439 | [rocsparse_axpby](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__axpby.html "Interface documentation") | C binding
440 | [rocsparse_gather](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__gather.html "Interface documentation") | C binding
441 | [rocsparse_scatter](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scatter.html "Interface documentation") | C binding
442 | [rocsparse_rot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__rot.html "Interface documentation") | C binding
443 | [rocsparse_sparse_to_dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sparse__to__dense.html "Interface documentation") | C binding
444 | [rocsparse_dense_to_sparse](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dense__to__sparse.html "Interface documentation") | C binding
445 | [rocsparse_spvv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spvv.html "Interface documentation") | C binding
446 | [rocsparse_spmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spmv.html "Interface documentation") | C binding
447 | [rocsparse_spsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spsv.html "Interface documentation") | C binding
448 | [rocsparse_spsm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spsm.html "Interface documentation") | C binding
449 | [rocsparse_spmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spmm.html "Interface documentation") | C binding
450 | [rocsparse_spgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__spgemm.html "Interface documentation") | C binding
451 | [rocsparse_sddmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sddmm.html "Interface documentation") | C binding
452 | [rocsparse_sddmm_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sddmm__buffer__size.html "Interface documentation") | C binding
453 | [rocsparse_sddmm_preprocess](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__sddmm__preprocess.html "Interface documentation") | C binding
454 | [rocsparse_scsrcolor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__scsrcolor.html "Interface documentation") | C binding, rank_0, rank_1
455 | [rocsparse_dcsrcolor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__dcsrcolor.html "Interface documentation") | C binding, rank_0, rank_1
456 | [rocsparse_ccsrcolor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__ccsrcolor.html "Interface documentation") | C binding, rank_0, rank_1
457 | [rocsparse_zcsrcolor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsparse_1_1rocsparse__zcsrcolor.html "Interface documentation") | C binding, rank_0, rank_1

# rocBLAS API Support

\# | API Name | Variants
----|---------------|---------
1 | [rocblas_set_vector](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas__auxiliary_1_1rocblas__set__vector.html "Interface documentation") | C binding
2 | [rocblas_get_vector](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas__auxiliary_1_1rocblas__get__vector.html "Interface documentation") | C binding
3 | [rocblas_set_matrix](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas__auxiliary_1_1rocblas__set__matrix.html "Interface documentation") | C binding
4 | [rocblas_get_matrix](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas__auxiliary_1_1rocblas__get__matrix.html "Interface documentation") | C binding
5 | [rocblas_set_vector_async](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas__auxiliary_1_1rocblas__set__vector__async.html "Interface documentation") | C binding
6 | [rocblas_get_vector_async](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas__auxiliary_1_1rocblas__get__vector__async.html "Interface documentation") | C binding
7 | [rocblas_set_matrix_async](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas__auxiliary_1_1rocblas__set__matrix__async.html "Interface documentation") | C binding
8 | [rocblas_get_matrix_async](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas__auxiliary_1_1rocblas__get__matrix__async.html "Interface documentation") | C binding
1 | [rocblas_sscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sscal.html "Interface documentation") | C binding
2 | [rocblas_dscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dscal.html "Interface documentation") | C binding
3 | [rocblas_cscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cscal.html "Interface documentation") | C binding, rank_0, rank_1
4 | [rocblas_zscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zscal.html "Interface documentation") | C binding, rank_0, rank_1
5 | [rocblas_csscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csscal.html "Interface documentation") | C binding, rank_0, rank_1
6 | [rocblas_zdscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdscal.html "Interface documentation") | C binding, rank_0, rank_1
7 | [rocblas_sscal_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sscal__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
8 | [rocblas_dscal_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dscal__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
9 | [rocblas_cscal_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cscal__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
10 | [rocblas_zscal_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zscal__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
11 | [rocblas_csscal_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csscal__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
12 | [rocblas_zdscal_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdscal__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
13 | [rocblas_sscal_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sscal__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
14 | [rocblas_dscal_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dscal__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
15 | [rocblas_cscal_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cscal__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
16 | [rocblas_zscal_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zscal__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
17 | [rocblas_csscal_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csscal__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
18 | [rocblas_zdscal_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdscal__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
19 | [rocblas_scopy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scopy.html "Interface documentation") | C binding, rank_0, rank_1
20 | [rocblas_dcopy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dcopy.html "Interface documentation") | C binding, rank_0, rank_1
21 | [rocblas_ccopy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ccopy.html "Interface documentation") | C binding, rank_0, rank_1
22 | [rocblas_zcopy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zcopy.html "Interface documentation") | C binding, rank_0, rank_1
23 | [rocblas_scopy_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scopy__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
24 | [rocblas_dcopy_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dcopy__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
25 | [rocblas_ccopy_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ccopy__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
26 | [rocblas_zcopy_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zcopy__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
27 | [rocblas_scopy_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scopy__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
28 | [rocblas_dcopy_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dcopy__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
29 | [rocblas_ccopy_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ccopy__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
30 | [rocblas_zcopy_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zcopy__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
31 | [rocblas_sdot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sdot.html "Interface documentation") | C binding, rank_0, rank_1
32 | [rocblas_ddot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ddot.html "Interface documentation") | C binding, rank_0, rank_1
33 | [rocblas_hdot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__hdot.html "Interface documentation") | C binding
34 | [rocblas_bfdot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__bfdot.html "Interface documentation") | C binding
35 | [rocblas_cdotu](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cdotu.html "Interface documentation") | C binding, rank_0, rank_1
36 | [rocblas_zdotu](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdotu.html "Interface documentation") | C binding, rank_0, rank_1
37 | [rocblas_cdotc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cdotc.html "Interface documentation") | C binding, rank_0, rank_1
38 | [rocblas_zdotc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdotc.html "Interface documentation") | C binding, rank_0, rank_1
39 | [rocblas_sdot_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sdot__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
40 | [rocblas_ddot_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ddot__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
41 | [rocblas_hdot_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__hdot__batched.html "Interface documentation") | C binding
42 | [rocblas_bfdot_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__bfdot__batched.html "Interface documentation") | C binding
43 | [rocblas_cdotu_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cdotu__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
44 | [rocblas_zdotu_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdotu__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
45 | [rocblas_cdotc_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cdotc__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
46 | [rocblas_zdotc_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdotc__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
47 | [rocblas_sdot_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sdot__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
48 | [rocblas_ddot_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ddot__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
49 | [rocblas_hdot_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__hdot__strided__batched.html "Interface documentation") | C binding
50 | [rocblas_bfdot_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__bfdot__strided__batched.html "Interface documentation") | C binding
51 | [rocblas_cdotu_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cdotu__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
52 | [rocblas_zdotu_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdotu__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
53 | [rocblas_cdotc_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cdotc__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
54 | [rocblas_zdotc_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdotc__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
55 | [rocblas_sswap](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sswap.html "Interface documentation") | C binding
56 | [rocblas_dswap](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dswap.html "Interface documentation") | C binding
57 | [rocblas_cswap](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cswap.html "Interface documentation") | C binding, rank_0, rank_1
58 | [rocblas_zswap](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zswap.html "Interface documentation") | C binding, rank_0, rank_1
59 | [rocblas_sswap_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sswap__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
60 | [rocblas_dswap_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dswap__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
61 | [rocblas_cswap_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cswap__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
62 | [rocblas_zswap_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zswap__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
63 | [rocblas_sswap_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sswap__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
64 | [rocblas_dswap_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dswap__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
65 | [rocblas_cswap_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cswap__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
66 | [rocblas_zswap_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zswap__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
67 | [rocblas_saxpy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__saxpy.html "Interface documentation") | C binding, rank_0, rank_1
68 | [rocblas_daxpy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__daxpy.html "Interface documentation") | C binding, rank_0, rank_1
69 | [rocblas_haxpy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__haxpy.html "Interface documentation") | C binding
70 | [rocblas_caxpy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__caxpy.html "Interface documentation") | C binding, rank_0, rank_1
71 | [rocblas_zaxpy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zaxpy.html "Interface documentation") | C binding, rank_0, rank_1
72 | [rocblas_haxpy_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__haxpy__batched.html "Interface documentation") | C binding
73 | [rocblas_saxpy_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__saxpy__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
74 | [rocblas_daxpy_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__daxpy__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
75 | [rocblas_caxpy_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__caxpy__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
76 | [rocblas_zaxpy_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zaxpy__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
77 | [rocblas_haxpy_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__haxpy__strided__batched.html "Interface documentation") | C binding
78 | [rocblas_saxpy_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__saxpy__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
79 | [rocblas_daxpy_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__daxpy__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
80 | [rocblas_caxpy_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__caxpy__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
81 | [rocblas_zaxpy_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zaxpy__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
82 | [rocblas_sasum](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sasum.html "Interface documentation") | C binding
83 | [rocblas_dasum](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dasum.html "Interface documentation") | C binding
84 | [rocblas_scasum](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scasum.html "Interface documentation") | C binding, rank_0, rank_1
85 | [rocblas_dzasum](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dzasum.html "Interface documentation") | C binding, rank_0, rank_1
86 | [rocblas_sasum_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sasum__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
87 | [rocblas_dasum_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dasum__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
88 | [rocblas_scasum_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scasum__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
89 | [rocblas_dzasum_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dzasum__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
90 | [rocblas_sasum_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sasum__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
91 | [rocblas_dasum_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dasum__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
92 | [rocblas_scasum_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scasum__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
93 | [rocblas_dzasum_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dzasum__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
94 | [rocblas_snrm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__snrm2.html "Interface documentation") | C binding
95 | [rocblas_dnrm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dnrm2.html "Interface documentation") | C binding
96 | [rocblas_scnrm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scnrm2.html "Interface documentation") | C binding, rank_0, rank_1
97 | [rocblas_dznrm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dznrm2.html "Interface documentation") | C binding, rank_0, rank_1
98 | [rocblas_snrm2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__snrm2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
99 | [rocblas_dnrm2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dnrm2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
100 | [rocblas_scnrm2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scnrm2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
101 | [rocblas_dznrm2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dznrm2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
102 | [rocblas_snrm2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__snrm2__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
103 | [rocblas_dnrm2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dnrm2__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
104 | [rocblas_scnrm2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scnrm2__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
105 | [rocblas_dznrm2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dznrm2__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
106 | [rocblas_isamax](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__isamax.html "Interface documentation") | C binding
107 | [rocblas_idamax](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__idamax.html "Interface documentation") | C binding
108 | [rocblas_icamax](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__icamax.html "Interface documentation") | C binding, rank_0, rank_1
109 | [rocblas_izamax](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__izamax.html "Interface documentation") | C binding, rank_0, rank_1
110 | [rocblas_isamax_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__isamax__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
111 | [rocblas_idamax_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__idamax__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
112 | [rocblas_icamax_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__icamax__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
113 | [rocblas_izamax_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__izamax__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
114 | [rocblas_isamax_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__isamax__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
115 | [rocblas_idamax_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__idamax__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
116 | [rocblas_icamax_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__icamax__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
117 | [rocblas_izamax_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__izamax__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
118 | [rocblas_isamin](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__isamin.html "Interface documentation") | C binding
119 | [rocblas_idamin](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__idamin.html "Interface documentation") | C binding
120 | [rocblas_icamin](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__icamin.html "Interface documentation") | C binding, rank_0, rank_1
121 | [rocblas_izamin](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__izamin.html "Interface documentation") | C binding, rank_0, rank_1
122 | [rocblas_isamin_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__isamin__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
123 | [rocblas_idamin_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__idamin__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
124 | [rocblas_icamin_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__icamin__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
125 | [rocblas_izamin_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__izamin__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
126 | [rocblas_isamin_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__isamin__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
127 | [rocblas_idamin_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__idamin__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
128 | [rocblas_icamin_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__icamin__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
129 | [rocblas_izamin_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__izamin__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
130 | [rocblas_srot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srot.html "Interface documentation") | C binding, rank_0, rank_1
131 | [rocblas_drot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drot.html "Interface documentation") | C binding, rank_0, rank_1
132 | [rocblas_crot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__crot.html "Interface documentation") | C binding, rank_0, rank_1
133 | [rocblas_csrot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csrot.html "Interface documentation") | C binding, rank_0, rank_1
134 | [rocblas_zrot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zrot.html "Interface documentation") | C binding, rank_0, rank_1
135 | [rocblas_zdrot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdrot.html "Interface documentation") | C binding, rank_0, rank_1
136 | [rocblas_srot_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srot__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
137 | [rocblas_drot_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drot__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
138 | [rocblas_crot_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__crot__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
139 | [rocblas_csrot_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csrot__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
140 | [rocblas_zrot_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zrot__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
141 | [rocblas_zdrot_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdrot__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
142 | [rocblas_srot_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srot__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
143 | [rocblas_drot_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drot__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
144 | [rocblas_crot_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__crot__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
145 | [rocblas_csrot_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csrot__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
146 | [rocblas_zrot_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zrot__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
147 | [rocblas_zdrot_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdrot__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
148 | [rocblas_srotg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srotg.html "Interface documentation") | C binding
149 | [rocblas_drotg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drotg.html "Interface documentation") | C binding
150 | [rocblas_crotg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__crotg.html "Interface documentation") | C binding
151 | [rocblas_zrotg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zrotg.html "Interface documentation") | C binding
152 | [rocblas_srotg_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srotg__batched.html "Interface documentation") | C binding
153 | [rocblas_drotg_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drotg__batched.html "Interface documentation") | C binding
154 | [rocblas_crotg_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__crotg__batched.html "Interface documentation") | C binding
155 | [rocblas_zrotg_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zrotg__batched.html "Interface documentation") | C binding
156 | [rocblas_srotg_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srotg__strided__batched.html "Interface documentation") | C binding
157 | [rocblas_drotg_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drotg__strided__batched.html "Interface documentation") | C binding
158 | [rocblas_crotg_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__crotg__strided__batched.html "Interface documentation") | C binding
159 | [rocblas_zrotg_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zrotg__strided__batched.html "Interface documentation") | C binding
160 | [rocblas_srotm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srotm.html "Interface documentation") | C binding, rank_0, rank_1
161 | [rocblas_drotm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drotm.html "Interface documentation") | C binding, rank_0, rank_1
162 | [rocblas_srotm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srotm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
163 | [rocblas_drotm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drotm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
164 | [rocblas_srotm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srotm__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
165 | [rocblas_drotm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drotm__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
166 | [rocblas_srotmg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srotmg.html "Interface documentation") | C binding
167 | [rocblas_drotmg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drotmg.html "Interface documentation") | C binding
168 | [rocblas_srotmg_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srotmg__batched.html "Interface documentation") | C binding
169 | [rocblas_drotmg_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drotmg__batched.html "Interface documentation") | C binding
170 | [rocblas_srotmg_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__srotmg__strided__batched.html "Interface documentation") | C binding
171 | [rocblas_drotmg_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__drotmg__strided__batched.html "Interface documentation") | C binding
172 | [rocblas_sgbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
173 | [rocblas_dgbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
174 | [rocblas_cgbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
175 | [rocblas_zgbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
176 | [rocblas_sgbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
177 | [rocblas_dgbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
178 | [rocblas_cgbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
179 | [rocblas_zgbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
180 | [rocblas_sgbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
181 | [rocblas_dgbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
182 | [rocblas_cgbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
183 | [rocblas_zgbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
184 | [rocblas_sgemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
185 | [rocblas_dgemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
186 | [rocblas_cgemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
187 | [rocblas_zgemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
188 | [rocblas_sgemv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgemv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
189 | [rocblas_dgemv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgemv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
190 | [rocblas_cgemv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgemv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
191 | [rocblas_zgemv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgemv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
192 | [rocblas_sgemv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgemv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
193 | [rocblas_dgemv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgemv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
194 | [rocblas_cgemv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgemv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
195 | [rocblas_zgemv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgemv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
196 | [rocblas_chbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
197 | [rocblas_zhbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
198 | [rocblas_chbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
199 | [rocblas_zhbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
200 | [rocblas_chbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
201 | [rocblas_zhbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
202 | [rocblas_chemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
203 | [rocblas_zhemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
204 | [rocblas_chemv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chemv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
205 | [rocblas_zhemv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhemv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
206 | [rocblas_chemv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chemv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
207 | [rocblas_zhemv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhemv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
208 | [rocblas_cher](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cher.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
209 | [rocblas_zher](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zher.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
210 | [rocblas_cher_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cher__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
211 | [rocblas_zher_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zher__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
212 | [rocblas_cher_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cher__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
213 | [rocblas_zher_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zher__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
214 | [rocblas_cher2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cher2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
215 | [rocblas_zher2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zher2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
216 | [rocblas_cher2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cher2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
217 | [rocblas_zher2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zher2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
218 | [rocblas_cher2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cher2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
219 | [rocblas_zher2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zher2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
220 | [rocblas_chpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chpmv.html "Interface documentation") | C binding, rank_0, rank_1
221 | [rocblas_zhpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhpmv.html "Interface documentation") | C binding, rank_0, rank_1
222 | [rocblas_chpmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chpmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
223 | [rocblas_zhpmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhpmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
224 | [rocblas_chpmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chpmv__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
225 | [rocblas_zhpmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhpmv__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
226 | [rocblas_chpr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chpr.html "Interface documentation") | C binding, rank_0, rank_1
227 | [rocblas_zhpr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhpr.html "Interface documentation") | C binding, rank_0, rank_1
228 | [rocblas_chpr_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chpr__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
229 | [rocblas_zhpr_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhpr__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
230 | [rocblas_chpr_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chpr__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
231 | [rocblas_zhpr_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhpr__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
232 | [rocblas_chpr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chpr2.html "Interface documentation") | C binding, rank_0, rank_1
233 | [rocblas_zhpr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhpr2.html "Interface documentation") | C binding, rank_0, rank_1
234 | [rocblas_chpr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chpr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
235 | [rocblas_zhpr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhpr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
236 | [rocblas_chpr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chpr2__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
237 | [rocblas_zhpr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhpr2__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
238 | [rocblas_strmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
239 | [rocblas_dtrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
240 | [rocblas_ctrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
241 | [rocblas_ztrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
242 | [rocblas_strmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
243 | [rocblas_dtrmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
244 | [rocblas_ctrmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
245 | [rocblas_ztrmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
246 | [rocblas_stpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stpmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
247 | [rocblas_dtpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtpmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
248 | [rocblas_ctpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctpmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
249 | [rocblas_ztpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztpmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
250 | [rocblas_stpmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stpmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
251 | [rocblas_dtpmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtpmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
252 | [rocblas_ctpmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctpmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
253 | [rocblas_ztpmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztpmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
254 | [rocblas_stbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
255 | [rocblas_dtbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
256 | [rocblas_ctbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
257 | [rocblas_ztbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
258 | [rocblas_stbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
259 | [rocblas_dtbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
260 | [rocblas_ctbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
261 | [rocblas_ztbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
262 | [rocblas_stbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
263 | [rocblas_dtbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
264 | [rocblas_ctbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
265 | [rocblas_ztbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
266 | [rocblas_stbsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stbsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
267 | [rocblas_dtbsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtbsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
268 | [rocblas_ctbsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctbsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
269 | [rocblas_ztbsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztbsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
270 | [rocblas_stbsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stbsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
271 | [rocblas_dtbsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtbsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
272 | [rocblas_ctbsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctbsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
273 | [rocblas_ztbsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztbsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
274 | [rocblas_stbsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stbsv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
275 | [rocblas_dtbsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtbsv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
276 | [rocblas_ctbsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctbsv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
277 | [rocblas_ztbsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztbsv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
278 | [rocblas_strsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
279 | [rocblas_dtrsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
280 | [rocblas_ctrsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
281 | [rocblas_ztrsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
282 | [rocblas_strsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
283 | [rocblas_dtrsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
284 | [rocblas_ctrsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
285 | [rocblas_ztrsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
286 | [rocblas_strsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strsv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
287 | [rocblas_dtrsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrsv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
288 | [rocblas_ctrsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrsv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
289 | [rocblas_ztrsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrsv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
290 | [rocblas_stpsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stpsv.html "Interface documentation") | C binding, rank_0, rank_1
291 | [rocblas_dtpsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtpsv.html "Interface documentation") | C binding, rank_0, rank_1
292 | [rocblas_ctpsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctpsv.html "Interface documentation") | C binding, rank_0, rank_1
293 | [rocblas_ztpsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztpsv.html "Interface documentation") | C binding, rank_0, rank_1
294 | [rocblas_stpsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stpsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
295 | [rocblas_dtpsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtpsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
296 | [rocblas_ctpsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctpsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
297 | [rocblas_ztpsv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztpsv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
298 | [rocblas_stpsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stpsv__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
299 | [rocblas_dtpsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtpsv__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
300 | [rocblas_ctpsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctpsv__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
301 | [rocblas_ztpsv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztpsv__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
302 | [rocblas_ssymv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssymv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
303 | [rocblas_dsymv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsymv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
304 | [rocblas_csymv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csymv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
305 | [rocblas_zsymv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsymv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
306 | [rocblas_ssymv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssymv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
307 | [rocblas_dsymv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsymv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
308 | [rocblas_csymv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csymv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
309 | [rocblas_zsymv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsymv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
310 | [rocblas_ssymv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssymv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
311 | [rocblas_dsymv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsymv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
312 | [rocblas_csymv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csymv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
313 | [rocblas_zsymv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsymv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
314 | [rocblas_sspmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sspmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
315 | [rocblas_dspmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dspmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
316 | [rocblas_sspmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sspmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
317 | [rocblas_dspmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dspmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
318 | [rocblas_sspmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sspmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
319 | [rocblas_dspmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dspmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
320 | [rocblas_ssbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
321 | [rocblas_dsbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
322 | [rocblas_dsbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
323 | [rocblas_ssbmv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssbmv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
324 | [rocblas_ssbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
325 | [rocblas_dsbmv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsbmv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
326 | [rocblas_sger](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sger.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
327 | [rocblas_dger](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dger.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
328 | [rocblas_cgeru](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgeru.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
329 | [rocblas_zgeru](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgeru.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
330 | [rocblas_cgerc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgerc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
331 | [rocblas_zgerc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgerc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
332 | [rocblas_sger_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sger__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
333 | [rocblas_dger_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dger__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
334 | [rocblas_cgeru_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgeru__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
335 | [rocblas_zgeru_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgeru__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
336 | [rocblas_cgerc_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgerc__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
337 | [rocblas_zgerc_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgerc__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
338 | [rocblas_sger_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sger__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
339 | [rocblas_dger_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dger__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
340 | [rocblas_cgeru_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgeru__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
341 | [rocblas_zgeru_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgeru__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
342 | [rocblas_cgerc_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgerc__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
343 | [rocblas_zgerc_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgerc__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
344 | [rocblas_sspr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sspr.html "Interface documentation") | C binding, rank_0, rank_1
345 | [rocblas_dspr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dspr.html "Interface documentation") | C binding, rank_0, rank_1
346 | [rocblas_cspr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cspr.html "Interface documentation") | C binding, rank_0, rank_1
347 | [rocblas_zspr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zspr.html "Interface documentation") | C binding, rank_0, rank_1
348 | [rocblas_sspr_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sspr__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
349 | [rocblas_dspr_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dspr__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
350 | [rocblas_cspr_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cspr__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
351 | [rocblas_zspr_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zspr__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
352 | [rocblas_sspr_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sspr__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
353 | [rocblas_dspr_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dspr__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
354 | [rocblas_cspr_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cspr__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
355 | [rocblas_zspr_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zspr__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
356 | [rocblas_sspr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sspr2.html "Interface documentation") | C binding, rank_0, rank_1
357 | [rocblas_dspr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dspr2.html "Interface documentation") | C binding, rank_0, rank_1
358 | [rocblas_sspr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sspr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
359 | [rocblas_dspr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dspr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
360 | [rocblas_sspr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sspr2__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
361 | [rocblas_dspr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dspr2__strided__batched.html "Interface documentation") | C binding, rank_0, rank_1
362 | [rocblas_ssyr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
363 | [rocblas_dsyr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
364 | [rocblas_csyr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
365 | [rocblas_zsyr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
366 | [rocblas_ssyr_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyr__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
367 | [rocblas_dsyr_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyr__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
368 | [rocblas_csyr_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyr__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
369 | [rocblas_zsyr_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyr__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
370 | [rocblas_ssyr_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyr__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
371 | [rocblas_dsyr_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyr__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
372 | [rocblas_csyr_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyr__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
373 | [rocblas_zsyr_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyr__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
374 | [rocblas_ssyr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
375 | [rocblas_dsyr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
376 | [rocblas_csyr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
377 | [rocblas_zsyr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
378 | [rocblas_ssyr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
379 | [rocblas_dsyr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
380 | [rocblas_csyr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
381 | [rocblas_zsyr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
382 | [rocblas_ssyr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyr2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
383 | [rocblas_dsyr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyr2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
384 | [rocblas_csyr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyr2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
385 | [rocblas_zsyr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyr2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
386 | [rocblas_chemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
387 | [rocblas_zhemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
388 | [rocblas_chemm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chemm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
389 | [rocblas_zhemm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhemm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
390 | [rocblas_chemm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__chemm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
391 | [rocblas_zhemm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zhemm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
392 | [rocblas_cherk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cherk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
393 | [rocblas_zherk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zherk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
394 | [rocblas_cherk_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cherk__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
395 | [rocblas_zherk_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zherk__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
396 | [rocblas_cherk_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cherk__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
397 | [rocblas_zherk_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zherk__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
398 | [rocblas_cher2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cher2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
399 | [rocblas_zher2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zher2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
400 | [rocblas_cher2k_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cher2k__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
401 | [rocblas_zher2k_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zher2k__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
402 | [rocblas_cher2k_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cher2k__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
403 | [rocblas_zher2k_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zher2k__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
404 | [rocblas_cherkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cherkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
405 | [rocblas_zherkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zherkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
406 | [rocblas_cherkx_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cherkx__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
407 | [rocblas_zherkx_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zherkx__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
408 | [rocblas_cherkx_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cherkx__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
409 | [rocblas_zherkx_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zherkx__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
410 | [rocblas_ssymm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssymm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
411 | [rocblas_dsymm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsymm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
412 | [rocblas_csymm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csymm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
413 | [rocblas_zsymm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsymm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
414 | [rocblas_ssymm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssymm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
415 | [rocblas_dsymm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsymm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
416 | [rocblas_csymm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csymm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
417 | [rocblas_zsymm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsymm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
418 | [rocblas_ssymm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssymm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
419 | [rocblas_dsymm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsymm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
420 | [rocblas_csymm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csymm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
421 | [rocblas_zsymm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsymm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
422 | [rocblas_ssyrk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyrk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
423 | [rocblas_dsyrk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyrk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
424 | [rocblas_csyrk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyrk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
425 | [rocblas_zsyrk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyrk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
426 | [rocblas_ssyrk_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyrk__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
427 | [rocblas_dsyrk_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyrk__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
428 | [rocblas_csyrk_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyrk__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
429 | [rocblas_zsyrk_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyrk__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
430 | [rocblas_ssyrk_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyrk__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
431 | [rocblas_dsyrk_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyrk__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
432 | [rocblas_csyrk_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyrk__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
433 | [rocblas_zsyrk_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyrk__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
434 | [rocblas_ssyr2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyr2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
435 | [rocblas_dsyr2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyr2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
436 | [rocblas_csyr2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyr2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
437 | [rocblas_zsyr2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyr2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
438 | [rocblas_ssyr2k_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyr2k__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
439 | [rocblas_dsyr2k_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyr2k__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
440 | [rocblas_csyr2k_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyr2k__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
441 | [rocblas_zsyr2k_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyr2k__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
442 | [rocblas_ssyr2k_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyr2k__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
443 | [rocblas_dsyr2k_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyr2k__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
444 | [rocblas_csyr2k_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyr2k__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
445 | [rocblas_zsyr2k_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyr2k__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
446 | [rocblas_ssyrkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyrkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
447 | [rocblas_dsyrkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyrkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
448 | [rocblas_csyrkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyrkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
449 | [rocblas_zsyrkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyrkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
450 | [rocblas_ssyrkx_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyrkx__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
451 | [rocblas_dsyrkx_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyrkx__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
452 | [rocblas_csyrkx_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyrkx__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
453 | [rocblas_zsyrkx_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyrkx__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
454 | [rocblas_ssyrkx_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ssyrkx__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
455 | [rocblas_dsyrkx_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dsyrkx__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
456 | [rocblas_csyrkx_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__csyrkx__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
457 | [rocblas_zsyrkx_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zsyrkx__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
458 | [rocblas_strmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
459 | [rocblas_dtrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
460 | [rocblas_ctrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
461 | [rocblas_ztrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
462 | [rocblas_strmm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strmm__batched.html "Interface documentation") | C binding
463 | [rocblas_dtrmm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrmm__batched.html "Interface documentation") | C binding
464 | [rocblas_ctrmm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrmm__batched.html "Interface documentation") | C binding
465 | [rocblas_ztrmm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrmm__batched.html "Interface documentation") | C binding
466 | [rocblas_strmm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strmm__strided__batched.html "Interface documentation") | C binding
467 | [rocblas_dtrmm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrmm__strided__batched.html "Interface documentation") | C binding
468 | [rocblas_ctrmm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrmm__strided__batched.html "Interface documentation") | C binding
469 | [rocblas_ztrmm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrmm__strided__batched.html "Interface documentation") | C binding
482 | [rocblas_strtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
483 | [rocblas_dtrtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
484 | [rocblas_ctrtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
485 | [rocblas_ztrtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
486 | [rocblas_strtri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strtri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
487 | [rocblas_dtrtri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrtri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
488 | [rocblas_ctrtri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrtri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
489 | [rocblas_ztrtri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrtri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
490 | [rocblas_strtri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strtri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
491 | [rocblas_dtrtri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrtri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
492 | [rocblas_ctrtri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrtri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
493 | [rocblas_ztrtri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrtri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
494 | [rocblas_strsm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strsm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
495 | [rocblas_dtrsm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrsm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
496 | [rocblas_ctrsm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrsm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
497 | [rocblas_ztrsm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrsm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
498 | [rocblas_strsm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strsm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
499 | [rocblas_dtrsm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrsm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
500 | [rocblas_ctrsm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrsm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
501 | [rocblas_ztrsm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrsm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
502 | [rocblas_strsm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__strsm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
503 | [rocblas_dtrsm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dtrsm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
504 | [rocblas_ctrsm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ctrsm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
505 | [rocblas_ztrsm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ztrsm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
506 | [rocblas_sgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
507 | [rocblas_dgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
508 | [rocblas_hgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__hgemm.html "Interface documentation") | C binding
509 | [rocblas_cgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
510 | [rocblas_zgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
511 | [rocblas_sgemm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgemm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
512 | [rocblas_dgemm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgemm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
513 | [rocblas_hgemm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__hgemm__batched.html "Interface documentation") | C binding
514 | [rocblas_cgemm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgemm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
515 | [rocblas_zgemm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgemm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
516 | [rocblas_sgemm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgemm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
517 | [rocblas_dgemm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgemm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
518 | [rocblas_hgemm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__hgemm__strided__batched.html "Interface documentation") | C binding
519 | [rocblas_hgemm_kernel_name](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__hgemm__kernel__name.html "Interface documentation") | C binding
520 | [rocblas_sgemm_kernel_name](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgemm__kernel__name.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
521 | [rocblas_dgemm_kernel_name](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgemm__kernel__name.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
522 | [rocblas_cgemm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgemm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
523 | [rocblas_zgemm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgemm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
524 | [rocblas_sdgmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sdgmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
525 | [rocblas_ddgmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ddgmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
526 | [rocblas_cdgmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cdgmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
527 | [rocblas_zdgmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdgmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
528 | [rocblas_sdgmm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sdgmm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
529 | [rocblas_ddgmm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ddgmm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
530 | [rocblas_cdgmm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cdgmm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
531 | [rocblas_zdgmm_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdgmm__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
532 | [rocblas_sdgmm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sdgmm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
533 | [rocblas_ddgmm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__ddgmm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
534 | [rocblas_cdgmm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cdgmm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
535 | [rocblas_zdgmm_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zdgmm__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
536 | [rocblas_sgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgeam.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
537 | [rocblas_dgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgeam.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
538 | [rocblas_cgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgeam.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
539 | [rocblas_zgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgeam.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
540 | [rocblas_sgeam_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgeam__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
541 | [rocblas_dgeam_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgeam__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
542 | [rocblas_cgeam_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgeam__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
543 | [rocblas_zgeam_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgeam__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
544 | [rocblas_sgeam_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__sgeam__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
545 | [rocblas_dgeam_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dgeam__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
546 | [rocblas_cgeam_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__cgeam__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
547 | [rocblas_zgeam_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__zgeam__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
548 | [rocblas_gemm_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__gemm__ex.html "Interface documentation") | C binding
549 | [rocblas_gemm_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__gemm__batched__ex.html "Interface documentation") | C binding
550 | [rocblas_gemm_strided_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__gemm__strided__batched__ex.html "Interface documentation") | C binding
551 | [rocblas_gemm_ext2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__gemm__ext2.html "Interface documentation") | C binding
552 | [rocblas_trsm_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__trsm__ex.html "Interface documentation") | C binding
553 | [rocblas_trsm_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__trsm__batched__ex.html "Interface documentation") | C binding
554 | [rocblas_trsm_strided_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__trsm__strided__batched__ex.html "Interface documentation") | C binding
555 | [rocblas_axpy_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__axpy__ex.html "Interface documentation") | C binding
556 | [rocblas_axpy_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__axpy__batched__ex.html "Interface documentation") | C binding
557 | [rocblas_axpy_strided_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__axpy__strided__batched__ex.html "Interface documentation") | C binding
558 | [rocblas_dot_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dot__ex.html "Interface documentation") | C binding
559 | [rocblas_dotc_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dotc__ex.html "Interface documentation") | C binding
560 | [rocblas_dot_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dot__batched__ex.html "Interface documentation") | C binding
561 | [rocblas_dotc_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dotc__batched__ex.html "Interface documentation") | C binding
562 | [rocblas_dot_strided_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dot__strided__batched__ex.html "Interface documentation") | C binding
563 | [rocblas_dotc_strided_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__dotc__strided__batched__ex.html "Interface documentation") | C binding
564 | [rocblas_nrm2_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__nrm2__ex.html "Interface documentation") | C binding
565 | [rocblas_nrm2_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__nrm2__batched__ex.html "Interface documentation") | C binding
566 | [rocblas_nrm2_strided_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__nrm2__strided__batched__ex.html "Interface documentation") | C binding
567 | [rocblas_rot_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__rot__ex.html "Interface documentation") | C binding
568 | [rocblas_rot_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__rot__batched__ex.html "Interface documentation") | C binding
569 | [rocblas_rot_strided_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__rot__strided__batched__ex.html "Interface documentation") | C binding
570 | [rocblas_scal_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scal__ex.html "Interface documentation") | C binding
571 | [rocblas_scal_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scal__batched__ex.html "Interface documentation") | C binding
572 | [rocblas_scal_strided_batched_ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__scal__strided__batched__ex.html "Interface documentation") | C binding
573 | [rocblas_get_version_string](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__get__version__string.html "Interface documentation") | C binding
574 | [rocblas_get_version_string_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__get__version__string__size.html "Interface documentation") | C binding
575 | [rocblas_start_device_memory_size_query](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__start__device__memory__size__query.html "Interface documentation") | C binding
576 | [rocblas_stop_device_memory_size_query](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__stop__device__memory__size__query.html "Interface documentation") | C binding
577 | [rocblas_device_malloc_ptr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__device__malloc__ptr.html "Interface documentation") | C binding
578 | [rocblas_device_malloc_get](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__device__malloc__get.html "Interface documentation") | C binding
579 | [rocblas_device_malloc_free](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__device__malloc__free.html "Interface documentation") | C binding
580 | [rocblas_get_device_memory_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__get__device__memory__size.html "Interface documentation") | C binding
581 | [rocblas_set_device_memory_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__set__device__memory__size.html "Interface documentation") | C binding
582 | [rocblas_set_workspace](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__set__workspace.html "Interface documentation") | C binding
583 | [rocblas_create_handle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__create__handle.html "Interface documentation") | C binding
584 | [rocblas_destroy_handle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__destroy__handle.html "Interface documentation") | C binding
585 | [rocblas_set_stream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__set__stream.html "Interface documentation") | C binding
586 | [rocblas_get_stream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__get__stream.html "Interface documentation") | C binding
587 | [rocblas_set_pointer_mode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__set__pointer__mode.html "Interface documentation") | C binding
588 | [rocblas_get_pointer_mode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__get__pointer__mode.html "Interface documentation") | C binding
589 | [rocblas_set_atomics_mode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__set__atomics__mode.html "Interface documentation") | C binding
590 | [rocblas_get_atomics_mode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__get__atomics__mode.html "Interface documentation") | C binding
591 | [rocblas_query_int8_layout_flag](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__query__int8__layout__flag.html "Interface documentation") | C binding
592 | [rocblas_set_start_stop_events](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__set__start__stop__events.html "Interface documentation") | C binding
593 | [rocblas_set_solution_fitness_query](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__set__solution__fitness__query.html "Interface documentation") | C binding
594 | [rocblas_set_performance_metric](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__set__performance__metric.html "Interface documentation") | C binding
595 | [rocblas_get_performance_metric](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocblas_1_1rocblas__get__performance__metric.html "Interface documentation") | C binding

# hipBLAS API support

\# | API Name | Variants
----|---------------|---------
1 | [hipblasSetVector](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas__auxiliary_1_1hipblassetvector.html "Interface documentation") | C binding
2 | [hipblasGetVector](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas__auxiliary_1_1hipblasgetvector.html "Interface documentation") | C binding
3 | [hipblasSetMatrix](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas__auxiliary_1_1hipblassetmatrix.html "Interface documentation") | C binding
4 | [hipblasGetMatrix](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas__auxiliary_1_1hipblasgetmatrix.html "Interface documentation") | C binding
5 | [hipblasSetVectorAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas__auxiliary_1_1hipblassetvectorasync.html "Interface documentation") | C binding
6 | [hipblasGetVectorAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas__auxiliary_1_1hipblasgetvectorasync.html "Interface documentation") | C binding
7 | [hipblasSetMatrixAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas__auxiliary_1_1hipblassetmatrixasync.html "Interface documentation") | C binding
8 | [hipblasGetMatrixAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas__auxiliary_1_1hipblasgetmatrixasync.html "Interface documentation") | C binding
1 | [hipblasCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascreate.html "Interface documentation") | C binding
2 | [hipblasDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdestroy.html "Interface documentation") | C binding
3 | [hipblasSetStream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassetstream.html "Interface documentation") | C binding
4 | [hipblasGetStream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasgetstream.html "Interface documentation") | C binding
5 | [hipblasSetPointerMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassetpointermode.html "Interface documentation") | C binding
6 | [hipblasGetPointerMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasgetpointermode.html "Interface documentation") | C binding
7 | [hipblasSetAtomicsMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassetatomicsmode.html "Interface documentation") | C binding
8 | [hipblasGetAtomicsMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasgetatomicsmode.html "Interface documentation") | C binding
9 | [hipblasIsamax](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasisamax.html "Interface documentation") | C binding, rank_0, rank_1
10 | [hipblasIdamax](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasidamax.html "Interface documentation") | C binding, rank_0, rank_1
11 | [hipblasIcamax](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasicamax.html "Interface documentation") | C binding, rank_0, rank_1
12 | [hipblasIzamax](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasizamax.html "Interface documentation") | C binding, rank_0, rank_1
13 | [hipblasIsamaxBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasisamaxbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
14 | [hipblasIdamaxBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasidamaxbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
15 | [hipblasIcamaxBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasicamaxbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
16 | [hipblasIzamaxBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasizamaxbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
17 | [hipblasIsamaxStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasisamaxstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
18 | [hipblasIdamaxStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasidamaxstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
19 | [hipblasIcamaxStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasicamaxstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
20 | [hipblasIzamaxStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasizamaxstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
21 | [hipblasIsamin](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasisamin.html "Interface documentation") | C binding, rank_0, rank_1
22 | [hipblasIdamin](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasidamin.html "Interface documentation") | C binding, rank_0, rank_1
23 | [hipblasIcamin](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasicamin.html "Interface documentation") | C binding, rank_0, rank_1
24 | [hipblasIzamin](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasizamin.html "Interface documentation") | C binding, rank_0, rank_1
25 | [hipblasIsaminBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasisaminbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
26 | [hipblasIdaminBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasidaminbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
27 | [hipblasIcaminBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasicaminbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
28 | [hipblasIzaminBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasizaminbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
29 | [hipblasIsaminStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasisaminstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
30 | [hipblasIdaminStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasidaminstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
31 | [hipblasIcaminStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasicaminstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
32 | [hipblasIzaminStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasizaminstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
33 | [hipblasSasum](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassasum.html "Interface documentation") | C binding, rank_0, rank_1
34 | [hipblasDasum](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdasum.html "Interface documentation") | C binding, rank_0, rank_1
35 | [hipblasScasum](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscasum.html "Interface documentation") | C binding, rank_0, rank_1
36 | [hipblasDzasum](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdzasum.html "Interface documentation") | C binding, rank_0, rank_1
37 | [hipblasSasumBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassasumbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
38 | [hipblasDasumBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdasumbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
39 | [hipblasScasumBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscasumbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
40 | [hipblasDzasumBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdzasumbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
41 | [hipblasSasumStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassasumstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
42 | [hipblasDasumStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdasumstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
43 | [hipblasScasumStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscasumstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
44 | [hipblasDzasumStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdzasumstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
45 | [hipblasSaxpy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassaxpy.html "Interface documentation") | C binding, rank_0, rank_1
46 | [hipblasDaxpy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdaxpy.html "Interface documentation") | C binding, rank_0, rank_1
47 | [hipblasCaxpy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascaxpy.html "Interface documentation") | C binding, rank_0, rank_1
48 | [hipblasZaxpy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszaxpy.html "Interface documentation") | C binding, rank_0, rank_1
49 | [hipblasSaxpyBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassaxpybatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
50 | [hipblasDaxpyBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdaxpybatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
51 | [hipblasCaxpyBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascaxpybatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
52 | [hipblasZaxpyBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszaxpybatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
53 | [hipblasSaxpyStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassaxpystridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
54 | [hipblasDaxpyStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdaxpystridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
55 | [hipblasCaxpyStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascaxpystridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
56 | [hipblasZaxpyStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszaxpystridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
57 | [hipblasScopy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscopy.html "Interface documentation") | C binding, rank_0, rank_1
58 | [hipblasDcopy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdcopy.html "Interface documentation") | C binding, rank_0, rank_1
59 | [hipblasCcopy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasccopy.html "Interface documentation") | C binding, rank_0, rank_1
60 | [hipblasZcopy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszcopy.html "Interface documentation") | C binding, rank_0, rank_1
61 | [hipblasScopyBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscopybatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
62 | [hipblasDcopyBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdcopybatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
63 | [hipblasCcopyBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasccopybatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
64 | [hipblasZcopyBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszcopybatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
65 | [hipblasScopyStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscopystridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
66 | [hipblasDcopyStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdcopystridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
67 | [hipblasCcopyStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasccopystridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
68 | [hipblasZcopyStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszcopystridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
69 | [hipblasSdot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassdot.html "Interface documentation") | C binding, rank_0, rank_1
70 | [hipblasDdot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasddot.html "Interface documentation") | C binding, rank_0, rank_1
71 | [hipblasCdotc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascdotc.html "Interface documentation") | C binding, rank_0, rank_1
72 | [hipblasCdotu](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascdotu.html "Interface documentation") | C binding, rank_0, rank_1
73 | [hipblasZdotc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdotc.html "Interface documentation") | C binding, rank_0, rank_1
74 | [hipblasZdotu](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdotu.html "Interface documentation") | C binding, rank_0, rank_1
75 | [hipblasSdotBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassdotbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
76 | [hipblasDdotBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasddotbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
77 | [hipblasCdotcBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascdotcbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
78 | [hipblasCdotuBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascdotubatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
79 | [hipblasZdotcBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdotcbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
80 | [hipblasZdotuBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdotubatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
81 | [hipblasSdotStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassdotstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
82 | [hipblasDdotStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasddotstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
83 | [hipblasCdotcStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascdotcstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
84 | [hipblasCdotuStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascdotustridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
85 | [hipblasZdotcStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdotcstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
86 | [hipblasZdotuStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdotustridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
87 | [hipblasSnrm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassnrm2.html "Interface documentation") | C binding, rank_0, rank_1
88 | [hipblasDnrm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdnrm2.html "Interface documentation") | C binding, rank_0, rank_1
89 | [hipblasScnrm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscnrm2.html "Interface documentation") | C binding, rank_0, rank_1
90 | [hipblasDznrm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdznrm2.html "Interface documentation") | C binding, rank_0, rank_1
91 | [hipblasSnrm2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassnrm2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
92 | [hipblasDnrm2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdnrm2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
93 | [hipblasScnrm2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscnrm2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
94 | [hipblasDznrm2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdznrm2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
95 | [hipblasSnrm2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassnrm2stridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
96 | [hipblasDnrm2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdnrm2stridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
97 | [hipblasScnrm2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscnrm2stridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
98 | [hipblasDznrm2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdznrm2stridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
99 | [hipblasSrot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrot.html "Interface documentation") | C binding, rank_0, rank_1
100 | [hipblasDrot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrot.html "Interface documentation") | C binding, rank_0, rank_1
101 | [hipblasCrot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascrot.html "Interface documentation") | C binding, rank_0, rank_1
102 | [hipblasCsrot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsrot.html "Interface documentation") | C binding, rank_0, rank_1
103 | [hipblasZrot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszrot.html "Interface documentation") | C binding, rank_0, rank_1
104 | [hipblasZdrot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdrot.html "Interface documentation") | C binding, rank_0, rank_1
105 | [hipblasSrotBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
106 | [hipblasDrotBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
107 | [hipblasCrotBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascrotbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
108 | [hipblasCsrotBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsrotbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
109 | [hipblasZrotBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszrotbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
110 | [hipblasZdrotBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdrotbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
111 | [hipblasSrotStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
112 | [hipblasDrotStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
113 | [hipblasCrotStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascrotstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
114 | [hipblasCsrotStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsrotstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
115 | [hipblasZrotStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszrotstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
116 | [hipblasZdrotStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdrotstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
117 | [hipblasSrotg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotg.html "Interface documentation") | C binding
118 | [hipblasDrotg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotg.html "Interface documentation") | C binding
119 | [hipblasCrotg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascrotg.html "Interface documentation") | C binding
120 | [hipblasZrotg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszrotg.html "Interface documentation") | C binding
121 | [hipblasSrotgBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotgbatched.html "Interface documentation") | C binding
122 | [hipblasDrotgBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotgbatched.html "Interface documentation") | C binding
123 | [hipblasCrotgBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascrotgbatched.html "Interface documentation") | C binding
124 | [hipblasZrotgBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszrotgbatched.html "Interface documentation") | C binding
125 | [hipblasSrotgStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotgstridedbatched.html "Interface documentation") | C binding
126 | [hipblasDrotgStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotgstridedbatched.html "Interface documentation") | C binding
127 | [hipblasCrotgStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascrotgstridedbatched.html "Interface documentation") | C binding
128 | [hipblasZrotgStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszrotgstridedbatched.html "Interface documentation") | C binding
129 | [hipblasSrotm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotm.html "Interface documentation") | C binding, rank_0, rank_1
130 | [hipblasDrotm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotm.html "Interface documentation") | C binding, rank_0, rank_1
131 | [hipblasSrotmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
132 | [hipblasDrotmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
133 | [hipblasSrotmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotmstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
134 | [hipblasDrotmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotmstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
135 | [hipblasSrotmg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotmg.html "Interface documentation") | C binding
136 | [hipblasDrotmg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotmg.html "Interface documentation") | C binding
137 | [hipblasSrotmgBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotmgbatched.html "Interface documentation") | C binding
138 | [hipblasDrotmgBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotmgbatched.html "Interface documentation") | C binding
139 | [hipblasSrotmgStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassrotmgstridedbatched.html "Interface documentation") | C binding
140 | [hipblasDrotmgStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdrotmgstridedbatched.html "Interface documentation") | C binding
141 | [hipblasSscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassscal.html "Interface documentation") | C binding, rank_0, rank_1
142 | [hipblasDscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdscal.html "Interface documentation") | C binding, rank_0, rank_1
143 | [hipblasCscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascscal.html "Interface documentation") | C binding, rank_0, rank_1
144 | [hipblasCsscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsscal.html "Interface documentation") | C binding, rank_0, rank_1
145 | [hipblasZscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszscal.html "Interface documentation") | C binding, rank_0, rank_1
146 | [hipblasZdscal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdscal.html "Interface documentation") | C binding, rank_0, rank_1
147 | [hipblasSscalBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassscalbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
148 | [hipblasDscalBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdscalbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
149 | [hipblasCscalBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascscalbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
150 | [hipblasZscalBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszscalbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
151 | [hipblasCsscalBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsscalbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
152 | [hipblasZdscalBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdscalbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
153 | [hipblasSscalStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassscalstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
154 | [hipblasDscalStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdscalstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
155 | [hipblasCscalStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascscalstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
156 | [hipblasZscalStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszscalstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
157 | [hipblasCsscalStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsscalstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
158 | [hipblasZdscalStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdscalstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
159 | [hipblasSswap](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassswap.html "Interface documentation") | C binding, rank_0, rank_1
160 | [hipblasDswap](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdswap.html "Interface documentation") | C binding, rank_0, rank_1
161 | [hipblasCswap](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascswap.html "Interface documentation") | C binding, rank_0, rank_1
162 | [hipblasZswap](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszswap.html "Interface documentation") | C binding, rank_0, rank_1
163 | [hipblasSswapBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassswapbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
164 | [hipblasDswapBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdswapbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
165 | [hipblasCswapBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascswapbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
166 | [hipblasZswapBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszswapbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
167 | [hipblasSswapStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassswapstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
168 | [hipblasDswapStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdswapstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
169 | [hipblasCswapStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascswapstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
170 | [hipblasZswapStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszswapstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
171 | [hipblasSgbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
172 | [hipblasDgbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
173 | [hipblasCgbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
174 | [hipblasZgbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
175 | [hipblasSgbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
176 | [hipblasDgbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
177 | [hipblasCgbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
178 | [hipblasZgbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
179 | [hipblasSgbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
180 | [hipblasDgbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
181 | [hipblasCgbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
182 | [hipblasZgbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
183 | [hipblasSgemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
184 | [hipblasDgemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
185 | [hipblasCgemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
186 | [hipblasZgemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
187 | [hipblasSgemvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgemvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
188 | [hipblasDgemvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgemvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
189 | [hipblasCgemvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgemvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
190 | [hipblasZgemvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgemvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
191 | [hipblasSgemvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgemvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
192 | [hipblasDgemvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgemvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
193 | [hipblasCgemvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgemvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
194 | [hipblasZgemvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgemvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
195 | [hipblasSger](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassger.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
196 | [hipblasDger](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdger.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
197 | [hipblasCgeru](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgeru.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
198 | [hipblasCgerc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgerc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
199 | [hipblasZgeru](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgeru.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
200 | [hipblasZgerc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgerc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
201 | [hipblasSgerBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgerbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
202 | [hipblasDgerBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgerbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
203 | [hipblasCgeruBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgerubatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
204 | [hipblasCgercBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgercbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
205 | [hipblasZgeruBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgerubatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
206 | [hipblasZgercBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgercbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
207 | [hipblasSgerStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgerstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
208 | [hipblasDgerStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgerstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
209 | [hipblasCgeruStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgerustridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
210 | [hipblasCgercStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgercstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
211 | [hipblasZgeruStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgerustridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
212 | [hipblasZgercStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgercstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
213 | [hipblasChbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
214 | [hipblasZhbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
215 | [hipblasChbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
216 | [hipblasZhbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
217 | [hipblasChbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
218 | [hipblasZhbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
219 | [hipblasChemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
220 | [hipblasZhemv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhemv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
221 | [hipblasChemvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschemvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
222 | [hipblasZhemvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhemvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
223 | [hipblasChemvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschemvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
224 | [hipblasZhemvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhemvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
225 | [hipblasCher](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascher.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
226 | [hipblasZher](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszher.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
227 | [hipblasCherBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascherbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
228 | [hipblasZherBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszherbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
229 | [hipblasCherStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascherstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
230 | [hipblasZherStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszherstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
231 | [hipblasCher2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascher2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
232 | [hipblasZher2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszher2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
233 | [hipblasCher2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascher2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
234 | [hipblasZher2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszher2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
235 | [hipblasCher2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascher2stridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
236 | [hipblasZher2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszher2stridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
237 | [hipblasChpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschpmv.html "Interface documentation") | C binding, rank_0, rank_1
238 | [hipblasZhpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhpmv.html "Interface documentation") | C binding, rank_0, rank_1
239 | [hipblasChpmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschpmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
240 | [hipblasZhpmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhpmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
241 | [hipblasChpmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschpmvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
242 | [hipblasZhpmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhpmvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
243 | [hipblasChpr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschpr.html "Interface documentation") | C binding, rank_0, rank_1
244 | [hipblasZhpr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhpr.html "Interface documentation") | C binding, rank_0, rank_1
245 | [hipblasChprBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschprbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
246 | [hipblasZhprBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhprbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
247 | [hipblasChprStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschprstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
248 | [hipblasZhprStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhprstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
249 | [hipblasChpr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschpr2.html "Interface documentation") | C binding, rank_0, rank_1
250 | [hipblasZhpr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhpr2.html "Interface documentation") | C binding, rank_0, rank_1
251 | [hipblasChpr2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschpr2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
252 | [hipblasZhpr2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhpr2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
253 | [hipblasChpr2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschpr2stridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
254 | [hipblasZhpr2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhpr2stridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
255 | [hipblasSsbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
256 | [hipblasDsbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
257 | [hipblasSsbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
258 | [hipblasDsbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
259 | [hipblasSsbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
260 | [hipblasDsbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
261 | [hipblasSspmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassspmv.html "Interface documentation") | C binding, rank_0, rank_1
262 | [hipblasDspmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdspmv.html "Interface documentation") | C binding, rank_0, rank_1
263 | [hipblasSspmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassspmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
264 | [hipblasDspmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdspmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
265 | [hipblasSspmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassspmvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
266 | [hipblasDspmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdspmvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
267 | [hipblasSspr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassspr.html "Interface documentation") | C binding, rank_0, rank_1
268 | [hipblasDspr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdspr.html "Interface documentation") | C binding, rank_0, rank_1
269 | [hipblasCspr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascspr.html "Interface documentation") | C binding, rank_0, rank_1
270 | [hipblasZspr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszspr.html "Interface documentation") | C binding, rank_0, rank_1
271 | [hipblasSsprBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssprbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
272 | [hipblasDsprBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsprbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
273 | [hipblasCsprBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsprbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
274 | [hipblasZsprBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsprbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
275 | [hipblasSsprStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssprstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
276 | [hipblasDsprStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsprstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
277 | [hipblasCsprStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsprstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
278 | [hipblasZsprStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsprstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
279 | [hipblasSspr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassspr2.html "Interface documentation") | C binding, rank_0, rank_1
280 | [hipblasDspr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdspr2.html "Interface documentation") | C binding, rank_0, rank_1
281 | [hipblasSspr2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassspr2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
282 | [hipblasDspr2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdspr2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
283 | [hipblasSspr2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassspr2stridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
284 | [hipblasDspr2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdspr2stridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
285 | [hipblasSsymv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssymv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
286 | [hipblasDsymv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsymv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
287 | [hipblasCsymv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsymv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
288 | [hipblasZsymv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsymv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
289 | [hipblasSsymvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssymvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
290 | [hipblasDsymvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsymvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
291 | [hipblasCsymvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsymvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
292 | [hipblasZsymvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsymvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
293 | [hipblasSsymvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssymvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
294 | [hipblasDsymvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsymvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
295 | [hipblasCsymvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsymvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
296 | [hipblasZsymvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsymvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
297 | [hipblasSsyr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
298 | [hipblasDsyr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
299 | [hipblasCsyr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
300 | [hipblasZsyr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
301 | [hipblasSsyrBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyrbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
302 | [hipblasDsyrBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyrbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
303 | [hipblasCsyrBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyrbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
304 | [hipblasZsyrBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyrbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
305 | [hipblasSsyrStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyrstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
306 | [hipblasDsyrStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyrstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
307 | [hipblasCsyrStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyrstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
308 | [hipblasZsyrStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyrstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
309 | [hipblasSsyr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
310 | [hipblasDsyr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
311 | [hipblasCsyr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
312 | [hipblasZsyr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
313 | [hipblasSsyr2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyr2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
314 | [hipblasDsyr2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyr2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
315 | [hipblasCsyr2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyr2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
316 | [hipblasZsyr2Batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyr2batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
317 | [hipblasSsyr2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyr2stridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
318 | [hipblasDsyr2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyr2stridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
319 | [hipblasCsyr2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyr2stridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
320 | [hipblasZsyr2StridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyr2stridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
321 | [hipblasStbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
322 | [hipblasDtbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
323 | [hipblasCtbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
324 | [hipblasZtbmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztbmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
325 | [hipblasStbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
326 | [hipblasDtbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
327 | [hipblasCtbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
328 | [hipblasZtbmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztbmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
329 | [hipblasStbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
330 | [hipblasDtbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
331 | [hipblasCtbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
332 | [hipblasZtbmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztbmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
333 | [hipblasStbsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstbsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
334 | [hipblasDtbsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtbsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
335 | [hipblasCtbsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctbsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
336 | [hipblasZtbsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztbsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
337 | [hipblasStbsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstbsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
338 | [hipblasDtbsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtbsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
339 | [hipblasCtbsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctbsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
340 | [hipblasZtbsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztbsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
341 | [hipblasStbsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstbsvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
342 | [hipblasDtbsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtbsvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
343 | [hipblasCtbsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctbsvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
344 | [hipblasZtbsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztbsvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
345 | [hipblasStpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstpmv.html "Interface documentation") | C binding, rank_0, rank_1
346 | [hipblasDtpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtpmv.html "Interface documentation") | C binding, rank_0, rank_1
347 | [hipblasCtpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctpmv.html "Interface documentation") | C binding, rank_0, rank_1
348 | [hipblasZtpmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztpmv.html "Interface documentation") | C binding, rank_0, rank_1
349 | [hipblasStpmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstpmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
350 | [hipblasDtpmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtpmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
351 | [hipblasCtpmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctpmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
352 | [hipblasZtpmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztpmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
353 | [hipblasStpmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstpmvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
354 | [hipblasDtpmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtpmvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
355 | [hipblasCtpmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctpmvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
356 | [hipblasZtpmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztpmvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
357 | [hipblasStpsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstpsv.html "Interface documentation") | C binding, rank_0, rank_1
358 | [hipblasDtpsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtpsv.html "Interface documentation") | C binding, rank_0, rank_1
359 | [hipblasCtpsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctpsv.html "Interface documentation") | C binding, rank_0, rank_1
360 | [hipblasZtpsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztpsv.html "Interface documentation") | C binding, rank_0, rank_1
361 | [hipblasStpsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstpsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
362 | [hipblasDtpsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtpsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
363 | [hipblasCtpsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctpsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
364 | [hipblasZtpsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztpsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
365 | [hipblasStpsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstpsvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
366 | [hipblasDtpsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtpsvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
367 | [hipblasCtpsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctpsvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
368 | [hipblasZtpsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztpsvstridedbatched.html "Interface documentation") | C binding, rank_0, rank_1
369 | [hipblasStrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
370 | [hipblasDtrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
371 | [hipblasCtrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
372 | [hipblasZtrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrmv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
373 | [hipblasStrmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
374 | [hipblasDtrmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
375 | [hipblasCtrmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
376 | [hipblasZtrmvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrmvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
377 | [hipblasStrmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
378 | [hipblasDtrmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
379 | [hipblasCtrmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
380 | [hipblasZtrmvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrmvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
381 | [hipblasStrsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
382 | [hipblasDtrsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
383 | [hipblasCtrsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
384 | [hipblasZtrsv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrsv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
385 | [hipblasStrsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
386 | [hipblasDtrsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
387 | [hipblasCtrsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
388 | [hipblasZtrsvBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrsvbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
389 | [hipblasStrsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrsvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
390 | [hipblasDtrsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrsvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
391 | [hipblasCtrsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrsvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
392 | [hipblasZtrsvStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrsvstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
393 | [hipblasSgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
394 | [hipblasDgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
395 | [hipblasCgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
396 | [hipblasZgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
397 | [hipblasSgemmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgemmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
398 | [hipblasDgemmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgemmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
399 | [hipblasCgemmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgemmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
400 | [hipblasZgemmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgemmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
401 | [hipblasSgemmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgemmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
402 | [hipblasDgemmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgemmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
403 | [hipblasCgemmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgemmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
404 | [hipblasZgemmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgemmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
405 | [hipblasCherk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascherk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
406 | [hipblasZherk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszherk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
407 | [hipblasCherkBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascherkbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
408 | [hipblasZherkBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszherkbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
409 | [hipblasCherkStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascherkstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
410 | [hipblasZherkStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszherkstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
411 | [hipblasCherkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascherkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
412 | [hipblasZherkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszherkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
413 | [hipblasCherkxBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascherkxbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
414 | [hipblasZherkxBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszherkxbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
415 | [hipblasCherkxStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascherkxstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
416 | [hipblasZherkxStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszherkxstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
417 | [hipblasCher2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascher2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
418 | [hipblasZher2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszher2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
419 | [hipblasCher2kBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascher2kbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
420 | [hipblasZher2kBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszher2kbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
421 | [hipblasCher2kStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascher2kstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
422 | [hipblasZher2kStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszher2kstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
423 | [hipblasSsymm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssymm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
424 | [hipblasDsymm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsymm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
425 | [hipblasCsymm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsymm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
426 | [hipblasZsymm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsymm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
427 | [hipblasSsymmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssymmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
428 | [hipblasDsymmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsymmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
429 | [hipblasCsymmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsymmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
430 | [hipblasZsymmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsymmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
431 | [hipblasSsymmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssymmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
432 | [hipblasDsymmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsymmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
433 | [hipblasCsymmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsymmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
434 | [hipblasZsymmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsymmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
435 | [hipblasSsyrk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyrk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
436 | [hipblasDsyrk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyrk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
437 | [hipblasCsyrk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyrk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
438 | [hipblasZsyrk](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyrk.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
439 | [hipblasSsyrkBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyrkbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
440 | [hipblasDsyrkBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyrkbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
441 | [hipblasCsyrkBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyrkbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
442 | [hipblasZsyrkBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyrkbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
443 | [hipblasSsyrkStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyrkstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
444 | [hipblasDsyrkStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyrkstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
445 | [hipblasCsyrkStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyrkstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
446 | [hipblasZsyrkStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyrkstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
447 | [hipblasSsyr2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyr2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
448 | [hipblasDsyr2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyr2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
449 | [hipblasCsyr2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyr2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
450 | [hipblasZsyr2k](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyr2k.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
451 | [hipblasSsyr2kBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyr2kbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
452 | [hipblasDsyr2kBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyr2kbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
453 | [hipblasCsyr2kBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyr2kbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
454 | [hipblasZsyr2kBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyr2kbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
455 | [hipblasSsyr2kStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyr2kstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
456 | [hipblasDsyr2kStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyr2kstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
457 | [hipblasCsyr2kStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyr2kstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
458 | [hipblasZsyr2kStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyr2kstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
459 | [hipblasSsyrkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyrkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
460 | [hipblasDsyrkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyrkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
461 | [hipblasCsyrkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyrkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
462 | [hipblasZsyrkx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyrkx.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
463 | [hipblasSsyrkxBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyrkxbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
464 | [hipblasDsyrkxBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyrkxbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
465 | [hipblasCsyrkxBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyrkxbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
466 | [hipblasZsyrkxBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyrkxbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
467 | [hipblasSsyrkxStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasssyrkxstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
468 | [hipblasDsyrkxStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdsyrkxstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
469 | [hipblasCsyrkxStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascsyrkxstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
470 | [hipblasZsyrkxStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszsyrkxstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
471 | [hipblasSgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgeam.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
472 | [hipblasDgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgeam.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
473 | [hipblasCgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgeam.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
474 | [hipblasZgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgeam.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
475 | [hipblasSgeamBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgeambatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
476 | [hipblasDgeamBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgeambatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
477 | [hipblasCgeamBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgeambatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
478 | [hipblasZgeamBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgeambatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
479 | [hipblasSgeamStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgeamstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
480 | [hipblasDgeamStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgeamstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
481 | [hipblasCgeamStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgeamstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
482 | [hipblasZgeamStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgeamstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
483 | [hipblasChemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
484 | [hipblasZhemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhemm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
485 | [hipblasChemmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschemmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
486 | [hipblasZhemmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhemmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
487 | [hipblasChemmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaschemmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
488 | [hipblasZhemmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszhemmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
489 | [hipblasStrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
490 | [hipblasDtrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
491 | [hipblasCtrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
492 | [hipblasZtrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
493 | [hipblasStrmmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrmmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
494 | [hipblasDtrmmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrmmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
495 | [hipblasCtrmmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrmmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
496 | [hipblasZtrmmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrmmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
497 | [hipblasStrmmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrmmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
498 | [hipblasDtrmmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrmmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
499 | [hipblasCtrmmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrmmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
500 | [hipblasZtrmmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrmmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
501 | [hipblasStrsm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrsm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
502 | [hipblasDtrsm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrsm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
503 | [hipblasCtrsm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrsm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
504 | [hipblasZtrsm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrsm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
505 | [hipblasStrsmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrsmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
506 | [hipblasDtrsmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrsmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
507 | [hipblasCtrsmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrsmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
508 | [hipblasZtrsmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrsmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
509 | [hipblasStrsmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrsmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
510 | [hipblasDtrsmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrsmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
511 | [hipblasCtrsmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrsmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
512 | [hipblasZtrsmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrsmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
513 | [hipblasStrtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
514 | [hipblasDtrtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
515 | [hipblasCtrtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
516 | [hipblasZtrtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
517 | [hipblasStrtriBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrtribatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
518 | [hipblasDtrtriBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrtribatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
519 | [hipblasCtrtriBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrtribatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
520 | [hipblasZtrtriBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrtribatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
521 | [hipblasStrtriStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasstrtristridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
522 | [hipblasDtrtriStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdtrtristridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
523 | [hipblasCtrtriStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasctrtristridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
524 | [hipblasZtrtriStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasztrtristridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
525 | [hipblasSdgmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassdgmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
526 | [hipblasDdgmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasddgmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
527 | [hipblasCdgmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascdgmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
528 | [hipblasZdgmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdgmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
529 | [hipblasSdgmmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassdgmmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
530 | [hipblasDdgmmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasddgmmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
531 | [hipblasCdgmmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascdgmmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
532 | [hipblasZdgmmBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdgmmbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
533 | [hipblasSdgmmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassdgmmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
534 | [hipblasDdgmmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasddgmmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
535 | [hipblasCdgmmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascdgmmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
536 | [hipblasZdgmmStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszdgmmstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
537 | [hipblasSgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
538 | [hipblasDgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
539 | [hipblasCgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
540 | [hipblasZgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
541 | [hipblasSgetrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgetrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
542 | [hipblasDgetrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgetrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
543 | [hipblasCgetrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgetrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
544 | [hipblasZgetrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgetrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
545 | [hipblasSgetrfStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgetrfstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
546 | [hipblasDgetrfStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgetrfstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
547 | [hipblasCgetrfStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgetrfstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
548 | [hipblasZgetrfStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgetrfstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
549 | [hipblasSgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
550 | [hipblasDgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
551 | [hipblasCgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
552 | [hipblasZgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
553 | [hipblasSgetrsBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgetrsbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
554 | [hipblasDgetrsBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgetrsbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
555 | [hipblasCgetrsBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgetrsbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
556 | [hipblasZgetrsBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgetrsbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
557 | [hipblasSgetrsStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgetrsstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
558 | [hipblasDgetrsStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgetrsstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
559 | [hipblasCgetrsStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgetrsstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
560 | [hipblasZgetrsStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgetrsstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
561 | [hipblasSgetriBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgetribatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
562 | [hipblasDgetriBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgetribatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
563 | [hipblasCgetriBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgetribatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
564 | [hipblasZgetriBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgetribatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
565 | [hipblasSgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
566 | [hipblasDgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
567 | [hipblasCgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
568 | [hipblasZgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
569 | [hipblasSgeqrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgeqrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
570 | [hipblasDgeqrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgeqrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
571 | [hipblasCgeqrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgeqrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
572 | [hipblasZgeqrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgeqrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
573 | [hipblasSgeqrfStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblassgeqrfstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
574 | [hipblasDgeqrfStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdgeqrfstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
575 | [hipblasCgeqrfStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblascgeqrfstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
576 | [hipblasZgeqrfStridedBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblaszgeqrfstridedbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
577 | [hipblasGemmEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasgemmex.html "Interface documentation") | C binding
578 | [hipblasGemmBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasgemmbatchedex.html "Interface documentation") | C binding
579 | [hipblasGemmStridedBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasgemmstridedbatchedex.html "Interface documentation") | C binding
580 | [hipblasTrsmEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblastrsmex.html "Interface documentation") | C binding
581 | [hipblasTrsmBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblastrsmbatchedex.html "Interface documentation") | C binding
582 | [hipblasTrsmStridedBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblastrsmstridedbatchedex.html "Interface documentation") | C binding
583 | [hipblasAxpyEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasaxpyex.html "Interface documentation") | C binding
584 | [hipblasAxpyBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasaxpybatchedex.html "Interface documentation") | C binding
585 | [hipblasAxpyStridedBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasaxpystridedbatchedex.html "Interface documentation") | C binding
586 | [hipblasDotEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdotex.html "Interface documentation") | C binding
587 | [hipblasDotcEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdotcex.html "Interface documentation") | C binding
588 | [hipblasDotBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdotbatchedex.html "Interface documentation") | C binding
589 | [hipblasDotcBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdotcbatchedex.html "Interface documentation") | C binding
590 | [hipblasDotStridedBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdotstridedbatchedex.html "Interface documentation") | C binding
591 | [hipblasDotcStridedBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasdotcstridedbatchedex.html "Interface documentation") | C binding
592 | [hipblasNrm2Ex](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasnrm2ex.html "Interface documentation") | C binding
593 | [hipblasNrm2BatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasnrm2batchedex.html "Interface documentation") | C binding
594 | [hipblasNrm2StridedBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasnrm2stridedbatchedex.html "Interface documentation") | C binding
595 | [hipblasRotEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasrotex.html "Interface documentation") | C binding
596 | [hipblasRotBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasrotbatchedex.html "Interface documentation") | C binding
597 | [hipblasRotStridedBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasrotstridedbatchedex.html "Interface documentation") | C binding
598 | [hipblasScalEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscalex.html "Interface documentation") | C binding
599 | [hipblasScalBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscalbatchedex.html "Interface documentation") | C binding
600 | [hipblasScalStridedBatchedEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipblas_1_1hipblasscalstridedbatchedex.html "Interface documentation") | C binding

# API reference This section provides technical descriptions and important information about the different hipFORT APIs and library components. - {doc}`/doxygen/html/md_input_supported_api_hip` - {doc}`/doxygen/html/md_input_supported_api_hipblas` - {doc}`/doxygen/html/md_input_supported_api_hipfft` - {doc}`/doxygen/html/md_input_supported_api_hiprand` - {doc}`/doxygen/html/md_input_supported_api_hipsolver` - {doc}`/doxygen/html/md_input_supported_api_hipsparse` - {doc}`/doxygen/html/md_input_supported_api_rocblas` - {doc}`/doxygen/html/md_input_supported_api_rocfft` - {doc}`/doxygen/html/md_input_supported_api_rocrand` - {doc}`/doxygen/html/md_input_supported_api_rocsolver` - {doc}`/doxygen/html/md_input_supported_api_rocsparse`

# hipFFT API Support

\# | API Name | Variants
----|---------------|---------
1 | [hipfftPlan1d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftplan1d.html "Interface documentation") | C binding
2 | [hipfftPlan2d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftplan2d.html "Interface documentation") | C binding
3 | [hipfftPlan3d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftplan3d.html "Interface documentation") | C binding
4 | [hipfftPlanMany](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftplanmany.html "Interface documentation") | C binding, rank_0, rank_1
5 | [hipfftCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftcreate.html "Interface documentation") | C binding
6 | [hipfftMakePlan1d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftmakeplan1d.html "Interface documentation") | C binding, rank_0, rank_1
7 | [hipfftMakePlan2d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftmakeplan2d.html "Interface documentation") | C binding, rank_0, rank_1
8 | [hipfftMakePlan3d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftmakeplan3d.html "Interface documentation") | C binding, rank_0, rank_1
9 | [hipfftMakePlanMany](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftmakeplanmany.html "Interface documentation") | C binding, rank_0, rank_1
10 | [hipfftMakePlanMany64](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftmakeplanmany64.html "Interface documentation") | C binding, rank_0, rank_1
11 | [hipfftEstimate1d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftestimate1d.html "Interface documentation") | C binding, rank_0, rank_1
12 | [hipfftEstimate2d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftestimate2d.html "Interface documentation") | C binding, rank_0, rank_1
13 | [hipfftEstimate3d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftestimate3d.html "Interface documentation") | C binding, rank_0, rank_1
14 | [hipfftEstimateMany](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftestimatemany.html "Interface documentation") | C binding, rank_0, rank_1
15 | [hipfftGetSize1d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftgetsize1d.html "Interface documentation") | C binding, rank_0, rank_1
16 | [hipfftGetSize2d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftgetsize2d.html "Interface documentation") | C binding, rank_0, rank_1
17 | [hipfftGetSize3d](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftgetsize3d.html "Interface documentation") | C binding, rank_0, rank_1
18 | [hipfftGetSizeMany](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftgetsizemany.html "Interface documentation") | C binding, rank_0, rank_1
19 | [hipfftGetSizeMany64](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftgetsizemany64.html "Interface documentation") | C binding, rank_0, rank_1
20 | [hipfftGetSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftgetsize.html "Interface documentation") | C binding, rank_0, rank_1
21 | [hipfftSetAutoAllocation](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftsetautoallocation.html "Interface documentation") | C binding
22 | [hipfftSetWorkArea](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftsetworkarea.html "Interface documentation") | C binding
23 | [hipfftExecC2C](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftexecc2c.html "Interface documentation") | C binding, rank_0, rank_1, rank_2, rank_3
24 | [hipfftExecR2C](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftexecr2c.html "Interface documentation") | C binding, rank_0, rank_1, rank_2, rank_3
25 | [hipfftExecC2R](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftexecc2r.html "Interface documentation") | C binding, rank_0, rank_1, rank_2, rank_3
26 | [hipfftExecZ2Z](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftexecz2z.html "Interface documentation") | C binding, rank_0, rank_1, rank_2, rank_3
27 | [hipfftExecD2Z](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftexecd2z.html "Interface documentation") | C binding, rank_0, rank_1, rank_2, rank_3
28 | [hipfftExecZ2D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftexecz2d.html "Interface documentation") | C binding, rank_0, rank_1, rank_2, rank_3
29 | [hipfftSetStream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftsetstream.html "Interface documentation") | C binding
30 | [hipfftDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftdestroy.html "Interface documentation") | C binding
31 | [hipfftGetVersion](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftgetversion.html "Interface documentation") | C binding
32 | [hipfftGetProperty](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipfft_1_1hipfftgetproperty.html "Interface documentation") | C binding

# HIP API Support

\# | API Name | Variants
----|---------------|---------
1   | [hipMalloc](#hipfort_hipmalloc::hipmalloc "Interface documentation") | C binding
2   | [hipMallocManaged](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipmalloc_1_1hipmallocmanaged.html "Interface documentation") | C binding
3   | [hipHostMalloc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipmalloc_1_1hiphostmalloc.html "Interface documentation") | C binding
4   | [hipFree](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipmalloc_1_1hipfree.html "Interface documentation") | C binding
5   | [hipHostFree](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipmalloc_1_1hiphostfree.html "Interface documentation") | C binding
1   | [hipMemcpy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipmemcpy_1_1hipmemcpy.html "Interface documentation") | C binding
2   | [hipMemcpyAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipmemcpy_1_1hipmemcpyasync.html "Interface documentation") | C binding
3   | [hipMemcpy2D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipmemcpy_1_1hipmemcpy2d.html "Interface documentation") | C binding
4   | [hipMemcpy2DAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipmemcpy_1_1hipmemcpy2dasync.html "Interface documentation") | C binding
1   | [hipGetDeviceProperties](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__auxiliary_1_1hipgetdeviceproperties.html "Interface documentation") | C binding
1   | [hipInit](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipinit.html "Interface documentation") | C binding
2   | [hipDriverGetVersion](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdrivergetversion.html "Interface documentation") | C binding
3   | [hipRuntimeGetVersion](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipruntimegetversion.html "Interface documentation") | C binding
4   | [hipDeviceGet](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdeviceget.html "Interface documentation") | C binding
5   | [hipDeviceComputeCapability](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicecomputecapability.html "Interface documentation") | C binding
6   | [hipDeviceGetName](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicegetname.html "Interface documentation") | C binding
7   | [hipDeviceGetP2PAttribute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicegetp2pattribute.html "Interface documentation") | C binding
8   | [hipDeviceGetPCIBusId](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicegetpcibusid.html "Interface documentation") | C binding
9   | [hipDeviceGetByPCIBusId](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicegetbypcibusid.html "Interface documentation") | C binding
10  | [hipDeviceTotalMem](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicetotalmem.html "Interface documentation") | C binding
11  | [hipDeviceSynchronize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicesynchronize.html "Interface documentation") | C binding
12  | [hipDeviceReset](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicereset.html "Interface documentation") | C binding
13  | [hipSetDevice](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipsetdevice.html "Interface documentation") | C binding
14  | [hipGetDevice](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgetdevice.html "Interface documentation") | C binding
15  | [hipGetDeviceCount](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgetdevicecount.html "Interface documentation") | C binding
16  | [hipDeviceGetAttribute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicegetattribute.html "Interface documentation") | C binding
17  | [hipDeviceSetCacheConfig](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicesetcacheconfig.html "Interface documentation") | C binding
18  | [hipDeviceGetCacheConfig](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicegetcacheconfig.html "Interface documentation") | C binding
19  | [hipDeviceGetLimit](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicegetlimit.html "Interface documentation") | C binding
20  | [hipDeviceGetSharedMemConfig](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicegetsharedmemconfig.html "Interface documentation") | C binding
21  | [hipGetDeviceFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgetdeviceflags.html "Interface documentation") | C binding
22  | [hipDeviceSetSharedMemConfig](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicesetsharedmemconfig.html "Interface documentation") | C binding
23  | [hipSetDeviceFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipsetdeviceflags.html "Interface documentation") | C binding
24  | [hipChooseDevice](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipchoosedevice.html "Interface documentation") | C binding
25  | [hipExtGetLinkTypeAndHopCount](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipextgetlinktypeandhopcount.html "Interface documentation") | C binding
26  | [hipIpcGetMemHandle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipipcgetmemhandle.html "Interface documentation") | C binding
27  | [hipIpcOpenMemHandle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipipcopenmemhandle.html "Interface documentation") | C binding
28  | [hipIpcCloseMemHandle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipipcclosememhandle.html "Interface documentation") | C binding
29  | [hipIpcGetEventHandle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipipcgeteventhandle.html "Interface documentation") | C binding
30  | [hipIpcOpenEventHandle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipipcopeneventhandle.html "Interface documentation") | C binding
31  | [hipFuncSetAttribute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipfuncsetattribute.html "Interface documentation") | C binding
32  | [hipFuncSetCacheConfig](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipfuncsetcacheconfig.html "Interface documentation") | C binding
33  | [hipFuncSetSharedMemConfig](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipfuncsetsharedmemconfig.html "Interface documentation") | C binding
34  | [hipGetLastError](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgetlasterror.html "Interface documentation") | C binding
35  | [hipPeekAtLastError](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hippeekatlasterror.html "Interface documentation") | C binding
36  | [hipStreamCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamcreate.html "Interface documentation") | C binding
37  | [hipStreamCreateWithFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamcreatewithflags.html "Interface documentation") | C binding
38  | [hipStreamCreateWithPriority](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamcreatewithpriority.html "Interface documentation") | C binding
39  | [hipDeviceGetStreamPriorityRange](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicegetstreampriorityrange.html "Interface documentation") | C binding
40  | [hipStreamDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamdestroy.html "Interface documentation") | C binding
41  | [hipStreamQuery](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamquery.html "Interface documentation") | C binding
42  | [hipStreamSynchronize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamsynchronize.html "Interface documentation") | C binding
43  | [hipStreamWaitEvent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamwaitevent.html "Interface documentation") | C binding
44  | [hipStreamGetFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamgetflags.html "Interface documentation") | C binding
45  | [hipStreamGetPriority](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamgetpriority.html "Interface documentation") | C binding
46  | [hipExtStreamCreateWithCUMask](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipextstreamcreatewithcumask.html "Interface documentation") | C binding
47  | [hipExtStreamGetCUMask](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipextstreamgetcumask.html "Interface documentation") | C binding
48  | [hipStreamAddCallback](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamaddcallback.html "Interface documentation") | C binding
49  | [hipStreamWriteValue32](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamwritevalue32.html "Interface documentation") | C binding
50  | [hipStreamWriteValue64](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamwritevalue64.html "Interface documentation") | C binding
51  | [hipEventCreateWithFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipeventcreatewithflags.html "Interface documentation") | C binding
52  | [hipEventCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipeventcreate.html "Interface documentation") | C binding
53  | [hipEventRecord](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipeventrecord.html "Interface documentation") | C binding
54  | [hipEventDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipeventdestroy.html "Interface documentation") | C binding
55  | [hipEventSynchronize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipeventsynchronize.html "Interface documentation") | C binding
56  | [hipEventElapsedTime](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipeventelapsedtime.html "Interface documentation") | C binding
57  | [hipEventQuery](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipeventquery.html "Interface documentation") | C binding
58  | [hipPointerGetAttributes](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hippointergetattributes.html "Interface documentation") | C binding
59  | [hipPointerGetAttribute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hippointergetattribute.html "Interface documentation") | C binding
60  | [hipDrvPointerGetAttributes](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdrvpointergetattributes.html "Interface documentation") | C binding
61  | [hipSignalExternalSemaphoresAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipsignalexternalsemaphoresasync.html "Interface documentation") | C binding
62  | [hipWaitExternalSemaphoresAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipwaitexternalsemaphoresasync.html "Interface documentation") | C binding
63  | [hipDestroyExternalSemaphore](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdestroyexternalsemaphore.html "Interface documentation") | C binding
64  | [hipExternalMemoryGetMappedBuffer](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipexternalmemorygetmappedbuffer.html "Interface documentation") | C binding
65  | [hipDestroyExternalMemory](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdestroyexternalmemory.html "Interface documentation") | C binding
66  | [hipExtMallocWithFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipextmallocwithflags.html "Interface documentation") | C binding
67  | [hipMallocHost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmallochost.html "Interface documentation") | C binding
68  | [hipMemAllocHost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemallochost.html "Interface documentation") | C binding
69  | [hipMemPrefetchAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemprefetchasync.html "Interface documentation") | C binding
70  | [hipMemAdvise](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemadvise.html "Interface documentation") | C binding
71  | [hipMemRangeGetAttribute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemrangegetattribute.html "Interface documentation") | C binding
72  | [hipMemRangeGetAttributes](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemrangegetattributes.html "Interface documentation") | C binding
73  | [hipStreamAttachMemAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamattachmemasync.html "Interface documentation") | C binding
74  | [hipHostAlloc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiphostalloc.html "Interface documentation") | C binding
75  | [hipMallocPitch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmallocpitch.html "Interface documentation") | C binding
76  | [hipMemAllocPitch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemallocpitch.html "Interface documentation") | C binding
77  | [hipFreeHost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipfreehost.html "Interface documentation") | C binding
78  | [hipMemcpyWithStream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpywithstream.html "Interface documentation") | C binding
79  | [hipMemcpyHtoD](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpyhtod.html "Interface documentation") | C binding
80  | [hipMemcpyDtoH](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpydtoh.html "Interface documentation") | C binding
81  | [hipMemcpyDtoD](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpydtod.html "Interface documentation") | C binding
82  | [hipMemcpyHtoDAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpyhtodasync.html "Interface documentation") | C binding
83  | [hipMemcpyDtoHAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpydtohasync.html "Interface documentation") | C binding
84  | [hipMemcpyDtoDAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpydtodasync.html "Interface documentation") | C binding
85  | [hipModuleGetGlobal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmodulegetglobal.html "Interface documentation") | C binding
86  | [hipGetSymbolAddress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgetsymboladdress.html "Interface documentation") | C binding
87  | [hipGetSymbolSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgetsymbolsize.html "Interface documentation") | C binding
88  | [hipMemcpyToSymbol](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpytosymbol.html "Interface documentation") | C binding
89  | [hipMemcpyToSymbolAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpytosymbolasync.html "Interface documentation") | C binding
90  | [hipMemcpyFromSymbol](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpyfromsymbol.html "Interface documentation") | C binding
91  | [hipMemcpyFromSymbolAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpyfromsymbolasync.html "Interface documentation") | C binding
92  | [hipMemset](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemset.html "Interface documentation") | C binding
93  | [hipMemsetD8](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemsetd8.html "Interface documentation") | C binding
94  | [hipMemsetD8Async](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemsetd8async.html "Interface documentation") | C binding
95  | [hipMemsetD16](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemsetd16.html "Interface documentation") | C binding
96  | [hipMemsetD16Async](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemsetd16async.html "Interface documentation") | C binding
97  | [hipMemsetD32](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemsetd32.html "Interface documentation") | C binding
98  | [hipMemsetAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemsetasync.html "Interface documentation") | C binding
99  | [hipMemsetD32Async](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemsetd32async.html "Interface documentation") | C binding
100 | [hipMemset2D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemset2d.html "Interface documentation") | C binding
101 | [hipMemset2DAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemset2dasync.html "Interface documentation") | C binding
102 | [hipMemset3D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemset3d.html "Interface documentation") | C binding
103 | [hipMemset3DAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemset3dasync.html "Interface documentation") | C binding
104 | [hipMemGetInfo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemgetinfo.html "Interface documentation") | C binding
105 | [hipMemPtrGetInfo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemptrgetinfo.html "Interface documentation") | C binding
106 | [hipMallocArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmallocarray.html "Interface documentation") | C binding
107 | [hipArrayCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiparraycreate.html "Interface documentation") | C binding
108 | [hipArrayDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiparraydestroy.html "Interface documentation") | C binding
109 | [hipArray3DCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiparray3dcreate.html "Interface documentation") | C binding
110 | [hipMalloc3D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmalloc3d.html "Interface documentation") | C binding
111 | [hipFreeArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipfreearray.html "Interface documentation") | C binding
112 | [hipFreeMipmappedArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipfreemipmappedarray.html "Interface documentation") | C binding
113 | [hipMalloc3DArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmalloc3darray.html "Interface documentation") | C binding
114 | [hipMallocMipmappedArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmallocmipmappedarray.html "Interface documentation") | C binding
115 | [hipGetMipmappedArrayLevel](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgetmipmappedarraylevel.html "Interface documentation") | C binding
116 | [hipMemcpyParam2D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpyparam2d.html "Interface documentation") | C binding
117 | [hipMemcpyParam2DAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpyparam2dasync.html "Interface documentation") | C binding
118 | [hipMemcpy2DToArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpy2dtoarray.html "Interface documentation") | C binding
119 | [hipMemcpy2DToArrayAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpy2dtoarrayasync.html "Interface documentation") | C binding
120 | [hipMemcpyToArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpytoarray.html "Interface documentation") | C binding
121 | [hipMemcpyFromArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpyfromarray.html "Interface documentation") | C binding
122 | [hipMemcpy2DFromArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpy2dfromarray.html "Interface documentation") | C binding
123 | [hipMemcpy2DFromArrayAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpy2dfromarrayasync.html "Interface documentation") | C binding
124 | [hipMemcpyAtoH](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpyatoh.html "Interface documentation") | C binding
125 | [hipMemcpyHtoA](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpyhtoa.html "Interface documentation") | C binding
126 | [hipMemcpy3D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpy3d.html "Interface documentation") | C binding
127 | [hipMemcpy3DAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpy3dasync.html "Interface documentation") | C binding
128 | [hipDrvMemcpy3D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdrvmemcpy3d.html "Interface documentation") | C binding
129 | [hipDrvMemcpy3DAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdrvmemcpy3dasync.html "Interface documentation") | C binding
130 | [hipDeviceCanAccessPeer](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicecanaccesspeer.html "Interface documentation") | C binding
131 | [hipDeviceEnablePeerAccess](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdeviceenablepeeraccess.html "Interface documentation") | C binding
132 | [hipDeviceDisablePeerAccess](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdevicedisablepeeraccess.html "Interface documentation") | C binding
133 | [hipMemGetAddressRange](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemgetaddressrange.html "Interface documentation") | C binding
134 | [hipMemcpyPeer](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpypeer.html "Interface documentation") | C binding
135 | [hipMemcpyPeerAsync](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmemcpypeerasync.html "Interface documentation") | C binding
136 | [hipCtxCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxcreate.html "Interface documentation") | C binding
137 | [hipCtxDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxdestroy.html "Interface documentation") | C binding
138 | [hipCtxPopCurrent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxpopcurrent.html "Interface documentation") | C binding
139 | [hipCtxPushCurrent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxpushcurrent.html "Interface documentation") | C binding
140 | [hipCtxSetCurrent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxsetcurrent.html "Interface documentation") | C binding
141 | [hipCtxGetCurrent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxgetcurrent.html "Interface documentation") | C binding
142 | [hipCtxGetDevice](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxgetdevice.html "Interface documentation") | C binding
143 | [hipCtxGetApiVersion](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxgetapiversion.html "Interface documentation") | C binding
144 | [hipCtxGetCacheConfig](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxgetcacheconfig.html "Interface documentation") | C binding
145 | [hipCtxSetCacheConfig](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxsetcacheconfig.html "Interface documentation") | C binding
146 | [hipCtxSetSharedMemConfig](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxsetsharedmemconfig.html "Interface documentation") | C binding
147 | [hipCtxGetSharedMemConfig](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxgetsharedmemconfig.html "Interface documentation") | C binding
148 | [hipCtxSynchronize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxsynchronize.html "Interface documentation") | C binding
149 | [hipCtxGetFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxgetflags.html "Interface documentation") | C binding
150 | [hipCtxEnablePeerAccess](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxenablepeeraccess.html "Interface documentation") | C binding
151 | [hipCtxDisablePeerAccess](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipctxdisablepeeraccess.html "Interface documentation") | C binding
152 | [hipDevicePrimaryCtxGetState](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdeviceprimaryctxgetstate.html "Interface documentation") | C binding
153 | [hipDevicePrimaryCtxRelease](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdeviceprimaryctxrelease.html "Interface documentation") | C binding
154 | [hipDevicePrimaryCtxRetain](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdeviceprimaryctxretain.html "Interface documentation") | C binding
155 | [hipDevicePrimaryCtxReset](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdeviceprimaryctxreset.html "Interface documentation") | C binding
156 | [hipDevicePrimaryCtxSetFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdeviceprimaryctxsetflags.html "Interface documentation") | C binding
157 | [hipModuleLoad](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmoduleload.html "Interface documentation") | C binding
158 | [hipModuleUnload](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmoduleunload.html "Interface documentation") | C binding
159 | [hipModuleGetFunction](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmodulegetfunction.html "Interface documentation") | C binding
160 | [hipFuncGetAttributes](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipfuncgetattributes.html "Interface documentation") | C binding
161 | [hipFuncGetAttribute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipfuncgetattribute.html "Interface documentation") | C binding
162 | [hipModuleGetTexRef](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmodulegettexref.html "Interface documentation") | C binding
163 | [hipModuleLoadData](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmoduleloaddata.html "Interface documentation") | C binding
164 | [hipModuleLoadDataEx](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmoduleloaddataex.html "Interface documentation") | C binding
165 | [hipModuleLaunchKernel](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmodulelaunchkernel.html "Interface documentation") | C binding
166 | [hipLaunchCooperativeKernel](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiplaunchcooperativekernel.html "Interface documentation") | C binding
167 | [hipLaunchCooperativeKernelMultiDevice](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiplaunchcooperativekernelmultidevice.html "Interface documentation") | C binding
168 | [hipExtLaunchMultiKernelMultiDevice](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipextlaunchmultikernelmultidevice.html "Interface documentation") | C binding
169 | [hipModuleOccupancyMaxPotentialBlockSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmoduleoccupancymaxpotentialblocksize.html "Interface documentation") | C binding
170 | [hipModuleOccupancyMaxPotentialBlockSizeWithFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmoduleoccupancymaxpotentialblocksizewithflags.html "Interface documentation") | C binding
171 | [hipModuleOccupancyMaxActiveBlocksPerMultiprocessor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmoduleoccupancymaxactiveblockspermultiprocessor.html "Interface documentation") | C binding
172 | [hipOccupancyMaxActiveBlocksPerMultiprocessor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipoccupancymaxactiveblockspermultiprocessor.html "Interface documentation") | C binding
173 | [hipOccupancyMaxActiveBlocksPerMultiprocessorWithFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipoccupancymaxactiveblockspermultiprocessorwithflags.html "Interface documentation") | C binding
174 | [hipOccupancyMaxPotentialBlockSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipoccupancymaxpotentialblocksize.html "Interface documentation") | C binding
175 | [hipProfilerStart](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipprofilerstart.html "Interface documentation") | C binding
176 | [hipProfilerStop](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipprofilerstop.html "Interface documentation") | C binding
177 | [hipConfigureCall](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipconfigurecall.html "Interface documentation") | C binding
178 | [hipSetupArgument](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipsetupargument.html "Interface documentation") | C binding
179 | [hipLaunchByPtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiplaunchbyptr.html "Interface documentation") | C binding
180 | [hipLaunchKernel](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiplaunchkernel.html "Interface documentation") | C binding
181 | [hipDrvMemcpy2DUnaligned](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdrvmemcpy2dunaligned.html "Interface documentation") | C binding
182 | [hipExtLaunchKernel](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipextlaunchkernel.html "Interface documentation") | C binding
183 | [hipBindTexture](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipbindtexture.html "Interface documentation") | C binding
184 | [hipBindTexture2D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipbindtexture2d.html "Interface documentation") | C binding
185 | [hipBindTextureToArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipbindtexturetoarray.html "Interface documentation") | C binding
186 | [hipGetTextureAlignmentOffset](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgettexturealignmentoffset.html "Interface documentation") | C binding
187 | [hipUnbindTexture](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipunbindtexture.html "Interface documentation") | C binding
188 | [hipTexRefGetAddress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefgetaddress.html "Interface documentation") | C binding
189 | [hipTexRefGetAddressMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefgetaddressmode.html "Interface documentation") | C binding
190 | [hipTexRefGetFilterMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefgetfiltermode.html "Interface documentation") | C binding
191 | [hipTexRefGetFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefgetflags.html "Interface documentation") | C binding
192 | [hipTexRefGetFormat](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefgetformat.html "Interface documentation") | C binding
193 | [hipTexRefGetMaxAnisotropy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefgetmaxanisotropy.html "Interface documentation") | C binding
194 | [hipTexRefGetMipmapFilterMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefgetmipmapfiltermode.html "Interface documentation") | C binding
195 | [hipTexRefGetMipmapLevelBias](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefgetmipmaplevelbias.html "Interface documentation") | C binding
196 | [hipTexRefGetMipmapLevelClamp](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefgetmipmaplevelclamp.html "Interface documentation") | C binding
197 | [hipTexRefGetMipMappedArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefgetmipmappedarray.html "Interface documentation") | C binding
198 | [hipTexRefSetAddress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetaddress.html "Interface documentation") | C binding
199 | [hipTexRefSetAddress2D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetaddress2d.html "Interface documentation") | C binding
200 | [hipTexRefSetMaxAnisotropy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetmaxanisotropy.html "Interface documentation") | C binding
201 | [hipBindTextureToMipmappedArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipbindtexturetomipmappedarray.html "Interface documentation") | C binding
202 | [hipCreateTextureObject](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipcreatetextureobject.html "Interface documentation") | C binding
203 | [hipDestroyTextureObject](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipdestroytextureobject.html "Interface documentation") | C binding
204 | [hipGetChannelDesc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgetchanneldesc.html "Interface documentation") | C binding
205 | [hipGetTextureObjectResourceDesc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgettextureobjectresourcedesc.html "Interface documentation") | C binding
206 | [hipGetTextureObjectResourceViewDesc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgettextureobjectresourceviewdesc.html "Interface documentation") | C binding
207 | [hipGetTextureObjectTextureDesc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgettextureobjecttexturedesc.html "Interface documentation") | C binding
208 | [hipTexRefSetAddressMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetaddressmode.html "Interface documentation") | C binding
209 | [hipTexRefSetArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetarray.html "Interface documentation") | C binding
210 | [hipTexRefSetFilterMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetfiltermode.html "Interface documentation") | C binding
211 | [hipTexRefSetFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetflags.html "Interface documentation") | C binding
212 | [hipTexRefSetFormat](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetformat.html "Interface documentation") | C binding
213 | [hipTexObjectCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexobjectcreate.html "Interface documentation") | C binding
214 | [hipTexObjectDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexobjectdestroy.html "Interface documentation") | C binding
215 | [hipTexObjectGetResourceDesc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexobjectgetresourcedesc.html "Interface documentation") | C binding
216 | [hipTexObjectGetResourceViewDesc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexobjectgetresourceviewdesc.html "Interface documentation") | C binding
217 | [hipTexObjectGetTextureDesc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexobjectgettexturedesc.html "Interface documentation") | C binding
218 | [hipTexRefSetBorderColor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetbordercolor.html "Interface documentation") | C binding
219 | [hipTexRefSetMipmapFilterMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetmipmapfiltermode.html "Interface documentation") | C binding
220 | [hipTexRefSetMipmapLevelBias](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetmipmaplevelbias.html "Interface documentation") | C binding
221 | [hipTexRefSetMipmapLevelClamp](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetmipmaplevelclamp.html "Interface documentation") | C binding
222 | [hipTexRefSetMipmappedArray](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hiptexrefsetmipmappedarray.html "Interface documentation") | C binding
223 | [hipMipmappedArrayCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmipmappedarraycreate.html "Interface documentation") | C binding
224 | [hipMipmappedArrayDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmipmappedarraydestroy.html "Interface documentation") | C binding
225 | [hipMipmappedArrayGetLevel](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipmipmappedarraygetlevel.html "Interface documentation") | C binding
226 | [hipRegisterApiCallback](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipregisterapicallback.html "Interface documentation") | C binding
227 | [hipRemoveApiCallback](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipremoveapicallback.html "Interface documentation") | C binding
228 | [hipRegisterActivityCallback](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipregisteractivitycallback.html "Interface documentation") | C binding
229 | [hipRemoveActivityCallback](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipremoveactivitycallback.html "Interface documentation") | C binding
230 | [hipStreamBeginCapture](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreambegincapture.html "Interface documentation") | C binding
231 | [hipStreamEndCapture](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamendcapture.html "Interface documentation") | C binding
232 | [hipStreamGetCaptureInfo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamgetcaptureinfo.html "Interface documentation") | C binding
233 | [hipStreamGetCaptureInfo_v2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamgetcaptureinfo__v2.html "Interface documentation") | C binding
234 | [hipStreamIsCapturing](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamiscapturing.html "Interface documentation") | C binding
235 | [hipStreamUpdateCaptureDependencies](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipstreamupdatecapturedependencies.html "Interface documentation") | C binding
236 | [hipGraphCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphcreate.html "Interface documentation") | C binding
237 | [hipGraphDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphdestroy.html "Interface documentation") | C binding
238 | [hipGraphAddDependencies](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphadddependencies.html "Interface documentation") | C binding
239 | [hipGraphRemoveDependencies](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphremovedependencies.html "Interface documentation") | C binding
240 | [hipGraphGetEdges](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphgetedges.html "Interface documentation") | C binding
241 | [hipGraphGetNodes](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphgetnodes.html "Interface documentation") | C binding
242 | [hipGraphGetRootNodes](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphgetrootnodes.html "Interface documentation") | C binding
243 | [hipGraphNodeGetDependencies](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphnodegetdependencies.html "Interface documentation") | C binding
244 | [hipGraphNodeGetDependentNodes](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphnodegetdependentnodes.html "Interface documentation") | C binding
245 | [hipGraphNodeGetType](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphnodegettype.html "Interface documentation") | C binding
246 | [hipGraphDestroyNode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphdestroynode.html "Interface documentation") | C binding
247 | [hipGraphClone](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphclone.html "Interface documentation") | C binding
248 | [hipGraphNodeFindInClone](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphnodefindinclone.html "Interface documentation") | C binding
249 | [hipGraphInstantiate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphinstantiate.html "Interface documentation") | C binding
250 | [hipGraphInstantiateWithFlags](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphinstantiatewithflags.html "Interface documentation") | C binding
251 | [hipGraphLaunch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphlaunch.html "Interface documentation") | C binding
252 | [hipGraphExecDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexecdestroy.html "Interface documentation") | C binding
253 | [hipGraphExecUpdate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexecupdate.html "Interface documentation") | C binding
254 | [hipGraphAddKernelNode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddkernelnode.html "Interface documentation") | C binding
255 | [hipGraphKernelNodeGetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphkernelnodegetparams.html "Interface documentation") | C binding
256 | [hipGraphKernelNodeSetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphkernelnodesetparams.html "Interface documentation") | C binding
257 | [hipGraphExecKernelNodeSetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexeckernelnodesetparams.html "Interface documentation") | C binding
258 | [hipGraphAddMemcpyNode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddmemcpynode.html "Interface documentation") | C binding
259 | [hipGraphMemcpyNodeGetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphmemcpynodegetparams.html "Interface documentation") | C binding
260 | [hipGraphMemcpyNodeSetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphmemcpynodesetparams.html "Interface documentation") | C binding
261 | [hipGraphExecMemcpyNodeSetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexecmemcpynodesetparams.html "Interface documentation") | C binding
262 | [hipGraphAddMemcpyNode1D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddmemcpynode1d.html "Interface documentation") | C binding
263 | [hipGraphMemcpyNodeSetParams1D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphmemcpynodesetparams1d.html "Interface documentation") | C binding
264 | [hipGraphExecMemcpyNodeSetParams1D](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexecmemcpynodesetparams1d.html "Interface documentation") | C binding
265 | [hipGraphAddMemcpyNodeFromSymbol](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddmemcpynodefromsymbol.html "Interface documentation") | C binding
266 | [hipGraphMemcpyNodeSetParamsFromSymbol](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphmemcpynodesetparamsfromsymbol.html "Interface documentation") | C binding
267 | [hipGraphExecMemcpyNodeSetParamsFromSymbol](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexecmemcpynodesetparamsfromsymbol.html "Interface documentation") | C binding
268 | [hipGraphAddMemcpyNodeToSymbol](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddmemcpynodetosymbol.html "Interface documentation") | C binding
269 | [hipGraphMemcpyNodeSetParamsToSymbol](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphmemcpynodesetparamstosymbol.html "Interface documentation") | C binding
270 | [hipGraphExecMemcpyNodeSetParamsToSymbol](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexecmemcpynodesetparamstosymbol.html "Interface documentation") | C binding
271 | [hipGraphAddMemsetNode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddmemsetnode.html "Interface documentation") | C binding
272 | [hipGraphMemsetNodeGetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphmemsetnodegetparams.html "Interface documentation") | C binding
273 | [hipGraphMemsetNodeSetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphmemsetnodesetparams.html "Interface documentation") | C binding
274 | [hipGraphExecMemsetNodeSetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexecmemsetnodesetparams.html "Interface documentation") | C binding
275 | [hipGraphAddHostNode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddhostnode.html "Interface documentation") | C binding
276 | [hipGraphHostNodeGetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphhostnodegetparams.html "Interface documentation") | C binding
277 | [hipGraphHostNodeSetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphhostnodesetparams.html "Interface documentation") | C binding
278 | [hipGraphExecHostNodeSetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexechostnodesetparams.html "Interface documentation") | C binding
279 | [hipGraphAddChildGraphNode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddchildgraphnode.html "Interface documentation") | C binding
280 | [hipGraphChildGraphNodeGetGraph](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphchildgraphnodegetgraph.html "Interface documentation") | C binding
281 | [hipGraphExecChildGraphNodeSetParams](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexecchildgraphnodesetparams.html "Interface documentation") | C binding
282 | [hipGraphAddEmptyNode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddemptynode.html "Interface documentation") | C binding
283 | [hipGraphAddEventRecordNode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddeventrecordnode.html "Interface documentation") | C binding
284 | [hipGraphEventRecordNodeGetEvent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgrapheventrecordnodegetevent.html "Interface documentation") | C binding
285 | [hipGraphEventRecordNodeSetEvent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgrapheventrecordnodesetevent.html "Interface documentation") | C binding
286 | [hipGraphExecEventRecordNodeSetEvent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexeceventrecordnodesetevent.html "Interface documentation") | C binding
287 | [hipGraphAddEventWaitNode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphaddeventwaitnode.html "Interface documentation") | C binding
288 | [hipGraphEventWaitNodeGetEvent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgrapheventwaitnodegetevent.html "Interface documentation") | C binding
289 | [hipGraphEventWaitNodeSetEvent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgrapheventwaitnodesetevent.html "Interface documentation") | C binding
290 | [hipGraphExecEventWaitNodeSetEvent](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort_1_1hipgraphexeceventwaitnodesetevent.html "Interface documentation") | C binding

# hipSOLVER API support

\# | API Name | Variants
----|---------------|---------
1 | [hipsolverCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercreate.html "Interface documentation") | C binding
2 | [hipsolverDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdestroy.html "Interface documentation") | C binding
3 | [hipsolverSetStream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversetstream.html "Interface documentation") | C binding
4 | [hipsolverGetStream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvergetstream.html "Interface documentation") | C binding
5 | [hipsolverSorgbr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversorgbr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
6 | [hipsolverDorgbr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdorgbr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
7 | [hipsolverCungbr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercungbr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
8 | [hipsolverZungbr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzungbr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
9 | [hipsolverSorgbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversorgbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
10 | [hipsolverDorgbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdorgbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
11 | [hipsolverCungbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercungbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
12 | [hipsolverZungbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzungbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
13 | [hipsolverSorgqr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversorgqr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
14 | [hipsolverDorgqr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdorgqr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
15 | [hipsolverCungqr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercungqr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
16 | [hipsolverZungqr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzungqr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
17 | [hipsolverSorgqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversorgqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
18 | [hipsolverDorgqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdorgqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
19 | [hipsolverCungqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercungqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
20 | [hipsolverZungqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzungqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
21 | [hipsolverSorgtr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversorgtr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
22 | [hipsolverDorgtr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdorgtr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
23 | [hipsolverCungtr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercungtr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
24 | [hipsolverZungtr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzungtr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
25 | [hipsolverSorgtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversorgtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
26 | [hipsolverDorgtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdorgtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
27 | [hipsolverCungtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercungtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
28 | [hipsolverZungtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzungtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
29 | [hipsolverSormqr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversormqr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
30 | [hipsolverDormqr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdormqr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
31 | [hipsolverCunmqr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercunmqr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
32 | [hipsolverZunmqr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzunmqr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
33 | [hipsolverSormqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversormqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
34 | [hipsolverDormqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdormqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
35 | [hipsolverCunmqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercunmqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
36 | [hipsolverZunmqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzunmqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
37 | [hipsolverSormtr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversormtr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
38 | [hipsolverDormtr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdormtr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
39 | [hipsolverCunmtr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercunmtr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
40 | [hipsolverZunmtr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzunmtr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
41 | [hipsolverSormtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversormtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
42 | [hipsolverDormtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdormtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
43 | [hipsolverCunmtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercunmtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
44 | [hipsolverZunmtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzunmtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
45 | [hipsolverSgebrd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversgebrd__buffersize.html "Interface documentation") | C binding
46 | [hipsolverDgebrd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdgebrd__buffersize.html "Interface documentation") | C binding
47 | [hipsolverCgebrd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercgebrd__buffersize.html "Interface documentation") | C binding
48 | [hipsolverZgebrd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzgebrd__buffersize.html "Interface documentation") | C binding
49 | [hipsolverSgebrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversgebrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
50 | [hipsolverDgebrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdgebrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
51 | [hipsolverCgebrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercgebrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
52 | [hipsolverZgebrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzgebrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
53 | [hipsolverSgeqrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversgeqrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
54 | [hipsolverDgeqrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdgeqrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
55 | [hipsolverCgeqrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercgeqrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
56 | [hipsolverZgeqrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzgeqrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
57 | [hipsolverSgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
58 | [hipsolverDgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
59 | [hipsolverCgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
60 | [hipsolverZgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
61 | [hipsolverSSgesv_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverssgesv__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
62 | [hipsolverDDgesv_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverddgesv__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
63 | [hipsolverCCgesv_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverccgesv__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
64 | [hipsolverZZgesv_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzzgesv__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
65 | [hipsolverSSgesv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverssgesv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
66 | [hipsolverDDgesv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverddgesv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
67 | [hipsolverCCgesv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverccgesv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
68 | [hipsolverZZgesv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzzgesv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
69 | [hipsolverSgetrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversgetrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
70 | [hipsolverDgetrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdgetrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
71 | [hipsolverCgetrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercgetrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
72 | [hipsolverZgetrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzgetrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
73 | [hipsolverSgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
74 | [hipsolverDgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
75 | [hipsolverCgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
76 | [hipsolverZgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
77 | [hipsolverSgetrs_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversgetrs__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
78 | [hipsolverDgetrs_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdgetrs__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
79 | [hipsolverCgetrs_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercgetrs__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
80 | [hipsolverZgetrs_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzgetrs__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
81 | [hipsolverSgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolversgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
82 | [hipsolverDgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
83 | [hipsolverCgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
84 | [hipsolverZgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
85 | [hipsolverSpotrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverspotrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
86 | [hipsolverDpotrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdpotrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
87 | [hipsolverCpotrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercpotrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
88 | [hipsolverZpotrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzpotrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
89 | [hipsolverSpotrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverspotrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
90 | [hipsolverDpotrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdpotrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
91 | [hipsolverCpotrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercpotrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
92 | [hipsolverZpotrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzpotrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
93 | [hipsolverSpotrfBatched_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverspotrfbatched__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
94 | [hipsolverDpotrfBatched_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdpotrfbatched__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
95 | [hipsolverCpotrfBatched_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercpotrfbatched__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
96 | [hipsolverZpotrfBatched_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzpotrfbatched__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
97 | [hipsolverSpotrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverspotrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
98 | [hipsolverDpotrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdpotrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
99 | [hipsolverCpotrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercpotrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
100 | [hipsolverZpotrfBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzpotrfbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
101 | [hipsolverSpotri_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverspotri__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
102 | [hipsolverDpotri_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdpotri__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
103 | [hipsolverCpotri_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercpotri__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
104 | [hipsolverZpotri_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzpotri__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
105 | [hipsolverSpotri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverspotri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
106 | [hipsolverDpotri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdpotri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
107 | [hipsolverCpotri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercpotri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
108 | [hipsolverZpotri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzpotri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
109 | [hipsolverSpotrs_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverspotrs__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
110 | [hipsolverDpotrs_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdpotrs__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
111 | [hipsolverCpotrs_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercpotrs__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
112 | [hipsolverZpotrs_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzpotrs__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
113 | [hipsolverSpotrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverspotrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
114 | [hipsolverDpotrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdpotrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
115 | [hipsolverCpotrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercpotrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
116 | [hipsolverZpotrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzpotrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
117 | [hipsolverSpotrsBatched_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverspotrsbatched__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
118 | [hipsolverDpotrsBatched_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdpotrsbatched__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
119 | [hipsolverCpotrsBatched_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercpotrsbatched__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
120 | [hipsolverZpotrsBatched_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzpotrsbatched__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
121 | [hipsolverSpotrsBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverspotrsbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
122 | [hipsolverDpotrsBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdpotrsbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
123 | [hipsolverCpotrsBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercpotrsbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
124 | [hipsolverZpotrsBatched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzpotrsbatched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
125 | [hipsolverSsyevd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverssyevd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
126 | [hipsolverDsyevd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdsyevd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
127 | [hipsolverCheevd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercheevd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
128 | [hipsolverZheevd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzheevd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
129 | [hipsolverSsyevd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverssyevd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
130 | [hipsolverDsyevd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdsyevd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
131 | [hipsolverCheevd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercheevd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
132 | [hipsolverZheevd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzheevd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
133 | [hipsolverSsygvd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverssygvd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
134 | [hipsolverDsygvd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdsygvd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
135 | [hipsolverChegvd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverchegvd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
136 | [hipsolverZhegvd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzhegvd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
137 | [hipsolverSsygvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverssygvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
138 | [hipsolverDsygvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdsygvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
139 | [hipsolverChegvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverchegvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
140 | [hipsolverZhegvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzhegvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
141 | [hipsolverSsytrd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverssytrd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
142 | [hipsolverDsytrd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdsytrd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
143 | [hipsolverChetrd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverchetrd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
144 | [hipsolverZhetrd_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzhetrd__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
145 | [hipsolverSsytrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverssytrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
146 | [hipsolverDsytrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdsytrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
147 | [hipsolverChetrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverchetrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
148 | [hipsolverZhetrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzhetrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
149 | [hipsolverSsytrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverssytrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
150 | [hipsolverDsytrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdsytrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
151 | [hipsolverCsytrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercsytrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
152 | [hipsolverZsytrf_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzsytrf__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
153 | [hipsolverSsytrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverssytrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
154 | [hipsolverDsytrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverdsytrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
155 | [hipsolverCsytrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolvercsytrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
156 | [hipsolverZsytrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsolver_1_1hipsolverzsytrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1

# rocFFT API Support

\# | API Name | Variants
----|---------------|---------
1 | [rocfft_setup](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__setup.html "Interface documentation") | C binding
2 | [rocfft_cleanup](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__cleanup.html "Interface documentation") | C binding
3 | [rocfft_plan_create](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__plan__create.html "Interface documentation") | C binding, rank_0, rank_1
4 | [rocfft_execute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__execute.html "Interface documentation") | C binding
5 | [rocfft_plan_destroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__plan__destroy.html "Interface documentation") | C binding
6 | [rocfft_plan_description_set_scale_float](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__plan__description__set__scale__float.html "Interface documentation") | C binding
7 | [rocfft_plan_description_set_scale_double](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__plan__description__set__scale__double.html "Interface documentation") | C binding
8 | [rocfft_plan_description_set_data_layout](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__plan__description__set__data__layout.html "Interface documentation") | C binding, rank_0, rank_1
9 | [rocfft_get_version_string](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__get__version__string.html "Interface documentation") | C binding
10 | [rocfft_plan_description_set_devices](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__plan__description__set__devices.html "Interface documentation") | C binding
11 | [rocfft_plan_get_work_buffer_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__plan__get__work__buffer__size.html "Interface documentation") | C binding
12 | [rocfft_plan_get_print](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__plan__get__print.html "Interface documentation") | C binding
13 | [rocfft_plan_description_create](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__plan__description__create.html "Interface documentation") | C binding
14 | [rocfft_plan_description_destroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__plan__description__destroy.html "Interface documentation") | C binding
15 | [rocfft_execution_info_create](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__execution__info__create.html "Interface documentation") | C binding
16 | [rocfft_execution_info_destroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__execution__info__destroy.html "Interface documentation") | C binding
17 | [rocfft_execution_info_set_work_buffer](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__execution__info__set__work__buffer.html "Interface documentation") | C binding
18 | [rocfft_execution_info_set_mode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__execution__info__set__mode.html "Interface documentation") | C binding
19 | [rocfft_execution_info_set_stream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__execution__info__set__stream.html "Interface documentation") | C binding
20 | [rocfft_execution_info_set_load_callback](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__execution__info__set__load__callback.html "Interface documentation") | C binding
21 | [rocfft_execution_info_set_store_callback](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__execution__info__set__store__callback.html "Interface documentation") | C binding
22 | [rocfft_execution_info_get_events](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__execution__info__get__events.html "Interface documentation") | C binding
23 | [rocfft_cache_serialize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__cache__serialize.html "Interface documentation") | C binding
24 | [rocfft_cache_buffer_free](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__cache__buffer__free.html "Interface documentation") | C binding
25 | [rocfft_cache_deserialize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocfft_1_1rocfft__cache__deserialize.html "Interface documentation") | C binding

# rocSOLVER API Support

\# | API Name | Variants
----|---------------|---------
1 | [rocsolver_create_handle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__create__handle.html "Interface documentation") | C binding
2 | [rocsolver_destroy_handle](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__destroy__handle.html "Interface documentation") | C binding
3 | [rocsolver_set_stream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__set__stream.html "Interface documentation") | C binding
4 | [rocsolver_get_stream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__get__stream.html "Interface documentation") | C binding
5 | [rocsolver_set_matrix](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__set__matrix.html "Interface documentation") | C binding
6 | [rocsolver_get_matrix](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__get__matrix.html "Interface documentation") | C binding
7 | [rocsolver_get_version_string](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__get__version__string.html "Interface documentation") | C binding
8 | [rocsolver_get_version_string_size](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__get__version__string__size.html "Interface documentation") | C binding
9 | [rocsolver_log_begin](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__log__begin.html "Interface documentation") | C binding
10 | [rocsolver_log_end](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__log__end.html "Interface documentation") | C binding
11 | [rocsolver_log_set_layer_mode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__log__set__layer__mode.html "Interface documentation") | C binding
12 | [rocsolver_log_set_max_levels](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__log__set__max__levels.html "Interface documentation") | C binding
13 | [rocsolver_log_restore_defaults](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__log__restore__defaults.html "Interface documentation") | C binding
14 | [rocsolver_log_write_profile](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__log__write__profile.html "Interface documentation") | C binding
15 | [rocsolver_log_flush_profile](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__log__flush__profile.html "Interface documentation") | C binding
16 | [rocsolver_clacgv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__clacgv.html "Interface documentation") | C binding, rank_0, rank_1
17 | [rocsolver_zlacgv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zlacgv.html "Interface documentation") | C binding, rank_0, rank_1
18 | [rocsolver_slaswp](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__slaswp.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
19 | [rocsolver_dlaswp](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dlaswp.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
20 | [rocsolver_claswp](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__claswp.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
21 | [rocsolver_zlaswp](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zlaswp.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
22 | [rocsolver_slarfg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__slarfg.html "Interface documentation") | C binding, rank_0, rank_1
23 | [rocsolver_dlarfg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dlarfg.html "Interface documentation") | C binding, rank_0, rank_1
24 | [rocsolver_clarfg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__clarfg.html "Interface documentation") | C binding, rank_0, rank_1
25 | [rocsolver_zlarfg](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zlarfg.html "Interface documentation") | C binding, rank_0, rank_1
26 | [rocsolver_slarft](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__slarft.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
27 | [rocsolver_dlarft](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dlarft.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
28 | [rocsolver_clarft](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__clarft.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
29 | [rocsolver_zlarft](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zlarft.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
30 | [rocsolver_slarf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__slarf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
31 | [rocsolver_dlarf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dlarf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
32 | [rocsolver_clarf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__clarf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
33 | [rocsolver_zlarf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zlarf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
34 | [rocsolver_slarfb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__slarfb.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
35 | [rocsolver_dlarfb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dlarfb.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
36 | [rocsolver_clarfb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__clarfb.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
37 | [rocsolver_zlarfb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zlarfb.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
38 | [rocsolver_slabrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__slabrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
39 | [rocsolver_dlabrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dlabrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
40 | [rocsolver_clabrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__clabrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
41 | [rocsolver_zlabrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zlabrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
42 | [rocsolver_slatrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__slatrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
43 | [rocsolver_dlatrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dlatrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
44 | [rocsolver_clatrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__clatrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
45 | [rocsolver_zlatrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zlatrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
46 | [rocsolver_slasyf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__slasyf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
47 | [rocsolver_dlasyf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dlasyf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
48 | [rocsolver_clasyf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__clasyf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
49 | [rocsolver_zlasyf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zlasyf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
50 | [rocsolver_sorg2r](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorg2r.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
51 | [rocsolver_dorg2r](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorg2r.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
52 | [rocsolver_cung2r](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cung2r.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
53 | [rocsolver_zung2r](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zung2r.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
54 | [rocsolver_sorgqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorgqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
55 | [rocsolver_dorgqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorgqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
56 | [rocsolver_cungqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cungqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
57 | [rocsolver_zungqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zungqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
58 | [rocsolver_sorgl2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorgl2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
59 | [rocsolver_dorgl2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorgl2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
60 | [rocsolver_cungl2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cungl2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
61 | [rocsolver_zungl2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zungl2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
62 | [rocsolver_sorglq](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorglq.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
63 | [rocsolver_dorglq](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorglq.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
64 | [rocsolver_cunglq](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cunglq.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
65 | [rocsolver_zunglq](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zunglq.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
66 | [rocsolver_sorg2l](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorg2l.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
67 | [rocsolver_dorg2l](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorg2l.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
68 | [rocsolver_cung2l](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cung2l.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
69 | [rocsolver_zung2l](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zung2l.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
70 | [rocsolver_sorgql](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorgql.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
71 | [rocsolver_dorgql](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorgql.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
72 | [rocsolver_cungql](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cungql.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
73 | [rocsolver_zungql](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zungql.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
74 | [rocsolver_sorgbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorgbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
75 | [rocsolver_dorgbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorgbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
76 | [rocsolver_cungbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cungbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
77 | [rocsolver_zungbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zungbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
78 | [rocsolver_sorgtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorgtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
79 | [rocsolver_dorgtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorgtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
80 | [rocsolver_cungtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cungtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
81 | [rocsolver_zungtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zungtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
82 | [rocsolver_sorm2r](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorm2r.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
83 | [rocsolver_dorm2r](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorm2r.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
84 | [rocsolver_cunm2r](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cunm2r.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
85 | [rocsolver_zunm2r](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zunm2r.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
86 | [rocsolver_sormqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sormqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
87 | [rocsolver_dormqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dormqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
88 | [rocsolver_cunmqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cunmqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
89 | [rocsolver_zunmqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zunmqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
90 | [rocsolver_sorml2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorml2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
91 | [rocsolver_dorml2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorml2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
92 | [rocsolver_cunml2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cunml2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
93 | [rocsolver_zunml2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zunml2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
94 | [rocsolver_sormlq](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sormlq.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
95 | [rocsolver_dormlq](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dormlq.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
96 | [rocsolver_cunmlq](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cunmlq.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
97 | [rocsolver_zunmlq](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zunmlq.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
98 | [rocsolver_sorm2l](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sorm2l.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
99 | [rocsolver_dorm2l](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dorm2l.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
100 | [rocsolver_cunm2l](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cunm2l.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
101 | [rocsolver_zunm2l](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zunm2l.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
102 | [rocsolver_sormql](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sormql.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
103 | [rocsolver_dormql](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dormql.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
104 | [rocsolver_cunmql](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cunmql.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
105 | [rocsolver_zunmql](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zunmql.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
106 | [rocsolver_sormbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sormbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
107 | [rocsolver_dormbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dormbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
108 | [rocsolver_cunmbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cunmbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
109 | [rocsolver_zunmbr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zunmbr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
110 | [rocsolver_sormtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sormtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
111 | [rocsolver_dormtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dormtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
112 | [rocsolver_cunmtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cunmtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
113 | [rocsolver_zunmtr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zunmtr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
114 | [rocsolver_sbdsqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sbdsqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
115 | [rocsolver_dbdsqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dbdsqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
116 | [rocsolver_cbdsqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cbdsqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
117 | [rocsolver_zbdsqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zbdsqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
118 | [rocsolver_ssterf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssterf.html "Interface documentation") | C binding, rank_0, rank_1
119 | [rocsolver_dsterf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsterf.html "Interface documentation") | C binding, rank_0, rank_1
120 | [rocsolver_ssteqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssteqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
121 | [rocsolver_dsteqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsteqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
122 | [rocsolver_csteqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__csteqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
123 | [rocsolver_zsteqr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zsteqr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
124 | [rocsolver_sstedc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sstedc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
125 | [rocsolver_dstedc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dstedc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
126 | [rocsolver_cstedc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cstedc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
127 | [rocsolver_zstedc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zstedc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
128 | [rocsolver_sgetf2_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetf2__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
129 | [rocsolver_dgetf2_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetf2__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
130 | [rocsolver_cgetf2_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetf2__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
131 | [rocsolver_zgetf2_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetf2__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
132 | [rocsolver_sgetf2_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetf2__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
133 | [rocsolver_dgetf2_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetf2__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
134 | [rocsolver_cgetf2_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetf2__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
135 | [rocsolver_zgetf2_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetf2__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
136 | [rocsolver_sgetf2_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetf2__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
137 | [rocsolver_dgetf2_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetf2__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
138 | [rocsolver_cgetf2_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetf2__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
139 | [rocsolver_zgetf2_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetf2__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
140 | [rocsolver_sgetrf_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetrf__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
141 | [rocsolver_dgetrf_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetrf__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
142 | [rocsolver_cgetrf_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetrf__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
143 | [rocsolver_zgetrf_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetrf__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
144 | [rocsolver_sgetrf_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetrf__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
145 | [rocsolver_dgetrf_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetrf__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
146 | [rocsolver_cgetrf_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetrf__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
147 | [rocsolver_zgetrf_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetrf__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
148 | [rocsolver_sgetrf_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetrf__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
149 | [rocsolver_dgetrf_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetrf__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
150 | [rocsolver_cgetrf_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetrf__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
151 | [rocsolver_zgetrf_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetrf__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
152 | [rocsolver_sgetf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
153 | [rocsolver_dgetf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
154 | [rocsolver_cgetf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
155 | [rocsolver_zgetf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
156 | [rocsolver_sgetf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
157 | [rocsolver_dgetf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
158 | [rocsolver_cgetf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
159 | [rocsolver_zgetf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
160 | [rocsolver_sgetf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
161 | [rocsolver_dgetf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
162 | [rocsolver_cgetf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
163 | [rocsolver_zgetf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
164 | [rocsolver_sgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
165 | [rocsolver_dgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
166 | [rocsolver_cgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
167 | [rocsolver_zgetrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
168 | [rocsolver_sgetrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
169 | [rocsolver_dgetrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
170 | [rocsolver_cgetrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
171 | [rocsolver_zgetrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
172 | [rocsolver_sgetrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
173 | [rocsolver_dgetrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
174 | [rocsolver_cgetrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
175 | [rocsolver_zgetrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
176 | [rocsolver_sgeqr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeqr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
177 | [rocsolver_dgeqr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeqr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
178 | [rocsolver_cgeqr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeqr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
179 | [rocsolver_zgeqr2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeqr2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
180 | [rocsolver_sgeqr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeqr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
181 | [rocsolver_dgeqr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeqr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
182 | [rocsolver_cgeqr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeqr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
183 | [rocsolver_zgeqr2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeqr2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
184 | [rocsolver_sgeqr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeqr2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
185 | [rocsolver_dgeqr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeqr2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
186 | [rocsolver_cgeqr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeqr2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
187 | [rocsolver_zgeqr2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeqr2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
188 | [rocsolver_sgerq2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgerq2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
189 | [rocsolver_dgerq2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgerq2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
190 | [rocsolver_cgerq2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgerq2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
191 | [rocsolver_zgerq2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgerq2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
192 | [rocsolver_sgerq2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgerq2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
193 | [rocsolver_dgerq2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgerq2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
194 | [rocsolver_cgerq2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgerq2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
195 | [rocsolver_zgerq2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgerq2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
196 | [rocsolver_sgerq2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgerq2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
197 | [rocsolver_dgerq2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgerq2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
198 | [rocsolver_cgerq2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgerq2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
199 | [rocsolver_zgerq2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgerq2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
200 | [rocsolver_sgeql2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeql2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
201 | [rocsolver_dgeql2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeql2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
202 | [rocsolver_cgeql2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeql2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
203 | [rocsolver_zgeql2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeql2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
204 | [rocsolver_sgeql2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeql2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
205 | [rocsolver_dgeql2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeql2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
206 | [rocsolver_cgeql2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeql2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
207 | [rocsolver_zgeql2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeql2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
208 | [rocsolver_sgeql2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeql2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
209 | [rocsolver_dgeql2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeql2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
210 | [rocsolver_cgeql2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeql2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
211 | [rocsolver_zgeql2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeql2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
212 | [rocsolver_sgelq2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgelq2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
213 | [rocsolver_dgelq2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgelq2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
214 | [rocsolver_cgelq2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgelq2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
215 | [rocsolver_zgelq2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgelq2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
216 | [rocsolver_sgelq2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgelq2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
217 | [rocsolver_dgelq2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgelq2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
218 | [rocsolver_cgelq2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgelq2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
219 | [rocsolver_zgelq2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgelq2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
220 | [rocsolver_sgelq2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgelq2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
221 | [rocsolver_dgelq2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgelq2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
222 | [rocsolver_cgelq2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgelq2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
223 | [rocsolver_zgelq2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgelq2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
224 | [rocsolver_sgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
225 | [rocsolver_dgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
226 | [rocsolver_cgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
227 | [rocsolver_zgeqrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeqrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
228 | [rocsolver_sgeqrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeqrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
229 | [rocsolver_dgeqrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeqrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
230 | [rocsolver_cgeqrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeqrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
231 | [rocsolver_zgeqrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeqrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
232 | [rocsolver_sgeqrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeqrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
233 | [rocsolver_dgeqrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeqrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
234 | [rocsolver_cgeqrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeqrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
235 | [rocsolver_zgeqrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeqrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
236 | [rocsolver_sgerqf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgerqf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
237 | [rocsolver_dgerqf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgerqf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
238 | [rocsolver_cgerqf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgerqf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
239 | [rocsolver_zgerqf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgerqf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
240 | [rocsolver_sgerqf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgerqf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
241 | [rocsolver_dgerqf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgerqf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
242 | [rocsolver_cgerqf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgerqf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
243 | [rocsolver_zgerqf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgerqf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
244 | [rocsolver_sgerqf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgerqf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
245 | [rocsolver_dgerqf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgerqf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
246 | [rocsolver_cgerqf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgerqf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
247 | [rocsolver_zgerqf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgerqf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
248 | [rocsolver_sgeqlf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeqlf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
249 | [rocsolver_dgeqlf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeqlf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
250 | [rocsolver_cgeqlf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeqlf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
251 | [rocsolver_zgeqlf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeqlf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
252 | [rocsolver_sgeqlf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeqlf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
253 | [rocsolver_dgeqlf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeqlf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
254 | [rocsolver_cgeqlf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeqlf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
255 | [rocsolver_zgeqlf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeqlf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
256 | [rocsolver_sgeqlf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgeqlf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
257 | [rocsolver_dgeqlf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgeqlf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
258 | [rocsolver_cgeqlf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgeqlf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
259 | [rocsolver_zgeqlf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgeqlf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
260 | [rocsolver_sgelqf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgelqf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
261 | [rocsolver_dgelqf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgelqf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
262 | [rocsolver_cgelqf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgelqf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
263 | [rocsolver_zgelqf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgelqf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
264 | [rocsolver_sgelqf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgelqf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
265 | [rocsolver_dgelqf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgelqf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
266 | [rocsolver_cgelqf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgelqf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
267 | [rocsolver_zgelqf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgelqf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
268 | [rocsolver_sgelqf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgelqf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
269 | [rocsolver_dgelqf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgelqf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
270 | [rocsolver_cgelqf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgelqf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
271 | [rocsolver_zgelqf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgelqf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
272 | [rocsolver_sgebd2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgebd2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
273 | [rocsolver_dgebd2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgebd2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
274 | [rocsolver_cgebd2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgebd2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
275 | [rocsolver_zgebd2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgebd2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
276 | [rocsolver_sgebd2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgebd2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
277 | [rocsolver_dgebd2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgebd2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
278 | [rocsolver_cgebd2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgebd2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
279 | [rocsolver_zgebd2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgebd2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
280 | [rocsolver_sgebd2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgebd2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
281 | [rocsolver_dgebd2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgebd2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
282 | [rocsolver_cgebd2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgebd2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
283 | [rocsolver_zgebd2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgebd2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
284 | [rocsolver_sgebrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgebrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
285 | [rocsolver_dgebrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgebrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
286 | [rocsolver_cgebrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgebrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
287 | [rocsolver_zgebrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgebrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
288 | [rocsolver_sgebrd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgebrd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
289 | [rocsolver_dgebrd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgebrd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
290 | [rocsolver_cgebrd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgebrd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
291 | [rocsolver_zgebrd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgebrd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
292 | [rocsolver_sgebrd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgebrd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
293 | [rocsolver_dgebrd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgebrd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
294 | [rocsolver_cgebrd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgebrd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
295 | [rocsolver_zgebrd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgebrd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
296 | [rocsolver_sgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
297 | [rocsolver_dgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
298 | [rocsolver_cgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
299 | [rocsolver_zgetrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
300 | [rocsolver_sgetrs_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetrs__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
301 | [rocsolver_dgetrs_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetrs__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
302 | [rocsolver_cgetrs_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetrs__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
303 | [rocsolver_zgetrs_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetrs__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
304 | [rocsolver_sgetrs_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetrs__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
305 | [rocsolver_dgetrs_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetrs__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
306 | [rocsolver_cgetrs_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetrs__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
307 | [rocsolver_zgetrs_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetrs__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
308 | [rocsolver_sgesv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgesv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
309 | [rocsolver_dgesv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgesv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
310 | [rocsolver_cgesv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgesv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
311 | [rocsolver_zgesv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgesv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
312 | [rocsolver_sgesv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgesv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
313 | [rocsolver_dgesv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgesv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
314 | [rocsolver_cgesv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgesv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
315 | [rocsolver_zgesv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgesv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
316 | [rocsolver_sgesv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgesv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
317 | [rocsolver_dgesv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgesv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
318 | [rocsolver_cgesv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgesv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
319 | [rocsolver_zgesv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgesv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
320 | [rocsolver_sgetri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
321 | [rocsolver_dgetri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
322 | [rocsolver_cgetri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
323 | [rocsolver_zgetri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
324 | [rocsolver_sgetri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
325 | [rocsolver_dgetri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
326 | [rocsolver_cgetri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
327 | [rocsolver_zgetri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
328 | [rocsolver_sgetri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
329 | [rocsolver_dgetri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
330 | [rocsolver_cgetri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
331 | [rocsolver_zgetri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
332 | [rocsolver_sgetri_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
333 | [rocsolver_dgetri_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
334 | [rocsolver_cgetri_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
335 | [rocsolver_zgetri_npvt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__npvt.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
336 | [rocsolver_sgetri_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
337 | [rocsolver_dgetri_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
338 | [rocsolver_cgetri_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
339 | [rocsolver_zgetri_npvt_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__npvt__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
340 | [rocsolver_sgetri_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
341 | [rocsolver_dgetri_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
342 | [rocsolver_cgetri_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
343 | [rocsolver_zgetri_npvt_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__npvt__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
344 | [rocsolver_sgels](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgels.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
345 | [rocsolver_dgels](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgels.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
346 | [rocsolver_cgels](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgels.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
347 | [rocsolver_zgels](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgels.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
348 | [rocsolver_sgels_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgels__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
349 | [rocsolver_dgels_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgels__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
350 | [rocsolver_cgels_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgels__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
351 | [rocsolver_zgels_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgels__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
352 | [rocsolver_sgels_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgels__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
353 | [rocsolver_dgels_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgels__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
354 | [rocsolver_cgels_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgels__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
355 | [rocsolver_zgels_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgels__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
356 | [rocsolver_spotf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
357 | [rocsolver_dpotf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
358 | [rocsolver_cpotf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
359 | [rocsolver_zpotf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
360 | [rocsolver_spotf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
361 | [rocsolver_dpotf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
362 | [rocsolver_cpotf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
363 | [rocsolver_zpotf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
364 | [rocsolver_spotf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
365 | [rocsolver_dpotf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
366 | [rocsolver_cpotf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
367 | [rocsolver_zpotf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
368 | [rocsolver_spotrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
369 | [rocsolver_dpotrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
370 | [rocsolver_cpotrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
371 | [rocsolver_zpotrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
372 | [rocsolver_spotrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
373 | [rocsolver_dpotrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
374 | [rocsolver_cpotrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
375 | [rocsolver_zpotrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
376 | [rocsolver_spotrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
377 | [rocsolver_dpotrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
378 | [rocsolver_cpotrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
379 | [rocsolver_zpotrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
380 | [rocsolver_spotrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
381 | [rocsolver_dpotrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
382 | [rocsolver_cpotrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
383 | [rocsolver_zpotrs](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotrs.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
384 | [rocsolver_spotrs_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotrs__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
385 | [rocsolver_dpotrs_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotrs__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
386 | [rocsolver_cpotrs_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotrs__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
387 | [rocsolver_zpotrs_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotrs__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
388 | [rocsolver_spotrs_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotrs__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
389 | [rocsolver_dpotrs_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotrs__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
390 | [rocsolver_cpotrs_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotrs__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
391 | [rocsolver_zpotrs_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotrs__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
392 | [rocsolver_sposv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sposv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
393 | [rocsolver_dposv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dposv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
394 | [rocsolver_cposv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cposv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
395 | [rocsolver_zposv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zposv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
396 | [rocsolver_sposv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sposv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
397 | [rocsolver_dposv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dposv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
398 | [rocsolver_cposv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cposv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
399 | [rocsolver_zposv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zposv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
400 | [rocsolver_sposv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sposv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
401 | [rocsolver_dposv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dposv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
402 | [rocsolver_cposv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cposv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
403 | [rocsolver_zposv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zposv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
404 | [rocsolver_spotri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
405 | [rocsolver_dpotri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
406 | [rocsolver_cpotri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
407 | [rocsolver_zpotri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
408 | [rocsolver_spotri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
409 | [rocsolver_dpotri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
410 | [rocsolver_cpotri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
411 | [rocsolver_zpotri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
412 | [rocsolver_spotri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__spotri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
413 | [rocsolver_dpotri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dpotri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
414 | [rocsolver_cpotri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cpotri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
415 | [rocsolver_zpotri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zpotri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
416 | [rocsolver_sgesvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgesvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
417 | [rocsolver_dgesvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgesvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
418 | [rocsolver_cgesvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgesvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
419 | [rocsolver_zgesvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgesvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
420 | [rocsolver_sgesvd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgesvd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
421 | [rocsolver_dgesvd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgesvd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
422 | [rocsolver_cgesvd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgesvd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
423 | [rocsolver_zgesvd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgesvd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
424 | [rocsolver_sgesvd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgesvd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
425 | [rocsolver_dgesvd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgesvd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
426 | [rocsolver_cgesvd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgesvd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
427 | [rocsolver_zgesvd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgesvd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
428 | [rocsolver_ssytd2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytd2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
429 | [rocsolver_dsytd2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytd2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
430 | [rocsolver_chetd2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chetd2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
431 | [rocsolver_zhetd2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhetd2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
432 | [rocsolver_ssytd2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytd2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
433 | [rocsolver_dsytd2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytd2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
434 | [rocsolver_chetd2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chetd2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
435 | [rocsolver_zhetd2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhetd2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
436 | [rocsolver_ssytd2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytd2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
437 | [rocsolver_dsytd2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytd2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
438 | [rocsolver_chetd2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chetd2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
439 | [rocsolver_zhetd2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhetd2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
440 | [rocsolver_ssytrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
441 | [rocsolver_dsytrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
442 | [rocsolver_chetrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chetrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
443 | [rocsolver_zhetrd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhetrd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
444 | [rocsolver_ssytrd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytrd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
445 | [rocsolver_dsytrd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytrd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
446 | [rocsolver_chetrd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chetrd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
447 | [rocsolver_zhetrd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhetrd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
448 | [rocsolver_ssytrd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytrd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
449 | [rocsolver_dsytrd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytrd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
450 | [rocsolver_chetrd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chetrd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
451 | [rocsolver_zhetrd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhetrd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
452 | [rocsolver_ssygs2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygs2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
453 | [rocsolver_dsygs2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygs2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
454 | [rocsolver_chegs2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegs2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
455 | [rocsolver_zhegs2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegs2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
456 | [rocsolver_ssygs2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygs2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
457 | [rocsolver_dsygs2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygs2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
458 | [rocsolver_chegs2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegs2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
459 | [rocsolver_zhegs2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegs2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
460 | [rocsolver_ssygs2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygs2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
461 | [rocsolver_dsygs2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygs2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
462 | [rocsolver_chegs2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegs2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
463 | [rocsolver_zhegs2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegs2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
464 | [rocsolver_ssygst](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygst.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
465 | [rocsolver_dsygst](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygst.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
466 | [rocsolver_chegst](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegst.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
467 | [rocsolver_zhegst](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegst.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
468 | [rocsolver_ssygst_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygst__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
469 | [rocsolver_dsygst_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygst__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
470 | [rocsolver_chegst_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegst__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
471 | [rocsolver_zhegst_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegst__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
472 | [rocsolver_ssygst_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygst__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
473 | [rocsolver_dsygst_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygst__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
474 | [rocsolver_chegst_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegst__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
475 | [rocsolver_zhegst_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegst__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
476 | [rocsolver_ssyev](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssyev.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
477 | [rocsolver_dsyev](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsyev.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
478 | [rocsolver_cheev](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cheev.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
479 | [rocsolver_zheev](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zheev.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
480 | [rocsolver_ssyev_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssyev__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
481 | [rocsolver_dsyev_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsyev__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
482 | [rocsolver_cheev_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cheev__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
483 | [rocsolver_zheev_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zheev__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
484 | [rocsolver_ssyev_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssyev__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
485 | [rocsolver_dsyev_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsyev__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
486 | [rocsolver_cheev_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cheev__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
487 | [rocsolver_zheev_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zheev__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
488 | [rocsolver_ssyevd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssyevd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
489 | [rocsolver_dsyevd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsyevd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
490 | [rocsolver_cheevd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cheevd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
491 | [rocsolver_zheevd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zheevd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
492 | [rocsolver_ssyevd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssyevd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
493 | [rocsolver_dsyevd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsyevd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
494 | [rocsolver_cheevd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cheevd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
495 | [rocsolver_zheevd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zheevd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
496 | [rocsolver_ssyevd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssyevd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
497 | [rocsolver_dsyevd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsyevd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
498 | [rocsolver_cheevd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cheevd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
499 | [rocsolver_zheevd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zheevd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
500 | [rocsolver_ssygv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
501 | [rocsolver_dsygv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
502 | [rocsolver_chegv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
503 | [rocsolver_zhegv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegv.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
504 | [rocsolver_ssygv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
505 | [rocsolver_dsygv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
506 | [rocsolver_chegv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
507 | [rocsolver_zhegv_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegv__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
508 | [rocsolver_ssygv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
509 | [rocsolver_dsygv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
510 | [rocsolver_chegv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
511 | [rocsolver_zhegv_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegv__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
512 | [rocsolver_ssygvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
513 | [rocsolver_dsygvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
514 | [rocsolver_chegvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
515 | [rocsolver_zhegvd](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegvd.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
516 | [rocsolver_ssygvd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygvd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
517 | [rocsolver_dsygvd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygvd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
518 | [rocsolver_chegvd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegvd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
519 | [rocsolver_zhegvd_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegvd__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
520 | [rocsolver_ssygvd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssygvd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
521 | [rocsolver_dsygvd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsygvd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
522 | [rocsolver_chegvd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__chegvd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
523 | [rocsolver_zhegvd_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zhegvd__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
524 | [rocsolver_sgetri_outofplace](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__outofplace.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
525 | [rocsolver_dgetri_outofplace](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__outofplace.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
526 | [rocsolver_cgetri_outofplace](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__outofplace.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
527 | [rocsolver_zgetri_outofplace](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__outofplace.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
528 | [rocsolver_sgetri_outofplace_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__outofplace__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
529 | [rocsolver_dgetri_outofplace_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__outofplace__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
530 | [rocsolver_cgetri_outofplace_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__outofplace__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
531 | [rocsolver_zgetri_outofplace_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__outofplace__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
532 | [rocsolver_sgetri_outofplace_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__outofplace__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
533 | [rocsolver_dgetri_outofplace_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__outofplace__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
534 | [rocsolver_cgetri_outofplace_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__outofplace__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
535 | [rocsolver_zgetri_outofplace_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__outofplace__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
536 | [rocsolver_sgetri_npvt_outofplace](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__npvt__outofplace.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
537 | [rocsolver_dgetri_npvt_outofplace](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__npvt__outofplace.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
538 | [rocsolver_cgetri_npvt_outofplace](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__npvt__outofplace.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
539 | [rocsolver_zgetri_npvt_outofplace](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__npvt__outofplace.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
540 | [rocsolver_sgetri_npvt_outofplace_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__npvt__outofplace__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
541 | [rocsolver_dgetri_npvt_outofplace_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__npvt__outofplace__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
542 | [rocsolver_cgetri_npvt_outofplace_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__npvt__outofplace__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
543 | [rocsolver_zgetri_npvt_outofplace_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__npvt__outofplace__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
544 | [rocsolver_sgetri_npvt_outofplace_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__sgetri__npvt__outofplace__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
545 | [rocsolver_dgetri_npvt_outofplace_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dgetri__npvt__outofplace__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
546 | [rocsolver_cgetri_npvt_outofplace_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__cgetri__npvt__outofplace__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
547 | [rocsolver_zgetri_npvt_outofplace_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zgetri__npvt__outofplace__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
548 | [rocsolver_strtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__strtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
549 | [rocsolver_dtrtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dtrtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
550 | [rocsolver_ctrtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ctrtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
551 | [rocsolver_ztrtri](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ztrtri.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
552 | [rocsolver_strtri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__strtri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
553 | [rocsolver_dtrtri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dtrtri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
554 | [rocsolver_ctrtri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ctrtri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
555 | [rocsolver_ztrtri_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ztrtri__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
556 | [rocsolver_strtri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__strtri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
557 | [rocsolver_dtrtri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dtrtri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
558 | [rocsolver_ctrtri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ctrtri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
559 | [rocsolver_ztrtri_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ztrtri__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
560 | [rocsolver_ssytf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
561 | [rocsolver_dsytf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
562 | [rocsolver_csytf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__csytf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
563 | [rocsolver_zsytf2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zsytf2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
564 | [rocsolver_ssytf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
565 | [rocsolver_dsytf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
566 | [rocsolver_csytf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__csytf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
567 | [rocsolver_zsytf2_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zsytf2__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
568 | [rocsolver_ssytf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
569 | [rocsolver_dsytf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
570 | [rocsolver_csytf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__csytf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
571 | [rocsolver_zsytf2_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zsytf2__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
572 | [rocsolver_ssytrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
573 | [rocsolver_dsytrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
574 | [rocsolver_csytrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__csytrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
575 | [rocsolver_zsytrf](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zsytrf.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
576 | [rocsolver_ssytrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
577 | [rocsolver_dsytrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
578 | [rocsolver_csytrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__csytrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
579 | [rocsolver_zsytrf_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zsytrf__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
580 | [rocsolver_ssytrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__ssytrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
581 | [rocsolver_dsytrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__dsytrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
582 | [rocsolver_csytrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__csytrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
583 | [rocsolver_zsytrf_strided_batched](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocsolver_1_1rocsolver__zsytrf__strided__batched.html "Interface documentation") | C binding, full_rank, rank_0, rank_1

# hipSPARSE API support

\# | API Name | Variants
----|---------------|---------
1 | [hipsparseCreate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreate.html "Interface documentation") | C binding
2 | [hipsparseDestroy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroy.html "Interface documentation") | C binding
3 | [hipsparseGetVersion](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsegetversion.html "Interface documentation") | C binding
4 | [hipsparseGetGitRevision](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsegetgitrevision.html "Interface documentation") | C binding
5 | [hipsparseSetStream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesetstream.html "Interface documentation") | C binding
6 | [hipsparseGetStream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsegetstream.html "Interface documentation") | C binding
7 | [hipsparseSetPointerMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesetpointermode.html "Interface documentation") | C binding
8 | [hipsparseGetPointerMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsegetpointermode.html "Interface documentation") | C binding
9 | [hipsparseCreateMatDescr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatematdescr.html "Interface documentation") | C binding
10 | [hipsparseDestroyMatDescr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroymatdescr.html "Interface documentation") | C binding
11 | [hipsparseCopyMatDescr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecopymatdescr.html "Interface documentation") | C binding
12 | [hipsparseSetMatType](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesetmattype.html "Interface documentation") | C binding
13 | [hipsparseSetMatFillMode](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesetmatfillmode.html "Interface documentation") | C binding
14 | [hipsparseSetMatDiagType](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesetmatdiagtype.html "Interface documentation") | C binding
15 | [hipsparseSetMatIndexBase](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesetmatindexbase.html "Interface documentation") | C binding
16 | [hipsparseCreateHybMat](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatehybmat.html "Interface documentation") | C binding
17 | [hipsparseDestroyHybMat](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroyhybmat.html "Interface documentation") | C binding
18 | [hipsparseCreateBsrsv2Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatebsrsv2info.html "Interface documentation") | C binding
19 | [hipsparseDestroyBsrsv2Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroybsrsv2info.html "Interface documentation") | C binding
20 | [hipsparseCreateBsrsm2Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatebsrsm2info.html "Interface documentation") | C binding
21 | [hipsparseDestroyBsrsm2Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroybsrsm2info.html "Interface documentation") | C binding
22 | [hipsparseCreateBsrilu02Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatebsrilu02info.html "Interface documentation") | C binding
23 | [hipsparseDestroyBsrilu02Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroybsrilu02info.html "Interface documentation") | C binding
24 | [hipsparseCreateBsric02Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatebsric02info.html "Interface documentation") | C binding
25 | [hipsparseDestroyBsric02Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroybsric02info.html "Interface documentation") | C binding
26 | [hipsparseCreateCsrsv2Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecsrsv2info.html "Interface documentation") | C binding
27 | [hipsparseDestroyCsrsv2Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroycsrsv2info.html "Interface documentation") | C binding
28 | [hipsparseCreateCsrsm2Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecsrsm2info.html "Interface documentation") | C binding
29 | [hipsparseDestroyCsrsm2Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroycsrsm2info.html "Interface documentation") | C binding
30 | [hipsparseCreateCsrilu02Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecsrilu02info.html "Interface documentation") | C binding
31 | [hipsparseDestroyCsrilu02Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroycsrilu02info.html "Interface documentation") | C binding
32 | [hipsparseCreateCsric02Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecsric02info.html "Interface documentation") | C binding
33 | [hipsparseDestroyCsric02Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroycsric02info.html "Interface documentation") | C binding
34 | [hipsparseCreateCsru2csrInfo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecsru2csrinfo.html "Interface documentation") | C binding
35 | [hipsparseDestroyCsru2csrInfo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroycsru2csrinfo.html "Interface documentation") | C binding
36 | [hipsparseCreateColorInfo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecolorinfo.html "Interface documentation") | C binding
37 | [hipsparseDestroyColorInfo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroycolorinfo.html "Interface documentation") | C binding
38 | [hipsparseCreateCsrgemm2Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecsrgemm2info.html "Interface documentation") | C binding
39 | [hipsparseDestroyCsrgemm2Info](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroycsrgemm2info.html "Interface documentation") | C binding
40 | [hipsparseCreatePruneInfo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatepruneinfo.html "Interface documentation") | C binding
41 | [hipsparseDestroyPruneInfo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroypruneinfo.html "Interface documentation") | C binding
42 | [hipsparseSaxpyi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesaxpyi.html "Interface documentation") | C binding, rank_0, rank_1
43 | [hipsparseDaxpyi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedaxpyi.html "Interface documentation") | C binding, rank_0, rank_1
44 | [hipsparseCaxpyi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecaxpyi.html "Interface documentation") | C binding, rank_0, rank_1
45 | [hipsparseZaxpyi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezaxpyi.html "Interface documentation") | C binding, rank_0, rank_1
46 | [hipsparseSdoti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesdoti.html "Interface documentation") | C binding, rank_0, rank_1
47 | [hipsparseDdoti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseddoti.html "Interface documentation") | C binding, rank_0, rank_1
48 | [hipsparseCdoti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecdoti.html "Interface documentation") | C binding, rank_0, rank_1
49 | [hipsparseZdoti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezdoti.html "Interface documentation") | C binding, rank_0, rank_1
50 | [hipsparseCdotci](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecdotci.html "Interface documentation") | C binding, rank_0, rank_1
51 | [hipsparseZdotci](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezdotci.html "Interface documentation") | C binding, rank_0, rank_1
52 | [hipsparseSgthr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgthr.html "Interface documentation") | C binding, rank_0, rank_1
53 | [hipsparseDgthr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgthr.html "Interface documentation") | C binding, rank_0, rank_1
54 | [hipsparseCgthr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgthr.html "Interface documentation") | C binding, rank_0, rank_1
55 | [hipsparseZgthr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgthr.html "Interface documentation") | C binding, rank_0, rank_1
56 | [hipsparseSgthrz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgthrz.html "Interface documentation") | C binding, rank_0, rank_1
57 | [hipsparseDgthrz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgthrz.html "Interface documentation") | C binding, rank_0, rank_1
58 | [hipsparseCgthrz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgthrz.html "Interface documentation") | C binding, rank_0, rank_1
59 | [hipsparseZgthrz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgthrz.html "Interface documentation") | C binding, rank_0, rank_1
60 | [hipsparseSroti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesroti.html "Interface documentation") | C binding, rank_0, rank_1
61 | [hipsparseDroti](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedroti.html "Interface documentation") | C binding, rank_0, rank_1
62 | [hipsparseSsctr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsessctr.html "Interface documentation") | C binding, rank_0, rank_1
63 | [hipsparseDsctr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedsctr.html "Interface documentation") | C binding, rank_0, rank_1
64 | [hipsparseCsctr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecsctr.html "Interface documentation") | C binding, rank_0, rank_1
65 | [hipsparseZsctr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezsctr.html "Interface documentation") | C binding, rank_0, rank_1
66 | [hipsparseScsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrmv.html "Interface documentation") | C binding, rank_0, rank_1
67 | [hipsparseDcsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrmv.html "Interface documentation") | C binding, rank_0, rank_1
68 | [hipsparseCcsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrmv.html "Interface documentation") | C binding, rank_0, rank_1
69 | [hipsparseZcsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrmv.html "Interface documentation") | C binding, rank_0, rank_1
70 | [hipsparseXcsrsv2_zeroPivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsrsv2__zeropivot.html "Interface documentation") | C binding
71 | [hipsparseScsrsv2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrsv2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
72 | [hipsparseDcsrsv2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrsv2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
73 | [hipsparseCcsrsv2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrsv2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
74 | [hipsparseZcsrsv2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrsv2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
75 | [hipsparseScsrsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrsv2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
76 | [hipsparseDcsrsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrsv2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
77 | [hipsparseCcsrsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrsv2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
78 | [hipsparseZcsrsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrsv2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
79 | [hipsparseScsrsv2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrsv2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
80 | [hipsparseDcsrsv2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrsv2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
81 | [hipsparseCcsrsv2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrsv2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
82 | [hipsparseZcsrsv2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrsv2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
83 | [hipsparseScsrsv2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrsv2__solve.html "Interface documentation") | C binding, rank_0, rank_1
84 | [hipsparseDcsrsv2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrsv2__solve.html "Interface documentation") | C binding, rank_0, rank_1
85 | [hipsparseCcsrsv2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrsv2__solve.html "Interface documentation") | C binding, rank_0, rank_1
86 | [hipsparseZcsrsv2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrsv2__solve.html "Interface documentation") | C binding, rank_0, rank_1
87 | [hipsparseShybmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseshybmv.html "Interface documentation") | C binding, rank_0, rank_1
88 | [hipsparseDhybmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedhybmv.html "Interface documentation") | C binding, rank_0, rank_1
89 | [hipsparseChybmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsechybmv.html "Interface documentation") | C binding, rank_0, rank_1
90 | [hipsparseZhybmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezhybmv.html "Interface documentation") | C binding, rank_0, rank_1
91 | [hipsparseSbsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrmv.html "Interface documentation") | C binding, rank_0, rank_1
92 | [hipsparseDbsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrmv.html "Interface documentation") | C binding, rank_0, rank_1
93 | [hipsparseCbsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrmv.html "Interface documentation") | C binding, rank_0, rank_1
94 | [hipsparseZbsrmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrmv.html "Interface documentation") | C binding, rank_0, rank_1
95 | [hipsparseSbsrxmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrxmv.html "Interface documentation") | C binding, rank_0, rank_1
96 | [hipsparseDbsrxmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrxmv.html "Interface documentation") | C binding, rank_0, rank_1
97 | [hipsparseCbsrxmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrxmv.html "Interface documentation") | C binding, rank_0, rank_1
98 | [hipsparseZbsrxmv](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrxmv.html "Interface documentation") | C binding, rank_0, rank_1
99 | [hipsparseXbsrsv2_zeroPivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexbsrsv2__zeropivot.html "Interface documentation") | C binding
100 | [hipsparseSbsrsv2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrsv2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
101 | [hipsparseDbsrsv2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrsv2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
102 | [hipsparseCbsrsv2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrsv2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
103 | [hipsparseZbsrsv2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrsv2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
104 | [hipsparseSbsrsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrsv2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
105 | [hipsparseDbsrsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrsv2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
106 | [hipsparseCbsrsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrsv2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
107 | [hipsparseZbsrsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrsv2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
108 | [hipsparseSbsrsv2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrsv2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
109 | [hipsparseDbsrsv2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrsv2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
110 | [hipsparseCbsrsv2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrsv2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
111 | [hipsparseZbsrsv2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrsv2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
112 | [hipsparseSbsrsv2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrsv2__solve.html "Interface documentation") | C binding, rank_0, rank_1
113 | [hipsparseDbsrsv2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrsv2__solve.html "Interface documentation") | C binding, rank_0, rank_1
114 | [hipsparseCbsrsv2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrsv2__solve.html "Interface documentation") | C binding, rank_0, rank_1
115 | [hipsparseZbsrsv2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrsv2__solve.html "Interface documentation") | C binding, rank_0, rank_1
116 | [hipsparseSgemvi_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgemvi__buffersize.html "Interface documentation") | C binding
117 | [hipsparseDgemvi_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgemvi__buffersize.html "Interface documentation") | C binding
118 | [hipsparseCgemvi_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgemvi__buffersize.html "Interface documentation") | C binding
119 | [hipsparseZgemvi_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgemvi__buffersize.html "Interface documentation") | C binding
120 | [hipsparseSgemvi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgemvi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
121 | [hipsparseDgemvi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgemvi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
122 | [hipsparseCgemvi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgemvi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
123 | [hipsparseZgemvi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgemvi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
124 | [hipsparseSbsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
125 | [hipsparseDbsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
126 | [hipsparseCbsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
127 | [hipsparseZbsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
128 | [hipsparseScsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
129 | [hipsparseDcsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
130 | [hipsparseCcsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
131 | [hipsparseZcsrmm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrmm.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
132 | [hipsparseScsrmm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrmm2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
133 | [hipsparseDcsrmm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrmm2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
134 | [hipsparseCcsrmm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrmm2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
135 | [hipsparseZcsrmm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrmm2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
136 | [hipsparseXbsrsm2_zeroPivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexbsrsm2__zeropivot.html "Interface documentation") | C binding
137 | [hipsparseSbsrsm2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrsm2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
138 | [hipsparseDbsrsm2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrsm2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
139 | [hipsparseCbsrsm2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrsm2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
140 | [hipsparseZbsrsm2_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrsm2__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
141 | [hipsparseSbsrsm2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrsm2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
142 | [hipsparseDbsrsm2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrsm2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
143 | [hipsparseCbsrsm2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrsm2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
144 | [hipsparseZbsrsm2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrsm2__analysis.html "Interface documentation") | C binding, rank_0, rank_1
145 | [hipsparseSbsrsm2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrsm2__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
146 | [hipsparseDbsrsm2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrsm2__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
147 | [hipsparseCbsrsm2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrsm2__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
148 | [hipsparseZbsrsm2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrsm2__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
149 | [hipsparseXcsrsm2_zeroPivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsrsm2__zeropivot.html "Interface documentation") | C binding
150 | [hipsparseScsrsm2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrsm2__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
151 | [hipsparseDcsrsm2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrsm2__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
152 | [hipsparseCcsrsm2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrsm2__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
153 | [hipsparseZcsrsm2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrsm2__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
154 | [hipsparseScsrsm2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrsm2__analysis.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
155 | [hipsparseDcsrsm2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrsm2__analysis.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
156 | [hipsparseCcsrsm2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrsm2__analysis.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
157 | [hipsparseZcsrsm2_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrsm2__analysis.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
158 | [hipsparseScsrsm2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrsm2__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
159 | [hipsparseDcsrsm2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrsm2__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
160 | [hipsparseCcsrsm2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrsm2__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
161 | [hipsparseZcsrsm2_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrsm2__solve.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
162 | [hipsparseSgemmi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgemmi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
163 | [hipsparseDgemmi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgemmi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
164 | [hipsparseCgemmi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgemmi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
165 | [hipsparseZgemmi](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgemmi.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
166 | [hipsparseXcsrgeamNnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsrgeamnnz.html "Interface documentation") | C binding, rank_0, rank_1
167 | [hipsparseScsrgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrgeam.html "Interface documentation") | C binding, rank_0, rank_1
168 | [hipsparseDcsrgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrgeam.html "Interface documentation") | C binding, rank_0, rank_1
169 | [hipsparseCcsrgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrgeam.html "Interface documentation") | C binding, rank_0, rank_1
170 | [hipsparseZcsrgeam](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrgeam.html "Interface documentation") | C binding, rank_0, rank_1
171 | [hipsparseScsrgeam2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrgeam2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
172 | [hipsparseDcsrgeam2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrgeam2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
173 | [hipsparseCcsrgeam2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrgeam2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
174 | [hipsparseZcsrgeam2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrgeam2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
175 | [hipsparseXcsrgeam2Nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsrgeam2nnz.html "Interface documentation") | C binding, rank_0, rank_1
176 | [hipsparseScsrgeam2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrgeam2.html "Interface documentation") | C binding, rank_0, rank_1
177 | [hipsparseDcsrgeam2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrgeam2.html "Interface documentation") | C binding, rank_0, rank_1
178 | [hipsparseCcsrgeam2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrgeam2.html "Interface documentation") | C binding, rank_0, rank_1
179 | [hipsparseZcsrgeam2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrgeam2.html "Interface documentation") | C binding, rank_0, rank_1
180 | [hipsparseXcsrgemmNnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsrgemmnnz.html "Interface documentation") | C binding, rank_0, rank_1
181 | [hipsparseScsrgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrgemm.html "Interface documentation") | C binding, rank_0, rank_1
182 | [hipsparseDcsrgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrgemm.html "Interface documentation") | C binding, rank_0, rank_1
183 | [hipsparseCcsrgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrgemm.html "Interface documentation") | C binding, rank_0, rank_1
184 | [hipsparseZcsrgemm](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrgemm.html "Interface documentation") | C binding, rank_0, rank_1
185 | [hipsparseScsrgemm2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrgemm2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
186 | [hipsparseDcsrgemm2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrgemm2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
187 | [hipsparseCcsrgemm2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrgemm2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
188 | [hipsparseZcsrgemm2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrgemm2__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
189 | [hipsparseXcsrgemm2Nnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsrgemm2nnz.html "Interface documentation") | C binding, rank_0, rank_1
190 | [hipsparseScsrgemm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrgemm2.html "Interface documentation") | C binding, rank_0, rank_1
191 | [hipsparseDcsrgemm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrgemm2.html "Interface documentation") | C binding, rank_0, rank_1
192 | [hipsparseCcsrgemm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrgemm2.html "Interface documentation") | C binding, rank_0, rank_1
193 | [hipsparseZcsrgemm2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrgemm2.html "Interface documentation") | C binding, rank_0, rank_1
194 | [hipsparseXbsrilu02_zeroPivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexbsrilu02__zeropivot.html "Interface documentation") | C binding
195 | [hipsparseSbsrilu02_numericBoost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrilu02__numericboost.html "Interface documentation") | C binding
196 | [hipsparseDbsrilu02_numericBoost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrilu02__numericboost.html "Interface documentation") | C binding
197 | [hipsparseCbsrilu02_numericBoost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrilu02__numericboost.html "Interface documentation") | C binding
198 | [hipsparseZbsrilu02_numericBoost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrilu02__numericboost.html "Interface documentation") | C binding
199 | [hipsparseSbsrilu02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrilu02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
200 | [hipsparseDbsrilu02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrilu02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
201 | [hipsparseCbsrilu02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrilu02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
202 | [hipsparseZbsrilu02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrilu02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
203 | [hipsparseSbsrilu02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrilu02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
204 | [hipsparseDbsrilu02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrilu02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
205 | [hipsparseCbsrilu02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrilu02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
206 | [hipsparseZbsrilu02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrilu02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
207 | [hipsparseSbsrilu02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsrilu02.html "Interface documentation") | C binding, rank_0, rank_1
208 | [hipsparseDbsrilu02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsrilu02.html "Interface documentation") | C binding, rank_0, rank_1
209 | [hipsparseCbsrilu02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsrilu02.html "Interface documentation") | C binding, rank_0, rank_1
210 | [hipsparseZbsrilu02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsrilu02.html "Interface documentation") | C binding, rank_0, rank_1
211 | [hipsparseXcsrilu02_zeroPivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsrilu02__zeropivot.html "Interface documentation") | C binding
212 | [hipsparseScsrilu02_numericBoost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrilu02__numericboost.html "Interface documentation") | C binding
213 | [hipsparseDcsrilu02_numericBoost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrilu02__numericboost.html "Interface documentation") | C binding
214 | [hipsparseCcsrilu02_numericBoost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrilu02__numericboost.html "Interface documentation") | C binding
215 | [hipsparseZcsrilu02_numericBoost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrilu02__numericboost.html "Interface documentation") | C binding
216 | [hipsparseScsrilu02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrilu02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
217 | [hipsparseDcsrilu02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrilu02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
218 | [hipsparseCcsrilu02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrilu02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
219 | [hipsparseZcsrilu02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrilu02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
220 | [hipsparseScsrilu02_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrilu02__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
221 | [hipsparseDcsrilu02_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrilu02__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
222 | [hipsparseCcsrilu02_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrilu02__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
223 | [hipsparseZcsrilu02_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrilu02__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
224 | [hipsparseScsrilu02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrilu02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
225 | [hipsparseDcsrilu02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrilu02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
226 | [hipsparseCcsrilu02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrilu02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
227 | [hipsparseZcsrilu02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrilu02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
228 | [hipsparseScsrilu02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrilu02.html "Interface documentation") | C binding, rank_0, rank_1
229 | [hipsparseDcsrilu02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrilu02.html "Interface documentation") | C binding, rank_0, rank_1
230 | [hipsparseCcsrilu02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrilu02.html "Interface documentation") | C binding, rank_0, rank_1
231 | [hipsparseZcsrilu02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrilu02.html "Interface documentation") | C binding, rank_0, rank_1
232 | [hipsparseXbsric02_zeroPivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexbsric02__zeropivot.html "Interface documentation") | C binding
233 | [hipsparseSbsric02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsric02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
234 | [hipsparseDbsric02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsric02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
235 | [hipsparseCbsric02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsric02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
236 | [hipsparseZbsric02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsric02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
237 | [hipsparseSbsric02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsric02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
238 | [hipsparseDbsric02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsric02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
239 | [hipsparseCbsric02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsric02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
240 | [hipsparseZbsric02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsric02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
241 | [hipsparseSbsric02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsric02.html "Interface documentation") | C binding, rank_0, rank_1
242 | [hipsparseDbsric02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsric02.html "Interface documentation") | C binding, rank_0, rank_1
243 | [hipsparseCbsric02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsric02.html "Interface documentation") | C binding, rank_0, rank_1
244 | [hipsparseZbsric02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsric02.html "Interface documentation") | C binding, rank_0, rank_1
245 | [hipsparseXcsric02_zeroPivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsric02__zeropivot.html "Interface documentation") | C binding
246 | [hipsparseScsric02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsric02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
247 | [hipsparseDcsric02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsric02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
248 | [hipsparseCcsric02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsric02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
249 | [hipsparseZcsric02_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsric02__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
250 | [hipsparseScsric02_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsric02__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
251 | [hipsparseDcsric02_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsric02__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
252 | [hipsparseCcsric02_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsric02__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
253 | [hipsparseZcsric02_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsric02__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
254 | [hipsparseScsric02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsric02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
255 | [hipsparseDcsric02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsric02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
256 | [hipsparseCcsric02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsric02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
257 | [hipsparseZcsric02_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsric02__analysis.html "Interface documentation") | C binding, rank_0, rank_1
258 | [hipsparseScsric02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsric02.html "Interface documentation") | C binding, rank_0, rank_1
259 | [hipsparseDcsric02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsric02.html "Interface documentation") | C binding, rank_0, rank_1
260 | [hipsparseCcsric02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsric02.html "Interface documentation") | C binding, rank_0, rank_1
261 | [hipsparseZcsric02](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsric02.html "Interface documentation") | C binding, rank_0, rank_1
262 | [hipsparseSgtsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgtsv2__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
263 | [hipsparseDgtsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgtsv2__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
264 | [hipsparseCgtsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgtsv2__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
265 | [hipsparseZgtsv2_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgtsv2__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
266 | [hipsparseSgtsv2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgtsv2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
267 | [hipsparseDgtsv2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgtsv2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
268 | [hipsparseCgtsv2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgtsv2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
269 | [hipsparseZgtsv2](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgtsv2.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
270 | [hipsparseSgtsv2_nopivot_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgtsv2__nopivot__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
271 | [hipsparseDgtsv2_nopivot_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgtsv2__nopivot__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
272 | [hipsparseCgtsv2_nopivot_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgtsv2__nopivot__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
273 | [hipsparseZgtsv2_nopivot_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgtsv2__nopivot__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
274 | [hipsparseSgtsv2_nopivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgtsv2__nopivot.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
275 | [hipsparseDgtsv2_nopivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgtsv2__nopivot.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
276 | [hipsparseCgtsv2_nopivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgtsv2__nopivot.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
277 | [hipsparseZgtsv2_nopivot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgtsv2__nopivot.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
278 | [hipsparseSgtsv2StridedBatch_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgtsv2stridedbatch__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
279 | [hipsparseDgtsv2StridedBatch_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgtsv2stridedbatch__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
280 | [hipsparseCgtsv2StridedBatch_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgtsv2stridedbatch__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
281 | [hipsparseZgtsv2StridedBatch_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgtsv2stridedbatch__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
282 | [hipsparseSgtsv2StridedBatch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgtsv2stridedbatch.html "Interface documentation") | C binding, rank_0, rank_1
283 | [hipsparseDgtsv2StridedBatch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgtsv2stridedbatch.html "Interface documentation") | C binding, rank_0, rank_1
284 | [hipsparseCgtsv2StridedBatch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgtsv2stridedbatch.html "Interface documentation") | C binding, rank_0, rank_1
285 | [hipsparseZgtsv2StridedBatch](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgtsv2stridedbatch.html "Interface documentation") | C binding, rank_0, rank_1
286 | [hipsparseSnnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesnnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
287 | [hipsparseDnnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsednnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
288 | [hipsparseCnnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecnnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
289 | [hipsparseZnnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseznnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
290 | [hipsparseSdense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesdense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
291 | [hipsparseDdense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseddense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
292 | [hipsparseCdense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecdense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
293 | [hipsparseZdense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezdense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
294 | [hipsparseSpruneDense2csr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunedense2csr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
295 | [hipsparseDpruneDense2csr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunedense2csr__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
296 | [hipsparseSpruneDense2csr_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunedense2csr__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
297 | [hipsparseDpruneDense2csr_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunedense2csr__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
298 | [hipsparseSpruneDense2csrNnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunedense2csrnnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
299 | [hipsparseDpruneDense2csrNnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunedense2csrnnz.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
300 | [hipsparseSpruneDense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunedense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
301 | [hipsparseDpruneDense2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunedense2csr.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
302 | [hipsparseSpruneDense2csrByPercentage_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunedense2csrbypercentage__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
303 | [hipsparseDpruneDense2csrByPercentage_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunedense2csrbypercentage__buffersize.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
304 | [hipsparseSpruneDense2csrByPercentage_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunedense2csrbypercentage__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
305 | [hipsparseDpruneDense2csrByPercentage_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunedense2csrbypercentage__buffersizeext.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
306 | [hipsparseSpruneDense2csrNnzByPercentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunedense2csrnnzbypercentage.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
307 | [hipsparseDpruneDense2csrNnzByPercentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunedense2csrnnzbypercentage.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
308 | [hipsparseSpruneDense2csrByPercentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunedense2csrbypercentage.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
309 | [hipsparseDpruneDense2csrByPercentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunedense2csrbypercentage.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
310 | [hipsparseSdense2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesdense2csc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
311 | [hipsparseDdense2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseddense2csc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
312 | [hipsparseCdense2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecdense2csc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
313 | [hipsparseZdense2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezdense2csc.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
314 | [hipsparseScsr2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsr2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
315 | [hipsparseDcsr2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsr2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
316 | [hipsparseCcsr2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsr2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
317 | [hipsparseZcsr2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsr2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
318 | [hipsparseScsc2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsc2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
319 | [hipsparseDcsc2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsc2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
320 | [hipsparseCcsc2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsc2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
321 | [hipsparseZcsc2dense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsc2dense.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
322 | [hipsparseXcsr2bsrNnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsr2bsrnnz.html "Interface documentation") | C binding, rank_0, rank_1
323 | [hipsparseSnnz_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesnnz__compress.html "Interface documentation") | C binding, rank_0, rank_1
324 | [hipsparseDnnz_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsednnz__compress.html "Interface documentation") | C binding, rank_0, rank_1
325 | [hipsparseCnnz_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecnnz__compress.html "Interface documentation") | C binding, rank_0, rank_1
326 | [hipsparseZnnz_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseznnz__compress.html "Interface documentation") | C binding, rank_0, rank_1
327 | [hipsparseXcsr2coo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsr2coo.html "Interface documentation") | C binding, rank_0, rank_1
328 | [hipsparseScsr2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsr2csc.html "Interface documentation") | C binding, rank_0, rank_1
329 | [hipsparseDcsr2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsr2csc.html "Interface documentation") | C binding, rank_0, rank_1
330 | [hipsparseCcsr2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsr2csc.html "Interface documentation") | C binding, rank_0, rank_1
331 | [hipsparseZcsr2csc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsr2csc.html "Interface documentation") | C binding, rank_0, rank_1
332 | [hipsparseScsr2hyb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsr2hyb.html "Interface documentation") | C binding, rank_0, rank_1
333 | [hipsparseDcsr2hyb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsr2hyb.html "Interface documentation") | C binding, rank_0, rank_1
334 | [hipsparseCcsr2hyb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsr2hyb.html "Interface documentation") | C binding, rank_0, rank_1
335 | [hipsparseZcsr2hyb](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsr2hyb.html "Interface documentation") | C binding, rank_0, rank_1
336 | [hipsparseSgebsr2gebsc_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgebsr2gebsc__buffersize.html "Interface documentation") | C binding
337 | [hipsparseDgebsr2gebsc_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgebsr2gebsc__buffersize.html "Interface documentation") | C binding
338 | [hipsparseCgebsr2gebsc_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgebsr2gebsc__buffersize.html "Interface documentation") | C binding
339 | [hipsparseZgebsr2gebsc_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgebsr2gebsc__buffersize.html "Interface documentation") | C binding
340 | [hipsparseSgebsr2gebsc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgebsr2gebsc.html "Interface documentation") | C binding
341 | [hipsparseDgebsr2gebsc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgebsr2gebsc.html "Interface documentation") | C binding
342 | [hipsparseCgebsr2gebsc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgebsr2gebsc.html "Interface documentation") | C binding
343 | [hipsparseZgebsr2gebsc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgebsr2gebsc.html "Interface documentation") | C binding
344 | [hipsparseScsr2gebsr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsr2gebsr__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
345 | [hipsparseDcsr2gebsr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsr2gebsr__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
346 | [hipsparseCcsr2gebsr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsr2gebsr__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
347 | [hipsparseZcsr2gebsr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsr2gebsr__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
348 | [hipsparseXcsr2gebsrNnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsr2gebsrnnz.html "Interface documentation") | C binding, rank_0, rank_1
349 | [hipsparseScsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
350 | [hipsparseDcsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
351 | [hipsparseCcsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
352 | [hipsparseZcsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
353 | [hipsparseScsr2bsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsr2bsr.html "Interface documentation") | C binding, rank_0, rank_1
354 | [hipsparseDcsr2bsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsr2bsr.html "Interface documentation") | C binding, rank_0, rank_1
355 | [hipsparseCcsr2bsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsr2bsr.html "Interface documentation") | C binding, rank_0, rank_1
356 | [hipsparseZcsr2bsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsr2bsr.html "Interface documentation") | C binding, rank_0, rank_1
357 | [hipsparseSbsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesbsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
358 | [hipsparseDbsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedbsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
359 | [hipsparseCbsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecbsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
360 | [hipsparseZbsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezbsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
361 | [hipsparseSgebsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgebsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
362 | [hipsparseDgebsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgebsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
363 | [hipsparseCgebsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgebsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
364 | [hipsparseZgebsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgebsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
365 | [hipsparseScsr2csr_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsr2csr__compress.html "Interface documentation") | C binding, rank_0, rank_1
366 | [hipsparseDcsr2csr_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsr2csr__compress.html "Interface documentation") | C binding, rank_0, rank_1
367 | [hipsparseCcsr2csr_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsr2csr__compress.html "Interface documentation") | C binding, rank_0, rank_1
368 | [hipsparseZcsr2csr_compress](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsr2csr__compress.html "Interface documentation") | C binding, rank_0, rank_1
369 | [hipsparseSpruneCsr2csr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunecsr2csr__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
370 | [hipsparseDpruneCsr2csr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunecsr2csr__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
371 | [hipsparseSpruneCsr2csr_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunecsr2csr__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
372 | [hipsparseDpruneCsr2csr_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunecsr2csr__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
373 | [hipsparseSpruneCsr2csrNnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunecsr2csrnnz.html "Interface documentation") | C binding, rank_0, rank_1
374 | [hipsparseDpruneCsr2csrNnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunecsr2csrnnz.html "Interface documentation") | C binding, rank_0, rank_1
375 | [hipsparseSpruneCsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunecsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
376 | [hipsparseDpruneCsr2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunecsr2csr.html "Interface documentation") | C binding, rank_0, rank_1
377 | [hipsparseSpruneCsr2csrByPercentage_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunecsr2csrbypercentage__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
378 | [hipsparseDpruneCsr2csrByPercentage_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunecsr2csrbypercentage__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
379 | [hipsparseSpruneCsr2csrByPercentage_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunecsr2csrbypercentage__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
380 | [hipsparseDpruneCsr2csrByPercentage_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunecsr2csrbypercentage__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
381 | [hipsparseSpruneCsr2csrNnzByPercentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunecsr2csrnnzbypercentage.html "Interface documentation") | C binding, rank_0, rank_1
382 | [hipsparseDpruneCsr2csrNnzByPercentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunecsr2csrnnzbypercentage.html "Interface documentation") | C binding, rank_0, rank_1
383 | [hipsparseSpruneCsr2csrByPercentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesprunecsr2csrbypercentage.html "Interface documentation") | C binding, rank_0, rank_1
384 | [hipsparseDpruneCsr2csrByPercentage](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedprunecsr2csrbypercentage.html "Interface documentation") | C binding, rank_0, rank_1
385 | [hipsparseShyb2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseshyb2csr.html "Interface documentation") | C binding, rank_0, rank_1
386 | [hipsparseDhyb2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedhyb2csr.html "Interface documentation") | C binding, rank_0, rank_1
387 | [hipsparseChyb2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsechyb2csr.html "Interface documentation") | C binding, rank_0, rank_1
388 | [hipsparseZhyb2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezhyb2csr.html "Interface documentation") | C binding, rank_0, rank_1
389 | [hipsparseXcoo2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcoo2csr.html "Interface documentation") | C binding, rank_0, rank_1
390 | [hipsparseCreateIdentityPermutation](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreateidentitypermutation.html "Interface documentation") | C binding, rank_0, rank_1
391 | [hipsparseXcsrsort_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsrsort__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
392 | [hipsparseXcsrsort](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcsrsort.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
393 | [hipsparseXcscsort_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcscsort__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
394 | [hipsparseXcscsort](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcscsort.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
395 | [hipsparseXcoosort_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcoosort__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
396 | [hipsparseXcoosortByRow](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcoosortbyrow.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
397 | [hipsparseXcoosortByColumn](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexcoosortbycolumn.html "Interface documentation") | C binding, full_rank, rank_0, rank_1
398 | [hipsparseSgebsr2gebsr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgebsr2gebsr__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
399 | [hipsparseDgebsr2gebsr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgebsr2gebsr__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
400 | [hipsparseCgebsr2gebsr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgebsr2gebsr__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
401 | [hipsparseZgebsr2gebsr_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgebsr2gebsr__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
402 | [hipsparseXgebsr2gebsrNnz](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsexgebsr2gebsrnnz.html "Interface documentation") | C binding, rank_0, rank_1
403 | [hipsparseSgebsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesgebsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
404 | [hipsparseDgebsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedgebsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
405 | [hipsparseCgebsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecgebsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
406 | [hipsparseZgebsr2gebsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezgebsr2gebsr.html "Interface documentation") | C binding, rank_0, rank_1
407 | [hipsparseScsru2csr_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsru2csr__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
408 | [hipsparseDcsru2csr_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsru2csr__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
409 | [hipsparseCcsru2csr_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsru2csr__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
410 | [hipsparseZcsru2csr_bufferSizeExt](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsru2csr__buffersizeext.html "Interface documentation") | C binding, rank_0, rank_1
411 | [hipsparseScsru2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsru2csr.html "Interface documentation") | C binding, rank_0, rank_1
412 | [hipsparseDcsru2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsru2csr.html "Interface documentation") | C binding, rank_0, rank_1
413 | [hipsparseCcsru2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsru2csr.html "Interface documentation") | C binding, rank_0, rank_1
414 | [hipsparseZcsru2csr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsru2csr.html "Interface documentation") | C binding, rank_0, rank_1
415 | [hipsparseScsr2csru](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsr2csru.html "Interface documentation") | C binding, rank_0, rank_1
416 | [hipsparseDcsr2csru](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsr2csru.html "Interface documentation") | C binding, rank_0, rank_1
417 | [hipsparseCcsr2csru](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsr2csru.html "Interface documentation") | C binding, rank_0, rank_1
418 | [hipsparseZcsr2csru](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsr2csru.html "Interface documentation") | C binding, rank_0, rank_1
419 | [hipsparseScsrcolor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescsrcolor.html "Interface documentation") | C binding, rank_0, rank_1
420 | [hipsparseDcsrcolor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedcsrcolor.html "Interface documentation") | C binding, rank_0, rank_1
421 | [hipsparseCcsrcolor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseccsrcolor.html "Interface documentation") | C binding, rank_0, rank_1
422 | [hipsparseZcsrcolor](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsezcsrcolor.html "Interface documentation") | C binding, rank_0, rank_1
423 | [hipsparseCreateSpVec](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatespvec.html "Interface documentation") | C binding
424 | [hipsparseDestroySpVec](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroyspvec.html "Interface documentation") | C binding
425 | [hipsparseSpVecGet](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespvecget.html "Interface documentation") | C binding
426 | [hipsparseSpVecGetIndexBase](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespvecgetindexbase.html "Interface documentation") | C binding
427 | [hipsparseSpVecGetValues](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespvecgetvalues.html "Interface documentation") | C binding
428 | [hipsparseSpVecSetValues](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespvecsetvalues.html "Interface documentation") | C binding
429 | [hipsparseCreateCoo](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecoo.html "Interface documentation") | C binding
430 | [hipsparseCreateCooAoS](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecooaos.html "Interface documentation") | C binding
431 | [hipsparseCreateCsr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecsr.html "Interface documentation") | C binding
432 | [hipsparseCreateCsc](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatecsc.html "Interface documentation") | C binding
433 | [hipsparseCreateBlockedEll](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreateblockedell.html "Interface documentation") | C binding
434 | [hipsparseDestroySpMat](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroyspmat.html "Interface documentation") | C binding
435 | [hipsparseCooGet](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecooget.html "Interface documentation") | C binding
436 | [hipsparseCooAoSGet](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecooaosget.html "Interface documentation") | C binding
437 | [hipsparseCsrGet](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecsrget.html "Interface documentation") | C binding
438 | [hipsparseBlockedEllGet](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseblockedellget.html "Interface documentation") | C binding
439 | [hipsparseCsrSetPointers](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecsrsetpointers.html "Interface documentation") | C binding
440 | [hipsparseCscSetPointers](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecscsetpointers.html "Interface documentation") | C binding
441 | [hipsparseCooSetPointers](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecoosetpointers.html "Interface documentation") | C binding
442 | [hipsparseSpMatGetSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmatgetsize.html "Interface documentation") | C binding
443 | [hipsparseSpMatGetFormat](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmatgetformat.html "Interface documentation") | C binding
444 | [hipsparseSpMatGetIndexBase](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmatgetindexbase.html "Interface documentation") | C binding
445 | [hipsparseSpMatGetValues](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmatgetvalues.html "Interface documentation") | C binding
446 | [hipsparseSpMatSetValues](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmatsetvalues.html "Interface documentation") | C binding
447 | [hipsparseCreateDnVec](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatednvec.html "Interface documentation") | C binding
448 | [hipsparseDestroyDnVec](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroydnvec.html "Interface documentation") | C binding
449 | [hipsparseDnVecGet](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsednvecget.html "Interface documentation") | C binding
450 | [hipsparseDnVecGetValues](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsednvecgetvalues.html "Interface documentation") | C binding
451 | [hipsparseDnVecSetValues](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsednvecsetvalues.html "Interface documentation") | C binding
452 | [hipsparseCreateDnMat](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsecreatednmat.html "Interface documentation") | C binding
453 | [hipsparseDestroyDnMat](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedestroydnmat.html "Interface documentation") | C binding
454 | [hipsparseDnMatGet](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsednmatget.html "Interface documentation") | C binding
455 | [hipsparseDnMatGetValues](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsednmatgetvalues.html "Interface documentation") | C binding
456 | [hipsparseDnMatSetValues](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsednmatsetvalues.html "Interface documentation") | C binding
457 | [hipsparseSpMatGetAttribute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmatgetattribute.html "Interface documentation") | C binding
458 | [hipsparseSpMatSetAttribute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmatsetattribute.html "Interface documentation") | C binding
459 | [hipsparseAxpby](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparseaxpby.html "Interface documentation") | C binding
460 | [hipsparseGather](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsegather.html "Interface documentation") | C binding
461 | [hipsparseScatter](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsescatter.html "Interface documentation") | C binding
462 | [hipsparseRot](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparserot.html "Interface documentation") | C binding
463 | [hipsparseSparseToDense_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesparsetodense__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
464 | [hipsparseSparseToDense](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesparsetodense.html "Interface documentation") | C binding
465 | [hipsparseDenseToSparse_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedensetosparse__buffersize.html "Interface documentation") | C binding, rank_0, rank_1
466 | [hipsparseDenseToSparse_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedensetosparse__analysis.html "Interface documentation") | C binding
467 | [hipsparseDenseToSparse_convert](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsedensetosparse__convert.html "Interface documentation") | C binding
468 | [hipsparseSpVV_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespvv__buffersize.html "Interface documentation") | C binding
469 | [hipsparseSpVV](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespvv.html "Interface documentation") | C binding
470 | [hipsparseSpMV_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmv__buffersize.html "Interface documentation") | C binding
471 | [hipsparseSpMV](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmv.html "Interface documentation") | C binding
472 | [hipsparseSpMM_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmm__buffersize.html "Interface documentation") | C binding
473 | [hipsparseSpMM_preprocess](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmm__preprocess.html "Interface documentation") | C binding
474 | [hipsparseSpMM](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespmm.html "Interface documentation") | C binding
475 | [hipsparseSpGEMM_createDescr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespgemm__createdescr.html "Interface documentation") | C binding
476 | [hipsparseSpGEMM_destroyDescr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespgemm__destroydescr.html "Interface documentation") | C binding
477 | [hipsparseSpGEMM_workEstimation](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespgemm__workestimation.html "Interface documentation") | C binding
478 | [hipsparseSpGEMM_compute](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespgemm__compute.html "Interface documentation") | C binding
479 | [hipsparseSpGEMM_copy](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespgemm__copy.html "Interface documentation") | C binding
480 | [hipsparseSDDMM](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesddmm.html "Interface documentation") | C binding
481 | [hipsparseSDDMM_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesddmm__buffersize.html "Interface documentation") | C binding
482 | [hipsparseSDDMM_preprocess](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsesddmm__preprocess.html "Interface documentation") | C binding
483 | [hipsparseSpSV_createDescr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespsv__createdescr.html "Interface documentation") | C binding
484 | [hipsparseSpSV_destroyDescr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespsv__destroydescr.html "Interface documentation") | C binding
485 | [hipsparseSpSV_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespsv__buffersize.html "Interface documentation") | C binding
486 | [hipsparseSpSV_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespsv__analysis.html "Interface documentation") | C binding
487 | [hipsparseSpSV_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespsv__solve.html "Interface documentation") | C binding
488 | [hipsparseSpSM_createDescr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespsm__createdescr.html "Interface documentation") | C binding
489 | [hipsparseSpSM_destroyDescr](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespsm__destroydescr.html "Interface documentation") | C binding
490 | [hipsparseSpSM_bufferSize](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespsm__buffersize.html "Interface documentation") | C binding
491 | [hipsparseSpSM_analysis](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespsm__analysis.html "Interface documentation") | C binding
492 | [hipsparseSpSM_solve](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hipsparse_1_1hipsparsespsm__solve.html "Interface documentation") | C binding

# hipRAND API Support

\# | API Name | Variants
----|---------------|---------
1 | [hiprandCreateGenerator](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandcreategenerator.html "Interface documentation") | C binding
2 | [hiprandCreateGeneratorHost](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandcreategeneratorhost.html "Interface documentation") | C binding
3 | [hiprandDestroyGenerator](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hipranddestroygenerator.html "Interface documentation") | C binding
4 | [hiprandGenerate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgenerate.html "Interface documentation") | C binding
5 | [hiprandGenerateChar](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgeneratechar.html "Interface documentation") | C binding
6 | [hiprandGenerateShort](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgenerateshort.html "Interface documentation") | C binding
7 | [hiprandGenerateUniform](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgenerateuniform.html "Interface documentation") | C binding
8 | [hiprandGenerateUniformDouble](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgenerateuniformdouble.html "Interface documentation") | C binding
9 | [hiprandGenerateNormal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgeneratenormal.html "Interface documentation") | C binding
10 | [hiprandGenerateNormalDouble](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgeneratenormaldouble.html "Interface documentation") | C binding
11 | [hiprandGenerateLogNormal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgeneratelognormal.html "Interface documentation") | C binding
12 | [hiprandGenerateLogNormalDouble](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgeneratelognormaldouble.html "Interface documentation") | C binding
13 | [hiprandGeneratePoisson](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgeneratepoisson.html "Interface documentation") | C binding
14 | [hiprandGenerateSeeds](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgenerateseeds.html "Interface documentation") | C binding
15 | [hiprandSetStream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandsetstream.html "Interface documentation") | C binding
16 | [hiprandSetPseudoRandomGeneratorSeed](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandsetpseudorandomgeneratorseed.html "Interface documentation") | C binding
17 | [hiprandSetGeneratorOffset](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandsetgeneratoroffset.html "Interface documentation") | C binding
18 | [hiprandSetQuasiRandomGeneratorDimensions](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandsetquasirandomgeneratordimensions.html "Interface documentation") | C binding
19 | [hiprandGetVersion](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandgetversion.html "Interface documentation") | C binding
20 | [hiprandCreatePoissonDistribution](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hiprandcreatepoissondistribution.html "Interface documentation") | C binding
21 | [hiprandDestroyDistribution](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__hiprand_1_1hipranddestroydistribution.html "Interface documentation") | C binding

# rocRAND API Support

\# | API Name | Variants
----|---------------|---------
1 | [rocrand_create_generator](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__create__generator.html "Interface documentation") | C binding
2 | [rocrand_destroy_generator](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__destroy__generator.html "Interface documentation") | C binding
3 | [rocrand_generate](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__generate.html "Interface documentation") | C binding
4 | [rocrand_generate_char](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__generate__char.html "Interface documentation") | C binding
5 | [rocrand_generate_short](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__generate__short.html "Interface documentation") | C binding
6 | [rocrand_generate_uniform](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__generate__uniform.html "Interface documentation") | C binding
7 | [rocrand_generate_uniform_double](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__generate__uniform__double.html "Interface documentation") | C binding
8 | [rocrand_generate_normal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__generate__normal.html "Interface documentation") | C binding
9 | [rocrand_generate_normal_double](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__generate__normal__double.html "Interface documentation") | C binding
10 | [rocrand_generate_log_normal](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__generate__log__normal.html "Interface documentation") | C binding
11 | [rocrand_generate_log_normal_double](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__generate__log__normal__double.html "Interface documentation") | C binding
12 | [rocrand_generate_poisson](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__generate__poisson.html "Interface documentation") | C binding
13 | [rocrand_initialize_generator](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__initialize__generator.html "Interface documentation") | C binding
14 | [rocrand_set_stream](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__set__stream.html "Interface documentation") | C binding
15 | [rocrand_set_seed](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__set__seed.html "Interface documentation") | C binding
16 | [rocrand_set_offset](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__set__offset.html "Interface documentation") | C binding
17 | [rocrand_set_quasi_random_generator_dimensions](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__set__quasi__random__generator__dimensions.html "Interface documentation") | C binding
18 | [rocrand_get_version](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__get__version.html "Interface documentation") | C binding
19 | [rocrand_create_poisson_distribution](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__create__poisson__distribution.html "Interface documentation") | C binding
20 | [rocrand_create_discrete_distribution](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__create__discrete__distribution.html "Interface documentation") | C binding
21 | [rocrand_destroy_discrete_distribution](https://rocm.docs.amd.com/projects/hipfort/en/latest/doxygen/html/interfacehipfort__rocrand_1_1rocrand__destroy__discrete__distribution.html "Interface documentation") | C binding
